--


--all the fuctions associated with batch tracking in here
sequence glob_data


------------------------------------------------------------------------------------------------------------------
global procedure update_batch_tracking_database(sequence nl_str, sequence selected_prod, sequence new_dosage, atom quantity)
--cmd = "CREATE TABLE Batches (id INTEGER PRIMARY KEY, prod_id INTEGER, prod_name TEXT, quantity REAL, date TEXT, batch_number TEXT DEFAULT '-', client_no, patient_no)"
--cmd = "CREATE TABLE DispList (id INTEGER, client_no INTEGER, patient_no INTEGER, patient_name TEXT, label_details TEXT )"
------------------------------------------------------------------------------------------------------------------
sequence DL, BT, cmd, data
atom batch_db, last_rowid


DL = repeat({}, 5) --dispensing list
BT = repeat({}, 6) --batch trackin

batch_db = sqlite_open("xbatch.sql", 0)

cmd = sprintf("INSERT INTO Batches (prod_id, prod_name, quantity, pack_units, date, batch_number, client_no, patient_no) " &
        "VALUES (%d, '%s', %f, '%s', '%s', '%s', %d, %d )",
        {selected_prod[PROD_NUMBER], escape_quotes(selected_prod[PROD_NAME]), quantity,
         escape_quotes(selected_prod[PROD_PACK_UNITS]),
         DateToStr(nowDate()), selected_prod[PROD_BATCH_NUMBER],
         CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]} )
data = query(batch_db, cmd)

if nl_str[1] = 'D' then
        --only if marked for dispensing
        last_rowid = sqlite_last_insert_rowid(batch_db)
        
        cmd = sprintf("INSERT INTO DispList (id, client_no, patient_no, patient_name, label_details) " &
                        "VALUES (%d, %d, %d, '%s', '%s')",
                        {last_rowid, CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO],
                        escape_quotes(CurPatient[PA_NAME]), escape_quotes(new_dosage)}                
                        )
        data = query(batch_db, cmd)
end if

sqlite_close(batch_db)

end procedure

---------------------------------------------------------------------------------------
global function update_batch(sequence selected_prod)
---------------------------------------------------------------------------------------
sequence cmd, data, result
sequence default

SetSize(4,35)
SetColors(GREEN, BLACK)
position( (SCREEN_LINES-8)/2, (SCREEN_COLS-35)/2 )

default = selected_prod[PROD_BATCH_NUMBER]

if length(default) < 20 then
        for i = length(default) to 20 do
                default = default & ' ' 
        end for
end if

result = Input("Update the batch", {"New batch "}, default)

selected_prod[PROD_BATCH_NUMBER] = remove_trailing_spaces(result)

data_update_product(selected_prod)

--clear the box
position( (SCREEN_LINES-8)/2, (SCREEN_COLS-35)/2) SetSize(4,35) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

return selected_prod
end function

---------------------------------------------------------------------------------------
function subtract_drug(sequence datum, sequence crpr)
---------------------------------------------------------------------------------------
sequence cmd, data, selected_prod, result, default , new_note, Batch
atom quantity, total_cost
integer pat_no

new_note = repeat({}, 12)

--get patient number from batch
cmd = "SELECT * FROM Batches WHERE id = " & datum[6]
data = query_database("xbatch.sql", cmd)

Batch = data[2]
pat_no = strtoval(data[2][9])

cmd = "SELECT * FROM Patients WHERE patient_no = " & data[2][9]
data = query_database("xclipats.sql", cmd)
CurPatient = data_validate_patient(data[2])

--get selected product from datum[7]
cmd = sprintf("SELECT * FROM Products WHERE number = %s", {datum[7]} ) --remeber, haven't converted string to number
data = query_database("xprods.sql", cmd)
selected_prod = data_validate_product(data[2])

quantity = -strtoval( datum[3] )

total_cost = (selected_prod[PROD_SALES_PRICE] * (1+(selected_prod[PROD_VAT]/100)) ) * quantity +
                (selected_prod[PROD_BASE_FEE] * (1+(selected_prod[PROD_VAT]/100)) )
--? VAT exemptions ?

--set defaults for note
new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
new_note[N_CLIENT_NO] = CurPatient[PA_CLIENT_NO]
new_note[N_DATE] = DateToStr(nowDate())
new_note[N_FEES] = 0
new_note[N_DRUGS] = 0
new_note[N_VAT] = 0
new_note[N_TOTAL] = 0
new_note[N_USER] = CurUser[U_INIT]
new_note[N_TYPE] = "D"
new_note[N_ANALYSIS] = "0"
new_note[N_NOTE] = ""

new_note[N_DRUGS] = selected_prod[PROD_SALES_PRICE] * quantity - selected_prod[PROD_BASE_FEE]
new_note[N_VAT] = new_note[N_DRUGS] * (selected_prod[PROD_VAT]/100)
new_note[N_TOTAL] = new_note[N_DRUGS] + new_note[N_VAT]
new_note[N_NOTE] = sprintf("%s%.2f %s %s", {crpr, -quantity, selected_prod[PROD_PACK_UNITS], selected_prod[PROD_ITEM]} )

data_insert_note(new_note)

--update patient in memory
CurPatient[PA_DRUGS] = CurPatient[PA_DRUGS] + new_note[N_DRUGS]
CurPatient[PA_VAT] = CurPatient[PA_VAT] + new_note[N_VAT]
CurPatient[PA_OUTS_BAL] = CurPatient[PA_OUTS_BAL] + new_note[N_TOTAL]

data_update_patient()

--update client in memory
CurClient[CL_DRUGS] += new_note[N_DRUGS]
CurClient[CL_VAT] += new_note[N_VAT]
CurClient[CL_OUTS_BAL] += new_note[N_TOTAL]

data_update_client()

return 0
end function

---------------------------------------------------------------------------------------
procedure remove_from_batch_db(sequence datum)
---------------------------------------------------------------------------------------
sequence cmd

cmd = "DELETE FROM Batches WHERE id = " & datum[6]
VOID = query_database("xbatch.sql", cmd)

end procedure

---------------------------------------------------------------------------------------
procedure remove_from_displist(sequence datum)
---------------------------------------------------------------------------------------
sequence  cmd

cmd = "DELETE FROM DispList WHERE id = " & datum[6]
VOID = query_database("xbatch.sql", cmd)

end procedure

---------------------------------------------------------------------------------------
function remove_from_list(sequence list, integer sel_item)
---------------------------------------------------------------------------------------
sequence ndl

ndl = {}

for i = 1 to length(list) do
        if i != sel_item then
                ndl = append(ndl, list[i])
        end if
end for

return ndl
end function


---------------------------------------------------------------------------------------
function update_batch_number(sequence datum)
--almost the same as above, except from client patient list
---------------------------------------------------------------------------------------
sequence cmd, data, selected_prod, result, default 

--get selected product from datum[7]
cmd = sprintf("SELECT * FROM Products WHERE number = %s", {datum[7]} ) --remeber, haven't converted string to number
data = query_database("xprods.sql", cmd)
selected_prod = data[2]

selected_prod = data_validate_product(selected_prod)

SetSize(4,35)
SetColors(GREEN, BLACK)
position( (SCREEN_LINES-8)/2, (SCREEN_COLS-35)/2 )

default = selected_prod[PROD_BATCH_NUMBER]

if length(default) < 20 then
        for i = length(default) to 20 do
                default = default & ' ' 
        end for
end if

result = Input("Update the batch", {"New batch "}, default)
result = remove_trailing_spaces(result)

selected_prod[PROD_BATCH_NUMBER] = result

data_update_product(selected_prod)

--clear the box
position( (SCREEN_LINES-8)/2, (SCREEN_COLS-35)/2) SetSize(4,35) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

--update the batch number in the batch tracking database
--datum[6] is DispList.id, which is also Batches.id

cmd = "UPDATE Batches SET batch_number = '" & result & "' " &
        "WHERE id = " & datum[6]        --DispList.id, still a string, not a number
data = query_database("xbatch.sql", cmd)

datum[4] = result

return datum
end function

---------------------------------------------------------------------------------------
procedure batch_track_print_label(sequence datum)
---------------------------------------------------------------------------------------
sequence cmd, data, selected_prod 
integer n

--get selected product from datum[7]
cmd = sprintf("SELECT * FROM Products WHERE number = %s", {datum[7]} ) --remeber, haven't converted string to number
data = query_database("xprods.sql", cmd)
selected_prod = data[2]

--whats needed for the label
--all the drug details
--current client (on)
--patient name
--quantity
--dosage
--batch details

n = strtoval(quick_question("How many labels for " &  selected_prod[PROD_ITEM] & "? [1]", {BRIGHT_GREEN, BLACK}))
n = n - '0'
if n < 1 or n > 9 then n = 1 end if

printers_batch_drug_label(selected_prod, datum[5], n, datum[1], strtoval(datum[3]))

--remove it from the dispensing list

--VOID = get_yn_box("May have printed a label!")

end procedure


---------------------------------------------------------------------------------------
function create_px_serial(integer px_num)
--made up of serial number, clientnumber, and date, branch number
---------------------------------------------------------------------------------------
return sprintf("%d-%d-%d", {CurClient[CL_CLIENT_NO], globalSettings[GS_BRANCH_NUMBER], px_num })
end function

---------------------------------------------------------------------------------------
function load_px_num()
--prescription serial number - a serial number, updated when used
---------------------------------------------------------------------------------------
integer px_num, fp
sequence line

px_num = 0

fp = open("xpxnum.txt", "r")
if fp > 0 then
        line = gets(fp)
        px_num = strtoval(line)
        close(fp)
end if

return px_num
end function

---------------------------------------------------------------------------------------
procedure save_px_num(integer px_num)
--increments px number
---------------------------------------------------------------------------------------
integer fp

fp = open("xpxnum.txt", "w")
printf(fp,"%d\n", {px_num+1} )
close(fp)

end procedure


---------------------------------------------------------------------------------------
procedure save_prescription(sequence fname, integer px_num)
--saves the prescription in xbatch.sql, prescription TABLE
--data that needs storing
--px serial number, date, client_no, and text body - then entire prescription!
---------------------------------------------------------------------------------------
sequence px_det, cmd, data, buffer
object line
integer fp

px_det = repeat({},5)

px_det[2] = px_num
px_det[3] = dateStrtoJdays(DateToStr(nowDate()))
px_det[4] = CurClient[CL_CLIENT_NO]

fp = open(fname, "r")
if fp > 0 then
        buffer = {}
        while 1 do
                line = gets(fp)
                if atom(line) then
                        exit   -- -1 is returned at end of file
                end if
                buffer = append(buffer, line)
        end while
end if
close(fp)

px_det[5] = utils_compress(buffer)

cmd = "INSERT INTO Prescriptions (serial_no, jdate, client_no, body) " &
        sprintf("VALUES (%d, %d, %d, \"%s\")", {px_det[2], px_det[3], px_det[4], escape_quotes(px_det[5])})
VOID = query_database("xbatch.sql", cmd)

end procedure

---------------------------------------------------------------------------------------
procedure batch_track_print_prescription(sequence datum)
--check out receipt printing in payments.ex
---------------------------------------------------------------------------------------
sequence cmd, data, selected_prod, px_serial
integer fp, space_posn, px_num

 --get prescription serial number
px_num = load_px_num()
px_serial = create_px_serial(px_num)

--get selected product from datum[7]
cmd = sprintf("SELECT * FROM Products WHERE number = %s", {datum[7]} ) --remeber, haven't converted string to number
data = query_database("xprods.sql", cmd)
selected_prod = data[2]

--whats needed for the prescription
--all the drug details
--current client (on)
--patient name
--quantity
--dosage

fp = open(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), "w")

--create a prescription to print

--address
printf(fp, "%s\n", {DrugLabelAddress[DL_NAME]})    
printf(fp, "%s\n", {DrugLabelAddress[DL_ADDRESS1]})
printf(fp, "%s\n", {DrugLabelAddress[DL_ADDRESS2]})
printf(fp, "%s\n", {DrugLabelAddress[DL_ADDRESS3]})
printf(fp, "%s\n", {DrugLabelAddress[DL_TEL]})     
printf(fp, "----------------------------------------------\n\n", {})

--client details
printf(fp,"%s %s %s\n",{CurClient[CL_TITLE], CurClient[CL_FIRST_NAME], CurClient[CL_SURNAME]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS1]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS2]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS3]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS4]})
printf(fp,"%-20.20s\n",{CurClient[CL_POSTCODE]})
printf(fp, "----------------------------------------------\n\n", {})

--animal
printf(fp, "Animal : %s\n", {datum[1]})
printf(fp, "----------------------------------------------\n", {})

--serial number
printf(fp, "Prescription serial number :\n", {})
printf(fp, "%s\n", {px_serial})
printf(fp, "----------------------------------------------\n\n", {})


--prescription body
printf(fp, "Rx : %s %s\n", {datum[3], selected_prod[PROD_PACK_UNITS]} )
printf(fp, "     %s\n\n",    {selected_prod[PROD_NAME]})

if length(datum[5]) > 26 then
        space_posn = 26
        for i = 26 to 1 by -1 do
                if datum[5][i] = ' ' then
                        space_posn = i
                        exit
                end if
        end for
        printf(fp, "Px : %s\n", {datum[5][1..space_posn]})
        printf(fp,"      %s\n", {datum[5][space_posn + 1..$]})
else
        printf(fp, "Px : %s\n", {datum[5]})
end if

printf(fp, "\n\n\nSignature\n\n\n", {})
printf(fp, "Date : %s\n\n\n", {DateToStr(nowDate())})

printf(fp,"Issued in respect of animals under my care.\n", {} )
printf(fp,"Sig. FOR ANIMAL TREATMENT ONLY.\n", {} )
printf(fp,"KEEP OUT OF REACH OF CHILDREN.\n", {} )
printf(fp,"Non transferrable.\n", {} )
printf(fp,"Only the medications indicated have been\n", {} )
printf(fp,"prescribed. Any consequences arising as a\n", {} )
printf(fp,"result of dispensing substitutes\n", {} )
printf(fp,"are the responsibility of the\n", {} )
printf(fp,"pharmacist or other dispensing agent.\n", {} )
printf(fp,"No responsibility will be accepted by the\n", {} )
printf(fp,"veterinary surgeon for any consequences\n", {} )
printf(fp,"arising as a result of substitutions.\n", {} )
printf(fp,"Any queries regarding substitute medications\n", {} )
printf(fp,"should be referred to the pharmacist or\n", {} )
printf(fp,"dispensing agent.\n", {} )
printf(fp, "\n\n\n\n\n\n\n\n\n", {})

close(fp)

--print it, and delete the file, and from the 2 databases too,
--and put a note on the client record too!

--VOID = get_yn_box("May have printed a prescription")

printers_print_file(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), PR_RECEIPT)
printers_print_file(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), PR_RECEIPT)

 --store prescription in database
save_prescription(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), px_num)

save_px_num(px_num)

system_delete_file(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ))

end procedure


---------------------------------------------------------------------------------------
function prescriptions_all(sequence display_list, sequence datas)
---------------------------------------------------------------------------------------
sequence cmd, data, selected_prod , ndl, px_serial
integer fp, space_posn, px_num

--get prescription serial number
px_num = load_px_num()
px_serial = create_px_serial(px_num)

--prescription header
fp = open(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), "w")
--address
printf(fp, "%s\n", {DrugLabelAddress[DL_NAME]})    
printf(fp, "%s\n", {DrugLabelAddress[DL_ADDRESS1]})
printf(fp, "%s\n", {DrugLabelAddress[DL_ADDRESS2]})
printf(fp, "%s\n", {DrugLabelAddress[DL_ADDRESS3]})
printf(fp, "%s\n", {DrugLabelAddress[DL_TEL]})     
printf(fp, "----------------------------------------------\n\n", {})

--client details
printf(fp,"%s %s %s\n",{CurClient[CL_TITLE], CurClient[CL_FIRST_NAME], CurClient[CL_SURNAME]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS1]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS2]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS3]})
printf(fp,"%-20.20s\n",{CurClient[CL_ADDRESS4]})
printf(fp,"%-20.20s\n",{CurClient[CL_POSTCODE]})
printf(fp, "----------------------------------------------\n", {})

--serial number
printf(fp, "Prescription serial number :\n", {})
printf(fp, "%s\n", {px_serial})
printf(fp, "----------------------------------------------\n\n", {})

--prescription body, multiple items
for i = 2 to length(datas) do
        --get selected product from datas[i][7]
        cmd = sprintf("SELECT * FROM Products WHERE number = %s", {datas[i][7]} ) --remeber, haven't converted string to number
        data = query_database("xprods.sql", cmd)
        selected_prod = data[2]

         --animal
        printf(fp, "Animal : %s\n", {datas[i][1]})
        printf(fp, "----------------------------------------------\n\n", {})

        
        printf(fp, "Rx : %s %s\n", {datas[i][3], selected_prod[PROD_PACK_UNITS]} )
        printf(fp, "     %s\n\n",    {selected_prod[PROD_NAME]})
        
        if length(datas[i][5]) > 26 then
                space_posn = 26
                for j = 26 to 1 by -1 do
                        if datas[i][5][j] = ' ' then
                                space_posn = j
                                exit
                        end if
                end for
                printf(fp, "Px : %s\n", {datas[i][5][1..space_posn]})
                printf(fp,"      %s\n\n", {datas[i][5][space_posn + 1..$]})
        else
                printf(fp, "Px : %s\n\n", {datas[i][5]})
        end if
        
        --remove from dispensing list
        cmd = sprintf("DELETE FROM DispList WHERE id = %s", {datas[i][6]})
        data = query_database("xbatch.sql", cmd)

        --credit in notes, patient, client
        VOID = subtract_drug(datas[i], "(PR)")
                
        --remove from batch tracking database
        remove_from_batch_db(datas[i])

end for

--remove all drugs from display_list
display_list = display_list[$-2..$]

--prescription footer

printf(fp, "\n\n\nSignature\n\n\n", {})
printf(fp, "Date : %s\n\n\n", {DateToStr(nowDate())})

printf(fp,"Issued in respect of animals under my care.\n", {} )
printf(fp,"Sig. FOR ANIMAL TREATMENT ONLY.\n", {} )
printf(fp,"KEEP OUT OF REACH OF CHILDREN.\n", {} )
printf(fp,"Non transferrable.\n", {} )
printf(fp,"Only the medications indicated have been\n", {} )
printf(fp,"prescribed. Any consequences arising as a\n", {} )
printf(fp,"result of dispensing substitutes\n", {} )
printf(fp,"are the responsibility of the\n", {} )
printf(fp,"pharmacist or other dispensing agent.\n", {} )
printf(fp,"No responsibility will be accepted by the\n", {} )
printf(fp,"veterinary surgeon for any consequences\n", {} )
printf(fp,"arising as a result of substitutions.\n", {} )
printf(fp,"Any queries regarding substitute medications\n", {} )
printf(fp,"should be referred to the pharmacist or\n", {} )
printf(fp,"dispensing agent.\n", {} )
printf(fp, "\n\n\n\n\n\n\n\n\n", {})

close(fp)

printers_print_file(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), PR_RECEIPT)
printers_print_file(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), PR_RECEIPT)

--store prescription in database
save_prescription(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ), px_num)

system_delete_file(sprintf("Prescrip-%d.txt", {CurClient[CL_CLIENT_NO]} ))

save_px_num(px_num)

return display_list
end function


---------------------------------------------------------------------------------------
function label_all(sequence display_list, sequence datas)
--for each item on list,
--create and print a label
--
---------------------------------------------------------------------------------------
sequence cmd, data, selected_prod , ndl
integer n


for i = 2 to length(datas) do
        --get selected product from datum[7]
        cmd = sprintf("SELECT * FROM Products WHERE number = %s", {datas[i][7]} ) --remeber, haven't converted string to number
        data = query_database("xprods.sql", cmd)
        selected_prod = data[2]

        n = strtoval(quick_question("How many labels for " &  selected_prod[PROD_ITEM] & "? [1]", {BRIGHT_GREEN, BLACK}))
        n = n - '0'
        if n < 1 or n > 9 then n = 1 end if
        if n = 0 then n = 1 end if
        
        printers_batch_drug_label(selected_prod, datas[i][5], n, datas[i][1], strtoval(data[i][3]))

        --remove from dispensing list
        cmd = sprintf("DELETE FROM DispList WHERE id = %s", {datas[i][6]})
        data = query_database("xbatch.sql", cmd)

end for

--remove all drugs from display_list
display_list = display_list[$-2..$]


return display_list
end function


---------------------------------------------------------------------------------------
function meds_opts(sequence display_list, sequence data, integer sel_item )
--options
--      print label
--      print prescriptions
--              credit the patient / client / notes
--              remove from the batchtracking database
--              remove from the disp list
--      update the batch number
--      remove from the list, and do nothing, except
--              credit the patient / client / notes
--              remove from the batchtracking database
---------------------------------------------------------------------------------------
integer choice, current_choice, 
        odl,    --offset details lines
        odc     --offset details cols
sequence dbox 
sequence menu_choices

odl = 5
odc = 20

--show details of drug
SetSize(11, 58)
position(odl,odc)
SetColors(WHITE, BLUE)
dbox = GenericBox("Drug : " & data[sel_item + 1][2], {})
printat({odl + 3, odc +1},  "Quantity : " & data[sel_item + 1][3])
printat({odl + 4, odc +1},  "Batch    : " & data[sel_item + 1][4])
printat({odl + 5, odc +1},  "Label    : " & data[sel_item + 1][5])

--create the menu

choice = quick_menu(odl + 6, odc + 1,
                {WHITE, BLACK},
                TRUE,
                {"Print label                     ",
                 "Print prescription              ",
                 "Update the batch number         ",
                 "Remove from the list, do nothing",
                 "Quit                            "
                })

--clear the box
position(odl, odc) SetSize(11,58) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

--this is used to transfer a changed data sequence back
glob_data = data

if choice = 1 then
        --print a label
        batch_track_print_label(data[sel_item + 1])
        display_list = remove_from_list(display_list, sel_item)
        glob_data = remove_from_list(data, sel_item + 1)
        remove_from_displist(data[sel_item + 1])
elsif choice = 2 then
        --prescription
        batch_track_print_prescription(data[sel_item + 1])

        --credit notes, patient and client, and retotal.
        --note 
        VOID = subtract_drug(data[sel_item + 1], "(PR)")
       
        display_list = remove_from_list(display_list, sel_item)
        glob_data = remove_from_list(data, sel_item + 1)
        remove_from_displist(data[sel_item + 1])
        --remove from batch database, as not dispensing from dispensary
        remove_from_batch_db(data[sel_item + 1])

elsif choice = 3 then
        --update the batch number
        data[sel_item + 1] = update_batch_number(data[sel_item + 1])
        glob_data = data
        --update the display list
        display_list[sel_item] = sprintf("%-5.5s %-20.20s %-12.12s", {data[sel_item + 1][3], data[sel_item + 1][2], data[sel_item + 1][4]} )        
elsif choice = 4 then
        --just remove from list
        VOID = subtract_drug(data[sel_item + 1], "(CR)")
        display_list = remove_from_list(display_list, sel_item)
        glob_data = remove_from_list(data, sel_item + 1)
        remove_from_displist(data[sel_item + 1])
        --remove from batch database, as not dispensing from dispensary
        remove_from_batch_db(data[sel_item + 1])
end if

return display_list
end function

---------------------------------------------------------------------------------------
global function dispense_meds(sequence medlist)
--medlist corresponds to a DispList structure
--id INTEGER, client_no INTEGER, patient_no INTEGER, patient_name TEXT, label_details TEXT 
--Batches 
--id INTEGER PRIMARY KEY, prod_id INTEGER, prod_name TEXT, quantity REAL, pack_units TEXT, date TEXT,
--      batch_number TEXT DEFAULT '-', client_no INTEGER, patient_no INTEGER

--display list of meds that need
--      batch numbers checked / changed
--      labels printed
--      or
--      prescription produced
--      then removed from batch tracking list
--      and removing from dispensing list
--      or
--      bypassing alltogether, to come back later

--what needs to be shown on selection list
--      patient name, prod_name, quantity, batch number, label instructions

---------------------------------------------------------------------------------------
sequence cmd, data, display_list
integer choice, current_choice
atom batch_db

display_list = {}

--get batch list for this client
cmd = "SELECT DispList.patient_name, Batches.prod_name, Batches.quantity, Batches.batch_number, DispList.label_details, DispList.id, Batches.prod_id " &
        "FROM DispList, Batches " &
        "WHERE DispList.id = Batches.id " &
        "AND DispList.client_no = " & sprintf("%d", {CurClient[CL_CLIENT_NO]})
data = query_database("xbatch.sql", cmd)

--create a formatted list to display in the selection box
for i = 2 to length(data) do
        display_list = append(display_list, sprintf("%-5.5s %-20.20s %-12.12s", {data[i][3], data[i][2], data[i][4]} ) )        
end for
display_list = append(display_list, "Labels for all")
display_list = append(display_list, "Prescriptions for all")
display_list = append(display_list, "Quit")

--display list
current_choice = 1
while 1 do
        if length(display_list) = 3 then exit end if
        
        position (9,1)
        SetColors(YELLOW, BLUE)
        SetSize(11,50)
        choice = ListBoxIndex("Drugs to be dispensed (enter for more options)",display_list, current_choice )

        current_choice = choice
        
        if choice = -1 or choice = length(display_list) then
                exit
        elsif choice = length(display_list) - 1 then
                --Prescriptions for all
                display_list = prescriptions_all(display_list, data)
        elsif choice = length(display_list) - 2 then
                --Labels for all
                display_list = label_all(display_list, data)
        else
                --individual item selected 
                display_list = meds_opts(display_list, data, choice)
                --update the data list here
                data = glob_data
        end if
        
end while                                                                

return 0
end function

------------------------------------------------------------------------------------------------------------------
global function batch_credit_dispensing_list(atom quantity, sequence selected_prod)
--checks for presence of product in dispensing list
--if present, removes from list,
-- cmd = "CREATE TABLE Batches (id INTEGER PRIMARY KEY, prod_id INTEGER, prod_name TEXT, quantity REAL, pack_units TEXT, " &
--                 "date TEXT, batch_number TEXT DEFAULT '-', client_no INTEGER, patient_no INTEGER)"
-- 
-- cmd = "CREATE TABLE DispList (id INTEGER, client_no INTEGER, patient_no INTEGER, patient_name TEXT, label_details TEXT )"

------------------------------------------------------------------------------------------------------------------
sequence cmd, data

quantity = quantity * -1

--get batch list for this _patient_
cmd = "SELECT DispList.patient_name, Batches.prod_name, Batches.quantity, Batches.batch_number, DispList.label_details, DispList.id, Batches.prod_id " &
        "FROM DispList, Batches " &
        "WHERE DispList.id = Batches.id " &
        "AND DispList.patient_no = " & sprintf("%d", {CurPatient[PA_PATIENT_NO]})
data = query_database("xbatch.sql", cmd)

if length(data) = 0 then return 0 end if

--check for matches
for i = 2 to length(data) do
        if equal(remove_trailing_spaces(data[i][2]), remove_trailing_spaces(selected_prod[PROD_ITEM])) then
                --match on the list, remove it, if the quantities are the same, else ask
                if quantity >= strtoval(data[i][3])  then
                        cmd = "DELETE FROM DispList WHERE DispList.id = " & data[i][6]
                        VOID = query_database("xbatch.sql", cmd)
                        cmd = "DELETE FROM Batches WHERE Batches.id = " & data[i][6]         
                        VOID = query_database("xbatch.sql", cmd)
                else
                        --                         if upper(get_yn_box("Quant less than on dispens list - remove item from list? (y/n)[n]")) = 'Y' then
                        --                                 cmd = "DELETE FROM DispList WHERE DispList.id = " & data[i][6]
                        --                                 VOID = query_database("xbatch.sql", cmd)
                        --                                 cmd = "DELETE FROM Batches WHERE Batches.id = " & data[i][6]         
                        --                                 VOID = query_database("xbatch.sql", cmd)
                        --                         else
                        --update quantities
                        quantity = strtoval(data[i][3]) - quantity --this should be a +ve number
                        cmd = "UPDATE Batches SET quantity = " & sprintf("%d", {quantity}) & " WHERE id = " & data[i][6]
                        VOID = query_database("xbatch.sql", cmd)
                        --end if
                end if
                               
        end if


end for



return 0
end function




