-- This file deals with most of the issueas around viewing,
-- adding, editing clients and patients etc.

include payments.ex
include clients_batch_tracking.ex

global atom choice, current_choice
global atom sql_db
sequence new_pl

---------------------------------------------------------------------------------------
global procedure paint_pdsa()
--displays pdsa details if client has a pdsa patient
---------------------------------------------------------------------------------------

if sequence(PDSAPatient[PDSA_CLIENT_NO]) = 0 then
        --clear the area first
        for i = 3 to 6 do
                printcolor( {i,63}, {GREEN, BLACK}, "                ")                  
        end for
        if PDSAPatient[PDSA_CLIENT_NO] > 0 then
                printcolor( {3,63}, {GREEN, BLACK}, "PDSA (cat " & remove_trailing_spaces(PDSAPatient[PDSA_CATEGORY]) & ")")
                printcolor( {4,63}, {GREEN, BLACK}, remove_trailing_spaces(PDSAPatient[PDSA_PATIENT_NAME]))
                printcolor( {5,63}, {GREEN, BLACK}, remove_trailing_spaces(PDSAPatient[PDSA_EXPIRY]))
                printcolor( {6,63}, {GREEN, BLACK}, remove_trailing_spaces(PDSAPatient[PDSA_CERT_NO]))
        end if
end if

end procedure


---------------------------------------------------------------------------------------
global procedure paint_client()
---------------------------------------------------------------------------------------
sequence mid_line
mid_line = repeat(Lines[1][2], SCREEN_COLS)

--paint the client details headers
SetColors(WHITE, BLACK)
SetStyle(5) position(1,1) MessageBox("",{}) SetStyle(1) --need this so that screen clears properly
clear_screen()

printcolor({1,1}, {BLACK,CYAN}, "Client record. Branch " & JV_BRANCH)
printcolor({2,1}, {BRIGHT_BLUE,BLACK}, "Name     :")
printcolor({3,1}, {BRIGHT_BLUE,BLACK}, "Address  :")
printcolor({7,1}, {BRIGHT_BLUE,BLACK}, "Postcode :")
printcolor({8,1}, {BRIGHT_BLUE,BLACK}, "Tel 1    :")
printcolor({9,1}, {BRIGHT_BLUE,BLACK}, "Tel 2    :")
printcolor({3,35}, {BRIGHT_BLUE,BLACK}, "Last cons date :")
printcolor({4,35}, {BRIGHT_BLUE,BLACK}, "Next cons date :")
printcolor({5,35}, {BRIGHT_BLUE,BLACK}, "Next cons time :")
printcolor({6,35}, {CYAN,BLACK},        "Last paid      :")
printcolor({7,35}, {CYAN,BLACK},        "Fees           :")
printcolor({8,35}, {CYAN,BLACK},        "Drugs          :")
printcolor({9,35}, {CYAN,BLACK},        "Vat            :")
printcolor({10,35}, {CYAN,BLACK},       "Balance        :")
printcolor({11,1},  {CYAN,BLACK}, mid_line)

--put on the client details
printcolor( {2,12}, {YELLOW, BLACK}, CurClient[CL_TITLE] & " " & CurClient[CL_FIRST_NAME] &" "& CurClient[CL_SURNAME])
printcolor( {3,12}, {YELLOW, BLACK}, CurClient[CL_ADDRESS1])
printcolor( {4,12}, {YELLOW, BLACK}, CurClient[CL_ADDRESS2])
printcolor( {5,12}, {YELLOW, BLACK}, CurClient[CL_ADDRESS3])
printcolor( {6,12}, {YELLOW, BLACK}, CurClient[CL_ADDRESS4])
printcolor( {7,12}, {YELLOW, BLACK}, CurClient[CL_POSTCODE])
printcolor( {8,12}, {YELLOW, BLACK}, CurClient[CL_TEL1])
printcolor( {9,12}, {YELLOW, BLACK}, CurClient[CL_TEL2])

printcolor( {3,52}, {YELLOW, BLACK}, CurClient[CL_LAST_CONS_DATE])
printcolor( {4,52}, {YELLOW, BLACK}, CurClient[CL_NEXT_CONS_DATE])
printcolor( {5,52}, {YELLOW, BLACK}, CurClient[CL_NEXT_CONS_TIME])
printcolor( {6,52}, {YELLOW, BLACK}, CurClient[CL_LAST_PAID])
printcolor( {7,52}, {YELLOW, BLACK}, sprintf("%8.2f", {strtoval(CurClient[CL_FEES])}) )
printcolor( {8,52}, {YELLOW, BLACK}, sprintf("%8.2f", {strtoval(CurClient[CL_DRUGS])}) )
printcolor( {9,52}, {YELLOW, BLACK}, sprintf("%8.2f", {strtoval(CurClient[CL_VAT])}) )
printcolor( {10,52}, {YELLOW, BLACK}, sprintf("%8.2f", {strtoval(CurClient[CL_OUTS_BAL])}) )

paint_pdsa()

--will also need to put in any warnings and flags etc here

end procedure


---------------------------------------------------------------------------------------
procedure edit_sa_patient_details()
---------------------------------------------------------------------------------------
sequence pa_dets1, pdsa_dets, data, cmd

pdsa_dets = repeat({}, 10)

position(6,6)
SetColors(BLACK, WHITE)

pa_dets1 = Form("Edit patient details - page 1 of 2",
                {"Name      ", CurPatient[PA_NAME], 20,
                "Species    ", CurPatient[PA_SPECIES], 20,
                "Breed      ", CurPatient[PA_BREED], 20,
                "DOB / Age  ", CurPatient[PA_DOB], 20,
                "Sex        ", CurPatient[PA_SEX], 20,
                "Colour     ", CurPatient[PA_COLOR], 20,
                "Insured    ", CurPatient[PA_INSURED], 20,
                "Microchip  ", CurPatient[PA_MICROCHIP], 30,
                "Vacc. due  ", "", 12,
                "Weight Kg  ", sprintf("%.2f", {CurPatient[PA_WEIGHT]}), 5    } )
                
--translate pa_dets to CurPatient
CurPatient[PA_NAME] = pa_dets1[1]
CurPatient[PA_SPECIES] = pa_dets1[2]
CurPatient[PA_BREED] = pa_dets1[3]
CurPatient[PA_SEX] = pa_dets1[5]
CurPatient[PA_COLOR] = pa_dets1[6]
CurPatient[PA_INSURED] = pa_dets1[7]
CurPatient[PA_MICROCHIP] = pa_dets1[8]
CurPatient[PA_WEIGHT] = pa_dets1[10]

data_update_patient()

--pdsa details
--have already loaded PDSA details into PDSAPatient
--convert to pdsa_dets

--turn notes into separate 3 sequences

--turn chronic conditions into 3 separate sequences

if sequence(PDSAPatient[PDSA_PATIENT_NO]) then
        PDSAPatient[PDSA_PATIENT_NO] = 0
end if

if PDSAPatient[PDSA_PATIENT_NO] = CurPatient[PA_PATIENT_NO] then
        pdsa_dets[1] = "YES"
        pdsa_dets[2] = PDSAPatient[PDSA_CERT_NO]
        pdsa_dets[3] = PDSAPatient[PDSA_EXPIRY]
        --notes
        --pdsa_dets[4] = 
        --chronic conditions
        --pdsa_dets[5] =
        pdsa_dets[10] = PDSAPatient[PDSA_CATEGORY]
        
end if

position(6,6)
SetColors(BLACK, WHITE)
pdsa_dets = Form("PDSA details - page 2 of 2" & remove_trailing_spaces(CurPatient[PA_NAME]),
                {"On scheme (Y/N)    ", pdsa_dets[1], 4,
                 "Cert. no.          ", pdsa_dets[2], 20,
                 "Expiry date        ", pdsa_dets[3], 15,
                 "Notes              ", "", 20,
                 "                   ", "", 20,
                 "                   ", "", 20,
                 "Chronic conditions ", "", 20,
                 "                   ", "", 20,
                 "                   ", "", 20,
                 "Category           ", pdsa_dets[10], 4                 
                })

--only have 1 PDSA patient per client, so have to delete any current PDSA record first
data = query_database("xclipats.sql", "DELETE FROM PDSA WHERE client_no = " & sprintf("%d", {CurClient[CL_CLIENT_NO]}) )
                
if upper(pdsa_dets[1][1]) = 'Y' then
        
        PDSAPatient[PDSA_CLIENT_NO] = CurClient[CL_CLIENT_NO]
        PDSAPatient[PDSA_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
        PDSAPatient[PDSA_PATIENT_NAME] = CurPatient[PA_NAME]
        PDSAPatient[PDSA_CERT_NO] = pdsa_dets[2]
        PDSAPatient[PDSA_CATEGORY] = upper(pdsa_dets[10])
        PDSAPatient[PDSA_EXPIRY] = pdsa_dets[3]
        
        PDSAPatient[PDSA_NOTES] = pdsa_dets[4] & pdsa_dets[5] & pdsa_dets[6]
        PDSAPatient[PDSA_CHRONIC_COND] = pdsa_dets[7] & pdsa_dets[8] & pdsa_dets[9]

        data_update_PDSAPatient()
else
        PDSAPatient = repeat({},10)
        data_validate_PDSAPatient()
end if

paint_pdsa()

end procedure


---------------------------------------------------------------------------------------
procedure edit_client_details()
---------------------------------------------------------------------------------------
sequence cl_dets, data, cmd

cl_dets = repeat("", 10)

position(6,6)
SetColors(BLACK, WHITE)
SCREEN_BKGND = BLACK
cl_dets = Form("Edit client details",
                    {"Surname    ", CurClient[CL_SURNAME], 20,
                     "Title      ", CurClient[CL_TITLE], 5,
                     "First name ", CurClient[CL_FIRST_NAME], 30,
                     "Address    ", CurClient[CL_ADDRESS1], 30,
                     "           ", CurClient[CL_ADDRESS2], 30,
                     "           ", CurClient[CL_ADDRESS3], 30,
                     "           ", CurClient[CL_ADDRESS4], 30,
                     "Postcode   ", CurClient[CL_POSTCODE], 10,
                     "Tel (main) ", CurClient[CL_TEL1], 15,
                     "Tel (alt)  ", CurClient[CL_TEL2], 15
                    })

CurClient[CL_SURNAME]   = cl_dets[1]        
CurClient[CL_TITLE]     = cl_dets[2]        
CurClient[CL_FIRST_NAME]        = cl_dets[3]        
CurClient[CL_ADDRESS1]  = cl_dets[4]        
CurClient[CL_ADDRESS2]  = cl_dets[5]        
CurClient[CL_ADDRESS3]  = cl_dets[6]        
CurClient[CL_ADDRESS4]  = cl_dets[7]        
CurClient[CL_POSTCODE]  = cl_dets[8]        
CurClient[CL_TEL1]      = cl_dets[9]        
CurClient[CL_TEL2]      = cl_dets[10]    

data_update_client()

paint_client()   
                    

end procedure

---------------------------------------------------------------------------------------
procedure show_flag_form(sequence t)
---------------------------------------------------------------------------------------
sequence box
integer offsetrow, offsetcol

offsetrow = 5 offsetcol = 5

box = DefaultBox
SetSize(15, 60)
position(offsetrow, offsetcol)
SetColors(WHITE, BLUE)

box = PlainBox(DefaultBox)

printat({offsetrow + 1, offsetcol + 1},  "Press the key indicated to change the attribute")
printat({offsetrow + 2, offsetcol + 1},  "Client type  Cash (C)    [ ]")
printat({offsetrow + 3, offsetcol + 1},  "             Account (A) [ ]")
printat({offsetrow + 4, offsetcol + 1},  "Send invoice (I)         [ ]")
printat({offsetrow + 5, offsetcol + 1},  "Add surcharge (S)        [ ]")
printat({offsetrow + 6, offsetcol + 1},  "Add accounting fee (F)   [ ]")
printat({offsetrow + 3, offsetcol + 30}, "Send statement (M)       [ ]")
printat({offsetrow + 4, offsetcol + 30}, "Send reminders (R)       [ ]")
printat({offsetrow + 5, offsetcol + 30}, "Accounts allowed (G)     [ ]")
printat({offsetrow + 6, offsetcol + 30}, "Ignore when invoicing (V)[ ]")

printat({offsetrow + 7, offsetcol + 1}, "Payments shown for CLIENT (not per patient) (L)[ ]")

printat({offsetrow + 9, offsetcol + 1},  "Slow payer (P)  [ ]")
printat({offsetrow + 9, offsetcol + 21}, "Bad debtor (B)  [ ]")
printat({offsetrow + 9, offsetcol + 42}, "PDSA (D)        [ ]")
printat({offsetrow + 10, offsetcol + 1},  "Plan member (E) [ ]")
printat({offsetrow + 12, offsetcol + 1},  "VAT on drugs (J) [ ]    VAT on services (K) [ ]")
printat({offsetrow + 13, offsetcol + 1},  "Press Q when done")


--now fill in boxes
if CurClient[CL_BILL_TYPE][1] = 'C' then
        printcolor({offsetrow + 2, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, "X") 
        printcolor({offsetrow + 3, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, " ") 
elsif CurClient[CL_BILL_TYPE][1] = 'A' then
        printcolor({offsetrow + 2, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, " ") 
        printcolor({offsetrow + 3, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, "X") 
end if  

if t[FL_PAYMENTS_ON_CLIENT] = 'X' then
        printcolor({offsetrow + 7, offsetcol + 49}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 7, offsetcol + 49}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_SEND_INVOICE] = 'X' then
        printcolor({offsetrow + 4, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 4, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_ADD_SURCHARGE] = 'X' then
        printcolor({offsetrow + 5, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 5, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_ADD_ACC_FEE] = 'X' then
        printcolor({offsetrow + 6, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 6, offsetcol + 27}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_SLOW_PAYER] = 'X' then
        printcolor({offsetrow + 9, offsetcol + 18}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 9, offsetcol + 18}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_BAD_DEBT] = 'X' then
        printcolor({offsetrow + 9, offsetcol + 38}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 9, offsetcol + 38}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_PDSA] = 'X' then
        printcolor({offsetrow + 9, offsetcol + 59}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 9, offsetcol + 59}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_PLAN] = 'X' then
        printcolor({offsetrow + 10, offsetcol + 18}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 10, offsetcol + 18}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_ACCOUNT_ALLOWED] = 'X' then
        printcolor({offsetrow + 5, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 5, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_SEND_REMINDERS] = 'X' then
        printcolor({offsetrow + 4, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 4, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_SEND_STATEMENT] = 'X' then
        printcolor({offsetrow + 3, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 3, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, " ")   
end if
if t[FL_VAT_ON_DRUGS] = 'X' then
        printcolor({offsetrow + 12, offsetcol + 19}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 12, offsetcol + 19}, {BRIGHT_WHITE, BLUE}, " ")          
end if
if t[FL_VAT_ON_SERVICES] = 'X' then
        printcolor({offsetrow + 12, offsetcol + 46}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 12, offsetcol + 46}, {BRIGHT_WHITE, BLUE}, " ")          
end if
if t[FL_IGNORE_WHEN_INVOICING] = 'X' then
        printcolor({offsetrow + 6, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, "X")
else    printcolor({offsetrow + 6, offsetcol + 56}, {BRIGHT_WHITE, BLUE}, " ")   
end if

position (offsetrow, offsetcol)

end procedure

---------------------------------------------------------------------------------------
procedure edit_client_flags()
--a flagged flag is marked with an 'X'
--ANYTHING else is NOT flagged
---------------------------------------------------------------------------------------
sequence t
integer c

--check client bill type
if length(CurClient[CL_BILL_TYPE]) = 0 or ( CurClient[CL_BILL_TYPE][1] != 'C' and  CurClient[CL_BILL_TYPE][1] != 'A' ) then
        --not set, so set it to default
        CurClient[CL_BILL_TYPE] = "C"
end if

--check client flag for conforming
--if length(CurClient[CL_FLAGS]) < FL_FLAG_COUNT then
--        while length(CurClient[CL_FLAGS]) < FL_FLAG_COUNT do
--                CurClient[CL_FLAGS] &= '-'
--        end while
--end if
--for i = 1 to FL_FLAG_COUNT do
--        if CurClient[CL_FLAGS][i] = ' ' then
--                CurClient[CL_FLAGS][i] = '-'
--        end if
--        if CurClient[CL_FLAGS][i] = 'N' then                  --from the olden days
--                CurClient[CL_FLAGS][i] = '-'                  --when used to Y and N for some reason
--        end if
--        if CurClient[CL_FLAGS][i] = 'Y' then
--                CurClient[CL_FLAGS][i] = 'X'
--        end if
--      
--end for

CurClient[CL_FLAGS] = data_normalise_flags(CurClient[CL_FLAGS])

t = CurClient[CL_FLAGS]         --laziness!

show_flag_form(t)

while 1 do
        c = upper(wait_key())
        if c = 'Q' then exit
        elsif c = 'I' then
                if t[FL_SEND_INVOICE] = 'X' then
                        t[FL_SEND_INVOICE] = '-'
                else    t[FL_SEND_INVOICE] = 'X'
                end if
        elsif c = 'S' then
                if t[FL_ADD_SURCHARGE] = 'X' then
                        t[FL_ADD_SURCHARGE] = '-'
                else    t[FL_ADD_SURCHARGE] = 'X'
                end if
        elsif c = 'F' then
                if t[FL_ADD_ACC_FEE] = 'X' then
                        t[FL_ADD_ACC_FEE] = '-'
                else    t[FL_ADD_ACC_FEE] = 'X'
                end if
        elsif c = 'P' then
                if t[FL_SLOW_PAYER] = 'X' then
                        t[FL_SLOW_PAYER] = '-'
                else    t[FL_SLOW_PAYER] = 'X'
                end if
        elsif c = 'B' then
                if t[FL_BAD_DEBT] = 'X' then
                        t[FL_BAD_DEBT] = '-'
                else    t[FL_BAD_DEBT] = 'X'
                end if
        elsif c = 'D' then
                if t[FL_PDSA] = 'X' then
                        t[FL_PDSA] = '-'
                else    t[FL_PDSA] = 'X'
                end if
        elsif c = 'E' then
                if t[FL_PLAN] = 'X' then
                        t[FL_PLAN] = '-'
                else    t[FL_PLAN] = 'X'
                end if
        elsif c = 'G' then
                if t[FL_ACCOUNT_ALLOWED] = 'X' then
                        t[FL_ACCOUNT_ALLOWED] = '-'
                else    t[FL_ACCOUNT_ALLOWED] = 'X'
                end if
        elsif c = 'R' then
                if t[FL_SEND_REMINDERS] = 'X' then
                        t[FL_SEND_REMINDERS] = '-'
                else    t[FL_SEND_REMINDERS] = 'X'
                end if
        elsif c = 'M' then
                if t[FL_SEND_STATEMENT] = 'X' then
                        t[FL_SEND_STATEMENT] = '-'
                else    t[FL_SEND_STATEMENT] = 'X'
                end if
        elsif c = 'J' then
                if t[FL_VAT_ON_DRUGS] = 'X' then
                        t[FL_VAT_ON_DRUGS] = '-'
                else    t[FL_VAT_ON_DRUGS] = 'X'
                end if
        elsif c = 'K' then
                if t[FL_VAT_ON_SERVICES] = 'X' then
                        t[FL_VAT_ON_SERVICES] = '-'
                else    t[FL_VAT_ON_SERVICES] = 'X'
                end if
        elsif c = 'V' then
                if t[FL_IGNORE_WHEN_INVOICING] = 'X' then
                        t[FL_IGNORE_WHEN_INVOICING] = '-'
                else    t[FL_IGNORE_WHEN_INVOICING] = 'X'
                end if
        elsif c = 'L' then
                if t[FL_PAYMENTS_ON_CLIENT] = 'X' then
                        t[FL_PAYMENTS_ON_CLIENT] = '-'
                else    t[FL_PAYMENTS_ON_CLIENT] = 'X'
                end if
       end if
        
       if c = 'C' then -- cash client
                CurClient[CL_BILL_TYPE] = "C"
                t[FL_SEND_INVOICE] = 'X'
                t[FL_ADD_SURCHARGE] = 'X'
                t[FL_ADD_ACC_FEE] = 'X'
                t[FL_SEND_STATEMENT] = '-'
                t[FL_SEND_REMINDERS] = 'X'
                t[FL_ACCOUNT_ALLOWED] = '-'
        end if
        if c = 'A' then --account client
                CurClient[CL_BILL_TYPE] = "A"
                t[FL_SEND_INVOICE] = '-'
                t[FL_ADD_SURCHARGE] = '-'
                t[FL_ADD_ACC_FEE] = '-'
                t[FL_SEND_STATEMENT] = 'X'
                t[FL_SEND_REMINDERS] = '-'
                t[FL_ACCOUNT_ALLOWED] = 'X'
        
        end if
        
                        
        show_flag_form(t)       

end while

CurClient[CL_FLAGS] = t
data_update_client()

paint_client()


end procedure


---------------------------------------------------------------------------------------
procedure client_sub_menu()
-- recap - what we have already!
-- CurClient - all the clients details
-- CurPatient - selected on the bar
-- theoretically (hah) this is everything thats needed for this section
---------------------------------------------------------------------------------------
sequence menu_items, data, scp_new
integer si, current_choice

scp_new = {0,0}

menu_items = { "Edit client details",                   --1
                "Edit client flags",                    --2
                "Edit / add client popup",              --3
                "-----------------------",              --4
                "Add a patient",                                --5
                "Edit patient details",                 --6
                "Edit patient flags",                   --7
                "Show deceased patients (d)",           --8
                "Move patient to another client",       --9
                "Delete patient",                       --10
                "Quit"}                                 --11

current_choice = 1
                
while 1 do
        SetSize(length(menu_items) + 3, 28 + length(remove_trailing_spaces(CurPatient[PA_NAME])))
        position(SCREEN_LINES - (length(menu_items) + 3), 7)
        SetColors(YELLOW, BLACK)
        si = Select("Client / patient menu " & remove_trailing_spaces(CurPatient[PA_NAME]), current_choice, menu_items)
        
        if si = -1 or si = length(menu_items) then exit end if
        
        if si = 1 then
                edit_client_details()
        elsif si = 2 then
                edit_client_flags()     
        elsif si = 3 then
                --check for popups
                data = popups_check('C')
                Popup[POP_COP] = "C"
                popups_show(data)
                paint_client()
        
        elsif si = 4 then
        
        elsif si = 5 then
                --add a patient
                --path taken to add a patient (when client added)
                --scp = add_patient(scp[1]) (or client number) (scp[2] is the patient number returned)
                --patient_no = add_small_animal(client_no)
                --display list of patients and select new one
                
                scp_new = call_func(rid_add_patient, {CurClient[CL_CLIENT_NO]})
                new_pl =  call_func(rid_load_all_live_patients, {CurClient[CL_CLIENT_NO]})
                exit         
                
        elsif si = 6 then
                edit_sa_patient_details()       
        elsif si = 8 then
                new_pl = call_func(rid_load_all_patients, {CurClient[CL_CLIENT_NO]})
                exit
        elsif si = 7 then
        
        elsif si = 9 then
        
        end if

end while

paint_client()

end procedure













---------------------------------------------------------------------------------------
global procedure paint_patient()
--at the top, as needed several times
---------------------------------------------------------------------------------------
sequence mid_line, age
mid_line = repeat(Lines[1][2], SCREEN_COLS)
age = {}

SetColors(WHITE, BLACK)
SetStyle(5) position(1,1) MessageBox("",{}) SetStyle(1) --need this so that screen clears properly

CurPatient[PA_NAME] = remove_trailing_spaces(CurPatient[PA_NAME])
CurClient[CL_SURNAME] = remove_trailing_spaces(CurClient[CL_SURNAME])
CurPatient[PA_MICROCHIP] = remove_trailing_spaces(CurPatient[PA_MICROCHIP])

printcolor({1,1}, {BRIGHT_WHITE,GREEN}, "Clinical notes for : " & CurPatient[PA_NAME] & " " & CurClient[CL_SURNAME] & " (" & CurPatient[PA_MICROCHIP] & ")" )
printcolor({2,1}, {BRIGHT_BLUE,BLACK}, "Species :           DOB     :              Vacc. due   :")
printcolor({3,1}, {BRIGHT_BLUE,BLACK}, "Breed   :           Age     :              Weight      :")
printcolor({4,1}, {BRIGHT_BLUE,BLACK}, "Sex     :           Insured :              Total outs. :")            
printcolor({5,1}, {BRIGHT_BLUE,BLACK}, "Colour  :                                  Patient bal :")
printcolor({6,1},  {CYAN,BLACK}, mid_line)

CurPatient[PA_BREED] = remove_trailing_spaces(CurPatient[PA_BREED])
CurPatient[PA_SPECIES] = remove_trailing_spaces(CurPatient[PA_SPECIES])
CurPatient[PA_SEX] = remove_trailing_spaces(CurPatient[PA_SEX])
CurPatient[PA_COLOR] = remove_trailing_spaces(CurPatient[PA_COLOR])
CurPatient[PA_DOB] = remove_trailing_spaces(CurPatient[PA_DOB])
CurPatient[PA_INSURED] = remove_trailing_spaces(CurPatient[PA_INSURED])

printcolor({2,11}, {YELLOW,BLACK}, CurPatient[PA_BREED])
printcolor({3,11}, {YELLOW,BLACK}, CurPatient[PA_SPECIES])
printcolor({4,11}, {YELLOW,BLACK}, CurPatient[PA_SEX])
printcolor({5,11}, {YELLOW,BLACK}, CurPatient[PA_COLOR])

--calculate age from DOB
age = DOB2age(CurPatient[PA_DOB])

printcolor({2,31}, {YELLOW,BLACK}, CurPatient[PA_DOB])
printcolor({3,31}, {YELLOW,BLACK},age)
printcolor({4,31}, {YELLOW,BLACK}, CurPatient[PA_INSURED])

--check vacc due

printcolor({3,58}, {YELLOW,BLACK}, sprintf("%8.2f Kg", {strtoval(CurPatient[PA_WEIGHT])}))
printcolor({4,58}, {YELLOW,BLACK}, sprintf("%8.2f", {strtoval(CurClient[CL_OUTS_BAL])}))
printcolor({5,58}, {YELLOW,BLACK}, sprintf("%8.2f", {strtoval(CurPatient[PA_OUTS_BAL])}))

end procedure

---------------------------------------------------------------------------------------
global procedure update_display_notes(sequence display_notes)
---------------------------------------------------------------------------------------
integer screen_length, screen_top, screen_bot, first_note, last_note, Ncolor, key

screen_length = SCREEN_LINES - 8
screen_top = 7
screen_bot = SCREEN_LINES - 3

last_note = length(display_notes)
if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        
for i = first_note to last_note do
        printcolor( {i-first_note + screen_top, 1}, {display_notes[i][2], BLACK}, display_notes[i][1])  
end for


end procedure

---------------------------------------------------------------------------------------
global procedure set_patient_defaults(integer client_no)
---------------------------------------------------------------------------------------
CurPatient[PA_WEIGHT] = 0
CurPatient[PA_FEES] = 0
CurPatient[PA_DRUGS] = 0
CurPatient[PA_VAT] = 0
CurPatient[PA_OUTS_BAL] = 0
CurPatient[PA_CLIENT_NO] = client_no
CurPatient[PA_MILEAGE] = 0


end procedure

---------------------------------------------------------------------------------------
global function add_farm_animal(integer client_no)
---------------------------------------------------------------------------------------
integer patient_no


return patient_no
end function


---------------------------------------------------------------------------------------
global function add_equine(integer client_no)
---------------------------------------------------------------------------------------
integer patient_no

return patient_no
end function


---------------------------------------------------------------------------------------
global function add_small_animal(integer client_no)
---------------------------------------------------------------------------------------
sequence cmd, data
atom sql_db
integer patient_no
sequence p_dets
p_dets = repeat(" ", 10)

--blank the CurPatient
CurPatient = repeat(" ", 45)

--set the number fields to 0
set_patient_defaults(client_no)

--create the form
position(8,2)
SetColors(BLACK, WHITE)
p_dets = Form("Patient details", {
                "Name       ", p_dets[1], 20,
                "Species    ", p_dets[2], 20,
                "Breed      ", p_dets[3], 20,
                "DOB / Age  ", p_dets[4], 20,
                "Sex        ", p_dets[5], 20,
                "Colour     ", p_dets[6], 20,
                "Insured    ", p_dets[7], 20,
                "Microchip  ", p_dets[8], 30,
                "Vacc. due  ", p_dets[9], 12,
                "Weight Kg  ", p_dets[10], 5    } )
                
--translate p_dets to CurPatient
CurPatient[PA_NAME] = p_dets[1]
CurPatient[PA_SPECIES] = p_dets[2]
CurPatient[PA_BREED] = p_dets[3]
CurPatient[PA_SEX] = p_dets[5]
CurPatient[PA_COLOR] = p_dets[6]
CurPatient[PA_INSURED] = p_dets[7]
CurPatient[PA_MICROCHIP] = p_dets[8]
CurPatient[PA_WEIGHT] = p_dets[10]


--need to sort out vacc dates, and reminders

--convert age to dob, and standardise date

CurPatient[PA_DOB] = check_date(p_dets[4])

--now add the CurPatient to the database
data_insert_patient()

--get patient number, so can return it
cmd = "SELECT patient_no FROM Patients WHERE client_no = " & sprintf("%d", {client_no}) & " ORDER BY patient_no"

sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
    VOID = get_yn_box("Unable to open database")
end if

data = sqlite_get_table(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error : " & sqlite_last_err_desc)
end if

sqlite_close(sql_db)

if length(data) = 0 then
        VOID = get_yn_box("Nonsensical error!")
        return 0
end if

patient_no = strtoval(data[$][PA_PATIENT_NO])

return patient_no
end function


---------------------------------------------------------------------------------------
global function add_patient(integer client_no)
--scp[1] - client_no
--scp[2] - patient_no
---------------------------------------------------------------------------------------
sequence scp
integer result, patient_no

scp = {client_no, 0}

--select type of patient to add
position((SCREEN_LINES/2)-3, (SCREEN_COLS/2)-10)
SetColors(YELLOW, BLUE)
SetSize(6,20)
result = ListBoxIndex("",{"Small animal", "Farm animal", "Equine"}, 1)

--default small animal
if result = 1 or result > 3 or result < 1 then patient_no = add_small_animal(client_no)
elsif result = 2 then patient_no = add_farm_animal(client_no)
elsif result = 3 then patient_no = add_equine(client_no)
end if

--clear the list box
position((SCREEN_LINES/2)-3, (SCREEN_COLS/2)-10)
SetColors(BLACK, WHITE)
SetSize(6,20)
SetStyle(5)
MessageBox("", {})
SetStyle(1)

scp[2] = result

return scp
end function
rid_add_patient = routine_id("add_patient")

---------------------------------------------------------------------------------------
function add_service(sequence display_notes, sequence selected_prod)
---------------------------------------------------------------------------------------
sequence box, underline, text, new_note
object quantstr
integer boxy, boxx
atom quantity

quantstr = {}
new_note = repeat({}, 12)

boxy = SCREEN_LINES-11
boxx = 1
--this time, just going to create a generic box, and layout by hand

box = DefaultBox
SetSize(10, 60)
position(boxy, boxx)
SetColors(BRIGHT_WHITE, BLUE)

box = PlainBox(DefaultBox)
underline = repeat('=', length(selected_prod[PROD_ITEM]) )

printcolor( {boxy+1, boxx+1}, {YELLOW, BLUE}, selected_prod[PROD_ITEM])
printcolor( {boxy+2, boxx+1}, {YELLOW, BLUE}, underline)
printcolor( {boxy+3, boxx+1}, {YELLOW, BLUE}, "Cost (ex VAT)  :")
printcolor( {boxy+4, boxx+1}, {YELLOW, BLUE}, "VAT            :")
printcolor( {boxy+5, boxx+1}, {YELLOW, BLUE}, "Cost (inc VAT) :")
printcolor( {boxy+3, boxx+17}, {YELLOW, BLUE}, sprintf("%8.2f", {selected_prod[PROD_SALES_PRICE]}))
printcolor( {boxy+4, boxx+17}, {YELLOW, BLUE}, sprintf("%8.2f", {selected_prod[PROD_VAT]}))
printcolor( {boxy+5, boxx+17}, {YELLOW, BLUE}, sprintf("%8.2f", {selected_prod[PROD_SALES_PRICE] * (1+(selected_prod[PROD_VAT]/100))  }))

printcolor( {boxy+7, boxx+1}, {YELLOW, BLUE}, "Quantity")
printcolor( {boxy+7, boxx+10}, {BRIGHT_WHITE, BLACK}, "1           ")

position(boxy+7, boxx+10)

quantstr = get_max_str(10)
quantstr = remove_trailing_spaces(quantstr)
if length(quantstr) > 0 then
        quantity = strtoval(quantstr)
else quantity = 1
end if


if quantity = 0 then
        SetSize(10, 60)
        position(boxy, boxx)
        SetColors(WHITE, BLACK)
        SetStyle(5)
        MessageBox("",{})
        SetStyle(1)
        
        return display_notes
end if

--additional text
printcolor( {boxy+8, boxx+1}, {YELLOW, BLUE}, "Text")
printcolor( {boxy+8, boxx+10}, {BRIGHT_WHITE, BLACK}, "                              ")
position(boxy+8, boxx+10)

text = get_max_str(30)

--now have quantity and text, add it to the notes, patient, client and VAT book
--? VAT exemptions here ?
--set defaults for note
new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
new_note[N_CLIENT_NO] = CurPatient[PA_CLIENT_NO]
new_note[N_DATE] = DateToStr(nowDate())
new_note[N_FEES] = selected_prod[PROD_SALES_PRICE] * quantity
new_note[N_DRUGS] = 0
new_note[N_VAT] = selected_prod[PROD_SALES_PRICE] * quantity * (selected_prod[PROD_VAT]/100)
new_note[N_TOTAL] = selected_prod[PROD_SALES_PRICE] * quantity * (1+(selected_prod[PROD_VAT]/100))
new_note[N_USER] = CurUser[U_INIT]
new_note[N_TYPE] = "S"
new_note[N_ANALYSIS] = "0"
new_note[N_NOTE] = selected_prod[PROD_ITEM] & " " & text

data_insert_note(new_note)

display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2f", {new_note[N_DATE], new_note[N_NOTE], new_note[N_TOTAL]}), CYAN} )  


--deceased flag
if selected_prod[PROD_STATUS][1] = 'X' then
        CurPatient[PA_STATUS][1] = 'X'
        CurPatient[PA_NAME] = remove_trailing_spaces(CurPatient[PA_NAME]) & "(D)"
end if  

--update patient in memory
CurPatient[PA_FEES] = CurPatient[PA_FEES] + new_note[N_FEES]
CurPatient[PA_VAT] = CurPatient[PA_VAT] + new_note[N_VAT]
CurPatient[PA_OUTS_BAL] = CurPatient[PA_OUTS_BAL] + new_note[N_TOTAL]

data_update_patient()

--update client in memory
CurClient[CL_FEES] += new_note[N_FEES]
CurClient[CL_VAT] += new_note[N_VAT]
CurClient[CL_OUTS_BAL] += new_note[N_TOTAL]

data_update_client()
paint_patient()


SetSize(10, 60)
position(boxy, boxx)
SetColors(WHITE, BLACK)
SetStyle(5)
MessageBox("",{})
SetStyle(1)

return display_notes
end function




---------------------------------------------------------------------------------------
function add_drug(sequence display_notes, sequence selected_prod)
---------------------------------------------------------------------------------------
sequence box, underline, text, new_note, new_dosage, dose_quantity, num_labels_str
object quantstr
integer boxy, boxx, num_labels, accept, c
atom quantity, total_cost

new_dosage = {}
dose_quantity = {}
quantstr = {}
num_labels_str = {}
num_labels = 0
new_note = repeat({}, 12)
c = 0

boxy = SCREEN_LINES-11
boxx = 1

--set defaults for note
new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
new_note[N_CLIENT_NO] = CurPatient[PA_CLIENT_NO]
new_note[N_DATE] = DateToStr(nowDate())
new_note[N_FEES] = 0
new_note[N_DRUGS] = 0
new_note[N_VAT] = 0
new_note[N_TOTAL] = 0
new_note[N_USER] = CurUser[U_INIT]
new_note[N_TYPE] = "D"
new_note[N_ANALYSIS] = "0"
new_note[N_NOTE] = ""


box = DefaultBox
SetSize(10, 60)
position(boxy, boxx)
SetColors(BRIGHT_WHITE, BLUE)

box = PlainBox(DefaultBox)
underline = repeat('=', length(selected_prod[PROD_ITEM]) )

printcolor( {boxy+1, boxx+1}, {YELLOW, BLUE}, selected_prod[PROD_ITEM])
printcolor( {boxy+1, boxx+length(selected_prod[PROD_ITEM])+2}, {GREEN, BLACK}, "Batch : " & selected_prod[PROD_BATCH_NUMBER])
printcolor( {boxy+2, boxx+1}, {YELLOW, BLUE}, underline)
printcolor( {boxy+3, boxx+1}, {YELLOW, BLUE}, "Cost (ex VAT)  :")
printcolor( {boxy+4, boxx+1}, {YELLOW, BLUE}, "VAT            :")
printcolor( {boxy+5, boxx+1}, {YELLOW, BLUE}, "Cost (inc VAT) :")
printcolor( {boxy+3, boxx+17}, {YELLOW, BLUE}, sprintf("%8.2f", {selected_prod[PROD_SALES_PRICE]}))
printcolor( {boxy+4, boxx+17}, {YELLOW, BLUE}, sprintf("%8.2f", {selected_prod[PROD_VAT]}))
printcolor( {boxy+5, boxx+17}, {YELLOW, BLUE}, sprintf("%8.2f", {selected_prod[PROD_SALES_PRICE] * (1+(selected_prod[PROD_VAT]/100))  }))

printcolor( {boxy+7, boxx+1}, {YELLOW, BLUE}, "Quantity")
printcolor( {boxy+7, boxx+10}, {BRIGHT_WHITE, BLACK}, "1           ")

position(boxy+7, boxx+10)

quantstr = get_max_str(10)

if length(quantstr) = 0 then quantstr = "1" end if

if quantstr[1] = 'I' then
        --info input / edit
end if  

--quantity
quantstr = remove_trailing_spaces(quantstr)
if length(quantstr) > 0 then
        quantity = strtoval(quantstr)
else quantity = 1
end if

if quantity = 0 then
        --clear the box, and return
        position(boxy, boxx) SetSize(10,60) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
        update_display_notes(display_notes)
        return display_notes 
end if

if quantity > 0 then
        --recalculate cost of product with dispensing fee
        total_cost = (selected_prod[PROD_SALES_PRICE] * (1+(selected_prod[PROD_VAT]/100)) ) * quantity +
                        (selected_prod[PROD_BASE_FEE] * (1+(selected_prod[PROD_VAT]/100)) )
        --? VAT exemptions ?
        --clear the top lines
        for i = 3 to 7 do
                printcolor( {boxy+i, boxx+1}, {YELLOW, BLUE}, "                         ")
        end for

        if equal(upper(selected_prod[PROD_DOSAGE]), "BID") then
                selected_prod[PROD_DOSAGE] = "twice daily"
        end if
        if equal(upper(selected_prod[PROD_DOSAGE]), "SID") then
                selected_prod[PROD_DOSAGE] = "once daily"
        end if
        if equal(upper(selected_prod[PROD_DOSAGE]), "TID") then
                selected_prod[PROD_DOSAGE] = "three times daily"
        end if
        if equal(upper(selected_prod[PROD_DOSAGE]), "QID") then
                selected_prod[PROD_DOSAGE] = "four times daily"
        end if

        selected_prod[PROD_PACK_UNITS] = remove_trailing_spaces(selected_prod[PROD_PACK_UNITS])
         if length(selected_prod[PROD_PACK_UNITS]) < 2 then
                selected_prod[PROD_PACK_UNITS] = {}
         end if

        printcolor( {boxy+3, boxx+1}, {YELLOW, BLUE}, sprintf("%-8.2f", {quantity}) & " " &  selected_prod[PROD_PACK_UNITS] & " at " & sprintf("%8.2f", {total_cost}))

        --dosing details
        if upper(selected_prod[PROD_GEN_LABEL][1]) = 'Y' then
                printcolor( {boxy+5, boxx+1}, {YELLOW, BLUE}, "Dosage :")
                printcolor( {boxy+6, boxx+1}, {BRIGHT_WHITE, BLACK}, "        ")
                --printcolor( {boxy+6, boxx+10}, {YELLOW, BLUE},selected_prod[PROD_PACK_UNITS] )
                printcolor( {boxy+6, boxx+12}, {BRIGHT_WHITE, BLACK}, "                                        ")
                printcolor( {boxy+6, boxx+12}, {BRIGHT_WHITE, BLACK}, selected_prod[PROD_DOSAGE] )
                
                position(boxy+6, boxx+1)
                dose_quantity = remove_trailing_spaces(get_max_str(10))
                
                position(boxy+6, boxx+12)
                new_dosage = remove_trailing_spaces(get_max_str(42))
        end if
        
        --label dosage
        if length(new_dosage) = 0 then 
                new_dosage = dose_quantity & " " & selected_prod[PROD_DOSAGE]
        else
                new_dosage = dose_quantity & " " & new_dosage
        end if
             
        --label?
        --(lines 7,8,9 available in box)
        --decide here whether to print a label, or add to a dispensing list
        --dispensing list creates a popup for the _CLIENT_, so that when
        --the client is brought up, a list of drugs, with batch numbers
        --is brought up, that can be edited, so as to update batch number tracking
        --items are added to batch tracking automatically at point of entry onto the
        --notes, but batch number can be edited from the dispensing list, or by re-doing a printed
        --label with a new batch on.
        --once an item has been dispensed, it is removed from the dispensing list

        
        while 1 do
                if upper(selected_prod[PROD_GEN_LABEL][1]) = 'Y' then
                        printcolor( {boxy+8, boxx+1}, {YELLOW, BLUE}, "Enter - label quantity, D dispense, B batch number")
                        printcolor( {boxy+9, boxx+1}, {BRIGHT_WHITE, BLACK}, "D    ")
                        position(boxy+9, boxx+1)
                        num_labels_str = remove_trailing_spaces(get_max_str(4))
                        if length(num_labels_str) > 0 then
                                num_labels = strtoval(num_labels_str)
                        elsif  length(num_labels_str) = 0 then
                                num_labels_str = "D"
                                num_labels = 0
                        end if 
                else
                        num_labels = -1
                        num_labels_str = "-"
                end if  
                
                if upper(num_labels_str[1]) = 'B' then
                        printcolor( {boxy+1, boxx+length(selected_prod[PROD_ITEM])+2}, {GREEN, BLACK}, "Batch : " & repeat(' ', length(selected_prod[PROD_BATCH_NUMBER])))
                        selected_prod = update_batch(selected_prod)
                        printcolor( {boxy+1, boxx+length(selected_prod[PROD_ITEM])+2}, {GREEN, BLACK}, "Batch : " & selected_prod[PROD_BATCH_NUMBER])
                elsif upper(num_labels_str[1]) = 'D' then
                        --add to dispensing list
                        num_labels = 0
                        exit 
                else 
                        exit
                end if  
        end while                

        --accept drug onto notes ?, or update the batch number
        if upper(selected_prod[PROD_GEN_LABEL][1]) = 'Y' then 
                printcolor( {boxy+9, boxx+18}, {BRIGHT_WHITE, RED}, "Accept (y/n)[y]")
                accept = wait_key()
        else
                while 1 do
                        printcolor( {boxy+9, boxx+10}, {BRIGHT_WHITE, RED}, "Accept (y/n)[y], or B to update batch number")
                        accept = wait_key()
                        if upper(accept) = 'B' then
                                printcolor( {boxy+1, boxx+length(selected_prod[PROD_ITEM])+2}, {GREEN, BLACK}, "Batch : " & repeat(' ', length(selected_prod[PROD_BATCH_NUMBER])))
                                selected_prod = update_batch(selected_prod)
                                printcolor( {boxy+1, boxx+length(selected_prod[PROD_ITEM])+2}, {GREEN, BLACK}, "Batch : " & selected_prod[PROD_BATCH_NUMBER])
                        else
                                exit
                        end if
                end while
        end if
        
        if upper(accept) = 'N' then
                --don't add anything, just return
                --clear the box
                position(boxy, boxx) SetSize(10,60) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
                update_display_notes(display_notes)
                return(display_notes)
        end if

        update_batch_tracking_database( num_labels_str,
                                        selected_prod,
                                        new_dosage,
                                        quantity
                                        ) --and dispensing list

        
        --has been accepted, and flagged for adding then, add it to the dispensing list
        --if num_labels_str[1] = 'D' then
        --end if

        if num_labels > 0 then
                --print label
                printers_drug_label(selected_prod, new_dosage, num_labels)
        end if
        
        --add to notes
        --first drug itself
        new_note[N_FEES] = selected_prod[PROD_SALES_PRICE] * quantity + selected_prod[PROD_BASE_FEE]
        new_note[N_VAT] = new_note[N_FEES] * (selected_prod[PROD_VAT]/100)
        new_note[N_TOTAL] = new_note[N_FEES] + new_note[N_VAT]
        new_note[N_NOTE] = sprintf("%.2f %s %s", {quantity, selected_prod[PROD_PACK_UNITS], selected_prod[PROD_ITEM]} )

        display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2f", {new_note[N_DATE], new_note[N_NOTE], new_note[N_TOTAL]}), GREEN} )  
        data_insert_note(new_note)
        
        --update patient in memory
        CurPatient[PA_FEES] = CurPatient[PA_FEES] + new_note[N_FEES]
        CurPatient[PA_VAT] = CurPatient[PA_VAT] + new_note[N_VAT]
        CurPatient[PA_OUTS_BAL] = CurPatient[PA_OUTS_BAL] + new_note[N_TOTAL]
        
        data_update_patient()
        
        --update client in memory
        CurClient[CL_FEES] += new_note[N_FEES]
        CurClient[CL_VAT] += new_note[N_VAT]
        CurClient[CL_OUTS_BAL] += new_note[N_TOTAL]
        
        data_update_client()
        paint_patient()
        
        --next create label line
        if num_labels > -1 then
                new_note[N_FEES] = 0
                new_note[N_VAT] = 0
                new_note[N_TOTAL] = 0
                new_note[N_NOTE] = sprintf("@ %-s", {new_dosage} )
                new_note[N_TYPE] = "T"
        
                display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2f", {new_note[N_DATE], new_note[N_NOTE], new_note[N_TOTAL]}), WHITE} )  
                data_insert_note(new_note)
        end if
        
end if --end of quantity > 0

if quantity < 0 then --credit it
    if selected_prod[PROD_BASE_FEE] > 0 then
        c = upper(get_yn_box("Credit the dispensing fee too? (y/n)[n]")   )
        if c != 'Y' then selected_prod[PROD_BASE_FEE] = 0 end if
    end if

        --add to notes
        --first drug itself
        new_note[N_FEES] = selected_prod[PROD_SALES_PRICE] * quantity - selected_prod[PROD_BASE_FEE]
        new_note[N_VAT] = new_note[N_FEES] * (selected_prod[PROD_VAT]/100)
        new_note[N_TOTAL] = new_note[N_FEES] + new_note[N_VAT]
        new_note[N_NOTE] = sprintf("%.2f %s %s", {quantity, selected_prod[PROD_PACK_UNITS], selected_prod[PROD_ITEM]} )

        display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2f", {new_note[N_DATE], new_note[N_NOTE], new_note[N_TOTAL]}), GREEN} )  
        data_insert_note(new_note)
        
        --update patient in memory
        CurPatient[PA_FEES] = CurPatient[PA_FEES] + new_note[N_FEES]
        CurPatient[PA_VAT] = CurPatient[PA_VAT] + new_note[N_VAT]
        CurPatient[PA_OUTS_BAL] = CurPatient[PA_OUTS_BAL] + new_note[N_TOTAL]
        
        data_update_patient()
        
        --update client in memory
        CurClient[CL_FEES] += new_note[N_FEES]
        CurClient[CL_VAT] += new_note[N_VAT]
        CurClient[CL_OUTS_BAL] += new_note[N_TOTAL]
        
        data_update_client()
        paint_patient()



end if --end of quantity < 0


position(boxy, boxx) SetSize(10,60) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
update_display_notes(display_notes)

return display_notes
end function

---------------------------------------------------------------------------------------
function add_priced_item(sequence display_notes)
--main function for adding products
---------------------------------------------------------------------------------------
sequence new_note, search_prod, matching_prods, matching_items, selected_prod
integer choice, current_choice

--basic form
--entry to search for product
--select from matching list
--reminder from past
--      Notes - is a list of notes from the database
--      display_notes is what is displayed
--      need to add to both, and store any new notes to database
--global Product will contain the currently selected product

CurPatient[PA_FEES] = strtoval(CurPatient[PA_FEES])
CurPatient[PA_VAT] = strtoval(CurPatient[PA_VAT])
CurPatient[PA_OUTS_BAL] = strtoval(CurPatient[PA_OUTS_BAL])

search_prod = ""
matching_prods = {}
matching_items = {}
selected_prod = {}
current_choice = 1
choice = 1

--input box
position(SCREEN_LINES - 5, 1)
SetColors(BRIGHT_WHITE, BLUE)
search_prod = Form("Add Priced item", {"Enter selection", "", 20})

search_prod = remove_trailing_spaces(search_prod[1])

if length(search_prod) = 0 then
        return display_notes
end if

matching_prods = query_database("xprods.sql", "SELECT * FROM Products where item LIKE '" & search_prod & "%' ORDER BY item")

if length(matching_prods) = 0 then
        VOID = get_yn_box("Sorry, no matches.")
        display_notes = add_priced_item(display_notes) --recursion!
        return display_notes
end if

--now create a list of matching items
for i = 2 to length(matching_prods) do
        matching_items = append(matching_items, matching_prods[i][PROD_ITEM])
end for

current_choice = 1
while 1 do
        SetSize(14, 40)
        position(SCREEN_LINES-15, 1)
        SetColors(BRIGHT_WHITE, BLUE)
        choice = ListBoxIndex("Select", matching_items, current_choice)

        current_choice = choice
        
        if choice = -1 then exit end if
        
        if choice > 0 then
                selected_prod = matching_prods[choice+1] --because of the data query title line
                exit
        end if
        
end while

--normalise selected_prod fields, as now start using them as numbers!
selected_prod = data_validate_product(selected_prod)

--clear the box
SetSize(14, 40)
position(SCREEN_LINES-15, 1)
SetColors(WHITE, BLACK)
SetStyle(5)
MessageBox("",{})
SetStyle(1)

--remember Notes, current client, current patient are all global
if selected_prod[PROD_TYPE][1] = 'S' then
        --service
        display_notes = add_service(display_notes, selected_prod)       
elsif selected_prod[PROD_TYPE][1] = 'D' then
        --drug
        display_notes = add_drug(display_notes, selected_prod)  
end if


update_display_notes(display_notes)
display_notes = add_priced_item(display_notes)

return display_notes
end function

---------------------------------------------------------------------------------------
function add_text(sequence display_notes)
--main function for adding text
---------------------------------------------------------------------------------------
sequence new_text, form_display, new_note
integer screen_top, Ncolor

new_note = repeat({}, 12)
new_text = repeat("", SCREEN_LINES - 11)
screen_top = 9

form_display = {}
for i = 1 to SCREEN_LINES - 11 do
    form_display = append(form_display,"           ")
    form_display = append(form_display,"")
    form_display = append(form_display,60)
end for
form_display[1] = DateToStr(nowDate())

position(screen_top, 1)
SetColors(BLACK, WHITE)
WORD_WRAP = TRUE
new_text = Form("", form_display )
WORD_WRAP = FALSE

--set defaults for note
new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
new_note[N_CLIENT_NO] = CurPatient[PA_CLIENT_NO]
new_note[N_DATE] = form_display[1]
new_note[N_FEES] = 0
new_note[N_DRUGS] = 0
new_note[N_VAT] = 0
new_note[N_TOTAL] = 0
new_note[N_USER] = CurUser[U_INIT]
new_note[N_TYPE] = "T"
new_note[N_ANALYSIS] = "0"
Ncolor = WHITE

for i = 1 to length(new_text) do
    new_text[i] = remove_trailing_spaces(new_text[i])

    if length(new_text[i]) > 0 then
        --convert new_text to saveable format, and displayable format
        new_note[N_NOTE] = new_text[i]

        --add note to display list
        --display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2f", {form_display[1], new_note[N_NOTE], strtoval(new_note[N_TOTAL])}), Ncolor} )  
        display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2s", {form_display[1], new_note[N_NOTE], "        "}), Ncolor} )

        --add note to notes database
        data_insert_note(new_note)

    end if

end for

return display_notes
end function



---------------------------------------------------------------------------------------
function add_wt(sequence display_notes, sequence wt)
---------------------------------------------------------------------------------------
sequence new_note
integer Ncolor

new_note = repeat({}, 12)

if strtoval(wt) = 0 then
        return display_notes
end if

--set defaults for note
new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
new_note[N_CLIENT_NO] = CurPatient[PA_CLIENT_NO]
new_note[N_DATE] =  DateToStr(nowDate())
new_note[N_FEES] = 0
new_note[N_DRUGS] = 0
new_note[N_VAT] = 0
new_note[N_TOTAL] = 0
new_note[N_USER] = CurUser[U_INIT]
new_note[N_TYPE] = "W"
new_note[N_ANALYSIS] = "0"
Ncolor = BROWN

new_note[N_NOTE] = remove_trailing_spaces(wt) & " " & "kg"

display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2s", {new_note[N_DATE], new_note[N_NOTE], "        "}), Ncolor} )

--add note to notes database
data_insert_note(new_note)

--update the patient weight
CurPatient[PA_WEIGHT] = strtoval(wt)
data_update_patient()

return display_notes
end function

---------------------------------------------------------------------------------------
global procedure load_notes()
--uses global CurPatient to ref notes
---------------------------------------------------------------------------------------
sequence cmd, data

Notes = {}

sql_db = sqlite_open("xnotes.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open database")
        abort(0)
end if

cmd = "SELECT * from Notes WHERE patient_no = " & sprintf("%d", {CurPatient[PA_PATIENT_NO]}) --& " AND client_no = " & sprintf("%d", {CurClient[CL_CLIENT_NO]})

    data = query(sql_db, cmd)
    if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error loading notes : " & sqlite_last_err_desc)
    end if

sqlite_close(sql_db)

if length(data) > 0 then
        for i = 2 to length(data) do
                Notes = append(Notes, data[i])
        end for
end if

end procedure


---------------------------------------------------------------------------------------
global procedure display_notes()
---------------------------------------------------------------------------------------
integer screen_length, screen_top, screen_bot, first_note, last_note, Ncolor, key,
        bmChoice
sequence display_notes, ud, bot_menu, data, wt

screen_length = SCREEN_LINES - 8
screen_top = 7
screen_bot = SCREEN_LINES - 3
display_notes = {}
ud = ""
bot_menu = { {"Quit",1}, {"Add text", 6}, {"Priced item", 15}, {"Keycard", 27} }
bmChoice = 1

--create list of display notes first
if length(Notes) > 0 then
        for i = 1 to length(Notes) do
                if i > 1 then
                        --has the previous date changed - if not, then print user instead of date.
                        if compare(Notes[i][N_DATE], Notes[i-1][N_DATE]) != 0 then
                                ud = Notes[i][N_DATE]
                        else
                                ud = Notes[i][N_USER]
                        end if
                else ud = Notes[i][N_DATE]
                end if
                
                if Notes[i][N_TYPE][1] = 'S' then Ncolor = CYAN 
                elsif Notes[i][N_TYPE][1] = 'D' then Ncolor = GREEN 
                elsif Notes[i][N_TYPE][1] = 'P' then Ncolor = RED 
                elsif Notes[i][N_TYPE][1] = 'W' then Ncolor = BROWN
                elsif Notes[i][N_TYPE][1] = 'A' then Ncolor = BLUE
                else Ncolor = WHITE 
                end if
                
        if strtoval(Notes[i][N_TOTAL]) != 0 then
                    display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2f", {ud, Notes[i][N_NOTE], strtoval(Notes[i][N_TOTAL])}), Ncolor} )  
        else
                    display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2s", {ud, Notes[i][N_NOTE], "        "}), Ncolor} )  
        end if
        end for
else
        display_notes = append(display_notes, {sprintf("%-11.11s%-60.60s%8.2f", {"--", "--", 0}), WHITE} )
end if

last_note = length(display_notes)
if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if

--check for popups
data = popups_check('P')
if length(data) > 0 then
        Popup[POP_COP] = "P"
        popups_show(data)
end if


--create screen bottom menu
for i = 1 to length(bot_menu) do
        printcolor( {SCREEN_LINES, bot_menu[i][2]}, {BRIGHT_WHITE, BLACK}, bot_menu[i][1] & "       ")
end for 
printcolor( {SCREEN_LINES, bot_menu[1][2]}, {BLACK, WHITE}, bot_menu[1][1])

--enter the display loop
while 1 do
        for i = first_note to last_note do
                printcolor( {i-first_note + screen_top, 1}, {display_notes[i][2], BLACK}, display_notes[i][1])  
        end for

        printcolor( {SCREEN_LINES, 35}, {BLACK, CYAN}, "User : " & CurUser[U_INIT] & " Branch : " & globalSettings[GS_BRANCH])
                
        key = upper(wait_key()) 
        
        if key = 'K' or (key = ENTER and bmChoice = 4) then
                key = upper(keycard_keycard())
                paint_patient()
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
                for i = first_note to last_note do
                        printcolor( {i-first_note + screen_top, 1}, {display_notes[i][2], BLACK}, display_notes[i][1])  
                end for
        end if

        if key = 'Q' or (key = ENTER and bmChoice = 1) then exit end if
        
        if key = up then
                first_note -= 1
                if first_note > 0 then
                        last_note -= 1
                else first_note = 1
                end if
        end if
        
        if key = dn then
                last_note += 1
                if last_note > length(display_notes) then
                        last_note = length(display_notes)
                else first_note += 1
                end if
        end if
        
        if key = pgup then
                first_note -= screen_length
                if first_note < 1 then
                        first_note = 1
                end if
                last_note = first_note+screen_length
                if last_note > length(display_notes) then
                        last_note = length(display_notes)
                end if
        end if
        
        if key = pgdn then
                last_note += screen_length
                if last_note >  length(display_notes) then
                        last_note = length(display_notes)
                end if
                first_note = last_note-screen_length
                if first_note < 1 then
                        first_note = 1
                        last_note = first_note + screen_length
                        if last_note > length(display_notes) then
                                last_note = length(display_notes)
                        end if
                        
                end if
        end if
        
        if key = right then
                printcolor( {SCREEN_LINES, bot_menu[bmChoice][2]}, {BRIGHT_WHITE, BLACK}, bot_menu[bmChoice][1])
                bmChoice += 1
                if bmChoice > length(bot_menu) then bmChoice -=1 end if
                printcolor( {SCREEN_LINES, bot_menu[bmChoice][2]}, {BLACK, WHITE}, bot_menu[bmChoice][1])
        end if
        
        if key = left then
                printcolor( {SCREEN_LINES, bot_menu[bmChoice][2]}, {BRIGHT_WHITE, BLACK}, bot_menu[bmChoice][1])
                bmChoice -= 1
                if bmChoice < 1 then bmChoice =1 end if
                printcolor( {SCREEN_LINES, bot_menu[bmChoice][2]}, {BLACK, WHITE}, bot_menu[bmChoice][1])
        end if
        
        if key = 'A' or (key = ENTER and bmChoice = 2) then
                display_notes = add_text(display_notes)
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if

        if key =  'I' or (key = ENTER and bmChoice = 3) then
                display_notes = add_priced_item(display_notes)
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if
        
        if key = 'P' then
                --check for popups
                data = popups_check('P')
                Popup[POP_COP] = "P"
                popups_show(data)
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if
        
        if key = 'F' then
                --free hand label
                keycard_freehand_label()
        end if

        if key = 'D' then
                --client / patient label
                keycard_patient_label()
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if
        
        if key = 'L' then
                --list notes
                keycard_list_notes()
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if

        if key = 'W' then
                --weight
                wt = keycard_weight()

                --now need to add wt to notes
                display_notes = add_wt(display_notes, wt)
                paint_patient()
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if
        
        if key = 'M' then
                keycard_make_appt()
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
                paint_patient()
                --recreate screen bot menu
                for i = 1 to length(bot_menu) do
                        printcolor( {SCREEN_LINES, bot_menu[i][2]}, {BRIGHT_WHITE, BLACK}, bot_menu[i][1] & "       ")
                end for 
                printcolor( {SCREEN_LINES, bot_menu[bmChoice][2]}, {BLACK, WHITE}, bot_menu[bmChoice][1])
        end if
        
        if key = 'B' then
                --get a fresh set of Notes
                load_notes()
                keycard_bill_today()    
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if
        
        if key = 'C' then
                keycard_change_user()
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
        end if
        
        if key = 'E' then
                --using wt as variable, as saves creating another one - wt is a sequence
                wt = estimates(CurClient[CL_CLIENT_NO])
                last_note = length(display_notes)
                if last_note > screen_length then first_note = last_note - screen_length else first_note = 1 end if
                paint_patient()
        end if
        
                
end while


end procedure



---------------------------------------------------------------------------------------
global procedure notes()
--have CurClient and CurPatient loaded, just need to paint and list notes now
---------------------------------------------------------------------------------------

--first clear the patient list box!
SetSize(SCREEN_LINES - 13, 78)
position(12,1)
SetColors(WHITE, BLACK)
SetStyle(5)
MessageBox("", {} )
SetStyle(1)


clear_screen()
paint_patient()

printcolor( {SCREEN_LINES, 1}, {WHITE + BLINKING, BLACK}, "Retrieving notes...")
load_notes() --loading into a global sequence
display_notes()


end procedure

---------------------------------------------------------------------------------------
global function load_all_patients_list(integer req_client)
---------------------------------------------------------------------------------------
sequence patientlist, cmd, data
patientlist = {}

--open the database
sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open database")
        abort(0)
end if

cmd = "SELECT * FROM Patients WHERE client_no = " & sprintf("%d", req_client )
        
data = query(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error : " & sqlite_last_err_desc)
end if
sqlite_close(sql_db)

if length(data) = 0 then --there are no patients - need to add some, if you want of course
        return patientlist
end if

for i = 2 to length(data) do
        patientlist = append(patientlist, data[i])
end for


return patientlist
end function
rid_load_all_patients = routine_id("load_all_patients_list")

---------------------------------------------------------------------------------------
global function load_patient_list(integer req_client)
---------------------------------------------------------------------------------------
sequence patientlist, cmd, data
patientlist = {}

--open the database
sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open database")
        abort(0)
end if

--select the patients
-- cmd = "SELECT patient_no, client_no, type, name, dob, species, sex, breed, colour, insured, " &
--      "microchip, status, weight, fees, drugs, vat, outs_bal, " &
--      "farm_name, farm_type, herd_ref, height, tattoo " & 
--      "FROM Patients WHERE client_no = " & sprintf("%d", req_client )

cmd = "SELECT * FROM Patients WHERE client_no = " & sprintf("%d", req_client )
         --& " AND (status NOT LIKE 'X%'" &" AND outs_bal = 0)"
        --mileage
        
data = query(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error : " & sqlite_last_err_desc)
end if
sqlite_close(sql_db)

if length(data) = 0 then --there are no patients - need to add some, if you want of course
        return patientlist
end if

for i = 2 to length(data) do
        --check for 'deadness' +/- money owing
        if upper(data[i][PA_STATUS][1]) != 'X' then
                patientlist = append(patientlist, data[i])
        else
                if strtoval(data[i][PA_OUTS_BAL]) != 0 then
                        patientlist = append(patientlist, data[i])
                end if          
        end if
end for


return patientlist
end function
rid_load_all_live_patients = routine_id("load_patient_list")
rid_load_patient_list = rid_load_all_live_patients

---------------------------------------------------------------------------------------
global procedure load_client(integer req_client)
---------------------------------------------------------------------------------------
sequence cmd, data
--open the database
sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open database")
        abort(0)
end if

--get the current client
cmd = "SELECT * FROM Clients WHERE client_no = " & sprintf("%d", req_client )
data = query(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error : " & sqlite_last_err_desc)
end if
sqlite_close(sql_db)

CurClient = data[2]

--validate client - convert number strings to actual numbers
CurClient = data_validate_client(CurClient)


--load PDSA details (if any)
PDSAPatient = repeat({}, 8)
cmd = "SELECT * FROM PDSA WHERE client_no = " & sprintf("%d", req_client )
data = query_database("xclipats.sql", cmd)

if length(data) > 1 then
        PDSAPatient = data[2]
        PDSAPatient[PDSA_CLIENT_NO] = strtoval(PDSAPatient[PDSA_CLIENT_NO])
        PDSAPatient[PDSA_PATIENT_NO] = strtoval(PDSAPatient[PDSA_PATIENT_NO])
        data_validate_PDSAPatient()
end if

        
end procedure

---------------------------------------------------------------------------------------
procedure a2wr(sequence patient, sequence wtype)
---------------------------------------------------------------------------------------
sequence reason_to_see
reason_to_see = ""

if wtype[1] = 'B' then
        reason_to_see = "Being seen"
end if
if wtype[1] = 'P' then
        reason_to_see = "To pay"
end if

call_proc(rid_a2wr,{CurClient[CL_CLIENT_NO],
                        strtoval(patient[PA_PATIENT_NO]),
                        CurClient[CL_SURNAME],
                        patient[PA_NAME],
                        reason_to_see,
                        wtype})
diary_flag = 0
end procedure



---------------------------------------------------------------------------------------
global procedure client_patient_page(sequence scp)
---------------------------------------------------------------------------------------
sequence patientlist, pl, cmd, data
integer choice, current_choice, current_menu, menu_limit, wr_added,
        deceased_counter
sequence menu_choices

wr_added = FALSE

menu_choices = {{"Quit",1}, {"Menu",7}, {"Notes",13}, {"Payment",19}, {"A2WR",27}}
menu_limit = length(menu_choices)

data = {}
patientlist = {}
pl = {}
current_choice = 1
current_menu = 3

load_client(scp[1])
paint_client()

--check if have to add a patient
if scp[2] = 0 then 
            
end if

patientlist = load_patient_list(scp[1] )

if length(patientlist) = 0 then --may have no live patients - just check by loading all patients
    patientlist = load_all_patients_list(scp[1] )
end if

if length(patientlist) = 0 then --still no patients, go straight to adding a patient
    scp = add_patient(scp[1] )
    patientlist = load_all_patients_list(scp[1] )
end if

--display list of patients in list box - selecting bits that aid display of course
for i = 1 to length(patientlist) do
        pl = append(pl,  sprintf("%-10.10s %2.2s %-10.10s %-10.10s %-3.3s %10.2f", 
                                {patientlist[i][PA_NAME], patientlist[i][PA_TYPE], patientlist[i][PA_SPECIES], patientlist[i][PA_BREED],patientlist[i][PA_SEX],
                                strtoval(patientlist[i][PA_OUTS_BAL]) } ) )  
end for

for i = 1 to length(patientlist) do
        if scp[2] = strtoval(patientlist[i][PA_PATIENT_NO]) then
                current_choice = i
        end if
end for

--change wr list to 'being seen'
a2wr(patientlist[current_choice], "B")


--check for dispensed drugs
cmd = sprintf("SELECT * FROM DispList WHERE client_no = %d", {CurClient[CL_CLIENT_NO]} )
data = query_database("xbatch.sql", cmd) 
if length(data) > 0 then
        VOID = dispense_meds(data[2..$])        --in clients_batch_tracking.ex
end if

paint_client()

--check for popups
data = popups_check('C')
if length(data) > 0 then
        Popup[POP_COP] = "C"
        popups_show(data)
        paint_client()
end if

--display menu choices
SetColors(WHITE, BLACK)
for i = 1 to 5 do
        printcolor( {SCREEN_LINES, menu_choices[i][2]}, {BRIGHT_WHITE,BLACK}, menu_choices[i][1] & "        " )
end for

printcolor( {SCREEN_LINES, menu_choices[current_menu][2]}, {BLACK, WHITE}, menu_choices[current_menu][1] )

while 1 do
        SetSize(SCREEN_LINES - 13, 78)
        position(12,1)
        SetColors(BLACK, GREEN)
        --choice = ListBoxIndex("Patients", pl, current_choice)
        choice = ListBoxIndex("", pl, current_choice)

        if choice = -1 then exit end if

        current_choice = choice         
        CurPatient = data_validate_patient(patientlist[current_choice]) --load the selected patient into memory, for use throughout the program

        if LIST_KEY != 0 then
        if upper(LIST_KEY) = 'Q' then exit end if
        
        if upper(LIST_KEY) = 'N' then
                --going to the notes, so validate the current patient
                --CurPatient = data_validate_patient(CurPatient)
                notes()
                paint_client()
                --update pl values
                patientlist[choice] = CurPatient
                pl[choice] = sprintf("%-10.10s %2.2s %-10.10s %-10.10s %-3.3s %10.2f", 
                                {patientlist[choice][PA_NAME], patientlist[choice][PA_TYPE], patientlist[choice][PA_SPECIES], patientlist[choice][PA_BREED],patientlist[choice][PA_SEX],
                                strtoval(CurPatient[PA_OUTS_BAL]) } ) 
        end if

        if upper(LIST_KEY) = 'D' then
                --also show/hide deceased
                patientlist = load_all_patients_list(scp[1])
                pl = {}
                for i = 1 to length(patientlist) do
                        
                        pl = append(pl,  sprintf("%-10.10s %2.2s %-10.10s %-10.10s %-3.3s %10.2f", 
                                                {patientlist[i][PA_NAME], patientlist[i][PA_TYPE], patientlist[i][PA_SPECIES], patientlist[i][PA_BREED],patientlist[i][PA_SEX],
                                                strtoval(patientlist[i][PA_OUTS_BAL]) } ) ) 
                        --if patientlist[i][PA_STATUS][1] = 'X' then
                        --        pl[i] = pl[i] & " (D)"
                        --end if                               
                end for

        end if                               
        
        if LIST_KEY = ENTER then --check the bottom screen menu
            if current_menu = 1 then exit end if
            
            if current_menu = 2 then
                new_pl = {}
                client_sub_menu()
                --will use a locally global variable to check for changes in patient list
                --note - new_pl -> patientlist, NOT pl
                if length(new_pl) > 0 then
                        --replace current patient list, and update pl
                        patientlist = new_pl
                        pl = {}
                        deceased_counter = 0
                        for i = 1 to length(patientlist) do
                                
                                pl = append(pl,  sprintf("%-10.10s %2.2s %-10.10s %-10.10s %-3.3s %10.2f", 
                                                        {patientlist[i][PA_NAME], patientlist[i][PA_TYPE], patientlist[i][PA_SPECIES], patientlist[i][PA_BREED],patientlist[i][PA_SEX],
                                                        strtoval(patientlist[i][PA_OUTS_BAL]) } ) )  
                                if patientlist[i][PA_STATUS][1] = 'X' then
                                        pl[i] = pl[i] & " (D)"
                                        deceased_counter += 1
                                end if                               
                        end for
                        if deceased_counter = 0 then
                                --a new patient has been added, set selection bar to the new one
                                choice = length(patientlist)
                                current_choice = choice
                        end if
                else                    
                        --update pl values
                        patientlist[choice] = CurPatient
                        pl[choice] = sprintf("%-10.10s %2.2s %-10.10s %-10.10s %-3.3s %10.2f", 
                                        {patientlist[choice][PA_NAME], patientlist[choice][PA_TYPE], patientlist[choice][PA_SPECIES], patientlist[choice][PA_BREED],patientlist[choice][PA_SEX],
                                        strtoval(CurPatient[PA_OUTS_BAL]) } ) 
                end if
                
            
            end if              
                
            if current_menu = 3 then
                --notes 
                notes()
                paint_client()
                --update pl values
                patientlist[choice] = CurPatient
                pl[choice] = sprintf("%-10.10s %2.2s %-10.10s %-10.10s %-3.3s %10.2f", 
                                {patientlist[choice][PA_NAME], patientlist[choice][PA_TYPE], patientlist[choice][PA_SPECIES], patientlist[choice][PA_BREED],patientlist[choice][PA_SEX],
                                strtoval(CurPatient[PA_OUTS_BAL]) } )   
            end if
            
            if current_menu = 4 then
                --take a payment
                patientlist = payments(patientlist, current_choice)
                paint_client()
                --refresh the pl from patientlist
                for i = 1 to length(patientlist) do
                        pl[i] = sprintf("%-10.10s %2.2s %-10.10s %-10.10s %-3.3s %10.2f", 
                                        {patientlist[i][PA_NAME], patientlist[i][PA_TYPE], patientlist[i][PA_SPECIES], patientlist[i][PA_BREED],patientlist[i][PA_SEX],
                                        strtoval(patientlist[i][PA_OUTS_BAL]) } ) 
                end for
            end if
            
            if current_menu = 5 then
                a2wr(patientlist[current_choice], "W")
                wr_added = TRUE
            end if

        end if

        if LIST_KEY = left then
            printcolor( {SCREEN_LINES, menu_choices[current_menu][2]}, {BRIGHT_WHITE,BLACK}, menu_choices[current_menu][1] )
            current_menu -= 1
            if current_menu = 0 then current_menu = 1 end if
            printcolor( {SCREEN_LINES, menu_choices[current_menu][2]}, {BLACK, WHITE}, menu_choices[current_menu][1] )
        end if

        if LIST_KEY = right then
            printcolor( {SCREEN_LINES, menu_choices[current_menu][2]}, {BRIGHT_WHITE,BLACK}, menu_choices[current_menu][1] )
            current_menu += 1
            if current_menu > menu_limit then current_menu = menu_limit end if
            printcolor( {SCREEN_LINES, menu_choices[current_menu][2]}, {BLACK, WHITE}, menu_choices[current_menu][1] )

        end if

    end if
        
        for i = 1 to 5 do
                printcolor( {SCREEN_LINES, menu_choices[i][2]}, {BRIGHT_WHITE,BLACK}, menu_choices[i][1] & "        " )
        end for
        printcolor( {SCREEN_LINES, menu_choices[current_menu][2]}, {BLACK, WHITE}, menu_choices[current_menu][1] )

end while  

--check waiting room add / remove stuff
if CurClient[CL_OUTS_BAL] != 0 and wr_added = FALSE then
        a2wr(patientlist[current_choice], "P")
        wr_added = TRUE
end if

if wr_added = FALSE then
        if CurClient[CL_OUTS_BAL] != 0 then
                a2wr(patientlist[current_choice], "P")
        else
                if called_from_wr = TRUE then
                        if upper(get_yn_box("Balance 0 - remove from waiting room (y/n)[n]") ) = 'Y' then
                                call_proc(rid_rmfwr, {CurClient[CL_CLIENT_NO]} )
                        else
                               a2wr(patientlist[current_choice], "w") 
                        end if                       
                else
                        call_proc(rid_rmfwr, {CurClient[CL_CLIENT_NO]} )
                end if
        end if
end if     
        
end procedure


---------------------------------------------------------------------------------------
global function find_client()
---------------------------------------------------------------------------------------
--this is mostly initial test for database
sequence SearchClient, cmd, data, tmp, tmp2, val
sequence CList, CPList, CPAList 


SearchClient = repeat({},3)
CList = {}
CPList = {}
CPAList = {}
tmp = {}

position(6,6)
SetSize(8,50)
if diary_flag = FALSE then
        SetColors(BLACK, GREEN)
else
        SetColors(BRIGHT_WHITE, BLUE)
end if
SCREEN_BKGND = BLACK
SearchClient = Form("Find a client - enter part or all details",
                        {"Surname      ", SearchClient[1], 25,
                         "Animal name  ", SearchClient[2], 25,
                         "Address      ", SearchClient[3], 25                   
                        })

for i = 1 to 3 do
        SearchClient[i] = remove_trailing_spaces(SearchClient[i])
end for

--position(1,1)
--for i = 1 to 3 do
--    printf(1, "%s, %d\n", {SearchClient[i], length(SearchClient[i])})
--end for
--VOID = wait_key()


if length(SearchClient[1]) = 0 and length(SearchClient[2]) = 0 and length(SearchClient[3]) = 0 then
    --haven't searched for anything
    return 0
end if

--cmd = "SELECT Client.client_no, patient_no, surname, name FROM Client, Patient "    &
--        "WHERE surname LIKE '" & escape_quotes(SearchClient[1]) & "%' "              
--        "AND name LIKE '" & escape_quotes(SearchClient[2]) & "%' "                  &
--        "AND Client.client_no = Patient.client_no "                               

--cmd = "SELECT client_no, surname, address1  FROM Client WHERE surname LIKE " & "'" & escape_quotes(SearchClient[1]) & "%'"
--cmd = "SELECT surname, address1 FROM Client WHERE (surname LIKE 'smi%')"

--cmd = "SELECT patient_no, client_no, name FROM Patient WHERE client_no =  " & --& escape_quotes(SearchClient[2]) & "%'" &
        --"ORDER BY client_no"

--cmd = "SELECT COUNT(*) FROM Patient"

-- cmd =        "SELECT Client.client_no patient_no, surname, name FROM Client, Patient " &
--      "WHERE surname LIKE '" & escape_quotes(SearchClient[1]) & "%'" &
--      "AND Client.client_no = Patient.client_no"

--cmd = "SELECT patient_no, client_no, name FROM Patient ORDER BY client_no"



sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open database")
        abort(0)
end if


--search if client name is a number
val = value(SearchClient[1])
if val[2] > 0 then
    cmd = "SELECT Clients.client_no, Patients.patient_no, surname, name, address1 FROM Clients, Patients "    &
            "WHERE Clients.client_no = " & sprintf("%d", {val[2]}) &
            "AND Clients.client_no = Patients.client_no "
    data = query(sql_db, cmd)
    if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error : " & sqlite_last_err_desc)
    end if

sqlite_close(sql_db)
return data
end if

--search if client , animal optional, no address
if length(SearchClient[1]) > 0 and length(SearchClient[3]) = 0 then
    data = {}
    cmd = "SELECT Clients.client_no, Patients.patient_no, surname, name, address1 FROM Clients, Patients "    &
            "WHERE surname LIKE '" & escape_quotes(SearchClient[1]) & "%' "  &           
            "AND Clients.client_no = Patients.client_no " &
            "AND name LIKE '" & escape_quotes(SearchClient[2]) & "%' ORDER BY surname"
                                           
    data = query(sql_db, cmd)
    if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error : " & sqlite_last_err_desc)
    end if

    if length(data) = 0 then --there may be some clients with no patients yet
        cmd = "SELECT Clients.client_no, surname, address1 FROM Clients " &
                "WHERE surname LIKE '" & escape_quotes(SearchClient[1]) & "%' ORDER BY surname"
        data = query(sql_db, cmd)
        if sqlite_last_err_no != SQLITE_OK then
            VOID = get_yn_box("Error : " & sqlite_last_err_desc)
        end if
    end if

end if

--search if no client, animal, no address
if length(SearchClient[1]) = 0 and length(SearchClient[2]) > 0 and length(SearchClient[3]) = 0 then
    data = {}
    cmd =   "SELECT Patients.client_no, Patients.patient_no, name FROM Patients WHERE " &
            "name LIKE '" & SearchClient[2] & "%' ORDER BY surname"
    tmp = query(sql_db, cmd)
    if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error : " & sqlite_last_err_desc)
    end if
    
    --this gives us a list of patient numbers and names
    if length(tmp) > 0 then
        data = {{" Clients.client_no ", "Patients.patient_no ", "surname ", "name ", "address1"}}
        for i = 2 to length(tmp) do
            cmd = "SELECT Clients.client_no, surname, address1 FROM Clients WHERE Clients.client_no = " & tmp[i][1] & " ORDER BY surname"
            tmp2 = query(sql_db, cmd)
            if sqlite_last_err_no != SQLITE_OK then
                VOID = get_yn_box("Error : " & sqlite_last_err_desc)
            end if
            
            if length(tmp2) > 0 then
                data = append(data, {tmp2[2][1], tmp[i][2], tmp2[2][2], tmp[i][3], tmp2[2][3]})
            end if
            
        end for
    end if
end if

--search if address only
if length(SearchClient[1]) = 0 and length(SearchClient[2]) = 0 and length(SearchClient[3]) > 0 then
    data = {}
    cmd = "SELECT Clients.client_no, Patients.patient_no, surname, name, address1 FROM Clients, Patients " &
            "WHERE address1 LIKE '%" & SearchClient[3] & "%' " & 
            "AND Clients.client_no = Patients.client_no ORDER BY surname"
    data = query(sql_db, cmd)
    if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error : " & sqlite_last_err_desc)
    end if
end if

--search if client and address, no animal
if length(SearchClient[1]) > 0 and length(SearchClient[2]) = 0 and length(SearchClient[3]) > 0 then
    data = {}
    cmd = "SELECT Clients.client_no, Patients.patient_no, surname, name, address1 FROM Clients, Patients " &
            "WHERE address1 LIKE '%" & SearchClient[3] & "%' " & 
            "AND surname LIKE '" & escape_quotes(SearchClient[1]) & "%' "  &    
            "AND Clients.client_no = Patients.client_no ORDER BY surname"
    data = query(sql_db, cmd)
    if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error : " & sqlite_last_err_desc)
    end if
end if

--search if client, animal and address - won't likely reveal many results often!
if length(SearchClient[1]) > 0 and length(SearchClient[2]) > 0 and length(SearchClient[3]) > 0 then
    data = {}
    cmd = "SELECT Clients.client_no, Patients.patient_no, surname, name, address1 FROM Clients, Patients " &
            "WHERE address1 LIKE '%" & SearchClient[3] & "%' " & 
            "AND surname LIKE '" & escape_quotes(SearchClient[1]) & "%' "  & 
            "AND name LIKE '" & SearchClient[2] & "%' " &
            "AND Clients.client_no = Patients.client_no ORDER BY surname"
    data = query(sql_db, cmd)
    if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error : " & sqlite_last_err_desc)
    end if
end if


sqlite_close(sql_db)

--clear the box
position(6,6)
SetSize(8,50)
if diary_flag = FALSE then
        SetColors(WHITE, BLACK)
else    
        SetColors(WHITE, GREEN)
        SetStyle(5)
        MessageBox("", {} )
        SetStyle(1)
end if

--review_data(data)

--VOID = wait_key()
                        
return data
end function

-----------------------------------------------------------------------------------------------------
global function select_client_from_list(object cpl)
-----------------------------------------------------------------------------------------------------
sequence scp, displaylist, val, new_cpl
integer si
scp = {0,0}
displaylist = {}
new_cpl = {}

if atom(cpl) then
        return scp
end if

if length(cpl) < 2 then
        VOID = get_yn_box("Sorry, no matches.")
        return scp
end if

--since find_client() returns data 5 objects long, if clint and patients exist
--client_no, patient_no, surname, name and address
--unless no patients exist for the client
--in which case get 3 objects
--client_no, surname and address
--then need to adjust this to a sequence 5 long

if length(cpl[1]) < 4 then
    for i = 1 to length(cpl) do
        new_cpl = append(new_cpl, {cpl[i][1], "0", cpl[i][2], "No patient", cpl[i][3] } )   
    end for
    cpl = new_cpl
end if

--create display sequence
for i = 2 to length(cpl) do
    displaylist = append(displaylist, sprintf("%-12.12s %-12.12s %-30.30s", {cpl[i][3], cpl[i][4], cpl[i][5]}) )
end for

--show display sequence in scrolling list box
position(2,2)
SetColors(BLACK, WHITE)
SetSize(20,57)
si = ListBoxIndex("Matching records", displaylist, 1)

--si is 0 if esc pressed
if si = -1 then si = 0 end if

--clear the box
SetStyle(5)
position(2,2)
SetColors(WHITE, BLACK)
SetSize(20,57)
MessageBox("",{})
SetStyle(1)
if diary_flag = FALSE then
        title()
else
        --clear_screen()
end if

if si = 0 then return scp end if

--remember, if no patient scp[2] is 0
scp = {strtoval(cpl[si+1][1]), strtoval(cpl[si+1][2]) }

return scp
end function







-----------------------------------------------------------------------------------------------------
global function add_client()
--create a form,
--add it to the database
--goto the client page
--(will have no patients, so will have to adapt this)
-----------------------------------------------------------------------------------------------------
sequence NewClient, cmd, data, scp

NewClient = repeat(" ", 10)
scp = {0,0}

position(6,6)
SetColors(BLACK, WHITE)
SCREEN_BKGND = BLACK
NewClient = Form("Add a new client",
                    {"Surname    ", NewClient[1], 20,
                     "Title      ", NewClient[2], 5,
                     "First name ", NewClient[3], 30,
                     "Address    ", NewClient[4], 30,
                     "           ", NewClient[5], 30,
                     "           ", NewClient[6], 30,
                     "           ", NewClient[7], 30,
                     "Postcode   ", NewClient[8], 10,
                     "Tel (main) ", NewClient[9], 15,
                     "Tel (alt)  ", NewClient[10], 15
                    })

NewClient[1] = remove_trailing_spaces(NewClient[1])
if length(NewClient[1]) = 0 then return 0 end if

for i = 2 to 10 do
    NewClient[i] = remove_trailing_spaces(NewClient[i])
end for

NewClient[7] = upper(NewClient[8])

--create a CurClient from NewClient
--note will not be complete - ideally should reload CurClient
CurClient = repeat({}, 27)

CurClient[CL_SURNAME] = NewClient[NC_SURNAME]
CurClient[CL_TITLE] = NewClient[NC_TITLE]
CurClient[CL_FIRST_NAME] = NewClient[NC_FIRST_NAME]
CurClient[CL_ADDRESS1] = NewClient[NC_ADDRESS1]
CurClient[CL_ADDRESS2] = NewClient[NC_ADDRESS2]
CurClient[CL_ADDRESS3] = NewClient[NC_ADDRESS3]
CurClient[CL_ADDRESS4] = NewClient[NC_ADDRESS4]
CurClient[CL_POSTCODE] = NewClient[NC_POSTCODE]
CurClient[CL_TEL1] = NewClient[NC_TEL1]
CurClient[CL_TEL2] = NewClient[NC_TEL2]

for i = 1 to 27 do
    if length(CurClient[i]) = 0 then
        CurClient[i] = " "
    end if
end for

CurClient[CL_FEES] = 0
CurClient[CL_DRUGS] = 0
CurClient[CL_VAT] = 0
CurClient[CL_OUTS_BAL] = 0
CurClient[CL_BILL_TYPE] = "C"

data_insert_client()

--now get that last client, and fill the CurClient sequence
sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open database")
end if
cmd = "Select * FROM Clients WHERE client_no = (SELECT max(client_no) FROM Clients)"
data = query(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error : " & sqlite_last_err_desc)
end if

CurClient = data[2]

scp[1] = strtoval(CurClient[CL_CLIENT_NO])
scp[2] = 0

paint_client()
scp = add_patient(scp[1])
if lock_client(scp[1]) = TRUE then --indicates the client can be locked, and has been
        client_patient_page(scp)
        unlock_client(scp[1])
end if


return 0 
end function
