--datafuncs.ex
--database updating functions in here
--all funcs/procs begin w data_


-------------------------------------------------------------------------------------
global procedure datafuncs_errors(atom db, sequence on_command)
--overrides default_fatal
-------------------------------------------------------------------------------------
        --printf (1, "Fatal SQLite Error: %s\nWhen Executing: %s\nError Number: %d\n\n",
        --   {sqlite_last_err_desc, on_command, sqlite_last_err_no})
        --    ?1/0 -- to see call stack

        VOID = get_yn_box("Database error : " &  sqlite_last_err_desc)
        if VOID = '?' then
                position(1,1)
                puts(1, on_command)
                VOID = wait_key()
        end if

end procedure
sqlite_fatal_id = routine_id("datafuncs_errors")


-------------------------------------------------------------------------------------
procedure str2file(sequence str, sequence file)
-------------------------------------------------------------------------------------
integer fp

fp = open(file, "w")
puts(fp,str)
close(fp)

end procedure

-------------------------------------------------------------------------------------
global procedure review_data(sequence data)
--works specifically as a quick way of seeing whats returned from
--an sql query
-------------------------------------------------------------------------------------
clear_screen()
for i = 1 to length(data) do
        for j = 1 to length(data[i]) do
                printf(1, "%s ", {data[i][j]})
        end for
        printf(1, "\n", {})
end for
printf(1, "%d records\n", {length(data)})
end procedure


-------------------------------------------------------------------------------------
global function data_sqlite_get_table(atom sql_db, sequence cmd)
--a wrapper for sqlite_get_table with error reporting 
-------------------------------------------------------------------------------------
sequence data

data = sqlite_get_table(sql_db, cmd)

if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("data_sqlite_get_table error : " & sqlite_last_err_desc)
        if VOID = '?' then
                position(1,1)
                puts(1, cmd)
                VOID = wait_key()
        end if
end if


return data
end function


-------------------------------------------------------------------------------------
global function query(atom sql_db, sequence cmd)
--just a quick way of sqlite_get_table
-------------------------------------------------------------------------------------
sequence data

data = sqlite_get_table(sql_db, cmd)

return data
end function

-------------------------------------------------------------------------------------
global function query_database(sequence database, sequence cmd)
--a universal get info from a database function
-------------------------------------------------------------------------------------
sequence data
atom sql_db

sql_db = sqlite_open(database, 0)
if sql_db <= 0 then
    VOID = get_yn_box("Unable to open database " & database)
end if

data = query(sql_db, cmd)  -- -> sqlite_get_table()

if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error in " & database & " : " & sqlite_last_err_desc)
        if VOID = '?' then
                position(1,1)
                puts(1, cmd)
                VOID = wait_key()
        end if
end if

sqlite_close(sql_db)

--remember 1st row of data is the headers
--will pass it back, but in most cases just discard it

return data
end function

----------------------------------------------------------------------------------
global procedure data_insert_client()
----------------------------------------------------------------------------------
sequence cmd, data
atom sql_db

cmd = "INSERT INTO Clients (surname, christianName, title, address1, address2, address3, address4, " &
                "postcode, tel1, tel2) VALUES (" &
        "'" & escape_quotes(CurClient[CL_SURNAME])          & "'," &
        "'" & escape_quotes(CurClient[CL_FIRST_NAME])       & "'," &
        "'" & escape_quotes(CurClient[CL_TITLE])            & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS1])         & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS2])         & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS3])         & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS4])         & "'," &
            "'" & escape_quotes(CurClient[CL_POSTCODE])         & "'," &
            "'" & escape_quotes(CurClient[CL_TEL1])             & "'," &
            "'" & escape_quotes(CurClient[CL_TEL2])             & "' )" 

cmd =   "INSERT INTO Clients (surname, christianName, title, address1, address2, address3, address4, " &
                "postcode, tel1, tel2, flags, warning, last_cons_date, next_cons_date, next_cons_time, " &
        "last_paid, bill_type, fees, drugs, vat, outs_bal, gone_to, branch, misc1, misc2 ) " &
        "VALUES (" &
        "'" & escape_quotes(CurClient[CL_SURNAME])          & "'," &
        "'" & escape_quotes(CurClient[CL_FIRST_NAME])       & "'," &
        "'" & escape_quotes(CurClient[CL_TITLE])            & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS1])         & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS2])         & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS3])         & "'," &
            "'" & escape_quotes(CurClient[CL_ADDRESS4])         & "'," &
            "'" & escape_quotes(CurClient[CL_POSTCODE])         & "'," &
            "'" & escape_quotes(CurClient[CL_TEL1])             & "'," &
            "'" & escape_quotes(CurClient[CL_TEL2])             & "'," &
            "'" & escape_quotes(CurClient[CL_FLAGS])            & "'," &
            "'" & escape_quotes(CurClient[CL_WARNING])          & "'," &
            "'" & escape_quotes(CurClient[CL_LAST_CONS_DATE])   & "'," &
            "'" & escape_quotes(CurClient[CL_NEXT_CONS_DATE])   & "'," &
            "'" & escape_quotes(CurClient[CL_NEXT_CONS_TIME])   & "'," &
            "'" & escape_quotes(CurClient[CL_LAST_PAID])        & "'," &
            "'" & escape_quotes(CurClient[CL_BILL_TYPE])        & "'," &
        "'" & sprintf("%f",{CurClient[CL_FEES]})            & "'," &
            "'" & sprintf("%f",{CurClient[CL_DRUGS]})           & "'," &
            "'" & sprintf("%f",{CurClient[CL_VAT]})             & "'," &
            "'" & sprintf("%f",{CurClient[CL_OUTS_BAL]})        & "'," &
            "'" & escape_quotes(CurClient[CL_GONE_TO])          & "'," &
            "'" & escape_quotes(CurClient[CL_BRANCH])           & "'," &
            "'" & escape_quotes(CurClient[CL_MISC1])            & "'," &
            "'" & escape_quotes(CurClient[CL_MISC2])            & "' " &
            " )"





while get_key() != -1 do end while --empty the keyboard buffer

--printf(1, "\n%s", {cmd})
--VOID = wait_key()

sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
    VOID = get_yn_box("Unable to open database")
end if

data = sqlite_get_table(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error in clients : " & sqlite_last_err_desc)
end if

sqlite_close(sql_db)

end procedure

----------------------------------------------------------------------------------
global procedure data_insert_patient()
----------------------------------------------------------------------------------
sequence cmd, data
atom sql_db

atom row_id

cmd = "INSERT INTO Patients (client_no, type, name, dob, species, sex, breed, colour, insured, " &
                "microchip, status, weight, fees, drugs, vat, outs_bal, mileage ) " &
                "VALUES (" &
                "'" & sprintf("%d", {CurPatient[PA_CLIENT_NO]}) & "', " &
                "'" & escape_quotes(CurPatient[PA_TYPE])        & "', " &
                "'" & escape_quotes(CurPatient[PA_NAME])        & "', " &
                "'" & escape_quotes(CurPatient[PA_DOB])         & "', " &
                "'" & escape_quotes(CurPatient[PA_SPECIES])     & "', " &
                "'" & escape_quotes(CurPatient[PA_SEX])         & "', " &
                "'" & escape_quotes(CurPatient[PA_BREED])       & "', " &
                "'" & escape_quotes(CurPatient[PA_COLOR])       & "', " &
                "'" & escape_quotes(CurPatient[PA_INSURED])     & "', " &
                "'" & escape_quotes(CurPatient[PA_MICROCHIP])   & "', " &
                "'" & escape_quotes(CurPatient[PA_STATUS])      & "', " &
                "'" & sprintf("%f", {CurPatient[PA_WEIGHT]})                            & "', " &
                "'" & sprintf("%f", {CurPatient[PA_FEES]})                              & "', " &
                "'" & sprintf("%f", {CurPatient[PA_DRUGS]})                             & "', " &
                "'" & sprintf("%f", {CurPatient[PA_VAT] })                              & "', " &
                "'" & sprintf("%f", {CurPatient[PA_OUTS_BAL]})                          & "', " &
                "'" & sprintf("%f", {CurPatient[PA_MILEAGE] })                  & "' )"

sql_db = sqlite_open("xclipats.sql", 0)
if sql_db <= 0 then
    VOID = get_yn_box("Unable to open database")
end if

data = sqlite_get_table(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error in patients : " & sqlite_last_err_desc)
end if

 --test of  sqlite_last_insert_rowid(atom db)    10394
--row_id =  sqlite_last_insert_rowid(sql_db)
--VOID = get_yn_box(sprintf("%d", {row_id}))

sqlite_close(sql_db)


end procedure

----------------------------------------------------------------------------------
global function data_validate_note(sequence note)
--vaidates all the note types, changes to correct type if required
----------------------------------------------------------------------------------

while length(note) < L_NOTE do
        note = append(note, {})
end while       

note[N_PATIENT_NO] = floor(strtoval(note[N_PATIENT_NO]))
note[N_CLIENT_NO] = floor(strtoval(note[N_CLIENT_NO]))
note[N_FEES] = strtoval(note[N_FEES])
note[N_DRUGS] = strtoval(note[N_DRUGS])
note[N_VAT] = strtoval(note[N_VAT])
note[N_TOTAL] = strtoval(note[N_TOTAL])
note[N_NUMBER] = strtoval(note[N_NUMBER])
note[N_JDATE] = strtoval(note[N_JDATE])

if note[N_JDATE] < 1 then
        note[N_JDATE] = dateStrtoJdays(note[N_DATE])
end if

if note[N_TYPE][1] = 'I' or note[N_TYPE][1] = 'R' or note[N_TYPE][1] = 'U' then
        note[N_FEES] = 0
        note[N_DRUGS] = 0
        note[N_VAT] = 0
        note[N_TOTAL] = 0
end if

return note
end function


----------------------------------------------------------------------------------
global procedure data_insert_note(sequence note)
----------------------------------------------------------------------------------
sequence cmd, data
atom sql_db

while get_key() != -1 do end while --empty the keyboard buffer

--pretty_print(1, note, {2} )
--VOID = wait_key()

note = data_validate_note(note)

--pretty_print(1, note, {2} )
--VOID = wait_key()

cmd = "INSERT INTO Notes (patient_no, client_no, date, note, fees, drugs, vat, total, user, type, analysis, jdate) " &
                "VALUES ( " &
        "'" & sprintf("%d", {note[N_PATIENT_NO]})       & "', " &       
        "'" & sprintf("%d", {note[N_CLIENT_NO]})        & "', " &
        "'" & escape_quotes(note[N_DATE])               & "', " &
        "'" & escape_quotes(note[N_NOTE])               & "', " &
        "'" & sprintf("%f", {note[N_FEES]})             & "', " &
        "'" & sprintf("%f", {note[N_DRUGS]})            & "', " &               
        "'" & sprintf("%f", {note[N_VAT] })             & "', " &       
        "'" & sprintf("%f", {note[N_TOTAL]})            & "', " &
        "'" & escape_quotes(note[N_USER])               & "', " &
        "'" & escape_quotes(note[N_TYPE])               & "', " &
        "'" & note[N_ANALYSIS]                          & "', "  &
        sprintf("%d", {note[N_JDATE]}) &         " )"

sql_db = sqlite_open("xnotes.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open notes database")
end if

data = sqlite_get_table(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
        VOID = get_yn_box("Error in notes : " & sqlite_last_err_desc)
end if

sqlite_close(sql_db)


end procedure


----------------------------------------------------------------------------------
global function data_validate_product(sequence product)
--converts strings returned from prod sql query to numbers
--since queries always seem to return strings
----------------------------------------------------------------------------------
product[PROD_PACK_COST] = strtoval(product[PROD_PACK_COST])
product[PROD_UNITS_PACK] = strtoval(product[PROD_UNITS_PACK])
product[PROD_IN_STOCK] = strtoval(product[PROD_IN_STOCK])
product[PROD_UNIT_SALES] = strtoval(product[PROD_UNIT_SALES])
product[PROD_COST] = strtoval(product[PROD_COST])
product[PROD_MARKUP] = strtoval(product[PROD_MARKUP])
product[PROD_DISC] = strtoval(product[PROD_DISC])
product[PROD_SALES_PRICE] = strtoval(product[PROD_SALES_PRICE])
product[PROD_VAT] = strtoval(product[PROD_VAT])
product[PROD_WEIGHT_MULT] = strtoval(product[PROD_WEIGHT_MULT])
product[PROD_BASE_FEE] = strtoval(product[PROD_BASE_FEE])
product[PROD_RECALL] = strtoval(product[PROD_RECALL])
product[PROD_RECALL_INTERVAL] = strtoval(product[PROD_RECALL_INTERVAL])
product[PROD_RECALL_COUNT] = strtoval(product[PROD_RECALL_COUNT])
product[PROD_NUMBER] = strtoval(product[PROD_NUMBER])

product[PROD_INFO] = remove_trailing_spaces(product[PROD_INFO])         --this is in 'compressed' form

return product
end function

----------------------------------------------------------------------------------
global function data_validate_client(sequence client)
--converts strings returned from prod sql query to numbers
--since queries always seem to return strings
----------------------------------------------------------------------------------
client[CL_FEES] = strtoval(client[CL_FEES])
client[CL_DRUGS] = strtoval(client[CL_DRUGS])
client[CL_VAT] = strtoval(client[CL_VAT])
client[CL_OUTS_BAL] = strtoval(client[CL_OUTS_BAL])
client[CL_CLIENT_NO] = strtoval(client[CL_CLIENT_NO])

if length(client[CL_FLAGS]) < FL_FLAG_COUNT then
        for i = length(client[CL_FLAGS]) to FL_FLAG_COUNT do
                client[CL_FLAGS] = append(client[CL_FLAGS], '-')
        end for
end if

return client
end function

----------------------------------------------------------------------------------
global function data_validate_patient(sequence patient)
--converts strings returned from prod sql query to numbers
--since queries always seem to return strings
----------------------------------------------------------------------------------

patient[PA_HEIGHT] = strtoval(patient[PA_HEIGHT])
patient[PA_WEIGHT] = strtoval(patient[PA_WEIGHT])
patient[PA_FEES] = strtoval(patient[PA_FEES])
patient[PA_DRUGS] = strtoval(patient[PA_DRUGS])
patient[PA_VAT] = strtoval(patient[PA_VAT])
patient[PA_OUTS_BAL] = strtoval(patient[PA_OUTS_BAL])
patient[PA_CLIENT_NO] = strtoval(patient[PA_CLIENT_NO])
patient[PA_MILEAGE] = strtoval(patient[PA_MILEAGE])
patient[PA_PATIENT_NO] = strtoval(patient[PA_PATIENT_NO])

return patient
end function

----------------------------------------------------------------------------------
global procedure data_update_patient()
----------------------------------------------------------------------------------
sequence cmd, data

cmd = "UPDATE Patients SET " &
        "type = '"                      & escape_quotes(CurPatient[PA_TYPE])            & "', " &
        "name = '"                      & escape_quotes(CurPatient[PA_NAME])            & "', " &
        "dob = '"                       & escape_quotes(CurPatient[PA_DOB])             & "', " &
        "species = '"               & escape_quotes(CurPatient[PA_SPECIES])             & "', " &
        "sex = '"                       & escape_quotes(CurPatient[PA_SEX])                 & "', " &
        "breed = '"                 & escape_quotes(CurPatient[PA_BREED])               & "', " &
        "colour = '"                & escape_quotes(CurPatient[PA_COLOR])               & "', " &
        "insured = '"               & escape_quotes(CurPatient[PA_INSURED])             & "', " &
        "farm_name = '"             & escape_quotes(CurPatient[PA_FARM_NAME])   & "', " &
        "farm_type = '"             & escape_quotes(CurPatient[PA_FARM_TYPE])   & "', " &
        "herd_ref = '"              & escape_quotes(CurPatient[PA_HERD_REF])    & "', " &
        "height = "                 & sprintf("%f", {CurPatient[PA_HEIGHT]})    & ", "  &       
        "tattoo = '"                & escape_quotes(CurPatient[PA_TATTOO])              & "', " &
        "microchip = '"             & escape_quotes(CurPatient[PA_MICROCHIP])   & "', " &
        "status = '"                & escape_quotes(CurPatient[PA_STATUS])              & "', " &
        "weight = "                 & sprintf("%f", {CurPatient[PA_WEIGHT]})    & ", "  &       
        "fees = "                       & sprintf("%f", {CurPatient[PA_FEES]})      & ", "  &                   
        "drugs = "                      & sprintf("%f", {CurPatient[PA_DRUGS]})     & ", "  &
        "vat = "                        & sprintf("%f", {CurPatient[PA_VAT]})           & ", "  &
        "outs_bal = "               & sprintf("%f", {CurPatient[PA_OUTS_BAL]})  & ", "  &
        "mileage = "                & sprintf("%f", {CurPatient[PA_MILEAGE]})   & ", "  &
        "client_no = "              & sprintf("%d", {CurPatient[PA_CLIENT_NO]}) & " "  &
        "WHERE patient_no = "   & sprintf("%d", {CurPatient[PA_PATIENT_NO]})

data = query_database("xclipats.sql", cmd)

--cmd = "SELECT fees FROM Patients WHERE patient_no = " & sprintf( "%d", {CurPatient[PA_PATIENT_NO]})
--data = query_database("xclipats.sql", cmd)

--review_data(data)
--printf(1, "%s %d %f", {CurPatient[PA_NAME], CurPatient[PA_PATIENT_NO], CurPatient[PA_FEES]})
--VOID = wait_key()       

end procedure


----------------------------------------------------------------------------------
global procedure data_update_client()
--works on CurClient
----------------------------------------------------------------------------------
sequence cmd, data
integer fp

if 1 = 1 then
        --monitoring database writing
        fp = open("upd.txt", "a")
        printf(fp, "%d %s\n", {CurClient[CL_CLIENT_NO], CurClient[CL_FLAGS]})
        close(fp)
end if

cmd = "UPDATE Clients SET " &
        "surname = '"                   & escape_quotes(CurClient[CL_SURNAME])          & "', " &
        "christianName = '"             & escape_quotes(CurClient[CL_FIRST_NAME])       & "', " &
        "title = '"                     & escape_quotes(CurClient[CL_TITLE])            & "', " &
        "address1 = '"                  & escape_quotes(CurClient[CL_ADDRESS1])         & "', " &
        "address2 = '"                  & escape_quotes(CurClient[CL_ADDRESS2])         & "', " &
        "address3 = '"                  & escape_quotes(CurClient[CL_ADDRESS3])         & "', " &
        "address4 = '"                  & escape_quotes(CurClient[CL_ADDRESS4])         & "', " &
        "postcode = '"                  & escape_quotes(CurClient[CL_POSTCODE])         & "', " &
        "tel1 = '"                      & escape_quotes(CurClient[CL_TEL1])             & "', " &
        "tel2 = '"                      & escape_quotes(CurClient[CL_TEL2])             & "', " &
        "flags = '"                     & escape_quotes(CurClient[CL_FLAGS])            & "', " &
        "warning = '"                   & escape_quotes(CurClient[CL_WARNING])          & "', " &
        "last_cons_date = '"            & escape_quotes(CurClient[CL_LAST_CONS_DATE])   & "', " &
        "next_cons_date = '"            & escape_quotes(CurClient[CL_NEXT_CONS_DATE])   & "', " &
        "next_cons_time = '"            & escape_quotes(CurClient[CL_NEXT_CONS_TIME])   & "', " &
        "last_paid = '"                 & escape_quotes(CurClient[CL_LAST_PAID])        & "', " &
        "bill_type = '"                 & escape_quotes(CurClient[CL_BILL_TYPE])        & "', " &
        "fees = "                       & sprintf("%f", {CurClient[CL_FEES]})           & ", "  &                   
        "drugs = "                      & sprintf("%f", {CurClient[CL_DRUGS]})          & ", "  &                   
        "vat = "                        & sprintf("%f", {CurClient[CL_VAT]})            & ", "  &                   
        "outs_bal = "                   & sprintf("%f", {CurClient[CL_OUTS_BAL]})       & ", "  &                   
        "gone_to = '"                   & escape_quotes(CurClient[CL_GONE_TO])          & "', " &
        "branch = '"                    & escape_quotes(CurClient[CL_BRANCH])           & "', " &
        "misc1 = '"                     & escape_quotes(CurClient[CL_MISC1])            & "', " &
        "misc2 = '"                     & escape_quotes(CurClient[CL_MISC2])            & "' " &
        "WHERE client_no = "            & sprintf("%d", {CurClient[CL_CLIENT_NO]})      

data = query_database("xclipats.sql", cmd)

--VOID = get_yn_box(CurClient[CL_FLAGS])
--cmd = "SELECT surname, fees FROM Clients WHERE client_no = " & sprintf( "%d", {CurClient[CL_CLIENT_NO]})
--data = query_database("xclipats.sql", cmd)

--review_data(data)
--printf(1, "%s %d %f", {CurClient[CL_SURNAME], CurClient[CL_CLIENT_NO], CurClient[CL_FEES]})
--VOID = wait_key()       
        
                
end procedure


----------------------------------------------------------------------------------
global procedure data_update_product(sequence item)
----------------------------------------------------------------------------------
sequence cmd, data

cmd = "UPDATE Products SET " &
        "item = '"                  & escape_quotes(item[PROD_ITEM])               & "', " &
        "code = '"                  & escape_quotes(item[PROD_CODE])               & "', " &
        "type = '"                  & escape_quotes(item[PROD_TYPE])               & "', " &
        "category = '"              & escape_quotes(item[PROD_CATEGORY])           & "', " &
        "supplier = '"              & escape_quotes(item[PROD_SUPPLIER])           & "', " &
        "sup_ref = '"               & escape_quotes(item[PROD_SUP_REF])            & "', " &
        "man_ref = '"               & escape_quotes(item[PROD_MAN_REF])            & "', " &
        "license = '"               & escape_quotes(item[PROD_LICENSE])            & "', " &
--prob don't need number, as stays the same anyway
--      "number = "                     & sprintf("%d", {item[PROD_NUMBER]})                & ", "  & 
        "pack_cost = "              & sprintf("%f", {item[PROD_PACK_COST]})             & ", "  &                   
        "units_pack = "             & sprintf("%f", {item[PROD_UNITS_PACK]})            & ", "  &         
        "pack_units = '"                    & escape_quotes(item[PROD_PACK_UNITS])         & "', " &
        "analysis = '"                      & escape_quotes(item[PROD_ANALYSIS])           & "', " &
        "in_stock = "               & sprintf("%f", {item[PROD_IN_STOCK]})              & ", "  & 
        "unit_sales = "             & sprintf("%f", {item[PROD_UNIT_SALES]})            & ", "  &                   
        "cost = "                       & sprintf("%f", {item[PROD_COST]})                  & ", "  &                   
        "markup = "                     & sprintf("%f", {item[PROD_MARKUP]})                & ", "  &                   
        "disc = "                       & sprintf("%f", {item[PROD_DISC]})                  & ", "  &                   
        "sales_price = "            & sprintf("%f", {item[PROD_SALES_PRICE]})      & ", "  &                   
        "milk_withhold = "          & sprintf("%f", {item[PROD_MILK_WITHHOLD]})    & ", "  &                   
        "meat_withhold = "          & sprintf("%f", {item[PROD_MEAT_WITHHOLD]})    & ", "  &                   
        "egg_withhold = "           & sprintf("%f", {item[PROD_EGG_WITHHOLD]})     & ", "  &                   
        "warning = '"                       & escape_quotes(item[PROD_WARNING])            & "', " &
        "gen_label = '"                     & escape_quotes(item[PROD_GEN_LABEL])          & "', " &
        "extra_label = '"                   & escape_quotes(item[PROD_EXTRA_LABEL])        & "', " &
        "dosage = '"                        & escape_quotes(item[PROD_DOSAGE])             & "', " &
        "gen_letter = '"                    & escape_quotes(item[PROD_GEN_LETTER])         & "', " &
        "vat = "                        & sprintf("%f", {item[PROD_VAT]})           & ", "  &      
        "recall = "                     & sprintf("%d", {item[PROD_RECALL]})                & ", "  &   
        "dose_units = '"                    & escape_quotes(item[PROD_DOSE_UNITS])         & "', " &
        "weight_mult = "            & sprintf("%f", {item[PROD_WEIGHT_MULT]})      & ", "  &  
        "status = '"                        & escape_quotes(item[PROD_STATUS])             & "', " &
        "sex = '"                               & escape_quotes(item[PROD_SEX])                & "', " &
        "base_fee = "                   & sprintf("%f", {item[PROD_BASE_FEE]})          & ", "  &  
        "info = '"                          & escape_quotes(item[PROD_INFO])               & "', " &
        "recall_interval = "        & sprintf("%d", {item[PROD_RECALL_INTERVAL]})  & ", "  &
        "batch_number = '"           & escape_quotes(item[PROD_BATCH_NUMBER])               & "', " &
        "recall_count = "           & sprintf("%d", {item[PROD_RECALL_COUNT]})     & " "  &    --no comma on final line !
        "WHERE number = "               & sprintf("%d", {item[PROD_NUMBER]})    

        
data = query_database("xprods.sql", cmd)

--what number is it searching for?
--str2file(cmd, "1111.tmp")
                
--      " = "                   & sprintf("%f", {item[PROD_]})          & ", "  &                   
 
end procedure


----------------------------------------------------------------------------------
global procedure data_insert_product(sequence item)
----------------------------------------------------------------------------------
sequence cmd, data

cmd = "INSERT INTO Products (item, code, type, category, supplier, sup_ref, man_ref, license, " &   --number would be at the end here
                "pack_cost, units_pack, pack_units, analysis, in_stock, unit_sales, cost, markup, disc, sales_price, " &
                "milk_withhold, meat_withhold, egg_withhold, warning, gen_label, extra_label, dosage, gen_letter, " &
                "vat, recall, dose_units, weight_mult, status, sex, base_fee, info, recall_interval, recall_count) " &
                "VALUES (" &
        "'" & escape_quotes(item[PROD_ITEM])               & "', " &
        "'" & escape_quotes(item[PROD_CODE])               & "', " &                              
        "'" & escape_quotes(item[PROD_TYPE])               & "', " &                              
        "'" & escape_quotes(item[PROD_CATEGORY])           & "', " &                              
        "'" & escape_quotes(item[PROD_SUPPLIER])           & "', " &                              
        "'" & escape_quotes(item[PROD_SUP_REF])            & "', " &                              
        "'" & escape_quotes(item[PROD_MAN_REF])            & "', " &                              
        "'" & escape_quotes(item[PROD_LICENSE])            & "', " &                              
        --PROD_NUMBER would go here
        --& sprintf("%d", {item[PROD_NUMBER]})              & ", "  &                             
        sprintf("%f", {item[PROD_PACK_COST]})           & ", "  &                             
        sprintf("%f", {item[PROD_UNITS_PACK]})          & ", "  &                             
        "'" & escape_quotes(item[PROD_PACK_UNITS])         & "', " &                              
        "'" & escape_quotes(item[PROD_ANALYSIS])           & "', " &                              
        sprintf("%f", {item[PROD_IN_STOCK]})            & ", "  &                             
        sprintf("%f", {item[PROD_UNIT_SALES]})          & ", "  &                             
        sprintf("%f", {item[PROD_COST]})            & ", "  &                             
        sprintf("%f", {item[PROD_MARKUP]})                  & ", "  &                             
        sprintf("%f", {item[PROD_DISC]})            & ", "  &                             
        sprintf("%f", {item[PROD_SALES_PRICE]})      & ", "  &                              
        sprintf("%f", {item[PROD_MILK_WITHHOLD]})    & ", "  &                              
        sprintf("%f", {item[PROD_MEAT_WITHHOLD]})    & ", "  &                              
        sprintf("%f", {item[PROD_EGG_WITHHOLD]})     & ", "  &                              
        "'" & escape_quotes(item[PROD_WARNING])            & "', " &                              
        "'" & escape_quotes(item[PROD_GEN_LABEL])          & "', " &                              
        "'" & escape_quotes(item[PROD_EXTRA_LABEL])        & "', " &                              
        "'" & escape_quotes(item[PROD_DOSAGE])             & "', " &                              
        "'" & escape_quotes(item[PROD_GEN_LETTER])         & "', " &                              
        sprintf("%f", {item[PROD_VAT]})             & ", "  &                                 
        sprintf("%d", {item[PROD_RECALL]})                  & ", "  &                             
        "'" & escape_quotes(item[PROD_DOSE_UNITS])         & "', " &                              
        sprintf("%f", {item[PROD_WEIGHT_MULT]})      & ", "  &                              
        "'" & escape_quotes(item[PROD_STATUS])             & "', " &                  
        "'" & escape_quotes(item[PROD_SEX])                & "', " &                              
        sprintf("%f", {item[PROD_BASE_FEE]})            & ", "  &                             
        "'" & escape_quotes(item[PROD_INFO])               & "', " &                              
        sprintf("%d", {item[PROD_RECALL_INTERVAL]})  & ", "  &                              
        sprintf("%d", {item[PROD_RECALL_COUNT]})     &  "', " &       
        "'" & escape_quotes(item[PROD_BATCH_NUMBER])            &  "' )"                         

        
        --no comma on final line ! 
        
data = query_database("xprods.sql", cmd)

end procedure

----------------------------------------------------------------------------------
global procedure data_validate_PDSAPatient()
----------------------------------------------------------------------------------

if sequence(PDSAPatient[PDSA_CLIENT_NO]) then
        PDSAPatient[PDSA_CLIENT_NO] = 0
        PDSAPatient[PDSA_PATIENT_NO] = 0
        PDSAPatient[PDSA_CERT_NO] = "-"
        PDSAPatient[PDSA_EXPIRY] = "-"
        PDSAPatient[PDSA_NOTES] = "-"
        PDSAPatient[PDSA_CHRONIC_COND] = "-"
        PDSAPatient[PDSA_CATEGORY] = "-"
else
        PDSAPatient[PDSA_CLIENT_NO] = strtoval(PDSAPatient[PDSA_CLIENT_NO])
        PDSAPatient[PDSA_PATIENT_NO] = strtoval(PDSAPatient[PDSA_PATIENT_NO])
end if


end procedure

----------------------------------------------------------------------------------
global procedure data_update_PDSAPatient()
----------------------------------------------------------------------------------
sequence cmd, data

data_validate_PDSAPatient()

cmd = "INSERT INTO PDSA (client_no, patient_no, patient_name, cert_no, expiry, notes, chronic_condition, category) " &
                "VALUES ( " &
                "'" & sprintf("%d", {PDSAPatient[PDSA_CLIENT_NO]})      & "', " &
                "'" & sprintf("%d", {PDSAPatient[PDSA_PATIENT_NO]})     & "', " &
                "'" & escape_quotes(PDSAPatient[PDSA_PATIENT_NAME])     & "', " &
                "'" & escape_quotes(PDSAPatient[PDSA_CERT_NO])          & "', " &
                "'" & PDSAPatient[PDSA_EXPIRY]                          & "', " &
                "'" & escape_quotes(PDSAPatient[PDSA_NOTES])            & "', " &
                "'" & escape_quotes(PDSAPatient[PDSA_CHRONIC_COND])     & "', " &
                "'" & PDSAPatient[PDSA_CATEGORY] & "' )"

data = query_database("xclipats.sql", cmd)


end procedure

----------------------------------------------------------------------------------
global function data_validate_popup(sequence Pop)
----------------------------------------------------------------------------------
Pop[POP_CLIENT_NO] = strtoval(Pop[POP_CLIENT_NO])
Pop[POP_PATIENT_NO] = strtoval(Pop[POP_PATIENT_NO])
return Pop
end function

----------------------------------------------------------------------------------
global function data_normalise_flags(sequence flags)
--applies to client flags
----------------------------------------------------------------------------------
if length(flags) < FL_FLAG_COUNT then
        while length(flags) < FL_FLAG_COUNT do
                flags &= '-'
        end while
end if

for i = 1 to FL_FLAG_COUNT do
        if flags[i] = ' ' then
                flags[i] = '-'
        end if
        if flags[i] = 'N' then                  --from the olden days
                flags[i] = '-'                  --when used to Y and N for some reason
        end if
        if flags[i] = 'Y' then
                flags[i] = 'X'
        end if
        
end for

return flags
end function


