--Diary.ex
--obviously contains all the diary functions
--Diary setup
--      table of diaries
--              diary_name, time_start, time_end, appointment_length, slots_per_appointment, use_on_days, slots_per_page
--      each diary
--              index(integer), diary_name, client_name, patient_name, client_no, patient_no, date, time, slot_no_on_page
--      day notes
--              diary_name, date, day_note             

------------------------------------------------------------------------------------------------------------
--routine ids within diary prog
------------------------------------------------------------------------------------------------------------

--constants for an appointment
--this is not the format of the database
--but stored internally by the current_page sequence
constant APPT_CLIENT_NO = 1,
         APPT_PATIENT_NO = 2,
         APPT_CLIENT_NAME = 3,
         APPT_PATIENT_NAME = 4,
         APPT_DATE = 5,
         APPT_TIME = 6,
         APPT_SLOT_NO = 7,
         APPT_SUB_SLOT = 8,
         APPT_REASON = 9,
         APPT_COLOUR = 10
         

         
------------------------------------------------------------------------------------------------------------
procedure draw_diary_page(sequence current_page, 
                                integer line_first, 
                                integer line_last,
                                integer line_current,
                                sequence appt_string,
                                integer offsetrow,
                                integer offsetcol,
                                integer draw_box)
------------------------------------------------------------------------------------------------------------
sequence appt_colours, box

if draw_box = TRUE then
        SetSize(SCREEN_LINES - 3, SCREEN_COLS - 2)
        SetColors(BRIGHT_WHITE, GREEN)
        position(1,1)
        box = GenericBox("Diary for " & current_page[1][APPT_DATE] & " Branch : " , "")
end if

for i = line_first to line_last do
        if current_page[i][APPT_COLOUR] = 0 then
                appt_colours = {BRIGHT_WHITE, BLUE}
        else
                appt_colours = {BRIGHT_WHITE, CYAN}
        end if
        printcolor({i + offsetrow - line_first, offsetcol}, appt_colours, sprintf(appt_string,   --"%-5s%-20.20s%-20.20s%-40.40s",
                {current_page[i][APPT_TIME],
                current_page[i][APPT_CLIENT_NAME],
                current_page[i][APPT_PATIENT_NAME],
                current_page[i][APPT_REASON]}) )
end for
--selection bar
appt_colours = {BRIGHT_WHITE, RED}
printcolor({1 + offsetrow - 1 + (line_current-line_first), offsetcol}, appt_colours, sprintf(appt_string,   --"%-5s%-20.20s%-20.20s%-40.40s",
                {current_page[line_current][APPT_TIME],
                current_page[line_current][APPT_CLIENT_NAME],
                current_page[line_current][APPT_PATIENT_NAME],
                current_page[line_current][APPT_REASON]}) )



end procedure    

------------------------------------------------------------------------------------------------------------
function get_diary_details(sequence dname)
------------------------------------------------------------------------------------------------------------
sequence cmd, data

cmd = "SELECT * FROM Diaries WHERE name LIKE '" & dname & "%'"
data = query_database("xdiary.sql", cmd)

return data[2]
end function

------------------------------------------------------------------------------------------------------------
function diary_keys()
------------------------------------------------------------------------------------------------------------
integer key

SetSize(14, 30)
SetColors(BLACK, CYAN)
position( (SCREEN_LINES-14)/2, (SCREEN_COLS-30)/2)
MessageBox("Diary keys",{
                "up/dn cursor keys - time",
                "left/right cursor keys - date",
                "Q - quit",
                "M - make appointment",
                "G - goto client",
                "C - cancel appointment",
                "W - add to waiting room",
                "T - tick as done",
                "L - print appointments as list",
                "P - print appointment ticket",
                "Z - mark as DNA"})

key = wait_key()

--clear the box
SetSize(14,30) position( (SCREEN_LINES-14)/2, (SCREEN_COLS-30)/2) SetColors(GREEN, GREEN) SetStyle(5) MessageBox("", {}) SetStyle(1)

return key
end function

------------------------------------------------------------------------------------------------------------
function get_current_page_appts(sequence dname, sequence current_page, sequence page_date_str)
------------------------------------------------------------------------------------------------------------
sequence cmd, data
integer slot_no

--get appointments for this day
cmd = "SELECT * FROM " & dname & " WHERE date LIKE '" & page_date_str & "%'"
data = query_database("xdiary.sql", cmd)
--review_data(data)

--empty the current page first
for i = 1 to length(current_page) do
        current_page[i][APPT_CLIENT_NO] = 0
        current_page[i][APPT_PATIENT_NO] = 0
        current_page[i][APPT_CLIENT_NAME] = ""
        current_page[i][APPT_PATIENT_NAME] = ""
        current_page[i][APPT_REASON] = ""
end for

--fill in the current_page
if length(data) > 0 then
        for i = 2 to length(data) do
                slot_no = strtoval(data[i][DP_SLOT_ON_PAGE])
                if slot_no <= length(current_page) then
                        current_page[slot_no][APPT_CLIENT_NO] = strtoval(data[i][DP_CLIENT_NO])
                        current_page[slot_no][APPT_PATIENT_NO] = strtoval(data[i][DP_PATIENT_NO])
                        current_page[slot_no][APPT_CLIENT_NAME] = data[i][DP_CLIENT_NAME]
                        current_page[slot_no][APPT_PATIENT_NAME] = data[i][DP_PATIENT_NAME]
                        current_page[slot_no][APPT_REASON] = data[i][DP_REASON]
                end if
        end for
end if

for i = 1 to length(current_page) do
        current_page[i][APPT_DATE] = page_date_str
end for


return current_page
end function


------------------------------------------------------------------------------------------------------------
function make_appointment(sequence dname, sequence current_page, integer slot_no,
                                integer line_first, 
                                integer line_last,
                                sequence appt_string,
                                integer offsetrow,
                                integer offsetcol)
------------------------------------------------------------------------------------------------------------
sequence cmd, data,
        locked_slots,
        popup_data,
        reason
integer fp,
        lock_number, ld,
        line_current
object line, tmp

--first, grab and lock the slot
--second, find client (get return details)
--third, add details to diary
--remove slot lock

locked_slots = {}
lock_number = 0
line_current = slot_no

fp = open("diary_slot_lock", "r")
if fp > 0 then
        while 1 do              
                line = gets(fp)
                if sequence(line) then
                        locked_slots = append(locked_slots, remove_trailing_spaces(line))
                else
                        exit
                end if
        end while
        
        close(fp)
        
        if length(locked_slots) > 0 then
                lock_number = 0
                for i = 1 to length(locked_slots) do
                        if match(dname, locked_slots[i]) > 0  and match(current_page[1][APPT_DATE], locked_slots[i]) > 0 then
                                --have a diary name, and page date match
                                --do we have a slot_no match?
                                for j = length(locked_slots[i]) to 1 by -1 do
                                        if locked_slots[i][j] = ':' then
                                                ld = j
                                                exit    
                                        end if
                                end for
                                if strtoval(locked_slots[i][ld+1..$]) = slot_no then
                                        lock_number = i
                                end if
                        end if
                        if lock_number > 0 then exit end if             
                end for
        end if          
end if

--slot is locked already
if lock_number > 0 then
        VOID = get_yn_box("This slot is currently locked - select another")
        return current_page     
end if

--slot isn't locked, so lock it!
fp = open("diary_slot_lock", "a")
printf(fp, "%s:%s:%d\n", {dname, current_page[1][APPT_DATE], slot_no})
close(fp)

--now go and find a client
diary_flag = TRUE
if called_from_patient = FALSE then
        SelectedCliPat = select_client_from_list(find_client())
else
        SelectedCliPat[1] = CurClient[CL_CLIENT_NO]
        SelectedCliPat[2] = CurPatient[PA_PATIENT_NO]
end if

if SelectedCliPat[1] > 0 then
        --add the client/patient to the current page
        load_client(SelectedCliPat[1]) --loads to CurClient

        --have to use database to load CurPatient
        cmd = "SELECT * FROM Patients WHERE patient_no = " & sprintf("%d", SelectedCliPat[2] )
        data = query_database("xclipats.sql", cmd)
        if length(data) > 0 then
                CurPatient = data_validate_patient(data[2])
        end if
        
        --put details onto current_page[slot_no]
        current_page[slot_no][APPT_CLIENT_NO] = CurClient[CL_CLIENT_NO]
        current_page[slot_no][APPT_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
        current_page[slot_no][APPT_CLIENT_NAME] = CurClient[CL_SURNAME]
        current_page[slot_no][APPT_PATIENT_NAME] = CurPatient[PA_NAME]

        draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, TRUE)
        
        --get the popup for the client
        --and any extra details
        popup_data = popups_check('C')
        --only need the text
        if length(popup_data) > 0 then
                popup_data = utils_resolve_strings(popup_data[2][POP_TEXT], 8)
                VOID = {}
                --bad debts, and any other notable flags in here too

                --reduce popup set
                for i = 1 to length(popup_data) do
                        if length(popup_data[i]) > 0 then
                                VOID = append(VOID, popup_data[i])
                        end if
                end for
                popup_data = VOID
                SetSize(10,42) SetColors(YELLOW, BLACK) position(12,35)
                MessageBox("", popup_data)
        end if  
        
        --get the reason
        SetColors(BRIGHT_GREEN, BLACK) position(5, 10)
        reason = Form("Appointment for " & remove_trailing_spaces(CurPatient[PA_NAME]) & " " & remove_trailing_spaces(CurClient[CL_SURNAME]),
                        {"Reason ", "", 30} )           
        current_page[slot_no][APPT_REASON] = reason[1]
        draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, TRUE)
        
        --update the database
        
--      cmd = "CREATE TABLE " & details[1] & "(ind INTEGER PRIMARY KEY, client_name TEXT, patient_name TEXT, client_no INTEGER, " &
--              "patient_no INTEGER, date TEXT, time TEXT, slot_on_page INTEGER, reason TEXT )"
        
        cmd = "INSERT INTO " & dname & "(client_name, patient_name, client_no, patient_no, date, time, slot_on_page, reason) " &
                "VALUES (" &
                "'" & escape_quotes(remove_trailing_spaces(CurClient[CL_SURNAME])) & "', " &
                "'" & escape_quotes(remove_trailing_spaces(CurPatient[PA_NAME])) & "', " &
                sprintf("%d", {CurClient[CL_CLIENT_NO]}) & ", " &
                sprintf("%d", {CurPatient[PA_PATIENT_NO]}) & ", " &
                "'" & current_page[1][APPT_DATE] & "', " &
                "'" & current_page[slot_no][APPT_TIME] & "', " &
                sprintf("%d", {slot_no}) & ", " &
                "'" & escape_quotes(reason[1]) & "')"
        data = query_database("xdiary.sql", cmd)
                
        
end if
diary_flag = FALSE

--release the lock
locked_slots = {}
fp = open("diary_slot_lock", "r")
while 1 do              
        line = gets(fp)
        if sequence(line) then
                locked_slots = append(locked_slots, remove_trailing_spaces(line))
        else
                exit
        end if
end while
close(fp)

fp = open("diary_slot_lock", "w")
for i = 1 to length(locked_slots) do
        if match(dname, locked_slots[i]) = 0  or match(current_page[1][APPT_DATE], locked_slots[i]) = 0 then
                printf(fp,"%s\n", {locked_slots[i]})
        else
                for j = length(locked_slots[i]) to 1 by -1 do
                        if locked_slots[i][j] = ':' then
                                ld = j
                                exit    
                        end if
                end for
                if strtoval(locked_slots[i][ld+1..$]) != slot_no then
                        printf(fp,"%s\n", {locked_slots[i]})
                end if
        end if
end for
close(fp)




return current_page
end function


------------------------------------------------------------------------------------------------------------
function cancel_appointment(sequence dname, sequence current_page, integer slot_no,
                                integer line_first, 
                                integer line_last,
                                sequence appt_string,
                                integer offsetrow,
                                integer offsetcol)
------------------------------------------------------------------------------------------------------------
sequence data, cmd

if current_page[slot_no][APPT_CLIENT_NO] = 0 then return current_page end if

cmd = "DELETE FROM " & dname & " WHERE " &
        "slot_on_page = " & sprintf("%d", {slot_no}) & " AND " &
        --"client_no = " & sprintf("%d", {current_page[slot_no][APPT_CLIENT_NO]}) & " AND " &
        --"patient_no = " & sprintf("%d", {current_page[slot_no][APPT_PATIENT_NO]}) & " AND " &
        "date LIKE '" & remove_trailing_spaces(current_page[1][APPT_DATE]) & "'"

if upper(get_yn_box("Delete " & remove_trailing_spaces(current_page[slot_no][APPT_PATIENT_NAME]) & " " & remove_trailing_spaces(current_page[slot_no][APPT_CLIENT_NAME]) & "? (y/n)[n]")) = 'Y' then
        data = query_database("xdiary.sql", cmd)
        current_page[slot_no][APPT_CLIENT_NO] = 0
        current_page[slot_no][APPT_PATIENT_NO] = 0
        current_page[slot_no][APPT_CLIENT_NAME] = ""
        current_page[slot_no][APPT_PATIENT_NAME] = ""
        current_page[slot_no][APPT_REASON] = ""        
end if


return current_page
end function


------------------------------------------------------------------------------------------------------------
function goto_client(sequence dname, sequence current_page, integer slot_no,
                                integer line_first, 
                                integer line_last,
                                sequence appt_string,
                                integer offsetrow,
                                integer offsetcol)
------------------------------------------------------------------------------------------------------------
sequence SelectedCliPat


SelectedCliPat = {0,0}

SelectedCliPat[1] = current_page[slot_no][APPT_CLIENT_NO]
SelectedCliPat[2] = current_page[slot_no][APPT_PATIENT_NO]

if SelectedCliPat[1] > 0 then
        if lock_client(SelectedCliPat[1]) = TRUE then --indicates the client can be locked, and has been
                client_patient_page(SelectedCliPat)
                unlock_client(SelectedCliPat[1])
        end if
end if

return current_page
end function

------------------------------------------------------------------------------------------------------------
function mark_appt(sequence dname, sequence current_page, integer slot_no,
                                integer line_first, 
                                integer line_last,
                                sequence appt_string,
                                integer offsetrow,
                                integer offsetcol,
                                sequence mark)
------------------------------------------------------------------------------------------------------------
sequence cmd, data

if current_page[slot_no][APPT_CLIENT_NO] = 0 then return current_page end if

cmd = "UPDATE " & dname & " SET " &
        "reason = '" & mark & "' " &
        "WHERE " &
        "slot_on_page = " & sprintf("%d", {slot_no}) & " AND " &
        "date LIKE '" & remove_trailing_spaces(current_page[1][APPT_DATE]) & "'"

data = query_database("xdiary.sql", cmd)
current_page[slot_no][APPT_REASON] = mark       
        

return current_page
end function

------------------------------------------------------------------------------------------------------------
procedure print_appt(sequence dname, sequence current_page, integer slot_no,
                                integer line_first, 
                                integer line_last,
                                sequence appt_string,
                                integer offsetrow,
                                integer offsetcol,
                                integer dow)
------------------------------------------------------------------------------------------------------------
--create a file to print to the printer
integer fp
sequence appt_time

fp = open("diary_appt","w")


--header
puts(fp, globalSettings[GS_PRACTICE] & "\n")
puts(fp, globalSettings[GS_ADDRESS1] & "\n")
puts(fp, globalSettings[GS_ADDRESS2] & "\n")
puts(fp, globalSettings[GS_ADDRESS3] & "\n")
puts(fp, globalSettings[GS_ADDRESS4] & "\n")
puts(fp, globalSettings[GS_POSTCODE] & "\n")
puts(fp, globalSettings[GS_TEL] & "\n")
puts(fp, "--------------------------------------------\n\n")

--appt details
puts(fp, "An appointment has been made for :\n")
puts(fp, remove_trailing_spaces(current_page[slot_no][APPT_PATIENT_NAME])  & " " & remove_trailing_spaces(current_page[slot_no][APPT_CLIENT_NAME]) & "\n" )
puts(fp, "on " & WEEKDAYS[dow] & " " & current_page[1][APPT_DATE] & "\n")

if length(remove_trailing_spaces(current_page[slot_no][APPT_TIME])) = 0 then
        appt_time = current_page[slot_no -1][APPT_TIME]
else 
        appt_time = current_page[slot_no][APPT_TIME]
end if

puts(fp, "at " & appt_time & "\n\n")

puts(fp, "Please let us know if you are unable to\n")
puts(fp, "keep this appointment\n")
puts(fp, "--------------------------------------------\n\n\n\n\n\n\n\n\n")

close(fp)

--print it
printers_print_file("diary_appt", PR_RECEIPT)

end procedure

------------------------------------------------------------------------------------------------------------
procedure list_appts(sequence dname, sequence current_page, integer slot_no,
                                integer line_first, 
                                integer line_last,
                                sequence appt_string,
                                integer offsetrow,
                                integer offsetcol,
                                integer dow)
------------------------------------------------------------------------------------------------------------
--create a file to print to the printer
integer fp

fp = open("diary_page", "w")

--header
puts(fp, "Appointments for " & WEEKDAYS[dow] & " " & current_page[1][APPT_DATE] & " " & dname & "\n\n")

for i = 1 to length(current_page) do
        printf(fp, "%-5s %-20.20s%-20.20s%-34.34s\n",
                {current_page[i][APPT_TIME],
                current_page[i][APPT_CLIENT_NAME],
                current_page[i][APPT_PATIENT_NAME],
                current_page[i][APPT_REASON]})
        puts(fp, "-------------------------------------------------------------------------------\n")
end for

close(fp)

printers_print_file("diary_page", PR_GENERAL)

end procedure


------------------------------------------------------------------------------------------------------------
function open_diary(sequence dname)
------------------------------------------------------------------------------------------------------------
sequence page_date, page_date_str,      --date of current page
         selected_diary,                --selected diary details
         current_appt,
         current_page,                  --current diary page
         cmd, data,
         box,
         appt_colours,
         appt_string                    --defines the length of the displayed appt
         
integer count, appt_secs, secs_inc, slot_no, slot_colour,
        line_first, line_last, line_max, line_current,
        offsetrow, offsetcol,
        dow, dow_conv,                  --day of week
        key,
        page_change

page_date = nowDate()
page_date_str = DateToStr(page_date)
dow = dayOfWeek(page_date)
selected_diary = get_diary_details(dname)
slot_colour = 0
page_change = FALSE

selected_diary[DD_APPT_LENGTH] = strtoval(selected_diary[DD_APPT_LENGTH])
selected_diary[DD_SLOTS_PER_APPT] = strtoval(selected_diary[DD_SLOTS_PER_APPT])
selected_diary[DD_SLOTS_PER_PAGE] = strtoval(selected_diary[DD_SLOTS_PER_PAGE])

current_appt = repeat({}, 10)

--generate a blank current_page
current_page = repeat(current_appt, selected_diary[DD_SLOTS_PER_PAGE])

--fill the current page sub slot numbering, doesn't change
count = 1
while 1 do
        for i = 1 to selected_diary[DD_SLOTS_PER_APPT] do
                current_page[count][APPT_SUB_SLOT] = i
                current_page[count][APPT_COLOUR] = slot_colour
                count += 1
                if count > length(current_page) then exit end if
        end for
        slot_colour = not(slot_colour)
        if count > length(current_page) then exit end if
end while

--first appt in secs since midnight
appt_secs = utils_valid_time(selected_diary[DD_TIME_START])
secs_inc = selected_diary[DD_APPT_LENGTH] * 60

--fill in the current page dates and times, times don't change, date does
for i = 1 to length(current_page) do
        if current_page[i][APPT_SUB_SLOT] = 1 then
                current_page[i][APPT_TIME] = utils_secstotimestr(appt_secs)
                appt_secs = appt_secs + secs_inc
        end if
        --current_page[i][APPT_DATE] = page_date_str
end for

--get the appointments for the page
current_page = get_current_page_appts(dname, current_page, page_date_str)

--create the diary frame
--SCREEN_LINES, SCREEN_COLS
SetSize(SCREEN_LINES - 3, SCREEN_COLS - 2)
SetColors(BRIGHT_WHITE, GREEN)
position(1,1)
box = GenericBox("Diary for " & WEEKDAYS[dow] & " " & page_date_str & " - " & dname & " Branch : " , "")
offsetrow = 4
offsetcol = 2
line_first = 1
line_last = SCREEN_LINES - 6
line_max = length(current_page)
if line_max < line_last then line_last = line_max end if
line_current = 1

--show the page
appt_string = sprintf("%s%s%s%s", {"%-5s","%-20.20s", "%-20.20s", "%-" & sprintf("%d.%ds", {SCREEN_COLS-47, SCREEN_COLS-47})  } )

draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, FALSE)

if called_from_patient = TRUE then
        printcolor( {SCREEN_LINES-1, 1}, {BLACK, WHITE}, 
                "Making appt for " & remove_trailing_spaces(CurPatient[PA_NAME]) & " " & remove_trailing_spaces(CurClient[CL_SURNAME]) )
        printcolor( {SCREEN_LINES, 1}, {WHITE, BLACK}, "                                                               ")
end if

--now into loop
while 1 do
        key = upper(wait_key())
        page_change = TRUE

        if called_from_patient = TRUE and (key = ENTER or key = 'M') then
                --make an appt for CurClient, CurPatient
                --check appointment can be made!
                current_page = get_current_page_appts(dname, current_page, page_date_str)
                --redraw the page
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, FALSE)
                if current_page[line_current][APPT_CLIENT_NO] <= 0 then
                        current_page = make_appointment(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol)
                        SetColors(BRIGHT_WHITE, GREEN)
                        position(1,1)
                        SetSize(SCREEN_LINES - 3, SCREEN_COLS - 2)
                        box = GenericBox("Diary for " & WEEKDAYS[dow] & " " & page_date_str & " - " & dname & " Branch : " , "")
                else
                        VOID = get_yn_box("That appointment is taken - select another")
                end if                       
                
        end if
        
        if key = ENTER and called_from_patient = FALSE then
                key = diary_keys()
        end if

        if key = 'Q' or key = ESC then exit end if

        if key = 'M' and called_from_patient = FALSE then
                --check appointment can be made!
                current_page = get_current_page_appts(dname, current_page, page_date_str)
                --redraw the page
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, FALSE)

                if current_page[line_current][APPT_CLIENT_NO] <= 0 then
                        current_page = make_appointment(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol)
                        SetColors(BRIGHT_WHITE, GREEN)
                        position(1,1)
                        SetSize(SCREEN_LINES - 3, SCREEN_COLS - 2)
                        box = GenericBox("Diary for " & WEEKDAYS[dow] & " " & page_date_str & " - " & dname & " Branch : " , "")
                else
                        VOID = get_yn_box("That appointment is taken - select another")
                end if                       
        end if

        if key = 'C' then
                current_page = cancel_appointment(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol)
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, FALSE)
        end if

        if key = 'G' and called_from_patient = FALSE then
                current_page = goto_client(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol)
                SetSize(2,2) position(1,1) SetColors(WHITE,BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
                clear_screen()
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, TRUE)
        end if

        if key = 'T' then
                current_page = mark_appt(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol, "*** DONE ***")
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, FALSE)
        end if
        
        if key = 'Z' then
                current_page = mark_appt(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol, "--- DNA ---")
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, FALSE)
        end if
        
        if key = 'P' then
                print_appt(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol, dow)
                VOID = get_yn_box("Collect the appointment ticket, hand to client")
        end if

        if key = 'L' then
                list_appts(dname, current_page, line_current, line_first, line_last, appt_string, offsetrow, offsetcol, dow)
                VOID = get_yn_box("Printed appointments for " & dname & " " & page_date_str)
        end if

        if key = 'W' then
                diary_flag = TRUE
                add_to_waiting_room(current_page[line_current][APPT_CLIENT_NO],
                                        current_page[line_current][APPT_PATIENT_NO],
                                        current_page[line_current][APPT_CLIENT_NAME],
                                        current_page[line_current][APPT_PATIENT_NAME],
                                        current_page[line_current][APPT_REASON],
                                        "W")
                diary_flag = FALSE
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, TRUE)
        end if

        if key = dn then
                line_current += 1
                if line_current > line_max then
                        line_current -= 1
                        page_change = FALSE
                end if
                if line_current > line_last then
                        line_first += 1
                        line_last += 1
                end if
        end if

        if key = up then
                line_current -= 1
                if line_current < 1 then
                        line_current += 1
                        page_change = FALSE
                end if
                if line_current < line_first then
                        line_first -= 1
                        line_last -= 1
                end if
        end if

        if upper(key) = 'B' then
                --back 7 days
                page_date = subFromDate(page_date, 7)
                dow = dayOfWeek(page_date)
                dow_conv = dow - 1
                if dow_conv = 0 then dow_conv = 7 end if
                --no need to check can use on this day - if can then can!
        end if

        if upper(key) = 'F' then
                --back 7 days
                page_date = addToDate(page_date, 7)
                dow = dayOfWeek(page_date)
                dow_conv = dow - 1
                if dow_conv = 0 then dow_conv = 7 end if
                --no need to check can use on this day - if can then can!
        end if

        if key = left then
                --back a day
                page_date = subFromDate(page_date, 1)
                dow = dayOfWeek(page_date)
                --check use_on
                --dow - Sunday is 1
                --selected_diary[DD_USE_ON_DAYS] - Monday is slot 1
                dow_conv = dow - 1
                if dow_conv = 0 then dow_conv = 7 end if
                while 1 do
                        if selected_diary[DD_USE_ON_DAYS][dow_conv] = 'Y' then exit end if
                        page_date = subFromDate(page_date, 1)
                        page_date_str = DateToStr(page_date)
                        dow = dayOfWeek(page_date)
                        dow_conv = dow - 1
                        if dow_conv = 0 then dow_conv = 7 end if
                end while
                --refresh current page appointments
                --current_page = get_current_page_appts(dname, current_page, page_date_str)
        end if

        if key = right then
                --advance a day
                page_date = addToDate(page_date, 1)
                dow = dayOfWeek(page_date)
                dow_conv = dow - 1
                if dow_conv = 0 then dow_conv = 7 end if
                while 1 do
                        if selected_diary[DD_USE_ON_DAYS][dow_conv] = 'Y' then exit end if
                        page_date = addToDate(page_date, 1)
                        page_date_str = DateToStr(page_date)
                        dow = dayOfWeek(page_date)
                        dow_conv = dow - 1
                        if dow_conv = 0 then dow_conv = 7 end if
                end while
                --refresh current page appointments
                --current_page = get_current_page_appts(dname, current_page, page_date_str)
         end if

        if key = right or key = left or upper(key) = 'B' or upper(key) = 'F'then
                --refresh diary header, and load new details from database
                page_date_str = DateToStr(page_date)
                printcolor({2,2}, {BRIGHT_WHITE, GREEN}, "Diary for " & WEEKDAYS[dow] & " " & page_date_str & " - " & dname & " Branch : " & "   " )
                current_page = get_current_page_appts(dname, current_page, page_date_str)
        end if

        --refresh the display
        if page_change = TRUE then
                draw_diary_page(current_page, line_first, line_last, line_current, appt_string, offsetrow, offsetcol, FALSE)
        end if

end while

--clear the diary page, re instate the title
if called_from_patient = FALSE then
        title()
end if

return 0
end function
rid_open_diary = routine_id("open_diary")





------------------------------------------------------------------------------------------------------------
procedure modify_diary_2(sequence dname)
--get diary details
--put into form
--validate
--update the diary details
------------------------------------------------------------------------------------------------------------
sequence details, cmd, data, use_on, Diary, diary_list, dl
integer val_pass, get_out, yes_count, secs, spp, secs_end, mins
atom num_appts

details = repeat({},12)
val_pass = TRUE
get_out = FALSE
yes_count = 0
use_on = {}
spp = 0 --slots per page
num_appts = 0.0
Diary = repeat({}, 7)
diary_list = {}

dl = call_func(rid_gdl, {})
if length(dl) > 0 then
        for i = 1 to length(dl) do
                diary_list = append(diary_list, remove_trailing_spaces(dl[i][1]))
        end for
end if

--get diary setails
cmd = "SELECT * FROM Diaries WHERE name LIKE '" & dname & "'"
data = query_database("xdiary.sql", cmd)
if length(data) > 0 then
        for i = 1 to 7 do
                Diary[i] = data[2][i]
        end for
end if
details[1] = Diary[DD_NAME]
details[2] = Diary[DD_TIME_START]
details[3] = Diary[DD_TIME_END]
details[4] = Diary[DD_APPT_LENGTH]
details[5] = Diary[DD_SLOTS_PER_APPT]
for i = 6 to 12 do
        details[i] = {Diary[DD_USE_ON_DAYS][i-5]}       --has to be a sequence
end for

while 1 do
        position (9,9)
        SetColors(BLACK, CYAN)
        
        val_pass = TRUE
        details = Form("Modify diary " & dname,
                        {"Name          ", details[1], 30,
                        "Start time     ", details[2], 7,
                        "End time       ", details[3], 7,
                        "Appt length    ", details[4], 7,
                        "Slots per appt ", details[5], 7,
                        "Use on Mon     ", details[6], 4,
                        "       Tue     ", details[7], 4,
                        "       Wed     ", details[8], 4,
                        "       Thur    ", details[9], 4,
                        "       Fri     ", details[10], 4,
                        "       Sat     ", details[11], 4,
                        "       Sun     ", details[12], 4
                        })

        --validate the diary
        for i = 1 to 12 do
                details[i] = remove_trailing_spaces(details[i])
        end for

        --check trying to create a diary with the name of a pre existing one
        if equal(dname, details[1]) = 0 then
                details[1] = dname
                VOID = get_yn_box("Sorry, can't change the name.")
        end if
        
        --validate the entries
        if val_pass = TRUE and length(details[1]) = 0 then 
                get_out = upper(get_yn_box("You must enter a name ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        
        if val_pass = TRUE and length(details[2]) = 0 then
                get_out = upper(get_yn_box("No start time ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if

        if val_pass = TRUE and length(details[3]) = 0 then
                get_out = upper(get_yn_box("No end time ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
                
        if val_pass = TRUE and length(details[4]) = 0 then
                get_out = upper(get_yn_box("No appt length ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if

        if val_pass = TRUE and length(details[5]) = 0 then
                get_out = upper(get_yn_box("No slots per appt ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        
        --work on the use days
        for i = 6 to 12 do
                if length(details[i]) = 0 then
                        details[i] = "N"
                end if
                details[i] = upper(details[i])
                if details[i][1] = 'Y' then yes_count += 1 end if       
        end for

        if val_pass = TRUE and yes_count = 0 then
                get_out = upper(get_yn_box("No days to use on entered ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if  

        --check for valid time format
        secs = utils_valid_time(details[2])
        if val_pass = TRUE and secs = -1 then
                get_out = upper(get_yn_box("Invalid start time format - HH:MM ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        secs = utils_valid_time(details[3])
        if val_pass = TRUE and secs = -1 then
                get_out = upper(get_yn_box("Invalid end time format - HH:MM ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        
        --success
        if val_pass = TRUE or get_out = 'C' then exit end if

end while


if get_out != 'C' and upper(get_yn_box("Success - save diary ? (y/n)[n]")) = 'Y' then
        --can now save the table

        --use_on days
        for i = 6 to 12 do
                use_on = use_on & details[i]
        end for

        --slots per page
        secs = utils_valid_time(details[2])
        secs_end = utils_valid_time(details[3])
        mins = (secs_end - secs)/60
        num_appts = mins / strtoval(details[4])
        if num_appts != floor(num_appts) then
                num_appts = floor(num_appts) + 1
        end if
        spp = num_appts * strtoval(details[5])

        cmd = "UPDATE Diaries SET " &
                "name = '"              & details[1] & "', " &
                "time_start = '"        & details[2] & "', " &
                "time_end = '"          & details[3] & "', " &
                "appt_length = '"       & details[4] & "', " &
                "slots_per_appt = '"    & details[5] & "', " &
                "use_on_days = '"       & use_on & "', " &
                "slots_per_page = '"    & sprintf("%d", {spp}) & "'" &
                "WHERE name LIKE '" & dname & "'"
        data = query_database("xdiary.sql", cmd)

end if

end procedure

------------------------------------------------------------------------------------------------------------
procedure modify_diary()
------------------------------------------------------------------------------------------------------------
sequence dl, diary_list, cmd, data
integer choice, current_choice, c

--get list of diaries
--dl = get_diary_list()
--ahhh, my first forward reference!
dl = call_func(rid_gdl, {})

diary_list = {}

if length(dl) > 0 then
        for i = 1 to length(dl) do
                diary_list = append(diary_list, remove_trailing_spaces(dl[i][1]))
        end for

        current_choice = 1
        position (10,10)
        SetColors(BRIGHT_WHITE, BLUE)
        SetSize(11,34)
        choice = Select("Select a diary to modify", current_choice,
                                        diary_list)
                
        current_choice = choice
        
        if choice > 0 then
                modify_diary_2(diary_list[choice])
        
        end if
else
        VOID = get_yn_box("No diaries!")        
end if


end procedure



------------------------------------------------------------------------------------------------------------
procedure delete_diary()
------------------------------------------------------------------------------------------------------------
sequence dl, diary_list, cmd, data
integer choice, current_choice, c

--get list of diaries
--dl = get_diary_list()
--ahhh, my first forward reference!
dl = call_func(rid_gdl, {})

diary_list = {}

if length(dl) > 0 then
        for i = 1 to length(dl) do
                diary_list = append(diary_list, remove_trailing_spaces(dl[i][1]))
        end for

        current_choice = 1
        position (10,10)
        SetColors(BRIGHT_WHITE, RED)
        SetSize(11,34)
        choice = Select("Select a diary to delete", current_choice,
                                        diary_list)
                
        current_choice = choice
        
        if choice > 0 then
                c = get_yn_box("Delete " & diary_list[choice]  & " - are you sure? (y/n)[n]")
                if upper(c) = 'Y' then
                        cmd = "DELETE FROM Diaries WHERE name LIKE '" & diary_list[choice] & "'"
                        data = query_database("xdiary.sql", cmd)        
                
                        --also need to remove any diary entries for this diary
                        cmd = "DROP TABLE '" & diary_list[choice] & "'"
                        data = query_database("xdiary.sql", cmd)        
                end if
        end if
        
        
        --clear the box
        SetSize(11,34) position(10,10) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

else
        VOID = get_yn_box("No diaries!")        

end if


end procedure


------------------------------------------------------------------------------------------------------------
procedure create_new_diary(sequence diary_list)
------------------------------------------------------------------------------------------------------------
sequence details, cmd, data, use_on
integer val_pass, get_out, yes_count, secs, spp, secs_end, mins
atom num_appts


details = repeat({},12)
val_pass = TRUE
get_out = FALSE
yes_count = 0
use_on = {}
spp = 0 --slots per page
num_appts = 0.0

while 1 do
        position (9,9)
        SetColors(BLACK, CYAN)
        
        val_pass = TRUE
        details = Form("Create new diary",
                        {"Name          ", details[1], 30,
                        "Start time     ", details[2], 7,
                        "End time       ", details[3], 7,
                        "Appt length    ", details[4], 7,
                        "Slots per appt ", details[5], 7,
                        "Use on Mon     ", details[6], 4,
                        "       Tue     ", details[7], 4,
                        "       Wed     ", details[8], 4,
                        "       Thur    ", details[9], 4,
                        "       Fri     ", details[10], 4,
                        "       Sat     ", details[11], 4,
                        "       Sun     ", details[12], 4
                        })

        for i = 1 to 12 do
                details[i] = remove_trailing_spaces(details[i])
        end for

        --check trying to create a diary with the name of a pre existing one
        for i = 1 to length(diary_list) do
                if length(details[1]) > 0 and match(upper(details[1]), upper(diary_list[i])) then
                get_out = upper(get_yn_box("Duplicate diary name - try again ('c' to cancel)"))
                val_pass = FALSE
                if get_out = 'C' then exit end if
                end if
        end for
                
        --validate the entries
        if val_pass = TRUE and length(details[1]) = 0 then 
                get_out = upper(get_yn_box("You must enter a name ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        
        if val_pass = TRUE and length(details[2]) = 0 then
                get_out = upper(get_yn_box("No start time ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if

        if val_pass = TRUE and length(details[3]) = 0 then
                get_out = upper(get_yn_box("No end time ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
                
        if val_pass = TRUE and length(details[4]) = 0 then
                get_out = upper(get_yn_box("No appt length ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if

        if val_pass = TRUE and length(details[5]) = 0 then
                get_out = upper(get_yn_box("No slots per appt ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        
        --work on the use days
        for i = 6 to 12 do
                if length(details[i]) = 0 then
                        details[i] = "N"
                end if
                details[i] = upper(details[i])
                if details[i][1] = 'Y' then yes_count += 1 end if       
        end for

        if val_pass = TRUE and yes_count = 0 then
                get_out = upper(get_yn_box("No days to use on entered ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if  

        --check for valid time format
        secs = utils_valid_time(details[2])
        if val_pass = TRUE and secs = -1 then
                get_out = upper(get_yn_box("Invalid start time format - HH:MM ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        secs = utils_valid_time(details[3])
        if val_pass = TRUE and secs = -1 then
                get_out = upper(get_yn_box("Invalid end time format - HH:MM ('c' to cancel)"))
                if get_out = 'C' then exit end if
                val_pass = FALSE
        end if
        
        --success
        if val_pass = TRUE then exit end if     
end while                       

if get_out != 'C' and upper(get_yn_box("Success - save diary ? (y/n)[n]")) = 'Y' then
        --can now save the table

        --use_on days
        for i = 6 to 12 do
                use_on = use_on & details[i]
        end for

        --slots per page
        secs = utils_valid_time(details[2])
        secs_end = utils_valid_time(details[3])
        mins = (secs_end - secs)/60
        num_appts = mins / strtoval(details[4])
        if num_appts != floor(num_appts) then
                num_appts = floor(num_appts) + 1
        end if
        spp = num_appts * strtoval(details[5])


        cmd = "INSERT INTO Diaries (name, time_start, time_end, appt_length, slots_per_appt, use_on_days, slots_per_page)" &
                "VALUES (" &
                "'" & details[1] & "', " &
                "'" & details[2] & "', " &
                "'" & details[3] & "', " &
                "'" & details[4] & "', " &
                "'" & details[5] & "', " &
                "'" & use_on & "', " &
                "'" & sprintf("%d", {spp}) & "' )"
        data = query_database("xdiary.sql", cmd)
        
        --and create the table for the diary here
        --does NOT like the word index as a column name!
        cmd = "CREATE TABLE " & details[1] & "(ind INTEGER PRIMARY KEY, client_name TEXT, patient_name TEXT, client_no INTEGER, " &
                "patient_no INTEGER, date TEXT, time TEXT, slot_on_page INTEGER, reason TEXT )"
        data = query_database("xdiary.sql", cmd)
        

end if

end procedure

------------------------------------------------------------------------------------------------------------
procedure diary_maintainence(sequence diary_list)
------------------------------------------------------------------------------------------------------------
integer choice, current_choice

current_choice = 1

while 1 do
        position (10,10)
        SetColors(BLACK, CYAN)
        SetSize(7,25)
        choice = Select("Diary maintainence menu", current_choice,
                                {"Create new diary",
                                 "Modify existing diary",
                                 "Delete a diary",
                                 "Quit"
                                })
        
        current_choice = choice
        
        if choice = 4 or choice = -1 then exit end if
        
        if choice = 1 then
                create_new_diary(diary_list)
        end if

        if choice = 2 then
                modify_diary()
        end if
        
        if choice = 3 then
                delete_diary()
        end if

end while
        
end procedure


------------------------------------------------------------------------------------------------------------
function get_diary_list()
------------------------------------------------------------------------------------------------------------
sequence diary_list, cmd, data

cmd = "SELECT name FROM Diaries"
data = query_database("xdiary.sql", cmd)

if length(data) > 0 then
        diary_list = data[2..$]
else diary_list = {}
end if

return diary_list
end function
rid_gdl = routine_id("get_diary_list")

------------------------------------------------------------------------------------------------------------
global procedure diary_main()
------------------------------------------------------------------------------------------------------------
integer choice, current_choice
sequence diary_list, dl

diary_list = {}

--get list of diaries
dl = get_diary_list()

if length(dl) > 0 then
        for i = 1 to length(dl) do
                diary_list = append(diary_list, dl[i][1])
        end for
end if
diary_list = append(diary_list, "Diary maintainence")
diary_list = append(diary_list, "Quit")

current_choice = 1

while 1 do
        position (9,9)
        SetColors(BRIGHT_WHITE, GREEN)
        SetSize(11,34)
        choice = Select("Diary menu", current_choice,
                                diary_list)
        
        current_choice = choice
        if choice = length(diary_list) or choice = -1 then exit end if
        
        if choice = length(diary_list) - 1 then
                diary_maintainence(diary_list)
                --refresh diary list
                diary_main()
                exit
        end if

        if length(diary_list) > 2 and choice <= length(diary_list) - 2 then
                VOID = open_diary(diary_list[choice])
        end if

        

end while               

--clear the box
position(9,9) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
        
        
end procedure






