--estimates.ex - for creating estimates!


sequence item_list
item_list = {}

-------------------------------------------------------------------------------------------------------------
function estimate_add_item()
-------------------------------------------------------------------------------------------------------------
sequence range_item, result, matching_prods, matching_items, selected_prod, quants, qstr
integer choice, current_choice

range_item = {0,0}
matching_items = {}
quants = {0,0}

if length(item_list) = SCREEN_LINES - 10 then
        VOID = get_yn_box("Estimate item limit reached")
        return range_item
end if


position(1, 18)
SetColors(BLACK, GREEN)
result = Form("Search for item", 
                {"","", 20})

result = remove_trailing_spaces(result[1])

matching_prods = query_database("xprods.sql", "SELECT * FROM Products where item LIKE '" & result & "%' ORDER BY item") 

if length(matching_prods) = 0 then
        VOID = get_yn_box("Sorry, no matches.")
        return range_item
end if
        
--now create a list of matching items
for i = 2 to length(matching_prods) do
        matching_items = append(matching_items, matching_prods[i][PROD_ITEM])
end for

current_choice = 1
while 1 do
        SetSize(14, 40)
        position(9,18)
        SetColors(BLACK, GREEN)
        choice = ListBoxIndex("Select", matching_items, current_choice)
        current_choice = choice
        if choice = -1 then exit end if
        if choice > 0 then
                selected_prod = matching_prods[choice+1] --because of the data query title line
                exit
        end if
end while

selected_prod = data_validate_product(selected_prod)

SetSize(14, 40)
position(9,18)
SetColors(BRIGHT_WHITE, GREEN)
quants = Form("Enter range / quantities",
                {"Lower ", "", 8,
                 "Upper ", "", 8})
quants[1] = strtoval(quants[1])
quants[2] = strtoval(quants[2])

if quants[1] = 0 and quants[2] = 0 then return range_item end if

if quants[2] < quants[1] then quants[2] = quants[1] end if      

qstr = sprintf("(%d - %d)", {quants[1], quants[2]})

--at the moment, not going to include dispensing fees, but will inc vat
range_item[1]  = selected_prod[PROD_SALES_PRICE]* quants[1] * (1+(selected_prod[PROD_VAT]/100))
range_item[2]  = selected_prod[PROD_SALES_PRICE]* quants[2] * (1+(selected_prod[PROD_VAT]/100))  * 1.1

--could put a little margin for error % increase in here!
item_list = append(item_list, {selected_prod[PROD_ITEM], qstr, range_item[1], range_item[2]} )

return range_item
end function




-------------------------------------------------------------------------------------------------------------
procedure create_estimates_window()
-------------------------------------------------------------------------------------------------------------
sequence box, range_total

range_total = {0,0}

position(8,1)
SetColors(GREEN, BLACK)
SetSize(SCREEN_LINES - 8, SCREEN_COLS-2)

box = DefaultBox
box = PlainBox(DefaultBox)

printcolor({9,2}, {CYAN, BLACK}, "Item")
printcolor({9, SCREEN_COLS-21}, {CYAN, BLACK}, "Lower          Upper")

if length(item_list) > 0 then
        for i = 1 to length(item_list) do
                printcolor({9+i,2}, {BRIGHT_GREEN, BLACK}, sprintf("%-40.40s %s ", {item_list[i][1], item_list[i][2]  })  )     
                printcolor( {9+i, SCREEN_COLS - 24}, {BRIGHT_GREEN, BLACK},  sprintf("%8.2f       %8.2f", {item_list[i][3], item_list[i][4]})  ) 
                range_total[1] = range_total[1] + item_list[i][3]
                range_total[2] = range_total[2] + item_list[i][4]
        end for
        printcolor( {7, SCREEN_COLS - 30}, {BRIGHT_BLUE, BLACK},  sprintf("Total %8.2f       %8.2f", {range_total[1], range_total[2]})  ) 

end if



end procedure




-------------------------------------------------------------------------------------------------------------
procedure estimates_header(integer fp)
-------------------------------------------------------------------------------------------------------------
puts(fp, "Estimate for procedures, drugs and materials\n")
puts(fp, "============================================\n\n\n")


printf(fp, "%s\n", {globalSettings[GS_PRACTICE]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS1]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS2]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS3]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS4]})
printf(fp, "%s\n", {globalSettings[GS_POSTCODE]})
printf(fp, "%s\n\n", {globalSettings[GS_TEL]})
printf(fp, "Branch : %s\n\n", {globalSettings[GS_BRANCH]})

printf(fp,"%s\n\n\n",{DateToStr(nowDate())})

end procedure

-------------------------------------------------------------------------------------------------------------
procedure estimates_body(integer fp)
-------------------------------------------------------------------------------------------------------------
atom lower_tot, upper_tot
lower_tot = 0
upper_tot = 0

printf(fp, "================================================================================\n\n\n\n", {})

printf(fp, "%-51s %8s       %8s\n\n", {"Item", "Lower", "Upper" })

for i = 1 to length(item_list) do
        printf(fp, "%s\n", {  sprintf("%-30.30s %-20.20s %8.2f       %8.2f", {item_list[i][1], item_list[i][2], item_list[i][3], item_list[i][4]  })               })
        lower_tot = lower_tot+ item_list[i][3]
        upper_tot = upper_tot + item_list[i][4]
end for

puts(fp, "\n")

printf(fp, "%51s %8.2f       %8.2f\n\n\n\n", {"Total ", lower_tot, upper_tot})


end procedure

-------------------------------------------------------------------------------------------------------------
procedure estimates_footer(integer fp)
-------------------------------------------------------------------------------------------------------------

puts(fp, "This is an ESTIMATE not a QUOTE. It is as accurate as possible at the time\n")
puts(fp, "of production. It only applies to the time it was produced. As with any\n")
puts(fp, "estimate, the actual cost may vary due to unforseen and unpredictable\n")
puts(fp, "circumstances and events arising during the procedure. This estimate does\n")
puts(fp, "NOT bind the practice to any price, nor is it any promise of price.\n")

end procedure

-------------------------------------------------------------------------------------------------------------
procedure personal_estimates()
-------------------------------------------------------------------------------------------------------------
integer fp

fp = open("estimate.txt","w")
estimates_header(fp)

printf(fp, "================================================================================\n\n\n", {})


printf(fp, "\nClient : %-30.30s    Patient : %s\n", {remove_trailing_spaces(CurClient[CL_TITLE]) & " " &  remove_trailing_spaces(CurClient[CL_FIRST_NAME]) & " " & remove_trailing_spaces(CurClient[CL_SURNAME]), CurPatient[PA_NAME]        })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS1],  CurPatient[PA_SPECIES]       })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS2],  CurPatient[PA_BREED]      })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS3],  CurPatient[PA_SEX]          })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS4],  CurPatient[PA_DOB]         })
printf(fp, "         %-30.30s              %.2f Kg\n", {CurClient[CL_POSTCODE], strtoval(CurPatient[PA_WEIGHT])         })
printf(fp, "         %-30.30s\n\n", {CurClient[CL_TEL1]})


estimates_body(fp)
estimates_footer(fp)
close(fp)
printers_print_file("estimate.txt", PR_ESTIMATES)
system_delete_file("estimate.txt")



end procedure

-------------------------------------------------------------------------------------------------------------
procedure general_estimates()
-------------------------------------------------------------------------------------------------------------
integer fp

fp = open("estimate.txt","w")
estimates_header(fp)
estimates_body(fp)
estimates_footer(fp)
close(fp)
printers_print_file("estimate.txt", PR_ESTIMATES)
system_delete_file("estimate.txt")

end procedure


-------------------------------------------------------------------------------------------------------------
global function estimates(integer client_no)
--need client_no to diff from main menu, or notes page
--simpler form of item addition, as don't need labels etc
-------------------------------------------------------------------------------------------------------------
integer choice, current_choice
sequence range_item, range_total, est_str

--clear the screen, create estimates boxes
utils_clear_screen()
current_choice = 1
range_total = {0,0}
range_item = {0,0}

item_list = {}
create_estimates_window()

while 1 do
        position(1,1)
        SetColors(BRIGHT_WHITE, BLUE)
        SetSize(6, 15)

        choice = Select("Estimates", current_choice,
                        {"Add item",
                         "Print estimate",
                         "Quit"})
        current_choice = choice
                         
        if choice = 3 or choice = -1 then 
                utils_clear_screen()
                exit
        elsif choice = 2 then
                --print estimate
                if client_no > 1 then
                        --have a client_no, so print personalised estimate
                        personal_estimates()
                else
                        --generalised estimate
                        general_estimates()
                end if
        elsif choice = 1 then
                range_item = estimate_add_item()
                create_estimates_window()
        end if
                         

end while

return "0" --may at some point put an option to add it to the client notes

end function
