--Forms - all functions dealing with creating / maintaining forms
sequence forms_list     --list of form names only
integer max_name_len

--------------------------------------------------------------------------------------------------
procedure get_forms_list()
--------------------------------------------------------------------------------------------------
sequence cmd, data
integer fp

--check for presence of forms database
fp = open("xforms.sql", "r")
if fp = -1 then
        cmd = "CREATE TABLE Forms (id INTEGER PRIMARY KEY, name TEXT, body TEXT)   "
        data = query_database("xforms.sql", cmd)
else
        close(fp)
end if  


cmd = "SELECT name FROM Forms"
data = query_database("xforms.sql", cmd)

max_name_len = 14

if length(data) = 0 then
        forms_list = {}
else
        forms_list = {}
        for i = 2 to length(data) do
                forms_list = append(forms_list, data[i][1])
                if length(data[i][1]) > max_name_len then
                        max_name_len = length(data[i][1])
                end if
        end for
end if   

end procedure


----------------------------------------------------------------------------------------------------
function parse_client_patient_block(sequence body, integer body_pos)
----------------------------------------------------------------------------------------------------
sequence cpblock, temp

cpblock = repeat({}, 10)
cpblock[1] = " -Client------------------------------Patient------------------------"
cpblock[2] = "|                                   |                                |"
cpblock[3] = "|                                   |                                |"
cpblock[4] = "|                                   |                                |"
cpblock[5] = "|                                   |                                |"
cpblock[6] = "|                                   |                                |"
cpblock[7] = "|                                   |                                |"
cpblock[8] = "|                                   |                                |"
cpblock[9] = "|                                   |                                |"
cpblock[10] = " --------------------------------------------------------------------"

temp = remove_trailing_spaces(CurClient[CL_TITLE]) & " " & remove_trailing_spaces(CurClient[CL_FIRST_NAME]) & " " &  remove_trailing_spaces(CurClient[CL_SURNAME])
cpblock[2] = seqcpy(temp, cpblock[2], 2)        --seqcpy in utils

temp = remove_trailing_spaces(CurClient[CL_ADDRESS1])
cpblock[3] = seqcpy(temp, cpblock[3], 2)  
temp = remove_trailing_spaces(CurClient[CL_ADDRESS2])
cpblock[4] = seqcpy(temp, cpblock[4], 2)  
temp = remove_trailing_spaces(CurClient[CL_ADDRESS3])
cpblock[5] = seqcpy(temp, cpblock[5], 2)  
temp = remove_trailing_spaces(CurClient[CL_ADDRESS4])
cpblock[6] = seqcpy(temp, cpblock[6], 2)  
temp = remove_trailing_spaces(CurClient[CL_POSTCODE])
cpblock[7] = seqcpy(temp, cpblock[7], 2)  
temp = remove_trailing_spaces(CurClient[CL_TEL1])
cpblock[8] = seqcpy(temp, cpblock[8], 2)  

temp = remove_trailing_spaces(CurPatient[PA_NAME])
cpblock[2] = seqcpy(temp, cpblock[2],39)  
temp = remove_trailing_spaces(CurPatient[PA_SPECIES])
cpblock[3] = seqcpy(temp, cpblock[3],39)  
temp = remove_trailing_spaces(CurPatient[PA_BREED])
cpblock[4] = seqcpy(temp, cpblock[4],39)  
temp = remove_trailing_spaces(CurPatient[PA_DOB])
cpblock[5] = seqcpy(temp, cpblock[5],39)  
temp = remove_trailing_spaces(CurPatient[PA_SEX])
cpblock[6] = seqcpy(temp, cpblock[6],39)  

temp = {}
temp = body[1..body_pos - 1] & cpblock & body[body_pos + 1 .. $]

return temp
end function


----------------------------------------------------------------------------------------------------
function replace_code(sequence str1, sequence str2, sequence line)
--replace str1 with str2 in line
----------------------------------------------------------------------------------------------------
sequence temp
integer pos_start, pos_end

pos_start = match(str1, line)
if pos_start = 0 then
        return line
end if

if pos_start = 1 then
        temp = remove_trailing_spaces(str2) & " " & line[length(remove_trailing_spaces(str1))+1 .. $] 
else
        temp = line[1..pos_start] & " " &  remove_trailing_spaces(str2) & " " & line[length(remove_trailing_spaces(str1))+1 .. $] 
end if

return temp
end function

----------------------------------------------------------------------------------------------------
function parse_client_block(sequence body, integer body_pos)
----------------------------------------------------------------------------------------------------
sequence cpblock, temp

cpblock = repeat("                                         ", 7)

temp = remove_trailing_spaces(CurClient[CL_TITLE]) & " " & remove_trailing_spaces(CurClient[CL_FIRST_NAME]) & " " &  remove_trailing_spaces(CurClient[CL_SURNAME])
if length(temp) > 40 then
        temp = temp[1..40]
end if
cpblock[1] = seqcpy(temp, cpblock[1], 2)        --seqcpy in utils

temp = remove_trailing_spaces(CurClient[CL_ADDRESS1])
cpblock[2] = seqcpy(temp, cpblock[2], 1)  
temp = remove_trailing_spaces(CurClient[CL_ADDRESS2])
cpblock[3] = seqcpy(temp, cpblock[3], 1)  
temp = remove_trailing_spaces(CurClient[CL_ADDRESS3])
cpblock[4] = seqcpy(temp, cpblock[4], 1)  
temp = remove_trailing_spaces(CurClient[CL_ADDRESS4])
cpblock[5] = seqcpy(temp, cpblock[5], 1)  
temp = remove_trailing_spaces(CurClient[CL_POSTCODE])
cpblock[6] = seqcpy(temp, cpblock[6], 1)  
temp = remove_trailing_spaces(CurClient[CL_TEL1])
cpblock[7] = seqcpy(temp, cpblock[7], 1)  

temp = body[1..body_pos - 1] & cpblock & body[body_pos + 1 .. $]

return temp
end function

----------------------------------------------------------------------------------------------------
function parse_patient_block(sequence body, integer body_pos)
----------------------------------------------------------------------------------------------------
sequence cpblock, temp

cpblock = repeat("                                         ", 10)

temp = remove_trailing_spaces(CurClient[CL_TITLE]) & " " & remove_trailing_spaces(CurClient[CL_FIRST_NAME]) & " " &  remove_trailing_spaces(CurClient[CL_SURNAME])
if length(temp) > 40 then
        temp = temp[1..40]
end if

temp = remove_trailing_spaces(CurPatient[PA_NAME])
cpblock[1] = seqcpy(temp, cpblock[1],1)  
temp = remove_trailing_spaces(CurPatient[PA_SPECIES])
cpblock[2] = seqcpy(temp, cpblock[2],1)  
temp = remove_trailing_spaces(CurPatient[PA_BREED])
cpblock[3] = seqcpy(temp, cpblock[3],1)  
temp = remove_trailing_spaces(CurPatient[PA_DOB])
cpblock[4] = seqcpy(temp, cpblock[4],1)  
temp = remove_trailing_spaces(CurPatient[PA_SEX])
cpblock[5] = seqcpy(temp, cpblock[5],1)  

temp = body[1..body_pos - 1] & cpblock & body[body_pos + 1 .. $]

return temp
end function

----------------------------------------------------------------------------------------------------
global function forms_select()
----------------------------------------------------------------------------------------------------
sequence data, cmd, body, temp
integer result, body_pos
integer si, form_id, lfl, fp, numcopies

temp = {}

get_forms_list()

if length(forms_list) = 0 then
        VOID = get_yn_box("No forms yet")
        return 0
end if

lfl = length(forms_list) + 3
if lfl > 11 then lfl = 11 end if

--select form to edit
SetSize(lfl , max_name_len + 2)
position(9,9)
SetColors(WHITE, BLUE)
si = ListBoxIndex("Select form", forms_list, 1)

if si < 1 then return 0 end if

--load form into memory
cmd = "SELECT body FROM Forms WHERE name like '" & forms_list[si] & "%'"
data = query_database("xforms.sql", cmd)

if length(data) = 0 then
        VOID = get_yn_box("Strange forms error!")
end if

body = utils_decompress(data[2][1])

--parse the file for FormCodes
body_pos = 1
while 1 do
        for i = 1 to length(FormCodes) do
                if match(FormCodes[i][1], upper(body[body_pos])) > 0 then
                        if i = 1 then
                                --client patient_block
                                body = parse_client_patient_block(body, body_pos)
                        elsif i = 2 then
                                body[body_pos] = replace_code("{date}", DateToStr(nowDate()), body[body_pos])
                                body[body_pos] = replace_code("{DATE}", DateToStr(nowDate()), body[body_pos])
                        elsif i = 3 then
                                --client block
                                body = parse_client_block(body, body_pos)
                        elsif i = 4 then
                                --patient block
                                  body = parse_patient_block(body, body_pos)
                        elsif i = 5 then
                                --nice client_name
                                body[body_pos] = replace_code("{clnamenice}", 
                                                                        remove_trailing_spaces(CurClient[CL_TITLE]) & " " & remove_trailing_spaces(CurClient[CL_FIRST_NAME]) & " " &  remove_trailing_spaces(CurClient[CL_SURNAME]),
                                                                        body[body_pos])
                                body[body_pos] = replace_code("{CLNAMENICE}",
                                                                        remove_trailing_spaces(CurClient[CL_TITLE]) & " " & remove_trailing_spaces(CurClient[CL_FIRST_NAME]) & " " &  remove_trailing_spaces(CurClient[CL_SURNAME]),
                                                                        body[body_pos])
                        elsif i = 6 then
                                --patient name
                                body[body_pos] = replace_code("{paname}",
                                                                        remove_trailing_spaces(CurPatient[PA_NAME]),
                                                                        body[body_pos])
                                body[body_pos] = replace_code("{PANAME}",
                                                                        remove_trailing_spaces(CurPatient[PA_NAME]),
                                                                        body[body_pos])
                        elsif i = 7 then
                                --species
                                body[body_pos] = replace_code("{paspecies}",
                                                                        remove_trailing_spaces(CurPatient[PA_SPECIES]),
                                                                        body[body_pos])
                                body[body_pos] = replace_code("{PASPECIES}",
                                                                        remove_trailing_spaces(CurPatient[PA_SPECIES]),
                                                                        body[body_pos])
                        elsif i = 8 then
                                --him her
                                if length(CurPatient[PA_SEX]) > 0 and upper(CurPatient[PA_SEX][1]) = 'M' then
                                        temp = "him"
                                else
                                        temp = "her"
                                end if                                       
                                body[body_pos] = replace_code("{pahimher}",
                                                                        temp,
                                                                        body[body_pos])
                                body[body_pos] = replace_code("{PAHIMHER}",
                                                                        temp,
                                                                        body[body_pos])
                        elsif i = 9 then 
                                --his hers
                                if length(CurPatient[PA_SEX]) > 0 and upper(CurPatient[PA_SEX][1]) = 'M' then
                                        temp = "his"
                                else
                                        temp = "her"
                                end if                                       
                                body[body_pos] = replace_code("{pahisher}",
                                                                        temp,
                                                                        body[body_pos])
                                body[body_pos] = replace_code("{PAHISHER}",
                                                                        temp,
                                                                        body[body_pos])
                        end if
                        
                        --reduce to check this line again for additional code
                        body_pos -= 1
                end if
        end for

        body_pos += 1
        if body_pos > length(body) then
                exit
        end if
                                                        
end while

fp = open("body.tmp", "w")
for i = 1 to length(body) do
        puts(fp, body[i] & "\n")
end for
close(fp)
system_view_file("body.tmp")


--how many copies of this file to send?
position(10,10)
SetSize(5,20)
SetColors(BRIGHT_GREEN, BLACK)
temp = Input("How many copies", {" "}, "1      ")

numcopies = strtoval(temp)

if numcopies <= 0 then
        return 0
end if

for i = 1 to numcopies do
        printers_print_file("body.tmp", PR_GENERAL)
end for
unlink("body.tmp")

return 0
end function

----------------------------------------------------------------------------------------------------
function new_form()
----------------------------------------------------------------------------------------------------
integer fp
sequence fname, form_name, ntime, cmd, data, form_body
object line


--get new form name
SetSize(4, 50)
position(9,9)
SetColors(WHITE, BLUE)
form_name = Input("Create a new form", {"Form name "}, "                                 ")

flush_key_buffers()

form_name = remove_trailing_spaces(form_name)

--check form_name against form_list
if length(forms_list) > 0 then
        for i = 1 to length(forms_list) do
                --VOID = get_yn_box(forms_list[i] & form_name)
                if equal(upper(form_name), upper(forms_list[i])) then
                        VOID = get_yn_box("This name is already taken - try again.")
                        return 0
                end if
        end for
end if

--create a tempoaray name to edit the file
fname = DateToStr(nowDate())
fname = "FORM-" & fname 
for i = 1 to length(fname) do
        if fname[i] = '/' then
                fname[i] = '-'
        end if
end for
fname = fname & "-"

ntime = nowTime()
fname = sprintf("%s%d%d%d.tmp", {fname, ntime[1], ntime[2], ntime[3]})

system_edit_file(fname)

--add to the database
form_body = {}
fp = open(fname, "r")
if fp != -1 then                
        while 1 do
                line = gets(fp)
                if atom(line) then exit end if
                form_body = append(form_body, line[1..$-1])     
        end while
        close(fp)

        form_body = utils_compress(form_body)
        
        cmd = sprintf("INSERT INTO Forms (name, body) VALUES ('%s', '%s')", {escape_quotes(form_name), escape_quotes(form_body)})
        data = query_database("xforms.sql", cmd) 
end if

unlink(fname)

return 0
end function


----------------------------------------------------------------------------------------------------
function open_form()
----------------------------------------------------------------------------------------------------
integer fp
sequence fname, form_name, ntime, cmd, data, form_body
object line
integer si, form_id, lfl

if length(forms_list) = 0 then
        VOID = get_yn_box("No forms yet")
        return 0
end if

lfl = length(forms_list) + 3
if lfl > 11 then lfl = 11 end if

--select form to edit
SetSize(lfl , max_name_len + 2)
position(9,9)
SetColors(WHITE, BLUE)
si = ListBoxIndex("Select form", forms_list, 1)

if si < 1 then return 0 end if

cmd = sprintf("SELECT * FROM Forms WHERE name LIKE '%s", {forms_list[si]})  & "%'"
data = query_database("xforms.sql", cmd)
form_name = forms_list[si]
form_id = strtoval(data[2][1])

--create a tempoaray name to edit the file
fname = DateToStr(nowDate())
fname = "FORM-" & fname 
for i = 1 to length(fname) do
        if fname[i] = '/' then
                fname[i] = '-'
        end if
end for
fname = fname & "-"

ntime = nowTime()
fname = sprintf("%s%d%d%d.tmp", {fname, ntime[1], ntime[2], ntime[3]})

--decompress the data string
form_body = utils_decompress(data[2][3])


--write the form_body to a file
fp = open(fname, "w")
for i = 1 to length(form_body) do
        printf(fp, "%s\n", {form_body[i]})
end for
close(fp)

--edit the file
system_edit_file(fname)

--add to the database
form_body = {}
fp = open(fname, "r")
if fp != -1 then                
        while 1 do
                line = gets(fp)
                if atom(line) then exit end if
                form_body = append(form_body, line[1..$-1])     
        end while
        close(fp)

        form_body = utils_compress(form_body)
        
        cmd = sprintf("UPDATE Forms SET name = '%s', body = '%s' WHERE id = %d", {escape_quotes(form_name), escape_quotes(form_body), form_id })
        data = query_database("xforms.sql", cmd) 
end if

unlink(fname)

return 0
end function


----------------------------------------------------------------------------------------------------
function delete_form()
----------------------------------------------------------------------------------------------------
integer fp
sequence fname, form_name, ntime, cmd, data, form_body
object line
integer si, form_id, lfl

if length(forms_list) = 0 then
        VOID = get_yn_box("No forms yet")
        return 0
end if

lfl = length(forms_list) + 3
if lfl > 11 then lfl = 11 end if

--select form to delete
SetSize(lfl,max_name_len + 2)
position(9,9)
SetColors(WHITE, BLUE)
si = ListBoxIndex("Select form", forms_list, 1)

if si < 1 then return 0 end if

cmd = sprintf("DELETE FROM Forms WHERE name LIKE '%s", {forms_list[si]})  & "%'"

if upper(get_yn_box("Delete " & forms_list[si] & " - are you sure (y/n)") ) = 'Y' then
        data = query_database("xforms.sql", cmd)
end if


return 0
end function

----------------------------------------------------------------------------------------------------
procedure show_variables()
----------------------------------------------------------------------------------------------------
sequence varlist
integer maxcodelen, si

maxcodelen = 14

varlist = repeat({}, length(FormCodes))
for i = 1 to length(FormCodes) do
        varlist[i] = FormCodes[i][1] & " - " & FormCodes[i][2]
        if length(varlist[i]) > maxcodelen then
                maxcodelen = length(varlist[i])
        end if               
end for

SetSize(10,maxcodelen + 2)
position(9,9)
SetColors(WHITE, BLUE)
si = ListBoxIndex("Form codes", varlist, 1)

end procedure

----------------------------------------------------------------------------------------------------
function import_form()
----------------------------------------------------------------------------------------------------
sequence dn_list, fname, form_body, form_name, cmd, data
integer maxdnlen, si, fp, match_found
object line, dir_list

--puts(1, current_dir())

dir_list = dir(current_dir() &"/forms")

if atom(dir_list) then return 0 end if

if length(dir_list) < 3 then return 0 end if

maxdnlen = 14
dn_list = {}
for i = 3 to length(dir_list) do
        dn_list = append(dn_list, dir_list[i][D_NAME])
        if length(dn_list[$]) > maxdnlen then maxdnlen = length(dn_list[$]) end if
end for

--for i = 1 to length(dn_list) do puts(1, dn_list[i] & "\n") end for
SetSize(10,maxdnlen + 2)
position(9,9)
SetColors(WHITE, BLUE)
si = ListBoxIndex("Import forms", dn_list, 1)

if si < 1 then
        return 0
end if

fname = current_dir() &"/forms/" & dn_list[si]

--get new form name (checking for dups)
while 1 do
        match_found = 0
        SetSize(4,50)
        position(9,9)
        SetColors(WHITE, BLUE)
        form_name = Input("Create a new form", {"Form name "}, "                                 ")

        flush_key_buffers()

        form_name = remove_trailing_spaces(form_name)
        
        if length(form_name) = 0 then
                return 0
        end if

        --check form_name against form_list
        if length(forms_list) > 0 then
                for i = 1 to length(forms_list) do
                        --VOID = get_yn_box(forms_list[i] & form_name)
                        if equal(upper(form_name), upper(forms_list[i])) then
                                VOID = get_yn_box("This name is already taken - try again.")
                                match_found = 1
                        end if
                end for
        end if
        if match_found = 0 then exit end if
end while

--load up selected form, then promptly save it
form_body = {}
fp = open(fname, "r")
if fp != -1 then                
        while 1 do
                line = gets(fp)
                if atom(line) then exit end if
                form_body = append(form_body, line[1..$-1])     
        end while
        close(fp)

        form_body = utils_compress(form_body)
        
        cmd = sprintf("INSERT INTO Forms (name, body) VALUES ('%s', '%s')", {escape_quotes(form_name), escape_quotes(form_body)})
        data = query_database("xforms.sql", cmd) 
end if

return 0
end function

----------------------------------------------------------------------------------------------------
function print_form()
----------------------------------------------------------------------------------------------------
 sequence data, cmd, body, temp
integer result, body_pos
integer si, form_id, lfl, fp, numcopies

temp = {}

get_forms_list()

if length(forms_list) = 0 then
        VOID = get_yn_box("No forms yet")
        return 0
end if

lfl = length(forms_list) + 3
if lfl > 11 then lfl = 11 end if

--select form to edit
SetSize(lfl , max_name_len + 2)
position(9,9)
SetColors(WHITE, BLUE)
si = ListBoxIndex("Select form", forms_list, 1)

if si < 1 then return 0 end if

--load form into memory
cmd = "SELECT body FROM Forms WHERE name like '" & forms_list[si] & "%'"
data = query_database("xforms.sql", cmd)

if length(data) = 0 then
        VOID = get_yn_box("Strange forms error!")
end if

body = utils_decompress(data[2][1])

fp = open("body.tmp", "w")
for i = 1 to length(body) do
        puts(fp, body[i] & "\n")
end for
close(fp)
system_view_file("body.tmp")

 --how many copies of this file to send?
position(10,10)
SetSize(5,20)
SetColors(BRIGHT_GREEN, BLACK)
temp = Input("How many copies", {" "}, "1      ")

numcopies = strtoval(temp)

if numcopies <= 0 then
        return 0
end if

for i = 1 to numcopies do
        printers_print_file("body.tmp", PR_GENERAL)
end for
unlink("body.tmp")



return 0
end function


----------------------------------------------------------------------------------------------------
global procedure forms_main()
--main form editing / creation section
--will store form in a database, makes backing up more consistent, and file structure better
----------------------------------------------------------------------------------------------------
sequence menu_items
integer choice, current_choice
object dir_list

dir_list = dir(current_dir())

menu_items = {  "New form",
                        "Open form",
                        "Delete form",
                        "Show variables",
                        "Print form",
                        "Quit"
                        }

if sequence(dir_list) then
        for i = 1 to length(dir_list) do
                if match("forms", dir_list[i][D_NAME]) > 0 then
                        menu_items = {  "New form",
                                        "Open form",
                                        "Delete form",
                                        "Show form codes",
                                        "Print form",
                                        "Import form",
                                        "Quit"
                                        }
                end if
        end for
end if

              
forms_list = {}                

get_forms_list()
                
current_choice = 1
while 1 do
        position(8,8)
        SetColors(BRIGHT_WHITE, BLACK)
        SetSize(length(menu_items) + 3,20)

        choice = Select("Forms", current_choice, menu_items )

        current_choice = choice

        if choice = -1 or choice = length(menu_items) then exit end if

        if choice = 1 then
                VOID = new_form()
                get_forms_list()
                title()
        elsif choice = 2 then
                VOID = open_form()
                title()
        elsif choice = 3 then
                VOID = delete_form()
                get_forms_list()
                title()
        elsif choice = 4 then
                show_variables()
                title()
        elsif choice = 5 then
                --print_form - will ignore any codings
                get_forms_list()
                VOID = print_form()
        elsif choice = 6 then
                --import form - if present
                VOID = import_form()
                get_forms_list()
        end if
end while

end procedure




