--global settings

------------------------------------------------------------------------------
global procedure global_settings()
------------------------------------------------------------------------------
integer fp

--create a form
globalSettings = Form("Global settings", {
                        "VAT rate (%)        ", sprintf("%f", {globalSettings[GS_VAT]}), 10,
                        "ECU conversion rate ", sprintf("%f", {globalSettings[GS_ECU]}), 10,
                        "Practice name       ", globalSettings[GS_PRACTICE], 40,
                        "Address             ", globalSettings[GS_ADDRESS1], 40,
                        "                    ", globalSettings[GS_ADDRESS2], 40,
                        "                    ", globalSettings[GS_ADDRESS3], 40,
                        "                    ", globalSettings[GS_ADDRESS4], 40,
                        "                    ", globalSettings[GS_POSTCODE], 12,
                        "Telephone           ", globalSettings[GS_TEL], 15,
                        "VAT reg number      ", globalSettings[GS_VATREG], 20,
                        "Branch name         ", globalSettings[GS_BRANCH], 30,
                        "Branch number       ", sprintf("%d", {globalSettings[GS_BRANCH_NUMBER]}), 5 } )



--save the details
--or update the details if they already exist

for i = 1 to length(globalSettings) do
        globalSettings[i] = remove_trailing_spaces(globalSettings[i])
end for

fp = open("xsettings.dat","w")
for i = 1 to length(globalSettings) do
        printf(fp,"%s\n", {globalSettings[i]} )
end for
close(fp)

--normalise numbers
globalSettings[GS_VAT] = strtoval(globalSettings[GS_VAT])
globalSettings[GS_ECU] = strtoval(globalSettings[GS_ECU])
globalSettings[GS_BRANCH_NUMBER] = strtoval(globalSettings[GS_BRANCH_NUMBER])



end procedure


------------------------------------------------------------------------------
global procedure global_drug_label_address()
------------------------------------------------------------------------------
integer fp

position(11,11)

DrugLabelAddress = Form("Drug label address", {
                                "Practice name ", DrugLabelAddress[DL_NAME], 40,
                                "Address       ", DrugLabelAddress[DL_ADDRESS1], 40,
                                "              ", DrugLabelAddress[DL_ADDRESS2], 40,
                                "              ", DrugLabelAddress[DL_ADDRESS3], 40,
                                "              ", DrugLabelAddress[DL_ADDRESS4], 40,
                                "Postcode      ", DrugLabelAddress[DL_POSTCODE], 12,
                                "Telephone     ", DrugLabelAddress[DL_TEL], 15} )

fp = open("xdruglabel.dat", "w")                                
for i = 1 to length(DrugLabelAddress) do
        DrugLabelAddress[i] = remove_trailing_spaces(DrugLabelAddress[i])
        printf(fp, "%s\n", {DrugLabelAddress[i]} )
end for                         
close(fp)

end procedure


----------------------------------------------------------------------------------------------------
global procedure global_remindertypes()
----------------------------------------------------------------------------------------------------
integer choice, current_choice, fp

current_choice = 1

if length(ReminderTypes[1]) = 0 then ReminderTypes[1] = "Vaccination" end if

        position(10,10)
        SetColors(GREEN, WHITE)
        ReminderTypes = Form("Set reminder types for each slot",
                                {"Slot 1  ", ReminderTypes[1], 20,
                                 "Slot 2  ", ReminderTypes[2], 20,
                                 "Slot 3  ", ReminderTypes[3], 20,
                                 "Slot 4  ", ReminderTypes[4], 20,
                                 "Slot 5  ", ReminderTypes[5], 20,
                                 "Slot 6  ", ReminderTypes[6], 20,
                                 "Slot 7  ", ReminderTypes[7], 20,
                                 "Slot 8  ", ReminderTypes[8], 20,
                                 "Slot 9  ", ReminderTypes[9], 20,
                                 "Slot 10 ", ReminderTypes[10], 20
                                })

--save reminder types   
fp = open("xremindertypes.dat", "w")
for i = 1 to length(ReminderTypes) do
    ReminderTypes[i] = remove_trailing_spaces(ReminderTypes[i])
    printf(fp, "%s\n", {ReminderTypes[i]})
end for
close(fp)

end procedure



----------------------------------------------------------------------------------------
global procedure global_set_branch_colours_title()
----------------------------------------------------------------------------------------
integer choice, current_choice, fp, c, c1, c2
sequence result

position (11,11)
SetColors(BLUE, CYAN)
result = Form("Set new branch name",
                {"", "", 20
                })

result[1] = remove_trailing_spaces(result[1])
if length(result[1]) = 0 then result[1] = JV_BRANCH end if

c1 = JV_COLOURS[1]
c2 = JV_COLOURS[2]

 --try setting and changing the colors
position(1,1)
SetSize(2, SCREEN_COLS - 2)
SetColors(c1, c2)
MessageBox("JetVet SQL " & JV_VERSION & " Branch : " & result[1],{})


position (12,12)
SetSize(3, 27)
SetColors(CYAN, BLACK)
MessageBox("", {"Cursor keys cycle colours"})
while 1 do 
        c = wait_key()

        if c = up then 
                c1 -= 1
                if c1 < 1 then
                        c1 = 1
                end if
        elsif c = dn then
                c1 += 1
                if c1 > 16 then 
                        c1 = 16
                end if
        elsif c = left then
                c2 -= 1 
                if c2 < 1 then
                        c2 = 1
                end if
        elsif c = right then
                c2 += 1 
                if c2 > 16 then
                        c2 = 16
                end if
        elsif upper(c) = 'Q' or c = ESC then
                exit
        end if

--try setting and changing the colors
position(1,1)
SetSize(2, SCREEN_COLS - 2)
SetColors(c1, c2)
MessageBox("JetVet SQL " & JV_VERSION & " Branch : " & result[1],{})

end while

c = get_yn_box("Accept changes (y/n)[n]")
if upper(c) = 'Y' then
        fp = open("xbranch", "w")
        printf(fp,"%s\n%d\n%d\n", {result[1], c1, c2} )
        JV_BRANCH = result[1]
        close(fp)
        JV_COLOURS[1] = c1
        JV_COLOURS[2] = c2
        title()
else
        --set back to old colours and title
        position(1,1)
        SetSize(2, SCREEN_COLS - 2)
        SetColors(JV_COLOURS[1], JV_COLOURS[2])
        MessageBox("JetVet SQL " & JV_VERSION & " Branch : " & JV_BRANCH,{})
end if



end procedure
