--initialisation routines


----------------------------------------------------------------------------------------------------------------------------------------
global procedure init_create_invoices()
----------------------------------------------------------------------------------------------------------------------------------------
sequence cmd, data, sample

sample = repeat("0", 20)
sample[1] = "1"

--type 1, 2, 3 - inv, rem, state

cmd = "CREATE TABLE params (type INTEGER, mwb INTEGER, mpb INTEGER, af REAL, surch REAL, " &
        "ifpaid INTEGER, ifgreater REAL, produce INTEGER,  daystorem_1 INTEGER, " &
        "daystorem_2 INTEGER, daystorem_3 INTEGER, daystorem_4 INTEGER, final_rem_no INTEGER, " &
        "vatonaccfees INTEGER, vatonsurch INTEGER, remafsurch TEXT, footer TEXT)"
data = query_database("xinvoice.sql", cmd)


--insert sample, to create blank data
for i = 1 to 3 do
        cmd = "INSERT INTO params (type, mwb, mpb, af,surch," &
                "ifpaid, ifgreater, produce, daystorem_1, " &
                "daystorem_2, daystorem_3, daystorem_4, final_rem_no, " &
                "vatonaccfees, vatonsurch, remafsurch) VALUES (" &
                sprintf("%d", {i}) & ", "
                
        for j = 1 to 14 do
                cmd = cmd & "0, "
        end for
        cmd = cmd & "'----' )"
        
        data = query_database("xinvoice.sql", cmd)
                
end for
                
end procedure

----------------------------------------------------------------------------------------------------------------------------------------
global procedure init_create_oldinvoices()
----------------------------------------------------------------------------------------------------------------------------------------
sequence cmd, data

cmd = "CREATE TABLE oldinvoices (invoice_no INTEGER, date TEXT, client_no INTEGER, outs_bal REAL, billet TEXT)"

--The recorded billet will just be one long string, like a popup

data = query_database("xinvoice.sql", cmd)





end procedure


-------------------------------------------------------------------------------
procedure create_xclipats(integer db_num)
--client table
--patient table
--reminders table
--popups table
--pdsa table
-------------------------------------------------------------------------------
sequence cmd, data

--create Client table
if db_num = 1 then
        cmd = "CREATE TABLE Clients (client_no INTEGER PRIMARY KEY, surname TEXT, christianName TEXT, title TEXT, address1 TEXT, address2 TEXT, " &
                "address3 TEXT, address4 TEXT, postcode TEXT, tel1 TEXT, tel2 TEXT, flags TEXT, warning TEXT, last_cons_date TEXT, " &
                "next_cons_date TEXT, next_cons_time TEXT, last_paid TEXT, bill_type TEXT, fees REAL, drugs REAL, vat REAL, outs_bal REAL, " &
                "gone_to TEXT, branch TEXT, misc1 TEXT, misc2 TEXT)"
        
        data = query_database("xclipats.sql", cmd)
end if

--create Patient table
if db_num = 2 then
        cmd = "CREATE TABLE Patients (patient_no INTEGER PRIMARY KEY, type TEXT DEFAULT '_', name TEXT DEFAULT '_', dob TEXT DEFAULT '_', species TEXT, " &
                "sex TEXT DEFAULT '_', " &
                "breed TEXT DEFAULT '_', colour TEXT DEFAULT '_', insured TEXT DEFAULT '_', " &
                "farm_name TEXT DEFAULT '_', farm_type TEXT DEFAULT '_', herd_ref TEXT DEFAULT '_', height TEXT DEFAULT '_', tattoo TEXT DEFAULT '_', " & 
                "microchip TEXT DEFAULT '_', status TEXT DEFAULT '_', " &
                "weight REAL DEFAULT 0, fees REAL, drugs REAL, vat REAL, outs_bal REAL, mileage REAL, client_no INTEGER )"
        
        data = query_database("xclipats.sql", cmd)
end if

if db_num = 3 then
        --make sure jdate - is date due!      
        cmd = "CREATE TABLE Reminders (id INTEGER PRIMARY KEY, jdate INTEGER, client_no INTEGER, patient_no INTEGER, type TEXT, reminder_count INTEGER, jdate_last_run INTEGER DEFAULT 0)"    
        data = query_database("xclipats.sql", cmd)
end if

if db_num = 4 then      
        cmd = "CREATE TABLE Popups (client_no INTEGER, patient_no INTEGER, colour TEXT, cop TEXT, popup TEXT)"  
        data = query_database("xclipats.sql", cmd)
end if

if db_num = 5 then      
        cmd = "CREATE TABLE PDSA (client_no INTEGER, patient_no INTEGER, patient_name TEXT DEFAULT '-', cert_no INTEGER, expiry DATE, notes TEXT, chronic_condition TEXT, category TEXT)"
        data = query_database("xclipats.sql", cmd)
end if

end procedure

-------------------------------------------------------------------------------
global procedure init_check_archive_patients()
--checks for presence of, and creates if not found, Patients archive
-------------------------------------------------------------------------------
sequence cmd, data
integer match_found

cmd = "SELECT * FROM sqlite_master"
data = query_database("xarchive.sql", cmd)

match_found = 0

if length(data) > 1 then
        for i = 1 to length(data) do
                if match("Pati", data[i][2]) > 0 then
                        match_found = 1
                end if  
       end for
end if

if match_found = 0 then
        cmd = "CREATE TABLE Patients (patient_no INTEGER PRIMARY KEY, type TEXT DEFAULT '_', name TEXT DEFAULT '_', dob TEXT DEFAULT '_', species TEXT, " &
                "sex TEXT DEFAULT '_', " &
                "breed TEXT DEFAULT '_', colour TEXT DEFAULT '_', insured TEXT DEFAULT '_', " &
                "farm_name TEXT DEFAULT '_', farm_type TEXT DEFAULT '_', herd_ref TEXT DEFAULT '_', height TEXT DEFAULT '_', tattoo TEXT DEFAULT '_', " & 
                "microchip TEXT DEFAULT '_', status TEXT DEFAULT '_', " &
                "weight REAL DEFAULT 0, fees REAL, drugs REAL, vat REAL, outs_bal REAL, mileage REAL, client_no INTEGER )"
        data = query_database("xarchive.sql", cmd)
end if

end procedure


-------------------------------------------------------------------------------
procedure check_xclipats()
-------------------------------------------------------------------------------
sequence cmd, data, tables
integer match_found

--get list of tables from database, compare it with what should be present,
--if not present then create the table

tables = {"Clients", "Patients", "Reminders", "Popups", "PDSA"} 

cmd = "SELECT * FROM sqlite_master"
data = query_database("xclipats.sql", cmd)

if length(data) < 2 then
        for i = 1 to length(tables) do
                create_xclipats(i)
        end for 
else
        for i = 1 to length(tables) do
                match_found = 0
                for j = 2 to length(data) do
                        if equal(tables[i], data[j][2]) = 1 then
                                match_found = 1
                        end if
                end for
                if match_found = 0 then
                        create_xclipats(i)
                end if
        end for
end if

end procedure



-------------------------------------------------------------------------------
procedure create_xnotes()
-------------------------------------------------------------------------------
sequence data, cmd


cmd = "CREATE TABLE Notes (number INTEGER PRIMARY KEY, patient_no INTEGER, client_no INTEGER, date TEXT, note TEXT, " &
        "fees REAL, drugs REAL, vat REAL, total REAL, user TEXT, type TEXT, analysis INTEGER, jdate INTEGER)"

data = query_database("xnotes.sql", cmd)

end procedure

-------------------------------------------------------------------------------
global procedure init_check_archives()
-------------------------------------------------------------------------------
integer fp
sequence cmd, data

fp = open("xarchive.sql", "r")

if fp = -1 then
        --notes archive mirrors notes database - should hopefully allow easy access
        cmd = "CREATE TABLE Notes (number INTEGER PRIMARY KEY, patient_no INTEGER, client_no INTEGER, date TEXT, note TEXT, " &
                "fees REAL, drugs REAL, vat REAL, total REAL, user TEXT, type TEXT, analysis INTEGER, jdate INTEGER)"
        data = query_database("xarchive.sql", cmd)
        
        --One day may create / check for other tables here too!
        
else
        close(fp)
end if

end procedure


-------------------------------------------------------------------------------
procedure check_xnotes()
-------------------------------------------------------------------------------
sequence cmd, data, tables
integer match_found

tables = {"Notes"}

cmd = "SELECT * FROM sqlite_master"
data = query_database("xnotes.sql", cmd)

if length(data) < 2 then
        create_xnotes()
end if

end procedure


-------------------------------------------------------------------------------
procedure create_xprods(integer db_num)
-------------------------------------------------------------------------------
sequence data, cmd

if db_num = 1 then
        cmd = "CREATE TABLE Products (item TEXT, code TEXT, type TEXT, category TEXT default ' ', supplier TEXT, sup_ref TEXT, " &
                "man_ref TEXT, license TEXT, number INTEGER PRIMARY KEY, pack_cost REAL, units_pack REAL, pack_units TEXT, analysis TEXT, in_stock REAL, "&
                "unit_sales REAL, cost REAL, markup REAL, disc REAL, sales_price REAL, milk_withhold INTEGER, meat_withhold INTEGER, " &
                "egg_withhold INTEGER, warning TEXT, gen_label TEXT, extra_label TEXT, dosage TEXT, gen_letter TEXT, vat REAL, " &
                "recall INTEGER, dose_units TEXT, weight_mult REAL, status TEXT, sex TEXT, base_fee TEXT, info TEXT, recall_interval INTEGER DEFAULT 0, " &
                "recall_count INTEGER DEFAULT 0, batch_number TEXT DEFAULT '-')"
        data = query_database("xprods.sql", cmd)
end if

if db_num = 2 then
        cmd = "CREATE TABLE Categories (category TEXT, description TEXT)"
        data = query_database("xprods.sql", cmd)
end if

if db_num = 3 then
        cmd = "CREATE TABLE Pus (u TEXT default '-', i TEXT default '-', p TEXT UNIQUE default '-', sec TEXT default '-')" 
        data = query_database("xprods.sql", cmd)
end if

end procedure

-------------------------------------------------------------------------------
procedure create_xdiary()
-------------------------------------------------------------------------------
sequence data, cmd

cmd = "CREATE TABLE Diaries (name TEXT, time_start TEXT, time_end TEXT, appt_length INTEGER, slots_per_appt INTEGER, use_on_days TEXT DEFAULT '-------', slots_per_page)"
data = query_database("xdiary.sql", cmd)

end procedure

-------------------------------------------------------------------------------
procedure check_xprods()
-------------------------------------------------------------------------------
sequence cmd, data, tables
integer match_found

--going to put user passwords in here - under Pus (!)

tables = {"Products", "Categories", "Pus"}

cmd = "SELECT * FROM sqlite_master"
data = query_database("xprods.sql", cmd)

if length(data) < 4 then
        for i = 1 to length(tables) do
                match_found =0
                for j = 2 to length(data) do
                        if equal(tables[i], data[j][2]) = 1 then
                                match_found = 1
                        end if
                end for
                if match_found = 0 then
                        create_xprods(i)
                end if
        end for
end if

end procedure

---------------------------------------------------------------------------------------
procedure check_prescription_database()
---------------------------------------------------------------------------------------
sequence cmd, data
integer found

found = 0

cmd = "SELECT * FROM sqlite_master"
data = query_database("xbatch.sql", cmd)

for i = 2 to length(data) do
        if match("PRESC", upper(data[i][2]) ) > 0 then
                found = 1
        end if      
end for

if found = 0 then
        cmd = "CREATE TABLE Prescriptions (id INTEGER PRIMARY KEY, serial_no INTEGER, jdate INTEGER, client_no INTEGER, body TEXT)"
        VOID = query_database("xbatch.sql", cmd)
end if

end procedure


-------------------------------------------------------------------------------
procedure create_xbatch()
-------------------------------------------------------------------------------
sequence cmd, data

cmd = "CREATE TABLE Batches (id INTEGER PRIMARY KEY, prod_id INTEGER, prod_name TEXT, quantity REAL, pack_units TEXT, " &
                "date TEXT, batch_number TEXT DEFAULT '-', client_no INTEGER, patient_no INTEGER)"
data = query_database("xbatch.sql", cmd)

cmd = "CREATE TABLE DispList (id INTEGER, client_no INTEGER, patient_no INTEGER, patient_name TEXT, label_details TEXT )"
data = query_database("xbatch.sql", cmd)


end procedure

-------------------------------------------------------------------------------
procedure create_xsales()
--note - this can also serve as a vat book
--will include payments made in here too
-------------------------------------------------------------------------------

end procedure

-------------------------------------------------------------------------------
procedure load_xsettings()
-------------------------------------------------------------------------------
integer fp
object line

fp = open("xsettings.dat","r")
while 1 do
        exit
end while
close(fp)

end procedure

-------------------------------------------------------------------------------
procedure check_databases()
-------------------------------------------------------------------------------
integer fp

fp = open("xclipats.sql","r")
if fp = -1 then 
       for i = 1 to 5 do                --number of databases in xclipats
                create_xclipats(i)
        end for 
else close(fp)
end if
--check for presence of tables
check_xclipats()


fp = open("xnotes.sql","r")
if fp = -1 then create_xnotes()
else close(fp)
end if
check_xnotes()

fp = open("xprods.sql","r")
if fp = -1 then 
        for i = 1 to 3 do
                create_xprods(i)
        end for
else close(fp)
end if
check_xprods()

fp = open("xsales.sql","r")
if fp = -1 then create_xsales()
else close(fp)
end if

fp = open("xsettings.dat","r")
if fp > 0 then load_xsettings()
        close(fp)
end if

fp = open("xdiary.sql","r")
if fp = -1 then create_xdiary()
else close(fp)
end if

fp = open("xbatch.sql","r")
--batch tracking database
--also contains dispensing list for client
if fp = -1 then create_xbatch()
else close(fp)
end if
check_prescription_database()


end procedure



-------------------------------------------------------------------------------
global procedure init_initialise()
-------------------------------------------------------------------------------
integer fp
object line
integer x

--check databases
check_databases()

--load global settings
fp = open("xsettings.dat","r")
if fp != -1 then
        x = 1
        while 1 do
                line = gets(fp)
                if sequence(line) then
                        globalSettings[x] = remove_trailing_spaces(line)
                        x += 1
                        if x = 13 then exit end if
                else
                        exit
                end if
        end while
        close(fp)
        --normalise numbers
        globalSettings[GS_VAT] = strtoval(globalSettings[GS_VAT])
        globalSettings[GS_ECU] = strtoval(globalSettings[GS_ECU])
        globalSettings[GS_BRANCH_NUMBER] = strtoval(globalSettings[GS_BRANCH_NUMBER])
else
        --warn haven't created settings file
        VOID = get_yn_box("Warning - create the global settings!")
end if

--load global label address settings
fp = open("xdruglabel.dat", "r")
if fp != -1 then
        x = 1
        while 1 do
                line = gets(fp)
                if sequence(line) then
                        DrugLabelAddress[x] = remove_trailing_spaces(line)
                        x += 1
                else
                        exit
                end if
        end while
        close(fp)
end if

--load printers
fp = open("xprinters.dat", "r")
if fp != -1 then
        x = 1
        while 1 do
                line = gets(fp)
                if sequence(line) then
                        printers[x] = remove_trailing_spaces(line)
                        x += 1
                else
                        exit
                end if
        end while
        close(fp)
end if

--load reminder types
fp = open("xremindertypes.dat", "r")
if fp != -1 then
        x = 1
        while 1 do
                line = gets(fp)
                if sequence(line) then
                        ReminderTypes[x] = remove_trailing_spaces(line)
                        x += 1
                else
                        exit
                end if
        end while
        close(fp)
end if

--load product categories
fp = open("xprod_cats", "r")
if fp != -1 then
        x = 1
        while 1 do
                line = gets(fp)
                if sequence(line) then
                        ProductCategories[x] = remove_trailing_spaces(line)
                        x += 1
                else
                        exit
                end if
                if x > 26 then exit end if
        end while
        close(fp)
end if

--load branch name and colours
JV_COLOURS = {BLACK, GREEN}
fp = open("xbranch", "r")
if fp != -1 then
        JV_BRANCH = gets(fp)
        JV_BRANCH = JV_BRANCH[1..$-1]

        line = gets(fp)
        JV_COLOURS[1] = strtoval(line)

        line = gets(fp)
        JV_COLOURS[2] = strtoval(line)
end if

end procedure



