--------------------------------------------------------------------------------------------------------------
--for the sake of navigation (hopefully), separating the functions into files

include invoicing_setup.ex              --setup functions
include invoicing_2.ex                  --listing / amending clients for sending of invoices
include invoicing_run.ex
include invoicing_review.ex

--------------------------------------------------------------------------------------------------------------
procedure aged_debt_report()
--------------------------------------------------------------------------------------------------------------
sequence data, cmd, report, st
integer fp

report = {}

--get all clients with outstanding balance
cmd = "SELECT * FROM Clients WHERE outs_bal > 0 ORDER BY surname"
data = query_database("xclipats.sql", cmd)



if length(data) > 0 then
        SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
        MessageBox(sprintf("Analysing %d clients aged debts", {length(data) - 1}), {})
        
       for i = 2 to length(data) do
                --position( (SCREEN_LINES/2) - 2, (SCREEN_COLS/2) - 19 ) print
                printcolor({(SCREEN_LINES/2) - 2, (SCREEN_COLS/2) - 19}, {BRIGHT_WHITE, GREEN}, sprintf("Current client : %d  ", {i})  )
                
                data[i] = data_validate_client(data[i])
                report = append(report, aged_debts(data[i]) )                
        end for
end if

st = repeat(0, 9)      --summary_totals

unlink("aged_debt_report.txt")
fp = open("aged_debt_report.txt", "a")

printf(fp, "\n\nAged debt list\n==============\n\n", {})

printf(fp, "Surname       Number     Debt age                               Outstanding\n", {})
printf(fp, "                           0-30     31-60    61-90      90+\n", {})

for i = 1 to length(report) do

        printf(fp, "%-13.13s %-8d %8.2f  %8.2f %8.2f %8.2f   %8.2f\n", 
                {report[i][2],
                 report[i][3],
                 report[i][4],
                 report[i][5],
                 report[i][6],
                 report[i][7],
                 report[i][8]
                })

        st[4] +=  report[i][4]
        st[5] +=  report[i][5]
        st[6] +=  report[i][6]
        st[7] +=  report[i][7]
        st[8] +=  report[i][8]
end for

printf(fp, "===========================================================================\n", {})
printf(fp, "%-13.13s %-8s %8.2f  %8.2f %8.2f %8.2f   %8.2f\n", 
                {" ",
                " ",
                st[4],
                st[5],
                st[6],
                st[7],
                st[8]
                })


close(fp)

--view the file
system_view_file("aged_debt_report.txt")

--ask whether to print file
if upper(get_yn_box("Print this file? (y/n)[n]")) = 'Y' then
        printers_print_file("aged_debt_report.txt", PR_INVOICE_SUMMARIES)
end if


end procedure

--------------------------------------------------------------------------------------------------------------
global procedure invoicing_main_menu()
--------------------------------------------------------------------------------------------------------------
integer choice, current_choice
sequence menu_items
 atom db, row_id


DUMMY_RUN = FALSE

load_params()  --in invoicing setup

menu_items = {  "Setup", 
                "List and amend clients",
                "Dummy run", 
                "Run invoices", 
                "Review current run", 
                "Review previous invoices",
                "Aged debt report",
                "Quit"}

utils_clear_screen()            
                
current_choice = 1
while 1 do
        position(2,2)
        SetColors(BRIGHT_WHITE, BLUE)
        SetSize(11,30)
        
        choice = Select("Invoicing main", current_choice, menu_items )
        
        current_choice = choice
        
        if choice = -1 or choice = length(menu_items) then exit end if
        
        if choice = 1 then
                VOID = inv_setup()
        elsif choice = 2 then
                VOID = list_amend_outstanding_clients() --invoicing_2.ex
                
        elsif choice = 3 then
                DUMMY_RUN = TRUE
                run_invoices()
        elsif choice = 4 then
                DUMMY_RUN = FALSE
                run_invoices() 
        elsif choice = 5 then
                review_current_run()    --invoicing_review.ex   
                utils_clear_screen()
        elsif choice = 6 then
                --review_previous_runs()        --invoicing_review.ex
                review_previous_runs()
                utils_clear_screen()
        elsif choice = 7 then
                aged_debt_report()
                utils_clear_screen()
        end if



end while



end procedure