--invoicing review - from review current run

--variables for selecting of old invoices
integer cn_from, cn_to,
        date_from_int, date_to_int
sequence sur_from, sur_to,
        date_from_seq, date_to_seq,
        review_IRS

        
------------------------------------------------------------------------------------------------------------
procedure review_print_spools(sequence spool_file)
--prints the files 'invoice_spool.txt' and 'invoice_summary.txt'
--fot the invoices (etc) create temp file to print
------------------------------------------------------------------------------------------------------------
integer fp, bc
object line
sequence buffer

fp = open(spool_file, "r")
buffer ={}
while 1 do
        --read in all lines, until reach end
        line = gets(fp)
        if atom(line) then exit end if
        buffer = append(buffer, line[1..$-1])
end while
close(fp)

bc = 0
while 1 do
        bc += 1
        if bc > length(buffer) then exit end if       
        if match("###START###", buffer[bc]) > 0 then
                --start of file to print, move onto next line
                fp = open("invoice.prn", "w")
                while 1 do
                        bc += 1
                        if match("###END###", buffer[bc]) > 0 then
                                exit
                        end if
                        printf(fp, "%s\n", {buffer[bc]})
                end while
                close(fp)                      
                --end of file to print, so print it  
                printers_print_file("invoice.prn", PR_INVOICING)
        end if
end while


end procedure



-----------------------------------------------------------------------------------------------------------
procedure show_key_menu()
-----------------------------------------------------------------------------------------------------------
integer key

SetSize(11, 32)
SetColors(BLACK, CYAN)
position( (SCREEN_LINES-14)/2, (SCREEN_COLS-30)/2)
MessageBox("Keys",{
                "up/dn cursor keys - scroll",
                "pgup/pgdn/left/right cursor keys",
                "  - next/previous",
                "E - edit",
                "Enter - this menu",
                "P - print this invoice",
                "Q - quit"})

key = wait_key()

end procedure

-----------------------------------------------------------------------------------------------------------
function display_billet(sequence billet, integer bc, integer lbc)
--create a blank sequence of SCREEN_LINES and SCREEN_COLS
-----------------------------------------------------------------------------------------------------------
sequence page, page_line, blank_page
integer c, offset, fp
object line

page_line = repeat(' ', SCREEN_COLS)
page = repeat(page_line, SCREEN_LINES - 1)
blank_page = page

--set the screen, giving it a white background
position(1,1) SetColors(BLACK, WHITE) SetStyle(5) MessageBox("", {}) SetStyle(1)
clear_screen()

--copy the selected billet into the page
for i = 1 to SCREEN_LINES - 1 do
        if i > length(billet) then exit end if
        for j = 1 to length(billet[i]) do
                if j > length(page[i]) then exit end if 
                page[i][j] = billet[i][j]  
        end for
end for

--display
for i = 1 to length(page) do
        printcolor({i, 1}, {BLACK, WHITE}, page[i])
end for
printcolor({SCREEN_LINES, 1}, {YELLOW, BLUE}, sprintf("Displaying billet %d of %d Hit enter for menu", {bc, lbc}))

--input cycle
offset = 0
while 1 do
        c = wait_key()
        
        if upper(c) = 'Q' or c = ESC or c = pgdn or c = pgup or c = left or c = right then 
                exit

        elsif c = ENTER then
                show_key_menu() 
                
        elsif c = dn then
                offset += 1 
        elsif c = up then
                offset -= 1
                if offset < 0 then offset = 0 end if 
                
        elsif upper(c) = 'P' then
                fp = open("invoice_reprint_billet.tmp", "w")
                for i = 1 to length(billet) do
                        printf(fp, "%s\n", {billet[i]})          
                end for
                close(fp)
                
                printers_print_file("invoice_reprint_billet.tmp", PR_INVOICING)
                
                unlink("invoice_reprint_billet.tmp")  
        
        elsif upper(c) = 'E' then
                fp = open("invoice_reprint_billet.tmp", "w")
                for i = 1 to length(billet) do
                        printf(fp, "%s\n", {billet[i]})          
                end for
                close(fp)

                system_edit_file("invoice_reprint_billet.tmp")
                
                --read file back into billet, and warn that edits are not permanent
                billet = {}
                fp = open("invoice_reprint_billet.tmp", "r")
                while 1 do
                        line = gets(fp)
                        if atom(line) then 
                                exit
                        else
                                if length(line) < 2 then
                                        line = line & "      "
                                end if
                                billet = append(billet, line[1..$-1])
                        end if          
                end while
                close(fp)
                SetSize(5, 32)
                SetColors(BLACK, RED)
                position( (SCREEN_LINES-14)/2, (SCREEN_COLS-30)/2)
                MessageBox("WARNING",{
                                "Edits to this file are not",
                                "permanent"})
                VOID = wait_key()                       
        
        end if

        --refresh display
        page = blank_page
         for i = 1 to length(page) do
                 if i + offset > length(billet) then 
                        exit 
                 end if
                 
                 for  j = 1 to length(page[1]) do       --all page lines are the same length
                        if j > length(billet[i + offset]) then
                                exit                    
                        end if
                        
                        page[i][j] = billet[i+offset][j]
                 end for 
        end for
        
        

        position(1,1) SetColors(BLACK, WHITE) SetStyle(5) MessageBox("", {}) SetStyle(1)       
        for i = 1 to length(page) do
                --puts(1, page[i])
                printcolor({i, 1}, {BLACK, WHITE}, page[i])
                
        end for
        printcolor({SCREEN_LINES, 1}, {YELLOW, BLUE}, sprintf("Displaying billet %d of %d Hit enter for menu", {bc, lbc}))
        
        
end while

return c
end function



-----------------------------------------------------------------------------------------------------------
function display_spool(sequence spool_file)
--create a list of each of the billets
-----------------------------------------------------------------------------------------------------------
sequence billet_list, buffer, billet
integer fp, bc
object line

billet_list = {}
billet = {}
buffer = {}

fp = open(spool_file, "r")
if fp = -1 then
        VOID = get_yn_box("Can't find the spool file! Try running some invoices!")
        return 0
end if

while 1 do
        line = gets(fp)
        if sequence(line) then
                buffer = append(buffer, line[1..$-1])
        else
                exit
        end if
end while
close(fp)

bc = 0
while 1 do
        bc += 1
        if bc > length(buffer) then exit end if
        if match("###START##", buffer[bc] ) > 0 then
                --start a new billet, move to next line
                billet = {}
                while 1 do
                        bc += 1
                        if match("###END##", buffer[bc] ) = 0 then
                                --add it to the billet
                                billet = append(billet, buffer[bc])
                        else
                                exit
                        end if
                end while
                --end of that billet, add it to the billet list
                billet_list = append(billet_list, billet)
        end if
end while

--billet_list should now contain a list of billets, ready for display / manip etc

bc = 1

while 1 do
        VOID = display_billet(billet_list[bc], bc, length(billet_list))

        if VOID = pgup or VOID = left then
                bc = bc - 1
                if bc < 1 then 
                        bc = 1 
                end if
        elsif VOID = pgdn or VOID = right then
                bc += 1
                if bc > length(billet_list) then
                        bc -= 1
                end if
        else
                exit
        end if
end while

utils_clear_screen()


return 1
end function


-----------------------------------------------------------------------------------------------------------
procedure display_summary()
--views the invoice_summary.txt file
-----------------------------------------------------------------------------------------------------------
system_view_file("invoice_summary.txt")

end procedure
-----------------------------------------------------------------------------------------------------------
procedure reprint_summary()
--views the invoice_summary.txt file
-----------------------------------------------------------------------------------------------------------
printers_print_file("invoice_summary.txt", PR_INVOICE_SUMMARIES)

end procedure


-----------------------------------------------------------------------------------------------------------
global procedure review_current_run()
--display the current summary
--print the current summary
--display the current spool
--reprint an individual invoice
--reprint all the invoices
-----------------------------------------------------------------------------------------------------------
integer choice, current_choice
sequence menu_items


menu_items = {  "Display the current summary",
                "Print the current summary",
                "Display the current spool",
                "Reprint the current spool",
                "Quit"}

current_choice = 1
while 1 do
        position(4,4)
        SetColors(BRIGHT_WHITE, GREEN)
        SetSize(8,30)

        choice = Select("Invoicing - review current run", current_choice, menu_items )

        current_choice = choice

        if choice = -1 or choice = length(menu_items) then exit end if

        if choice = 1 then
                display_summary()
        elsif choice = 2 then
                reprint_summary()
        elsif choice = 3 then
                VOID = display_spool("invoice_spool.txt")
        elsif choice = 4 then
                review_print_spools("invoice_spool.txt")
        end if

end while

end procedure


--*********************************************************************************************************
--*********************************************************************************************************
-----------------------------------------------------------------------------------------------------------
procedure create_spool_file(sequence data)
-----------------------------------------------------------------------------------------------------------
integer fp
sequence oi

fp = open("old_invoice_spool.txt", "w")

for i = 1 to length(data) do
        oi = utils_decompress(data[i][5])

        for j = 1 to length(oi) do
                printf(fp, "%s\n", {oi[j]})
        end for

end for
close(fp)

VOID = display_spool("old_invoice_spool.txt")

end procedure

-----------------------------------------------------------------------------------------------------------
function get_invcs(sequence date_from, sequence date_to,
                        integer cn_from, integer cn_to,
                        sequence cs_from, sequence cs_to,
                        integer in_from, integer in_to,
                        integer INV, integer REM, integer STAT, integer BD)

--build SQL according to data presented
--date is only sorted out on a returned data set - less efficient I know, but easier
--surname also sorted on returned dataset
--  -2 is bad debt letter
--   0 is reminder
--  -1 is statement
--  anything greater than 0 is an invoice
-----------------------------------------------------------------------------------------------------------
sequence data, cmd, qcmd, ndata, sdata, ncompf, ncompt, fcomp, tcomp
atom date_from_n, date_to_n, calc_date_n
integer shortest

cmd = repeat({}, 5)
qcmd = {}

cmd[1] = sprintf("SELECT * FROM oldinvoices WHERE client_no >= %d AND client_no <= %d ", {cn_from, cn_to} )

if INV = TRUE then
        cmd[2] = sprintf("AND ( (invoice_no >= %d AND invoice_no <= %d) ", {in_from, in_to})
else
        cmd[2] = "AND ( invoice_no = 1.5 "      --invoice number will never be a REAL!
end if

qcmd = cmd[1] & cmd[2]

if REM = TRUE then
        cmd[3] = sprintf("OR (invoice_no = 0 ) ", {} )
        qcmd = qcmd & cmd[3]
end if

if STAT = TRUE then
        cmd[4] = sprintf("OR (invoice_no = -1 ) ", {})
        qcmd = qcmd & cmd[4]
end if

if BD = TRUE then
        cmd[5] = sprintf("OR (invoice_no = -2 ) ", {} )
        qcmd = qcmd & cmd[5]
end if

qcmd = qcmd & ")"

data = query_database("xinvoice.sql", qcmd)

--now need to filter out dates
ndata = {}
date_from_n = dateStrtoJdays(date_from)
date_to_n = dateStrtoJdays(date_to)

for i = 2 to length(data) do
        calc_date_n = dateStrtoJdays(data[i][2])
        if calc_date_n >= date_from_n and calc_date_n <= date_to_n then
                ndata = append(ndata, data[i])
        end if
end for

data = ndata

--filter out client surnames
cs_from = upper(remove_trailing_spaces(cs_from))
cs_to = upper(remove_trailing_spaces(cs_to))
if length(cs_from) != 1 or cs_from[1] != 'A' or length(cs_to) != 1 or cs_to[1] != 'Z' then
        --might be able to speed this up for long repeated searches, by keeping database open
        ndata = {}
        for i = 1 to length(data) do
                cmd = "SELECT surname FROM Clients WHERE client_no = " & data[i][3]
                sdata = query_database("xclipats.sql", cmd)
                if length(sdata) = 0 then
                        VOID = get_yn_box("Strange errors abound in searching!")
                        exit
                end if

                sdata[2][1] = upper(sdata[2][1])

                --get lengths of strings to all the same for comparison
                --from strings
                if length(sdata[2][1]) > length(cs_from) then
                        ncompf = sdata[2][1][1..length(sdata[2][1])]
                        fcomp =  cs_from
                else 
                        fcomp = cs_from[1..length(sdata[2][1])]
                        ncompf = sdata[2][1]
                end if
                
                --to strings
                if length(sdata[2][1]) > length(cs_to) then
                        ncompt = sdata[2][1][1..length(sdata[2][1])]
                        tcomp =  cs_to
                else 
                        tcomp = cs_to[1..length(sdata[2][1])]
                        ncompt = sdata[2][1]
                end if
                
                if compare(ncompf, fcomp) >= 0 and compare(ncompt, tcomp) <= 0 then
                        ndata = append(ndata, data[i])          
                end if

        end for

data = ndata
end if

return data
end function

-----------------------------------------------------------------------------------------------------------
procedure previous_runs_parameters(integer client_count)
-----------------------------------------------------------------------------------------------------------
sequence result, cmd, data
atom last_invoice_number
integer proceed

--get last invoice number
cmd = "SELECT * FROM oldinvoices"
data = query_database("xinvoice.sql", cmd)

last_invoice_number = 0

for i = length(data) to 1 by -1 do
        last_invoice_number = strtoval(data[i][1])
        if last_invoice_number > 0 then exit end if
end for 

SetSize(19,40)
result = MixedForm("Set search parameters", {BRIGHT_WHITE,BLUE}, 5,5,
                        {
                                {MF_LABEL, 3,3, "Date from           Date to"},                 --1
                                {MF_LABEL, 6,3, "Client number from  Client number to"},        --2
                                {MF_LABEL, 9,3, "Client surname from Client surname to"},       --3
                                {MF_LABEL, 12,3,"Invoice number from Invoice number to"},       --4

                                {MF_TEXT, 4,3, 15, date_from_seq},                              --5
                                {MF_TEXT, 4,23, 15, date_to_seq},                               --6
                                                                                              
                                {MF_TEXT, 7,3, 10, "1"},                                        --7
                                {MF_TEXT, 7,23, 10, sprintf("%d", {client_count})},             --8

                                {MF_TEXT, 10,3, 10, "A"},                                       --9
                                {MF_TEXT, 10, 23, 10, "Z"},                                     --10

                                {MF_TEXT, 13,3, 10, "1"},                                       --11
                                {MF_TEXT, 13,23, 10, sprintf("%d", {last_invoice_number})},     --12

                                {MF_CHECK, 15,3, TRUE, "Invoices"},                            --13
                                {MF_CHECK, 16,3, TRUE, "Reminders"},                            --14
                                {MF_CHECK, 17,3, TRUE, "Statements"},                          --15
                                {MF_CHECK, 18,3, TRUE, "Bad debt letters"},                    --16

                                {MF_BUTTON, 15,25, 10, 1, "   OK    "},                         --17
                                {MF_BUTTON, 16,25, 10, 2, " Cancel  "}                          --18
                        }
                        )

proceed = TRUE                  
result[7] = strtoval(result[7])
result[8] = strtoval(result[8])

result[11] = strtoval(result[11])
result[12] = strtoval(result[12])

--valid dates?
if utils_validDate(result[5]) = FALSE or utils_validDate(result[6]) = FALSE then
        proceed = FALSE
        VOID = get_yn_box("Invalid dates")
end if

if result[12] > last_invoice_number then 
        result[12] = last_invoice_number
end if

if result[8] > client_count then 
        result[8] = client_count 
end if

if result[7] < 1 or result[8] < 1  then
        proceed = FALSE
        VOID = get_yn_box("Invalid client number")
end if

 if result[11] < 1 or result[12] < 1 then
        proceed = FALSE
        VOID = get_yn_box("Invalid invoice number")
end if

if result[7] > result[8] then
        proceed = FALSE
        VOID = get_yn_box("Start client < end client")
end if

if result[11] > result[12] then
        proceed = FALSE
        VOID = get_yn_box("Start invoice < end invoice")
end if

if result [18] = 2 then
        proceed = FALSE
end if

if proceed = TRUE then
        data = get_invcs(      result[5], result[6],
                        result[7], result[8],
                        result[9], result[10],
                        result[11], result[12],
                        result[13], result[14], result[15], result[16])

        --data - set of oldinvoices within selected criterion - on to display section
        if length(data) > 0 then
                create_spool_file(data)
        else
                VOID = get_yn_box("No invoices matching search request")
        end if
end if

end procedure

-----------------------------------------------------------------------------------------------------------
global procedure review_previous_runs()
--select parameters to display
--client number / range
--client name /range
--date range
--invoices / reminders / statements etc
-----------------------------------------------------------------------------------------------------------
sequence cmd, data
integer choice, current_choice
sequence menu_items
integer fp

menu_items = {"Selection parameters",
                "Print selection",
                "Quit"
                }

--set initial values    
date_from_seq = "01/01/1999"
date_to_seq = DateToStr(nowDate()) 

cmd = "SELECT count(*) from clients"
data = query_database("xclipats.sql", cmd)
cn_from = 1
cn_to = strtoval(data[2][1]) 

sur_from = "" sur_to = ""

date_from_int =  dateStrtoJdays(date_from_seq)
date_to_int =  dateStrtoJdays(date_to_seq)

review_IRS = "XXXX"
               
current_choice = 1
while 1 do
        position(4,4)
        SetColors(BRIGHT_WHITE, GREEN)
        SetSize(6,33)

        choice = Select("Invoicing - review previous runs", current_choice, menu_items )

        current_choice = choice

        if choice = -1 or choice = length(menu_items) then exit end if

        if choice = 1 then
                previous_runs_parameters(cn_to)
        elsif choice = 2 then
                fp = open("old_invoice_spool.txt", "r")
                if fp = -1 then
                        previous_runs_parameters(cn_to)
                        if upper(get_yn_box("Print the selection (y/n)[n]")) = 'Y' then
                                review_print_spools("old_invoice_spool.txt")
                        end if
                else
                        if upper(get_yn_box("Print the selection (y/n)[n]")) = 'Y' then
                                review_print_spools("old_invoice_spool.txt")
                        end if
                        close(fp)
                end if
        end if

end while

--remove the file
unlink("old_invoice_spool.txt")

end procedure
