


--invoicing setup
--------------------------------------------------------------------------------------------------------------
global constant INVOICE = 1,
                REMINDER = 2,
                STATEMENT = 3,
                AGED_DEBT = 4,
                BAD_DEBT = 5,
        
                MWB = 1,                --monthly work breakdown
                MPB = 2,                --monthly payment breakdown
                AF = 3,                 --accounting fees
                SURCH = 4,              --surcharge
                IFPAID = 5,             --send if client paid
                IFGREATER = 6,          --produce only if greater than
                PRODUCE = 7,            --produce invoices / reminders / statements
                DAYSTOREM_1 = 8,        --days from invoice to 1st reminder
                DAYSTOREM_2 = 9,        --days to 2nd reminder, after 1st reminder
                DAYSTOREM_3 = 10,       --days to 3rd reminder, after 2nd reminder
                DAYSTOREM_4 = 11,       --days to 4th reminder, after 3rd reminder
                                        --NOTE - an invoice or reminder is an 'ACCOUNT EVENT'
                FINAL_REM_NO = 12,      --final reminder is reminder number x
                VATONACCFEES = 13,      --vat on accounting fees
                VATONSURCH = 14,        --vat on surcharge
                REMAFSURCH = 15,        --add af / surch to reminders
                                        --string 4 long, each char X or -
                DATEONPAGE = 16,
                CNFROM = 17,
                CNTO = 18
                
global integer  DUMMY_RUN,
                ADDRESS_LINES, --
                ADDRESS_COLS   -- delineates start of address for windowed envelopes             
                
global sequence params
params = repeat({}, 25) --some spare
params = repeat(params, 3) --for invoices / reminders / statements

--------------------------------------------------------------------------------------------------------------
procedure view_params(integer sel, sequence str)
--debugging
--------------------------------------------------------------------------------------------------------------
integer fp


fp = open("Params.txt", "a")
puts(fp, "\n" & str & "\n============================================\n")
pretty_print(fp, params[sel], {} ) 
close(fp)

end procedure

--------------------------------------------------------------------------------------------------------------
procedure validate_params(integer sel)
--------------------------------------------------------------------------------------------------------------

params[sel][MWB] = strtoval(params[sel][MWB])           --TRUE/FALSE
if params[sel][MWB] != 0 and params[sel][MWB] != 1 then
        params[sel][MWB] = 0
end if

params[sel][MPB] = strtoval(params[sel][MPB])           --TRUE/FALSE
if params[sel][MPB] != 0 and params[sel][MPB] != 1 then
        params[sel][MPB] = 0
end if

params[sel][AF] = strtoval(params[sel][AF])
params[sel][SURCH] = strtoval(params[sel][SURCH])

params[sel][IFPAID] = strtoval(params[sel][IFPAID])     --TRUE/FALSE
if params[sel][IFPAID] != 0 and params[sel][IFPAID] != 1 then
        params[sel][IFPAID] = 0
end if

params[sel][IFGREATER] = strtoval(params[sel][IFGREATER]) 

params[sel][PRODUCE] = strtoval(params[sel][PRODUCE])   --TRUE/FALSE
if params[sel][PRODUCE] != 0 and params[sel][PRODUCE] != 1 then
        params[sel][PRODUCE] = 0
end if

params[sel][DAYSTOREM_1] = strtoval(params[sel][DAYSTOREM_1])
params[sel][DAYSTOREM_2] = strtoval(params[sel][DAYSTOREM_2])
params[sel][DAYSTOREM_3] = strtoval(params[sel][DAYSTOREM_3])
params[sel][DAYSTOREM_4] = strtoval(params[sel][DAYSTOREM_4])

params[sel][FINAL_REM_NO] = strtoval(params[sel][FINAL_REM_NO])

params[sel][VATONACCFEES] = strtoval(params[sel][VATONACCFEES]) --TRUE/FALSE
if params[sel][VATONACCFEES] != 0 and params[sel][VATONACCFEES] != 1 then
        params[sel][VATONACCFEES] = 0
end if

params[sel][VATONSURCH] = strtoval(params[sel][VATONSURCH])     --TRUE/FALSE
if params[sel][VATONSURCH] != 0 and params[sel][VATONSURCH] != 1 then
        params[sel][VATONSURCH] = 0
end if

params[sel][CNFROM] = strtoval(params[sel][CNFROM])
params[sel][CNTO] = strtoval(params[sel][CNTO])

end procedure



--------------------------------------------------------------------------------------------------------------
procedure check_params_present()
--------------------------------------------------------------------------------------------------------------
sequence cmd, data
integer fp, oldinvoices_present

oldinvoices_present = FALSE

fp = open("xinvoice.sql", "r")
if fp > 0 then
        close(fp)
else
        --putting it in here, as its an initialisation issue
        init_create_invoices()
end if

--check for presence of old invoices database
cmd = "SELECT * FROM sqlite_master"
data = query_database("xinvoice.sql", cmd)

if length(data) > 0 then
        for i = 1 to length(data) do
                if match(data[i][2], "oldinvoices") > 0 then
                        oldinvoices_present = TRUE
                end if                  
        end for
end if  
if oldinvoices_present = FALSE then
        init_create_oldinvoices()
end if

end procedure



--------------------------------------------------------------------------------------------------------------
global procedure load_params()
--this is the very first setup routine called when the invoicing prog starts
--new - client number and dates will also be setup here now
--general params will be stored in invoicing param
--------------------------------------------------------------------------------------------------------------
sequence cmd, data
integer fp
object line


check_params_present()

--set client range
cmd = "SELECT count (*) FROM Clients"
data = query_database("xclipats.sql", cmd)
params[INVOICE][CNFROM] = 1
params[INVOICE][CNTO] =  strtoval(data[2][1])
params[INVOICE][DATEONPAGE] = DateToStr(nowDate())

--ok to load params now
cmd = "SELECT * from params WHERE type = 1"
data = query_database("xinvoice.sql", cmd)
if length(data) > 0 then
        for i = 2 to length(data[2]) do --1st value is type
                params[INVOICE][i-1] = data[2][i]
        end for
end if
validate_params(INVOICE)

cmd = "SELECT * from params WHERE type = 2 "
data = query_database("xinvoice.sql", cmd)
if length(data) > 0 then
        for i = 2 to length(data[2]) do
                params[REMINDER][i-1] = data[2][i]
        end for
end if
validate_params(REMINDER)

cmd = "SELECT * from params WHERE type = 3"
data = query_database("xinvoice.sql", cmd)
if length(data) > 0 then
        for i = 2 to length(data[2]) do
                params[STATEMENT][i-1] = data[2][i]
        end for
end if
validate_params(STATEMENT)

params[INVOICE][DATEONPAGE] = DateToStr(nowDate())


--load in address position
ADDRESS_LINES = 0
ADDRESS_COLS = 0
fp = open("xaddrposn","r")
if fp > 0 then
        line = gets(fp)
        ADDRESS_LINES = strtoval(line)          
        line = gets(fp)
        ADDRESS_COLS = strtoval(line)
        close(fp)
end if

if ADDRESS_LINES = -1 then ADDRESS_LINES = 0 end if
if ADDRESS_COLS = -1 then ADDRESS_COLS = 0 end if

end procedure


--------------------------------------------------------------------------------------------------------------
procedure update_params(integer sel)
--------------------------------------------------------------------------------------------------------------
sequence cmd, data

cmd = "UPDATE params SET " &
        "mwb = " & sprintf("%d", {params[sel][MWB]}) & ", " &
        "mpb = " & sprintf("%d", {params[sel][MPB]}) & ", " &
        "af = " & sprintf("%f", {params[sel][AF]}) & ", " &
        "surch = " & sprintf("%f", {params[sel][SURCH]}) & ", " &
        "ifpaid = " & sprintf("%d", {params[sel][IFPAID]}) & ", " &
        "ifgreater = " & sprintf("%f", {params[sel][IFGREATER]}) & ", " &
        "produce = " & sprintf("%d", {params[sel][PRODUCE]}) & ", " &
        "daystorem_1 = " & sprintf("%d", {params[sel][DAYSTOREM_1]}) & ", " &
        "daystorem_2 = " & sprintf("%d", {params[sel][DAYSTOREM_2]}) & ", " &
        "daystorem_3 = " & sprintf("%d", {params[sel][DAYSTOREM_3]}) & ", " &
        "daystorem_4 = " & sprintf("%d", {params[sel][DAYSTOREM_4]}) & ", " &
        "final_rem_no = " & sprintf("%d", {params[sel][FINAL_REM_NO]}) & ", " &
        "vatonaccfees = " & sprintf("%d", {params[sel][VATONACCFEES]}) & ", " &
        "vatonsurch = " & sprintf("%d", {params[sel][VATONSURCH]}) & ", " &
        "remafsurch = '" & params[sel][REMAFSURCH] & "' " &
        "WHERE type = " & sprintf("%d", {sel})
        
data = query_database("xinvoice.sql", cmd)

end procedure

--------------------------------------------------------------------------------------------------------------
procedure invoice_params()
--------------------------------------------------------------------------------------------------------------
sequence result, d, data, cmd

--setup defaults
d = repeat({}, 25)


--text boxes must ONLY be TRUE or FALSE - anything else, they don't work

SetSize(12, 70)
result = MixedForm("Invoice parameters", {BRIGHT_WHITE, BROWN}, 4,4,
                        {
                        {MF_CHECK, 3, 1,  params[INVOICE][MWB], "Monthly work breakdown"},              --1         
                        {MF_CHECK, 4, 1,  params[INVOICE][MPB], "Monthly payment breakdown"},           --2
                        {MF_CHECK, 3, 35, params[INVOICE][IFPAID], "Invoice client if paid for"},       --3
                        {MF_LABEL, 4, 39, "all work since last invoice"},                               --4
                        
                        {MF_LABEL, 6, 1, "Accounting fees"},                                            --5
                        {MF_TEXT,  6, 17, 7,sprintf("%-7.2f",{params[INVOICE][AF]}) },                  --6
                        {MF_CHECK, 6, 25, params[INVOICE][VATONACCFEES], "VAT on accounting fees"},     --7
                        {MF_LABEL, 7, 1,  "Surcharge %"},                                               --8
                        {MF_TEXT,  7, 17, 7,sprintf("%-7.2f",{params[INVOICE][SURCH]}) },               --9
                        {MF_CHECK, 7, 25, params[INVOICE][VATONSURCH], "VAT on surcharges"},            --10
                        {MF_LABEL, 9, 1, "Invoice only if outstanding greater than"},                   --11
                        {MF_TEXT,  9, 42, 7,sprintf("%-7.2f",{params[INVOICE][IFGREATER]}) },           --12             
                        
                        {MF_CHECK, 11, 1, params[INVOICE][PRODUCE], "Produce invoices"}                 --13
                        
                        
                        --acounting fees
                        --{MF_TEXT, 11, 17, 7,sprintf("%d",{params[INVOICE][AFAA]}) },                 
                        --{MF_TEXT, 13, 17, 7,sprintf("%d",{params[INVOICE][SURCHAA]}) },       
                
                        })

--put values back into database
params[INVOICE][MWB] =          result[1]
params[INVOICE][MPB] =          result[2]
params[INVOICE][IFPAID] =       result[3]
params[INVOICE][AF] = strtoval(result[6])
params[INVOICE][VATONACCFEES] = result[7]
params[INVOICE][SURCH] = strtoval(result[9])
params[INVOICE][VATONSURCH] =   result[10]
params[INVOICE][IFGREATER] = strtoval(result[12])
params[INVOICE][PRODUCE] =      result[13]

update_params(INVOICE)


end procedure


--------------------------------------------------------------------------------------------------------------
procedure reminder_params()
--------------------------------------------------------------------------------------------------------------
sequence result, d, data, cmd

--setup defaults
d = repeat({}, 25)

--set remafsurch
for i = 1 to 4 do
        if params[REMINDER][REMAFSURCH][i] = 'X' then
                d[3+i] = TRUE
        else
                d[3+i] = FALSE
        end if
end for 

--text boxes must ONLY be TRUE or FALSE - anything else, they don't work

SetSize(20, 70)
result = MixedForm("Reminder parameters", {BRIGHT_WHITE, BROWN}, 4,4,
                        {
                        {MF_LABEL, 3, 1, "Accounting fees"},                                         --1
                        {MF_LABEL, 4,1,  "Surcharge %"},                                             --2
                        {MF_TEXT,  3, 17, 7,sprintf("%-7.2f",{params[REMINDER][AF]}) },              --3
                        {MF_CHECK, 3, 25, params[REMINDER][VATONACCFEES], "VAT on accounting fees"}, --4
                        {MF_TEXT,  4, 17, 7,sprintf("%-7.2f",{params[REMINDER][SURCH]}) },           --5
                        {MF_CHECK, 4, 25, params[REMINDER][VATONSURCH], "VAT on surcharges"},        --6

                        {MF_CHECK, 6, 1, params[REMINDER][IFPAID], "Remind client if paid for"},     --7
                        {MF_LABEL, 7, 1, "    all work since last reminder"},                        --8

                        {MF_LABEL, 9, 1, "Remind only if outstanding greater than"},                 --9
                        {MF_TEXT,  9, 42, 7,sprintf("%-7.2f",{params[REMINDER][IFGREATER]}) },       --10
                        
                        {MF_LABEL, 11,1, "1st reminder sent       days after invoice"},              --11         
                        {MF_LABEL, 12,1, "2nd reminder sent       days after 1st reminder"},         --12
                        {MF_LABEL, 13,1, "3rd reminder sent       days after 2nd reminder"},         --13
                        {MF_LABEL, 14,1, "4th reminder sent       days after 3rd reminder"},         --14
                        {MF_LABEL, 15,1, "Final reminder is reminder number "},                      --15
                        {MF_TEXT, 11, 19, 5, sprintf("%d", {params[REMINDER][DAYSTOREM_1]})},        --16
                        {MF_CHECK,11,49, d[4], "Acc fee / surch"},                                   --17
                        {MF_TEXT, 12, 19, 5, sprintf("%d", {params[REMINDER][DAYSTOREM_2]})},        --18
                        {MF_CHECK,12,49, d[5], "Acc fee / surch"},                                   --19
                        {MF_TEXT, 13, 19, 5, sprintf("%d", {params[REMINDER][DAYSTOREM_3]})},        --20
                        {MF_CHECK,13,49, d[6], "Acc fee / surch"},                                   --21
                        {MF_TEXT, 14, 19, 5, sprintf("%d", {params[REMINDER][DAYSTOREM_4]})},        --22
                        {MF_CHECK,14,49, d[7], "Acc fee / surch"},                                   --23
                        {MF_TEXT, 15, 35, 5, sprintf("%d", {params[REMINDER][FINAL_REM_NO]})},       --24

                        {MF_CHECK, 17,1,params[REMINDER][MWB], "Monthly work breakdown"},            --25           
                        {MF_CHECK, 18,1,params[REMINDER][MPB], "Monthly payment breakdown"},         --26
                
                        {MF_CHECK, 19, 1, params[REMINDER][PRODUCE], "Produce reminders"}            --27           
                
                        })

--put values back into database
params[REMINDER][DAYSTOREM_1] = strtoval(result[16])
params[REMINDER][DAYSTOREM_2] = strtoval(result[18])
params[REMINDER][DAYSTOREM_3] = strtoval(result[20])
params[REMINDER][DAYSTOREM_4] = strtoval(result[22])
params[REMINDER][FINAL_REM_NO] = strtoval(result[24])

if result[17] = TRUE then
        params[REMINDER][REMAFSURCH][1] = 'X'
else
        params[REMINDER][REMAFSURCH][1] = '-'
        
end if
if result[19] = TRUE then
        params[REMINDER][REMAFSURCH][2] = 'X'
else
        params[REMINDER][REMAFSURCH][2] = '-'
        
end if
if result[21] = TRUE then
        params[REMINDER][REMAFSURCH][3] = 'X'
else
        params[REMINDER][REMAFSURCH][3] = '-'
        
end if
if result[23] = TRUE then
        params[REMINDER][REMAFSURCH][4] = 'X'
else
        params[REMINDER][REMAFSURCH][4] = '-'
        
end if



params[REMINDER][MWB] =                 result[25]
params[REMINDER][MPB] =                 result[26]
params[REMINDER][IFPAID] =              result[7]
params[REMINDER][AF] =                  strtoval(result[3])
params[REMINDER][VATONACCFEES] =        result[4]
params[REMINDER][SURCH] =               strtoval(result[5])
params[REMINDER][VATONSURCH] =          result[6]
params[REMINDER][IFGREATER] =           strtoval(result[10])
params[REMINDER][PRODUCE] =             result[27]

update_params(REMINDER)

end procedure

--------------------------------------------------------------------------------------------------------------
procedure statement_params()
--------------------------------------------------------------------------------------------------------------
sequence result, d, data, cmd

--setup defaults
d = repeat({}, 25)

--text boxes must ONLY be TRUE or FALSE - anything else, they don't work

SetSize(6, 30)
result = MixedForm("Statement parameters", {BRIGHT_WHITE, BROWN}, 4,4,
                        {
                        
                        {MF_CHECK, 4, 1, params[STATEMENT][PRODUCE], "Produce statement"}                               --10            
                
                        })


update_params(STATEMENT)


end procedure

--------------------------------------------------------------------------------------------------------------
procedure general_parameters()
--procedure set_address_position()
--moved into general setup
--------------------------------------------------------------------------------------------------------------
sequence result
integer fp
sequence prDate

position(4,4)
SetColors(WHITE, BLUE)

result = Form("General paramters",
                {"Selecting - Client from         ", sprintf("%d", {params[INVOICE][CNFROM]}), 6,
                 "Selecting - Client to           ", sprintf("%d", {params[INVOICE][CNTO]}), 6,
                 "Date shown on printout          ", DateToStr(nowDate()), 14,          
                 "Printing - Lines from top       ", sprintf("%d", {ADDRESS_LINES}), 4,
                 "Printing - Characters from left ", sprintf("%d", {ADDRESS_COLS}), 4
                 })

result[3] = remove_trailing_spaces(result[3])            
prDate = datestrtoDate(result[3]) 
if ValidDate(prDate) = 0 then
        VOID = get_yn_box(result[3] & " is not a valid date")
        params[INVOICE][DATEONPAGE] = DateToStr(nowDate())
else
        params[INVOICE][DATEONPAGE] = result[3]
end if                           
                 
--glbal constants defined in vetstruc
ADDRESS_LINES = strtoval(result[4])
ADDRESS_COLS = strtoval(result[5]) 

params[INVOICE][CNFROM] = strtoval(result[1])
params[INVOICE][CNTO] = strtoval(result[2])


--save it into file               
fp = open("xaddrposn", "w")
printf(fp,"%d\n%d\n", {ADDRESS_LINES, ADDRESS_COLS})
close(fp)


end procedure


--------------------------------------------------------------------------------------------------------------
procedure invoice_footer()
--footers will be stored in params database, as text string
--------------------------------------------------------------------------------------------------------------
sequence result, temp_str, form_seq, cmd, data

--get result from database
cmd = "SELECT footer FROM params WHERE type = 1"
data = query_database("xinvoice.sql", cmd)

if length(data) > 0 and find('|', data[2][1]) > 0 then
        result = utils_resolve_strings(data[2][1], -1)
else
        result = repeat("", 17)
end if

form_seq = repeat(0, 17 * 3)
for i = 1 to 17 do
        form_seq[(i-1) * 3 + 1] = ""
        form_seq[(i-1) * 3 + 2 ] = result[i]
        form_seq[(i-1) * 3 + 3 ] = 60
end for

position(4,4)
SetColors(BLACK, WHITE)

WORD_WRAP = TRUE
result = Form("", form_seq)
WORD_WRAP = FALSE

temp_str = ""
for i = 1 to length(result) do
        temp_str = temp_str & remove_trailing_spaces(result[i]) & "|"
end for

--save the footer
cmd = "UPDATE params SET footer = '" & escape_quotes(temp_str) & "' WHERE type = 1"
data = query_database("xinvoice.sql", cmd)

end procedure


--------------------------------------------------------------------------------------------------------------
procedure reminder_footer()
--footers will be stored in params database, as text string
--------------------------------------------------------------------------------------------------------------
sequence result, temp_str, form_seq, cmd, data

--get result from database
cmd = "SELECT footer FROM params WHERE type = 2"
data = query_database("xinvoice.sql", cmd)

if length(data) > 0 and find('|', data[2][1]) > 0 then
        result = utils_resolve_strings(data[2][1], -1)
else
        result = repeat("", 17)
end if

form_seq = repeat(0, 17 * 3)
for i = 1 to 17 do
        form_seq[(i-1) * 3 + 1] = ""
        form_seq[(i-1) * 3 + 2 ] = result[i]
        form_seq[(i-1) * 3 + 3 ] = 60
end for

position(4,4)
SetColors(BLACK, WHITE)

WORD_WRAP = TRUE
result = Form("", form_seq)
WORD_WRAP = FALSE

temp_str = ""
for i = 1 to length(result) do
        temp_str = temp_str & remove_trailing_spaces(result[i]) & "|"
end for

--save the footer
cmd = "UPDATE params SET footer = '" & escape_quotes(temp_str) & "' WHERE type = 2"
data = query_database("xinvoice.sql", cmd)

end procedure




--------------------------------------------------------------------------------------------------------------
global function inv_setup()
--invoicing parameters
--reminder parameters
--invoice / reminder footers
--printer setup
--------------------------------------------------------------------------------------------------------------
integer choice, current_choice
sequence menu_items

menu_items = {  "General parameters",
                "Invoice parameters",
                "Reminder parameters",
                "Statement parameters",
                "Invoice footers",
                "Reminder footers",
                "Bad debt letter",
                "Quit"}

current_choice = 1
while 1 do
        position(3,3)
        SetColors(BRIGHT_WHITE, GREEN)
        SetSize(length(menu_items)+3,30)
        
        choice = Select("Invoicing setup", current_choice, menu_items )
        
        current_choice = choice
        
        if choice = -1 or choice = length(menu_items) then exit end if
        
        if choice = 2 then
                invoice_params()
        elsif choice = 1 then
                general_parameters()        
        elsif choice = 3 then
                reminder_params()
        elsif choice = 4 then
                statement_params()
        elsif choice = 5 then
                invoice_footer()
        elsif choice = 6 then
                reminder_footer()
        elsif choice = 7 then
                system_edit_file("xBadDebtLetter.txt")
        end if

        utils_clear_screen()


end while



return 0
end function














































