--jvutils.ex
--from main menu utilities sub menu
--messaging system
--front page bottom info







-----------------------------------------------------------------------------------------------------------------
global function jvutils_client_locks()
-----------------------------------------------------------------------------------------------------------------
sequence file_contents, client_list, client_item, data, cmd, pick_list
object line
integer fp, max_length, choice

fp = open("client_locks", "r")
if fp = -1 then
        VOID = get_yn_box("No clients locked apparently")
        unlink("client_locks")
        return 0
end if

file_contents = {}

while 1 do
        line = gets(fp)
        if sequence(line) and length(remove_trailing_spaces(line)) > 0 then
                file_contents = append(file_contents, line)
        else
                exit
        end if
end while
close(fp)

if length(file_contents) = 0 then
        VOID = get_yn_box("No clients locked apparently")
        return 0
end if

--can now process contents of client_locks
--contains client_no and initials of user.
--to get client name for display, have to quick ref to database

client_item = {0,{},{},{}}  --client_number, surname, locked by, location (to do)
client_list = repeat(client_item, length(file_contents) )

--get initial details from file_contents
for i = 1 to length(file_contents) do
        client_list[i][1] = strtoval(file_contents[i])
        for j = 1 to length(file_contents[i]) do
                if file_contents[i][j] = ' ' then
                        client_list[i][3] = file_contents[i][j+1..$]  
                        exit
                end if
        end for
end for

--get surnames from database
for i = 1 to length(client_list) do
        cmd = "SELECT surname FROM Clients WHERE client_no = " & sprintf("%d", {client_list[i][1]} )
        data = query_database("xclipats.sql", cmd)
        if length(data) = 0 then
                VOID = get_yn_box("Strange error - no data associated with client_no!")
                exit
        else
                client_list[i][2] = data[2][1]
        end if
end for

--display a listbox to select a client to unlock
max_length = 0
pick_list = repeat({}, length(client_list))
for i = 1 to length(client_list) do
        pick_list[i] = sprintf("%d %s locked by %s", {client_list[i][1] , client_list[i][2], client_list[i][3] } )
        if length(pick_list[i]) > max_length then 
                max_length = length(pick_list[i])
        end if
end for

position(  floor((SCREEN_LINES/2) - 4), floor((SCREEN_COLS/2) - max_length/2) )
SetColors(YELLOW, BLACK)
SetSize(6, max_length+2)

choice = Select("Select a client to unlock", 1, pick_list)
if choice > 0 then
        fp = open("client_locks", "w")
        for i = 1 to length(client_list) do
                if strtoval(pick_list[choice]) != client_list[i][1] then
                        printf(fp, "%d %s\n", { client_list[i][1], client_list[i][3]})
        end if
        end for
        close(fp)
        VOID = get_yn_box("OK")
end if

--clear the box
position(  floor((SCREEN_LINES/2) - 4), floor((SCREEN_COLS/2) - max_length/2) )
SetSize(6, max_length+2)
SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

return 0
end function


------------------------------------------------------------------------------------------------------------
procedure create_messages_database()
------------------------------------------------------------------------------------------------------------
sequence cmd, data

cmd = "CREATE TABLE messages (number INTEGER PRIMARY KEY, global TEXT, sender TEXT, user TEXT, read TEXT, date TEXT, subject TEXT, body TEXT)"

data = query_database("xmessages.sql", cmd)

end procedure


global integer MESSAGE_BOARD_ACTIVE
------------------------------------------------------------------------------------------------------------
global function jvutils_check_messages()
--messages checked every time main menu is passed
------------------------------------------------------------------------------------------------------------
integer fp
sequence data, cmd, box, body_text, strings


--check messages database exists
fp = open("xmessages.sql", "r")
if fp = -1 then
        create_messages_database()
else
        close(fp)       
end if

--check messages for user logged on
cmd = "SELECT * FROM messages WHERE user = '" & remove_trailing_spaces(CurUser[U_INIT]) & "'"
data = query_database("xmessages.sql", cmd)

if length(data) > 0 then
        --inform user of presence of messages
        SetColors(BRIGHT_WHITE, RED)
        position(SCREEN_LINES - 2, SCREEN_COLS - 18)
        SetSize(2, 17)
        MessageBox("You have messages", {})
end if

if MESSAGE_BOARD_ACTIVE = FALSE then
        return 0
end if

--check messages for main screen
cmd = "SELECT * FROM messages WHERE global = 'Y'"
data = query_database("xmessages.sql", cmd)

body_text = {}

if length(data) > 0 then
for i = 2 to length(data) do
        body_text = append(body_text, data[i][6])
        strings = utils_resolve_strings(data[i][8], 8)
        for j = 1 to length(strings) do
                if length(strings[j]) > 0 then
                        body_text = append(body_text, strings[j])
                end if
        end for
end for

--now have body_text
if length(body_text) > SCREEN_LINES - 8 then
        --body text is greater than length of available screen space
        body_text = body_text[ length(body_text) - (SCREEN_LINES-8) .. $]
end if

for i = 1 to length(body_text) do
        printcolor( {4+i, 40}, {WHITE, BLACK}, body_text[i] )
end for

end if

return 0
end function

------------------------------------------------------------------------------------------------------------
function read_messages()
--message text formatted same as popups 
------------------------------------------------------------------------------------------------------------
sequence cmd, data, messages, subjects, body_text, result, dtemp
integer choice, current_choice

cmd = "SELECT * FROM messages WHERE user = '" & remove_trailing_spaces(CurUser[U_INIT]) & "' ORDER BY number DESC"

data = query_database("xmessages.sql", cmd)

if length(data) = 0 then
        VOID = get_yn_box("No messages")
        return 0
end if          

current_choice = 1

while 1 do

        if length(data) = 0 then exit end if
        
        subjects = {}
        for i = 2 to length(data) do
                subjects = append(subjects, data[i][7])
                if data[i][5][1] = 'Y' then
                        subjects[i-1] = subjects[i-1] & " (Read)"
                        if length(subjects[i-1]) > 47 then
                                subjects[i-1] = subjects[i-1][1..47]
                        end if
                end if                  
        end for
        
        position(3,3)
        SetColors(BRIGHT_WHITE, BLUE)
        SetSize(7, 50)

        if current_choice > length(subjects) then
                current_choice = 1
        end if
        
        if length(subjects) = 0 then exit end if
                        
        choice = ListBoxIndex("Messages", subjects, current_choice)
        
        if choice = -1 then exit end if
        
        current_choice = choice
        
        --decode message from text str
        body_text = utils_resolve_strings(data[choice+1][8], 8)
        
        SetSize(15, 48)
        result = MixedForm(subjects[choice], {BRIGHT_WHITE, BROWN}, 5,5,
                                                {
                                                {MF_CHECK, 3, 1, FALSE, "Delete"},
                                                {MF_LABEL, 4,1, "From "},
                                                {MF_LABEL, 5,1, "Date "},
                                                {MF_LABEL, 6,1, "Body "},
                                                {MF_TEXT, 4,6, 30, data[choice+1][3]},
                                                {MF_TEXT, 5, 6, 12, data[choice+1][6]}, --date
                                                {MF_TEXT, 6,6,40, body_text[1]},
                                                {MF_TEXT, 7,6,40, body_text[2]},
                                                {MF_TEXT, 8,6,40, body_text[3]},
                                                {MF_TEXT, 9,6,40, body_text[4]},
                                                {MF_TEXT, 10,6,40, body_text[5]},
                                                {MF_TEXT, 11,6,40, body_text[6]},
                                                {MF_TEXT, 12,6,40, body_text[7]},
                                                {MF_TEXT, 13,6,40, body_text[8]}                                        
                                                })
        
        SetSize(15,48) position(5,5)
        SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
        
        if result[1] = TRUE then
                --delete the message
                cmd = "DELETE FROM messages WHERE number = " & data[choice+1][1]
                dtemp ={}
                if length(data) > 1 then
                        for i = 1 to length(data) do
                                if i != choice+1 then
                                        dtemp = append(dtemp, data[i])
                                end if
                        end for
                end if
                data = dtemp
        else
                --mark as read
                cmd = "UPDATE messages SET read = 'Y ' WHERE number = " & data[choice+1][1]
                data[choice+1][7] = data[choice+1][7] & " (Read)"
                if length(data[choice+1][7]) > 47 then
                        data[choice+1][7] = data[choice+1][7][1..47]
                end if
        end if
        VOID = query_database("xmessages.sql", cmd)     

end while       


position(3,3)
SetSize(7, 50)
SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

                
return 0
end function


------------------------------------------------------------------------------------------------------------
function send_message()
--message text formatted same as popups 
------------------------------------------------------------------------------------------------------------
sequence cmd, data, result, user_i, user_u, body_text
integer choice

--get list of users
cmd = "SELECT i, u FROM Pus"
data = query_database("xprods.sql", cmd)

if length(data) = 0 then
        VOID = get_yn_box("No users?")
        return 0
end if  

user_i = {} user_u = {}

for i = 2 to length(data) do
        user_i = append(user_i, data[i][1])
        user_u = append(user_u, data[i][2])
end for

--select user to send
position(4,4)
SetColors(YELLOW, BLACK)
SetSize(8,35)

--choice = Select("Select user to send message to", 1, user_u)

choice = ListBoxIndex("Select uset to send message to",user_u, 1)

if choice = -1 then return 0 end if

position(4,4)
SetColors(WHITE, GREEN)
WORD_WRAP = TRUE

result = Form("Compose your message", 
                {"Subject ", "", 40,
                 "Body    ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40
                 })
WORD_WRAP = FALSE

body_text = remove_trailing_spaces(result[2])

--create body from lines
for i = 3 to length(result) do
        body_text = body_text & "|" & remove_trailing_spaces(result[i])
end for
                             --2     --3   --4  --5  --6   --7    --8
cmd = "INSERT INTO messages (global, sender, user, read, date, subject, body) VALUES (" &
        "'N', " &
        "'" & CurUser[U_INIT] & "', " &
        "'" & user_i[choice] & "', " &
        "'N', " &
        "'" & DateToStr(nowDate()) & "', " &
        "'" & result[1] & "'," &
        "'" & body_text & "') "

data = query_database("xmessages.sql", cmd)

if sqlite_last_err_no = SQLITE_OK then
        VOID = get_yn_box("Message sent")
else
        VOID = get_yn_box("Unknown error!")
end if          

return 0
end function


------------------------------------------------------------------------------------------------------------
function main_screen_messages()
--just a simple wrapped form to add the message
------------------------------------------------------------------------------------------------------------
sequence result
sequence cmd, data, body_text

position(4,4)
SetColors(WHITE, GREEN)
WORD_WRAP = TRUE

result = Form("Message for main screen", 
                {"Text ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40,
                 "        ", "", 40
                 })
WORD_WRAP = FALSE

body_text = remove_trailing_spaces(result[1])

--create body from lines
for i = 2 to length(result) do
        body_text = body_text & "|" & remove_trailing_spaces(result[i])
end for

cmd = "INSERT INTO messages (global, sender, user, read, date, subject, body) VALUES (" &
        "'Y', " &
        "'-', " &
        "'-', " &
        "'N', " &
        "'" & DateToStr(nowDate()) & "', " &
        "'-'," &
        "'" & body_text & "') "

data = query_database("xmessages.sql", cmd)

if sqlite_last_err_no = SQLITE_OK then
        --VOID = get_yn_box("Message sent")
else
        VOID = get_yn_box("Unknown error!")
end if          


return 0
end function


------------------------------------------------------------------------------------------------------------
global procedure jvutils_message_centre()
------------------------------------------------------------------------------------------------------------
integer choice, current_choice, days, current_days
sequence data, cmd, tdata

utils_clear_screen()

--check for old global messages
cmd = "SELECT * FROM messages WHERE global = 'Y'"
tdata = query_database("xmessages.sql", cmd)
if length(tdata) > 0 then
        current_days =   dateStrtoJdays( DateToStr(nowDate()) )
        for i = 2 to length(tdata) do
                days = dateStrtoJdays(tdata[i][6])
                if current_days - days > 30 then
                      cmd = "DELETE FROM messages WHERE number = " & tdata[i][1]
                      data = query_database("xmessages.sql", cmd)
                end if
        end for
end if

current_choice = 1

while 1 do
        position(2,2)
        SetColors(BRIGHT_WHITE, BLUE)
        SetSize(7, 40)
        choice = Select("Message centre " & CurUser[U_NAME], current_choice,
                                {"List / read my messages",
                                 "Send a message",
                                 "Main screen messages",
                                 "Quit"
                                })
        
        current_choice = choice
        
        if choice = 4 or choice = -1 then exit end if
        
        if choice = 1 then
                VOID = read_messages()
        end if
        
        if choice = 2 then
                VOID = send_message()
        end if
        
        if choice = 3 then
                VOID = main_screen_messages()
        end if
                                        

end while

end procedure





