--management section
--miscellaneous management functions in here


------------------------------------------------------------------------------------------------------
procedure archive_notes_for_dead_patients()
------------------------------------------------------------------------------------------------------
sequence cmd, data, dead_patient_list, progress_bar
integer patient_count
atom percent, lpb

dead_patient_list = {}

cmd = "SELECT * FROM Patients WHERE status LIKE 'X%' and outs_bal = 0"
data = query_database("xclipats.sql", cmd)

dead_patient_list = data[2..$]
patient_count = length(dead_patient_list)

SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox(sprintf("Archiving dead patients, %d", {patient_count}), {})

for i = 1 to length(dead_patient_list)  do
                 
        percent = (i/patient_count) * 100
        lpb = floor(40 * percent/100)
        progress_bar = repeat('#', lpb)
        position( (SCREEN_LINES/2) - 1, (SCREEN_COLS/2) - 19 ) puts(1, progress_bar)

        cmd = "UPDATE Notes SET analysis = -1 WHERE patient_no = " & dead_patient_list[i][PA_PATIENT_NO] 
        VOID = query_database("xnotes.sql", cmd)
end for

end procedure

------------------------------------------------------------------------------------------------------
procedure archive_all_notes_before(atom jd)
------------------------------------------------------------------------------------------------------
sequence cmd, data

SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox("Marking old notes for archiving", {})

cmd = sprintf("UPDATE Notes SET analysis = -1 WHERE jdate < %d", {jd} )
VOID = query_database("xnotes.sql", cmd)

end procedure


------------------------------------------------------------------------------------------------------
procedure archive_all_notes_patient_not_seen_since (atom jd)
-- think this one will be the slowest
-- need to get the last note for each live patient
------------------------------------------------------------------------------------------------------
sequence cmd, data

end procedure

------------------------------------------------------------------------------------------------------
function copy_notes_to_archive()
------------------------------------------------------------------------------------------------------
sequence cmd, data, patient_list, notes_list, progress_bar
atom percent, lpb, sql_db

cmd = "SELECT * FROM Notes WHERE analysis = -1"
data = query_database("xnotes.sql", cmd)

if length(data) = 0 then return 0 end if

notes_list = data[2..$]

SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox(sprintf("Copying %d notes to archive", {length(notes_list)}), {})

sql_db = sqlite_open("xarchive.sql", 0)
if sql_db <= 0 then
        VOID = get_yn_box("Unable to open notes database")
end if

for i = 1 to length(notes_list) do
        notes_list[i] = data_validate_note(notes_list[i])
        
        percent = (i/length(notes_list)) * 100
        lpb = floor(40 * percent/100)
        progress_bar = repeat('#', lpb)
        position( (SCREEN_LINES/2) - 1, (SCREEN_COLS/2) - 19 ) puts(1, progress_bar)
        
        cmd = "INSERT INTO Notes (patient_no, client_no, date, note, fees, drugs, vat, total, user, type, analysis, jdate) " &
                        "VALUES ( " &
                "'" & sprintf("%d", {notes_list[i][N_PATIENT_NO]})       & "', " &       
                "'" & sprintf("%d", {notes_list[i][N_CLIENT_NO]})        & "', " &
                "'" & escape_quotes(notes_list[i][N_DATE])               & "', " &
                "'" & escape_quotes(notes_list[i][N_NOTE])               & "', " &
                "'" & sprintf("%f", {notes_list[i][N_FEES]})     & "', " &
                "'" & sprintf("%f", {notes_list[i][N_DRUGS]})    & "', " &               
                "'" & sprintf("%f", {notes_list[i][N_VAT] })     & "', " &       
                "'" & sprintf("%f", {notes_list[i][N_TOTAL]})    & "', " &
                "'" & escape_quotes(notes_list[i][N_USER])               & "', " &
                "'" & escape_quotes(notes_list[i][N_TYPE])            & "', " &
                "'" & notes_list[i][N_ANALYSIS]                  & "', "  &
                sprintf("%d", {notes_list[i][N_JDATE]}) &         " )"
        
        
        data = sqlite_get_table(sql_db, cmd)
        if sqlite_last_err_no != SQLITE_OK then
                VOID = get_yn_box("Error in notes : " & sqlite_last_err_desc)
        end if

end for
sqlite_close(sql_db)

return 0
end function


------------------------------------------------------------------------------------------------------
procedure mark_last_notes()
------------------------------------------------------------------------------------------------------
sequence cmd, data, patient_list, progress_bar
atom percent, lpb


SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox(sprintf("Marking last notes", {}), {})

cmd = "SELECT DISTINCT patient_no FROM Notes WHERE analysis = -1"
data = query_database("xnotes.sql", cmd)

patient_list = data[2..$]

for i = 1 to length(patient_list) do
        cmd = "SELECT * FROM Notes WHERE patient_no = " & patient_list[i][PA_PATIENT_NO] & " AND analysis = -1 ORDER BY jdate ASC"
        data = query_database("xnotes.sql", cmd)
        
        percent = (i/length(patient_list)) * 100
        lpb = floor(40 * percent/100)
        progress_bar = repeat('#', lpb)
        position( (SCREEN_LINES/2) - 1, (SCREEN_COLS/2) - 19 ) puts(1, progress_bar)
        
        
        --take last note
        if length(data) > 0 then
        
                cmd = "UPDATE Notes SET " &
                        "note = '*** Previous records archived - X - to view ***', " &
                        "type = 'C',  " &
                        "total = 0, fees = 0, drugs = 0, vat = 0, analysis = 0, " &
                        "date = '" & DateToStr(nowDate()) & "', " &
                        "jdate = " & sprintf("%d", {julianDay(nowDate()) }) & 
                        "WHERE number = " & data[$][N_NUMBER]   
                data = query_database("xnotes.sql", cmd)
        
        end if                             
        
end for

end procedure

------------------------------------------------------------------------------------------------------
procedure delete_selected_notes()
------------------------------------------------------------------------------------------------------
sequence cmd, data

SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox(sprintf("Deleting marked notes", {}), {})

cmd = "DELETE from Notes WHERE analysis = -1"
data = query_database("xnotes.sql", cmd)

SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox(sprintf("Vacuuming database", {}), {})

cmd = "VACUUM Notes"
data = query_database("xnotes.sql", cmd)


end procedure

------------------------------------------------------------------------------------------------------
procedure archive_notes()
--creates / a new database file if needed.
--moves notes / records there
--removes them from the main notes database
--vaccums the notes database
--archive parameters 
--      archive notes from dead patients with no outstanding balance
--      archive if patient not seen for a certain amount of time
--      archive all notes taken before a certain date
--leave a note to say notes have been archived

--when note is archived, will set N_ANALYSIS to '-1' 
------------------------------------------------------------------------------------------------------
sequence selection_params, result, cmd, data
atom original_notes_count, deleting_notes_count


selection_params =      {1,             --dead patients / TRUE/FALSE
                         0,             --not seen since x days - jdate
                         0}             --archive all notes before x days - jdate

init_check_archives()


 SetSize(5,40) SetColors(WHITE, GREEN) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox(sprintf("Getting notes count", {}), {})

 --unmark all analysis -1s
cmd = sprintf("UPDATE Notes SET analysis = 0  WHERE analysis = -1", {} )
data = query_database("xnotes.sql", cmd)

--get note count
cmd = "SELECT count(*) FROM Notes"
data = query_database("xnotes.sql", cmd)
original_notes_count = strtoval(data[2][1])

SetSize(6,42)
result = MixedForm("Archive notes parameters", {WHITE, BLUE}, 9,9,
                        {{MF_CHECK, 3, 1, TRUE, "Dead patients (Excluded with balance)"},
                         {MF_LABEL, 4, 1, "Patient not seen since "},
                         {MF_TEXT , 4, 24, 12, ""},
                         {MF_LABEL, 5, 1, "Archive notes before   "},
                         {MF_TEXT, 5, 24, 12, ""}
                        }
                        )

if result[1] =  FALSE then selection_params[1] = FALSE end if
                        
if length(remove_trailing_spaces(result[3])) > 0 and utils_validDate(result[3]) = 1 then
        selection_params[2] =  dateStrtoJdays(result[5])
end if

if length(remove_trailing_spaces(result[5])) > 0 and utils_validDate(result[5]) = 1 then
        selection_params[3] =  dateStrtoJdays(result[5])
end if

--if dates aren't valid, will just keep default values.
--first mark notes for archiving

if selection_params[1] = TRUE then
        archive_notes_for_dead_patients()
end if  

if selection_params[3] > 0 then
        archive_all_notes_before(selection_params[3])
end if

if selection_params[2] > 0 then
        archive_all_notes_patient_not_seen_since(selection_params[2])
end if

cmd = "SELECT count(*) FROM Notes WHERE analysis = -1"
data = query_database("xnotes.sql", cmd)
deleting_notes_count = strtoval(data[2][1])

VOID = get_yn_box(sprintf("Deleting %d of %d notes (N to stop)", {deleting_notes_count, original_notes_count}))

if upper(VOID) != 'N' then
        VOID = copy_notes_to_archive()
        mark_last_notes()               --mark last note of archive selection, shows archiving to notes user
        delete_selected_notes()         
end if 


--clear the box
SetStyle(5)
SetColors(WHITE, BLACK)
SetSize(5,40) position( (SCREEN_LINES/2) - 5, (SCREEN_COLS/2) - 20 )
MessageBox("", {})
SetStyle(1)

VOID = get_yn_box("Done!")
                        
end procedure

------------------------------------------------------------------------------------------------------
procedure vacuum_databases()
------------------------------------------------------------------------------------------------------
sequence cmd, data

cmd = "VACUUM Products"
data = query_database("xprods.sql", cmd)

cmd = "VACUUM Notes"
data = query_database("xnotes.sql", cmd)

cmd = "VACUUM Clients"
data = query_database("xclipats.sql", cmd)

cmd = "VACUUM Patients"
data = query_database("xclipats.sql", cmd)


VOID = get_yn_box("Done")


end procedure

------------------------------------------------------------------------------------------------------
global procedure zip_database()
------------------------------------------------------------------------------------------------------
sequence fname, ntime

--create file name from todays date

fname = DateToStr(nowDate())
fname = "DB-" & fname 
for i = 1 to length(fname) do
        if fname[i] = '/' then
                fname[i] = '-'
        end if
end for
fname = fname & "-"

ntime = nowTime()
fname = sprintf("%s%d%d%d.zip", {fname, ntime[1], ntime[2], ntime[3]})

position(9,9)
SetColors(BLACK, RED)
fname = Form("Accept or enter a new file name",
                {"", fname, 30}
                 )

if length(fname) > 0 and upper(get_yn_box("Proceed?")) = 'Y' then
        system("clear ; zip " & fname[1] & " x*", 0)
end if                                           
                                
end procedure

------------------------------------------------------------------------------------------------------
global function management_copy_archive_patient()
--works on CurPatient
--not allowed to delete patients with non zero balance
--need to first copy archive, delete notes
------------------------------------------------------------------------------------------------------
sequence cmd, data
atom sql_db

init_check_archive_patients()

if CurPatient[PA_OUTS_BAL] != 0 then
        VOID = get_yn_box("Not allowed - outstanding balance NOT zero")
        return 0
end if

--unmark all analysis -1s
cmd = sprintf("UPDATE Notes SET analysis = 0  WHERE analysis = -1", {} )
data = query_database("xnotes.sql", cmd)

--mark notes
cmd = sprintf("UPDATE Notes SET analysis = -1 WHERE patient_no = %d", {CurPatient[PA_PATIENT_NO]} )
data = query_database("xnotes.sql", cmd)
VOID = copy_notes_to_archive()

--delete notes
delete_selected_notes()

--copy patient to patient archive
cmd = "INSERT INTO Patients (client_no, type, name, dob, species, sex, breed, colour, insured, " &
                "microchip, status, weight, fees, drugs, vat, outs_bal, mileage ) " &
                "VALUES (" &
                "'" & sprintf("%d", {CurPatient[PA_CLIENT_NO]}) & "', " &
                "'" & escape_quotes(CurPatient[PA_TYPE])        & "', " &
                "'" & escape_quotes(CurPatient[PA_NAME])        & "', " &
                "'" & escape_quotes(CurPatient[PA_DOB])         & "', " &
                "'" & escape_quotes(CurPatient[PA_SPECIES])     & "', " &
                "'" & escape_quotes(CurPatient[PA_SEX])         & "', " &
                "'" & escape_quotes(CurPatient[PA_BREED])       & "', " &
                "'" & escape_quotes(CurPatient[PA_COLOR])       & "', " &
                "'" & escape_quotes(CurPatient[PA_INSURED])     & "', " &
                "'" & escape_quotes(CurPatient[PA_MICROCHIP])   & "', " &
                "'" & escape_quotes(CurPatient[PA_STATUS])      & "', " &
                "'" & sprintf("%f", {CurPatient[PA_WEIGHT]})                            & "', " &
                "'" & sprintf("%f", {CurPatient[PA_FEES]})                              & "', " &
                "'" & sprintf("%f", {CurPatient[PA_DRUGS]})                             & "', " &
                "'" & sprintf("%f", {CurPatient[PA_VAT] })                              & "', " &
                "'" & sprintf("%f", {CurPatient[PA_OUTS_BAL]})                          & "', " &
                "'" & sprintf("%f", {CurPatient[PA_MILEAGE] })                  & "' )"

sql_db = sqlite_open("xarchive.sql", 0)
if sql_db <= 0 then
    VOID = get_yn_box("Unable to open database")
end if

data = sqlite_get_table(sql_db, cmd)
if sqlite_last_err_no != SQLITE_OK then
    VOID = get_yn_box("Error in patients : " & sqlite_last_err_desc)
end if

--remove patient from the patient database
cmd = sprintf("DELETE FROM Patients  WHERE patient_no = %d", {CurPatient[PA_PATIENT_NO]} )
VOID = query_database("xclipats.sql", cmd)

return 0
end function



------------------------------------------------------------------------------------------------------
global procedure management_database_maintainance() 
--functions for database maintainance, trimming, etc
------------------------------------------------------------------------------------------------------
sequence menu_items
integer choice, current_choice

menu_items = {  "Zip databases",
                "Vacuum databases",
                "Archive notes",
                "Delete old diary entries",
                "Quit"}

current_choice = 1
while 1 do
        position(8,8)
        SetColors(BLACK, YELLOW)
        SetSize(length(menu_items) + 3, 33)

        choice = Select("Database management", current_choice, menu_items )

        current_choice = choice

        if choice = -1 or choice = length(menu_items) then exit end if
        
        if choice = 1 then
                zip_database()
        elsif choice = 2 then
                vacuum_databases() 
        elsif choice = 3 then
                archive_notes()
        end if

end while

--clear the box
position(8,8) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)




end procedure








