--payments
-------------------------------------------------------------------------
procedure receipt(sequence patientlist)
-------------------------------------------------------------------------
sequence notes_list, cmd, dts, receipt_file
integer fp, patient_found
atom sales_subtotal, sales_total, tendered_subtotal, tendered_total, vat_total
DateTime dt

dt = nowDateTime()
dts = ""
receipt_file = ""
patient_found = 0
sales_subtotal = 0
sales_total = 0
tendered_subtotal = 0
tendered_total = 0
vat_total = 0

cmd = "SELECT * FROM Notes WHERE client_no = " & sprintf("%d", {CurClient[CL_CLIENT_NO]}) &
	" AND date LIKE '" & DateToStr(nowDate()) & "'" &
	" AND total != 0 "

notes_list = query_database("xnotes.sql", cmd)

notes_list = notes_list[2..$]

--review_data(notes_list)
--VOID = wait_key()

--validate notes_list - convert strings to numbers!
for i = 1 to length(notes_list) do
	notes_list[i] = data_validate_note(notes_list[i])
end for


--anything on the patient list which has an entry in the notes list gets printed
--note this will fail at 12.00 midnight, when the dates change

--create file name
for i = 1 to 2 do
	for j = 1 to 3 do
		dts = sprintf("%s%d", {dts, dt[i][j]} )		
	end for
end for	

receipt_file = sprintf("receipt%d-%s.tmp", {CurClient[CL_CLIENT_NO], dts} )

fp = open(receipt_file, "w")

--receipt header
printf(fp, "%s\n", {globalSettings[GS_PRACTICE]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS1]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS2]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS3]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS4]})
printf(fp, "%s\n", {globalSettings[GS_POSTCODE]})
printf(fp, "%s\n\n", {globalSettings[GS_TEL]})
printf(fp, "VAT reg : %s\n\n", {globalSettings[GS_VATREG]})
printf(fp, "Receipt date : %s\n\n", {DateToStr(nowDate())})
printf(fp, "----------------------------------------------\n", {})

--client details
printf(fp, "%s %s %s\n", {remove_trailing_spaces(CurClient[CL_TITLE]), remove_trailing_spaces(CurClient[CL_FIRST_NAME]), remove_trailing_spaces(CurClient[CL_SURNAME])          })
printf(fp, "%s\n", {CurClient[CL_ADDRESS1]})
printf(fp, "%s\n", {CurClient[CL_ADDRESS2]})
printf(fp, "%s\n", {CurClient[CL_ADDRESS3]})
printf(fp, "%s\n", {CurClient[CL_ADDRESS4]})
printf(fp, "%s\n", {CurClient[CL_POSTCODE]})
printf(fp, "----------------------------------------------\n\n", {})


for i = 1 to length(patientlist) do
	patient_found = 0
	sales_subtotal = 0
	tendered_subtotal = 0
	patientlist[i][PA_PATIENT_NO] = strtoval(patientlist[i][PA_PATIENT_NO])
	for j = 1 to length(notes_list) do
		if patientlist[i][PA_PATIENT_NO] = notes_list[j][N_PATIENT_NO] then
			if patient_found = 0 then
				--print the patient name
				patient_found = 1
				printf(fp,"\n%s\n", {patientlist[i][PA_NAME]})
				for k = 1 to length(patientlist[i][PA_NAME]) do
					puts(fp,"=")
				end for
				puts(fp,"\n")
			end if
			--print the note, anly doing sales, not payments
			if notes_list[j][N_TYPE][1] = 'D' or notes_list[j][N_TYPE][1] = 'S' then
				printf(fp, "%-3.3s %-33.33s %8.2f\n", {notes_list[j][N_USER], notes_list[j][N_NOTE], notes_list[j][N_TOTAL]})
				sales_subtotal += notes_list[j][N_TOTAL]
				vat_total += notes_list[j][N_VAT]
			end if
			if notes_list[j][N_TYPE][1] = 'P' then
				tendered_subtotal += notes_list[j][N_TOTAL]
			end if
		end if
	end for
	
	--when reached end of notes for that patient
	printf(fp, "\nSales sub total %30.2f\n", {sales_subtotal})
	sales_total += sales_subtotal
	tendered_total += tendered_subtotal
	
end for

--finish off the receipt
printf(fp, "\nThis receipt :\n", {})
printf(fp, " Total sales : %8.2f\n", {sales_total})
printf(fp, " VAT         : %8.2f\n", {vat_total})
printf(fp, " Paid        : %8.2f\n", {tendered_total})

if CurClient[CL_OUTS_BAL] > 0 then
	printf(fp, "\nYour outstanding balance is : %8.2f\n", {CurClient[CL_OUTS_BAL]})
end if

if CurClient[CL_OUTS_BAL] < 0 then
	printf(fp, "\nYou have a credit balance of : %8.2f\n", {CurClient[CL_OUTS_BAL]})
end if

printf(fp, "\nThank you for your custom.\n", {})

puts(fp, "\n\n\n\n\n\n\n\n")

close(fp)

printers_print_file(receipt_file, PR_RECEIPT)
system_delete_file(receipt_file)
end procedure


-------------------------------------------------------------------------
global function payments(sequence patientlist, integer selected_patient)
--already have CurClient,and CurPatient loaded
-------------------------------------------------------------------------
integer boxy, boxx, c, x
atom tendered, change, tr, pr_rem
sequence tendered_str, payment_method, paid_by, new_note
atom fees, drugs, vat, patient_total

tendered_str = {}
tendered = 0
change = 0
payment_method = {"1. Cash", "2. Cheque", "3. Card", "4. Other", "5. Quit"} --match to payment methods
paid_by = {}
new_note = repeat({}, 12)
tr = 0 pr_rem = 0
fees = 0 drugs = 0 vat = 0

--note defaults
new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
new_note[N_CLIENT_NO] = CurPatient[PA_CLIENT_NO]
new_note[N_DATE] = DateToStr(nowDate())
new_note[N_FEES] = 0
new_note[N_DRUGS] = 0
new_note[N_VAT] = 0
new_note[N_TOTAL] = 0
new_note[N_USER] = CurUser[U_INIT]
new_note[N_TYPE] = "P"
new_note[N_ANALYSIS] = "0"
new_note[N_NOTE] = ""

--create the box
boxy = floor((SCREEN_LINES/2) - 7)
boxx = floor((SCREEN_COLS/2) - 28)

SetColors(BRIGHT_WHITE, BLUE)
position(boxy  , boxx)
SetSize(17, 55)
MessageBox("Payments", "")

printcolor( {boxy+3, boxx+1}, {WHITE, BLUE}, "Current client balance  :")
printcolor( {boxy+4, boxx+1}, {WHITE, BLUE}, "Current patient balance :")
printcolor( {boxy+5, boxx+1}, {WHITE, BLUE}, "Amount tendered         :")
printcolor( {boxy+6, boxx+1}, {WHITE, BLUE}, "Payment method          :")
printcolor( {boxy+7, boxx+1}, {WHITE, BLUE}, "Change                  :")
printcolor( {boxy+8, boxx+1}, {WHITE, BLUE}, "Amount otstanding       :")

for i = 0 to 6 do
    printcolor( {boxy+10+i, boxx+1}, {BRIGHT_WHITE, BLACK}, "                                                       ")
end for

--tendered amount
printcolor( {boxy+3, boxx+27}, {YELLOW, BLUE}, sprintf("%10.2f", {CurClient[CL_OUTS_BAL]}) )
printcolor( {boxy+4, boxx+27}, {YELLOW, BLUE}, sprintf("%10.2f", {CurPatient[PA_OUTS_BAL]}) )
printcolor( {boxy+5, boxx+27}, {BLUE, BLACK}, sprintf("%-10.2f", {CurClient[CL_OUTS_BAL]}))
printcolor( {boxy+10, boxx+1}, {BRIGHT_WHITE, BLACK}, "Enter the amount the client is paying, press return." )
printcolor( {boxy+11, boxx+1}, {BRIGHT_WHITE, BLACK}, "If the exact amount is tendered, just press return," )
printcolor( {boxy+14, boxx+1}, {BRIGHT_WHITE, BLACK}, "or to quit, enter q and press return." )

position(boxy+5, boxx+27)
SetColors(BRIGHT_WHITE, BLACK)
tendered_str = get_max_str(10)

--round to 2 dec places
CurClient[CL_OUTS_BAL] = floor( CurClient[CL_OUTS_BAL] * 100 ) / 100

if length(tendered_str) = 0 then
	tendered = CurClient[CL_OUTS_BAL]
	change = 0
else 
	tendered = strtoval(tendered_str)
	change = tendered - CurClient[CL_OUTS_BAL]
	if change < 0 then change = 0 end if	    
end if

for i = 0 to 6 do
    printcolor( {boxy+10+i, boxx+1}, {BRIGHT_WHITE, BLACK}, "                                                       ")
end for

--payment method
for i = 1 to 5 do
	printcolor( {boxy+10+i, boxx+1}, {BRIGHT_WHITE, BLACK}, payment_method[i])
end for

while 1 do
	c = upper(wait_key())
	if c = 'Q' then c = '5' end if
	if c >= '1' and c <= '5' then
		paid_by = payment_method[c - '1'+1][4..$]
		if c = '4' then
			--what is the other?
			printcolor({boxy+16, boxx+1}, {BRIGHT_WHITE, BLACK}, "What is the other? ____________________________________"  )
			position(boxy+16, boxx+20)
			paid_by = "Other - " & get_max_str(25)
		end if
		exit
	end if
end while

if c = '5' then
	position(boxy, boxx) SetSize(17,55) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
	return patientlist
end if

--gather together all the credit patients
--for i = 1 to length(patientlist) do
--	CurPatient = data_validate_patient(patientlist[i])
--	if CurPatient[PA_OUTS_BAL] < 0 then
--		--then there is a credit note
--		tendered = tendered - CurPatient[PA_OUTS_BAL] - CurPatient[PA_VAT] - CurPatient[PA_FEES] - CurPatient[PA_DRUGS]
--		CurPatient[PA_OUTS_BAL] = 0
--		CurPatient[PA_VAT] = 0
--		CurPatient[PA_FEES] = 0
--		CurPatient[PA_DRUGS] = 0
--		patientlist[i] = CurPatient
--		data_update_patient()	
--	end if	
--end for
CurPatient = patientlist[selected_patient]

--should now have all the info required, so can process the patient list
if tendered >= CurClient[CL_OUTS_BAL] then
	CurClient[CL_OUTS_BAL] = 0
	CurClient[CL_VAT] = 0
	CurClient[CL_FEES] = 0
	CurClient[CL_DRUGS] = 0
	data_update_client()
	
	for i = 1 to length(patientlist) do
		--data_update_patient works on CurPatient, so have to copy it back and forth
		CurPatient = data_validate_patient(patientlist[i])
		
		--on each patient in the list with outs_bal, make a note on the notes
		if CurPatient[PA_OUTS_BAL] != 0 then
			--create a note
			--first in line
			new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
			new_note[N_FEES] = CurPatient[PA_FEES]
			new_note[N_DRUGS] = CurPatient[PA_DRUGS]
			new_note[N_VAT] = CurPatient[PA_VAT]
			new_note[N_TOTAL] = CurPatient[PA_OUTS_BAL]
			new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
			data_insert_note(new_note)
			
		end if		
		
		--data_update_patient works on CurPatient, so have to copy it back and forth
		CurPatient = data_validate_patient(patientlist[i])
		CurPatient[PA_OUTS_BAL] = 0
		CurPatient[PA_VAT] = 0
		CurPatient[PA_FEES] = 0
		CurPatient[PA_DRUGS] = 0
		patientlist[i] = CurPatient
		data_update_patient()	
				
	end for
	CurPatient = data_validate_patient(patientlist[selected_patient])
end if --end of tendered = CurClient[CL_OUTS_BAL]

if tendered <=  CurClient[CL_OUTS_BAL] then
	CurPatient = data_validate_patient(patientlist[selected_patient])

	--have a tendered amount, start with current, selected patient,
	--then go thru each of the other patients, starting with the first one
	tr = tendered

	if CurPatient[PA_OUTS_BAL] > 0 then
		
		CurPatient[PA_DRUGS]    = CurPatient[PA_DRUGS] 	- CurPatient[PA_DRUGS]/CurPatient[PA_OUTS_BAL] * tr
		CurPatient[PA_VAT] 	= CurPatient[PA_VAT] 	- CurPatient[PA_VAT]/CurPatient[PA_OUTS_BAL] * tr
		CurPatient[PA_FEES] 	= CurPatient[PA_FEES] 	- CurPatient[PA_FEES]/CurPatient[PA_OUTS_BAL] * tr
		CurPatient[PA_OUTS_BAL] = CurPatient[PA_DRUGS] + CurPatient[PA_VAT] + CurPatient[PA_FEES]
	
		if CurPatient[PA_OUTS_BAL] < 0 then
			--make a note
			new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
			new_note[N_FEES] = 0
			new_note[N_DRUGS] = 0
			new_note[N_VAT] = 0
			new_note[N_TOTAL] = CurPatient[PA_OUTS_BAL]
			new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
			data_insert_note(new_note)
		
		
			tr = -CurPatient[PA_OUTS_BAL] -- this is how much left for other clients 
			
			--update the patient		
			CurPatient[PA_DRUGS]    = 0
			CurPatient[PA_VAT] 	= 0
			CurPatient[PA_FEES] 	= 0
			CurPatient[PA_OUTS_BAL] = 0
			--update the patient
			data_update_patient()
			
			--update the patientlist
			patientlist[selected_patient] = CurPatient
		else 
			--make a note
			new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
			new_note[N_FEES] = 0
			new_note[N_DRUGS] = 0
			new_note[N_VAT] = 0
			new_note[N_TOTAL] = tr
			new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
			data_insert_note(new_note)
	
			tr = 0
	
			--update the patient
			data_update_patient()
			patientlist[selected_patient] = CurPatient
						
		end if	
	end if -- end of if cur pat > 0
	
			
	if tr > 0 then
		--then have some left, distribute amongst other patients
		for i = 1 to length(patientlist) do
			CurPatient = data_validate_patient(patientlist[i])
			if CurPatient[PA_OUTS_BAL] > 0 and tr > 0 then
				CurPatient[PA_DRUGS]    = CurPatient[PA_DRUGS] 	- CurPatient[PA_DRUGS]/CurPatient[PA_OUTS_BAL] * tr
				CurPatient[PA_VAT] 	= CurPatient[PA_VAT] 	- CurPatient[PA_VAT]/CurPatient[PA_OUTS_BAL] * tr
				CurPatient[PA_FEES] 	= CurPatient[PA_FEES] 	- CurPatient[PA_FEES]/CurPatient[PA_OUTS_BAL] * tr
				CurPatient[PA_OUTS_BAL] = CurPatient[PA_DRUGS] + CurPatient[PA_VAT] + CurPatient[PA_FEES]
				
				if CurPatient[PA_OUTS_BAL] < 0 then
					--make a note
					new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
					new_note[N_FEES] = 0
					new_note[N_DRUGS] = 0
					new_note[N_VAT] = 0
					new_note[N_TOTAL] = CurPatient[PA_OUTS_BAL]
					new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
					data_insert_note(new_note)
				
					tr = -CurPatient[PA_OUTS_BAL] -- this is how much left for other clients 
					
					--update the patient		
					CurPatient[PA_DRUGS]    = 0
					CurPatient[PA_VAT] 	= 0
					CurPatient[PA_FEES] 	= 0
					CurPatient[PA_OUTS_BAL] = 0
					--update the patient
					data_update_patient()
					
					--update the patientlist
					patientlist[i] = CurPatient
				else 
					--make a note
					new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
					new_note[N_FEES] = 0
					new_note[N_DRUGS] = 0
					new_note[N_VAT] = 0
					new_note[N_TOTAL] = tr
					new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
					data_insert_note(new_note)
			
					tr = 0
			
					--update the patient
					data_update_patient()
					patientlist[i] = CurPatient
				end if	
			end if
		end for
	end if
	
		


end if --end of tendered < CurClient[CL_OUTS_BAL] 

CurPatient = patientlist[selected_patient]

if change > 0 then
	for i = 0 to 6 do
		printcolor( {boxy+10+i, boxx+1}, {BRIGHT_WHITE, BLACK}, "                                                       ")
	end for
	
	printcolor( {boxy+11, boxx+10}, {BRIGHT_WHITE, BLACK}, sprintf("Change %9.2f", {change}))
	printcolor( {boxy+12, boxx+10}, {BRIGHT_WHITE, BLACK}, "Change [1] or Credit note [2]")
	
	c = 0
	
	while c = 0 do
		c = upper(wait_key())
		if c = '1' then
			printcolor( {boxy+12, boxx+10}, {BRIGHT_WHITE, BLACK}, "Dispense change               ")
			exit	
		elsif c = '2' then
			CurPatient = patientlist[1]
			
			new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
			new_note[N_FEES] = 0
			new_note[N_DRUGS] = 0
			new_note[N_VAT] = 0
			new_note[N_TOTAL] = -change
			new_note[N_NOTE] = sprintf("Credit note for %-9.2f", { change} )
			data_insert_note(new_note)
			
			CurPatient[PA_FEES] = 0
			CurPatient[PA_DRUGS] = 0
			CurPatient[PA_VAT] = 0
			CurPatient[PA_OUTS_BAL] = -change
			data_update_patient()

			patientlist[1] = CurPatient					
		else
			c = 0
		end if
	end while

end if

--update the client
fees = 0 drugs = 0 vat = 0 patient_total = 0
for i = 1 to length(patientlist) do
	CurPatient = data_validate_patient(patientlist[i])
	patientlist[i] = CurPatient
	fees = fees + CurPatient[PA_FEES]
	drugs = drugs + CurPatient[PA_DRUGS]
	vat  = vat + CurPatient[PA_VAT]	
	patient_total = patient_total + CurPatient[PA_OUTS_BAL]
end for
CurClient[CL_OUTS_BAL] = patient_total
CurClient[CL_FEES] = fees
CurClient[CL_VAT] = vat
CurClient[CL_DRUGS] = drugs
CurClient = data_validate_client(CurClient)
data_update_client()

for i = 0 to 6 do
	printcolor( {boxy+10+i, boxx+1}, {BRIGHT_WHITE, BLACK}, "                                                       ")
end for

--print receipt ?
c = 0
printcolor( {boxy+12, boxx+10}, {BRIGHT_WHITE, BLACK}, "Print a receipt? (y/n)[n]")
c = wait_key()
printcolor( {boxy+12, boxx+10}, {BRIGHT_WHITE + BLINKING, BLACK}, "Processing, please wait.........")

if upper(c) = 'Y' then receipt(patientlist) end if

--clear the box
position(boxy, boxx) SetSize(17,55) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

return patientlist

end function


