--this file adds and checks for popups in both the client and
--patient page
--keycard also in here



------------------------------------------------------------------------------------
global function popups_check(integer cop)
--checks for presence of popup,
--if one exists, fills in the fields and edits it,
--if doesn't just returns
--cop - client or patient
--works with CurClient and CurPatient
--called when opening client or patient record
--and when an edit requested
------------------------------------------------------------------------------------
sequence data, cmd

if cop = 'C' then
        cmd = "SELECT * FROM Popups WHERE client_no = " & sprintf("%d", {CurClient[CL_CLIENT_NO]}) & " AND cop LIKE 'C%'"
end if
if cop = 'P' then
        cmd = "SELECT * FROM Popups WHERE patient_no = " & sprintf("%d", {CurPatient[PA_PATIENT_NO]}) & " AND cop LIKE 'P%'"
end if

data = query_database("xclipats.sql", cmd)

return data
end function


------------------------------------------------------------------------------------
global procedure popups_show(sequence data)
--decode the popup
--end of line delineator in text string is '|'
--since this is likely to be rarely used
------------------------------------------------------------------------------------
sequence popup_strings, cmd
integer offsetrow, offsetcol, save_flag, length_flag, popup_exists, delete_flag
object pp

offsetrow = floor(SCREEN_LINES/2) - 3
offsetcol = floor(SCREEN_COLS/2) - 28
save_flag = FALSE
length_flag = 0
popup_exists = FALSE
delete_flag = FALSE
popup_strings = repeat({}, 8) --setting length of popup to 8 lines

pp = Popup[POP_COP]
if length(data) = 0 then
        for i = 1 to 5 do
                Popup[i] = {}
        end for
        Popup[POP_COP] = pp
end if


--set defaults
Popup[POP_CLIENT_NO] = CurClient[CL_CLIENT_NO]
Popup[POP_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
Popup[POP_TEXT] = {}
--set the popup colour
if length(Popup[POP_COLOUR]) = 0 then
        Popup[POP_COLOUR] = "WHITE"
end if
--remember to set COP BEFORE coming to this proc
--Popup is global!

if length(data) > 0 then
        --resolve text string into individual popup_strings
        --and set popup form colours here too
        popup_strings = utils_resolve_strings(data[2][POP_TEXT], 8)
        
        Popup[POP_CLIENT_NO] = data[2][POP_CLIENT_NO]
        Popup[POP_PATIENT_NO] = data[2][POP_PATIENT_NO]
        Popup[POP_COP] = data[2][POP_COP]
        Popup[POP_COLOUR] = data[2][POP_COLOUR]
        Popup[POP_TEXT] = {}
        
        save_flag = TRUE
        popup_exists = TRUE
end if

popup_strings = append(popup_strings, {})

--set the popup colour
if length(Popup[POP_COLOUR]) = 0 then
        Popup[POP_COLOUR] = "WHITE"
end if
if Popup[POP_COLOUR][1] = 'W' then
        SetColors(BLACK, WHITE)
        popup_strings[9] = "WHITE"
elsif Popup[POP_COLOUR][1] = 'R' then
        SetColors(BRIGHT_WHITE, RED)
        popup_strings[9] = "RED"
elsif Popup[POP_COLOUR][1] = 'Y' then
        SetColors(BRIGHT_WHITE, YELLOW)
        popup_strings[9] = "YELLOW"
elsif Popup[POP_COLOUR][1] = 'G' then
        SetColors(BRIGHT_WHITE, GREEN)
        popup_strings[9] = "GREEN"
elsif Popup[POP_COLOUR][1] = 'B' then
        SetColors(BRIGHT_WHITE, BLUE)
        popup_strings[9] = "BLUE"
end if
        
position(offsetrow, offsetcol)
WORD_WRAP = TRUE
popup_strings = Form("",
                {"Text   ",popup_strings[1],40,
                 "       ",popup_strings[2],40,
                 "       ",popup_strings[3],40,
                 "       ",popup_strings[4],40,
                 "       ",popup_strings[5],40,
                 "       ",popup_strings[6],40,
                 "       ",popup_strings[7],40,
                 "       ",popup_strings[8],40,
                 "Colour ", popup_strings[9], 6
                })
WORD_WRAP = FALSE
                
for i = 1 to 8 do
        popup_strings[i] = remove_trailing_spaces(popup_strings[i])
        length_flag = length_flag + length(popup_strings[i])
end for

if length(popup_strings[9]) > 0 and upper(popup_strings[9][1]) = 'D' then
        delete_flag = TRUE
end if

if length_flag > 0 and delete_flag = FALSE then 
        save_flag = TRUE
else
        delete_flag = TRUE
        save_flag = FALSE
end if

Popup[POP_CLIENT_NO] = CurClient[CL_CLIENT_NO]
Popup[POP_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
Popup[POP_COLOUR] = upper(popup_strings[9])
Popup[POP_TEXT] = ""
for i = 1 to 8 do
        Popup[POP_TEXT] = Popup[POP_TEXT] & popup_strings[i] & "|"
end for
        
if save_flag = TRUE then
        if popup_exists then
                cmd = "UPDATE Popups SET" &
                        " client_no = " & sprintf("%d",{CurClient[CL_CLIENT_NO]}) & "," &
                        " patient_no = " & sprintf("%d", {Popup[POP_PATIENT_NO]}) & "," &
                        " cop = '" & Popup[POP_COP] & "'," &
                        " colour = '" & Popup[POP_COLOUR] & "'," &
                        " popup = '" & escape_quotes(Popup[POP_TEXT]) & "'"
                 
                if Popup[POP_COP][1] = 'P' then
                        cmd = cmd & " WHERE patient_no = " & sprintf("%d", {Popup[POP_PATIENT_NO]}) & " AND cop LIKE 'P%'"
                else
                        cmd = cmd & " WHERE client_no = " & sprintf("%d", {CurClient[CL_CLIENT_NO]}) & " AND cop LIKE 'C%'"
                
                end if
        else
                cmd = "INSERT INTO Popups (client_no, patient_no, colour, cop, popup) VALUES (" &
                        "'" & sprintf("%d",{Popup[POP_CLIENT_NO]}) & "', " &
                        "'" & sprintf("%d", {Popup[POP_PATIENT_NO]}) & "', " &
                        "'" & Popup[POP_COLOUR] & "', " &
                        "'" & Popup[POP_COP] & "', " &
                        "'" & escape_quotes(Popup[POP_TEXT]) & "')"
        end if
end if

if delete_flag = TRUE then
        cmd = "DELETE FROM Popups WHERE cop = '" & Popup[POP_COP] & "' "
        if Popup[POP_COP][1] = 'P' then
                cmd = cmd & "AND patient_no = " & sprintf("%d", {Popup[POP_PATIENT_NO]})
        else
                cmd = cmd & "AND client_no = " & sprintf("%d", {Popup[POP_CLIENT_NO]})
        end if
end if

data = query_database("xclipats.sql", cmd)

end procedure

