--printer setup and printing routines
--all printing will take place using temporary files
--temporary file deleting will not be done here

-----------------------------------------------------------------------
global procedure printers_print_file(sequence str, integer sel_printer)
-----------------------------------------------------------------------
integer fp
sequence print_command

print_command = {}

str = remove_trailing_spaces(str)
printers[sel_printer] = remove_trailing_spaces(printers[sel_printer])
fp = open(str, "r")

if length(str) > 0 and fp > 0 then
        close(fp)
        print_command = printers[sel_printer] & " " & str & " > /dev/null"
        system(print_command, 0)

end if

end procedure

-----------------------------------------------------------------------
procedure test_printers()
-----------------------------------------------------------------------
integer choice, current_choice  --local here

current_choice = 1

while 1 do
        position (5,9)
        SetColors(BLUE, WHITE)
        SetSize(13,15)
        choice = Select("Test printers", current_choice,
                                {"Label printer",
                                 "Receipt printer",
                                 "Invoice printer",
                                 "Statements",
                                 "History",
                                 "General",
                                 "Forms",
                                 "Diary",
                                 "Estimates",
                                 "Quit"})

        current_choice = choice
        
        if choice = 10 then exit end if                         

        if choice = 1 or choice = 2 then
                printers_print_file("label.test", choice)
        else
                printers_print_file("printer.test", choice)
        end if
        
                                         
end while                                                       

--clear the box
--clear the box
SetStyle(5)
SetColors(WHITE, BLACK)
position(  5,9)
SetSize(13, 15)
MessageBox("", {})
SetStyle(1)


end procedure

-----------------------------------------------------------------------
global procedure printers_assign()
-----------------------------------------------------------------------
integer fp
object c

position(5, 5)
SetColors(YELLOW, BLUE)

printers = Form("Assign printers - file name added to command", {
                "Label printer     ", printers[PR_LABEL], 50,
                "Receipt printer   ", printers[PR_RECEIPT], 50,
                "Invoice printer   ", printers[PR_INVOICING], 50,
                "Invoice summaries ", printers[PR_INVOICE_SUMMARIES], 50,
                "Statements        ", printers[PR_STATEMENT], 50,
                "History           ", printers[PR_HISTORY], 50,
                "General           ", printers[PR_GENERAL], 50,
                "Forms             ", printers[PR_FORMS], 50,
                "Diary             ", printers[PR_DIARY], 50,
                "Estimates         ", printers[PR_ESTIMATES], 50
               })

fp = open("xprinters.dat", "w")
for i = 1 to length(printers) do
        printers[i] = remove_trailing_spaces(printers[i])
        printf(fp, "%s\n", {printers[i]} )
end for
close(fp)

c = get_yn_box("Test printers? (y/n)")

if upper(c) = 'Y' then
        test_printers()
end if

end procedure

-----------------------------------------------------------------------
global procedure printers_batch_drug_label(sequence selected_prod, sequence drug_dosage, integer n, sequence patient_name, atom quantity)
--prints a label from batch prog - when dispensed from reception
--almost the same, except dont have cur patient sequence filled, hence patient name
-----------------------------------------------------------------------
sequence labelprn, dts
integer fp, space_posn
DateTime dt

dt = nowDateTime()
dts = ""
space_posn = 0

--convert dt to a number string
for i = 1 to 2 do
        for j = 1 to 3 do
                dts = sprintf("%s%d", {dts, dt[i][j]} )         
        end for
end for 

labelprn = sprintf("label%d-%s.tmp", {CurClient[CL_CLIENT_NO], dts} )

fp = open(labelprn, "w")

--practice address
printf(fp, "\nN\nA20,275,3,2,1,1,N,\"%-20.20s\"\n",     {DrugLabelAddress[DL_NAME]})
printf(fp, "A40,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS1]})
printf(fp, "A60,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS2]})
printf(fp, "A80,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS3]})
printf(fp,"A100,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_TEL]})

--animal
printf(fp,"A200,0,0,2,1,1,N,\"%s\"\n",          {patient_name})

--drug
--printf(fp,"A200,45,0,3,1,1,N,\"%s\"\n",               {selected_prod[PROD_ITEM]})
if quantity = floor(quantity) then
        printf(fp,"A200,30,0,3,1,1,N,\"%d %s\"\n",         {floor(quantity), selected_prod[PROD_ITEM]})
else
        printf(fp,"A200,30,0,3,1,1,N,\"%.2f %s\"\n",         {quantity, selected_prod[PROD_ITEM]})
end if

--batch number
printf(fp,"A200,52,0,2,1,1,N,\"%s\"\n",         {"Batch : " & selected_prod[PROD_BATCH_NUMBER]})

--dosage
if length(drug_dosage) > 29 then
        space_posn = 29
        for i = 29 to 1 by -1 do
                if drug_dosage[i] = ' ' then
                        space_posn = i
                        exit
                end if
        end for


        printf(fp, "A200,85,0,4,1,1,N,\"%-29.29s\"\n", {drug_dosage[1..space_posn]})
        printf(fp,"A200,115,0,4,1,1,N,\"%-29.29s\"\n", {drug_dosage[space_posn + 1..$]})
else
        printf(fp, "A200,85,0,4,1,1,N,\"%-29.29s\"\n", {drug_dosage})
end if

--drug specific warnings
printf(fp,"A200,160,0,4,1,1,N,\"%-29.29s\"\n", {selected_prod[PROD_WARNING]})

--general warnings
printf(fp,"A200,200,0,4,1,1,R,\"Keep out of reach of children\"\n", {})
printf(fp,"A200,250,0,4,1,1,R,\"  For animal treatment only  \"\n", {})

--dates
printf(fp,"A140,275,3,4,1,1,N,\"%s\"\n",{DateToStr(nowDate())})

--client details
printf(fp,"A670,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_SURNAME]})
printf(fp,"A690,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS1]})
printf(fp,"A710,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS2]})
printf(fp,"A730,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS3]})
printf(fp,"A750,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS4]})
printf(fp,"A770,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_POSTCODE]})

--number of labels to print
printf(fp, "P%d\n", {n}) 

close(fp)

--now send it off to the printer
printers_print_file(labelprn, PR_LABEL)
system_delete_file(labelprn)


end procedure

-----------------------------------------------------------------------
global procedure printers_drug_label(sequence selected_prod, sequence drug_dosage, integer n, atom quantity)
--this section applies to the star TSP series
--may apply to others, but don't know
--takes client, patient, drug, label details (inputted), and number
--of labels to be printed
--TSP ascii printing params
--      N                                               - new
--      Ap1,p2,p3,p4,p5,p6,p7,data_string               - control / data
--      P1                                              - 1 page (label)

--      p1      horizontal start posn - x - in dots
--      p2      vertical start posn - y - in dots
--      p3      rotation - 0 none, 1 90 deg, 2 180 deg, 3 270 deg
--      p4      font selection - 1,2,3,4,5 (5 only supports upper case)
--              1 small -> 5 large
--      p5      horizontal multiplier - expands text horizontally
--      p6      vertical multiplier - expands text vertically
--      p7      N - normal  R - reverse

--      smbclient //reception1/dispensary -U crylex -N -P -c "print ./file.txt"
-----------------------------------------------------------------------
sequence labelprn, dts
integer fp, space_posn
DateTime dt

dt = nowDateTime()
dts = ""
space_posn = 0

--convert dt to a number string
for i = 1 to 2 do
        for j = 1 to 3 do
                dts = sprintf("%s%d", {dts, dt[i][j]} )         
        end for
end for 

labelprn = sprintf("label%d-%s.tmp", {CurClient[CL_CLIENT_NO], dts} )

fp = open(labelprn, "w")

--practice address
printf(fp, "\nN\nA20,275,3,2,1,1,N,\"%-20.20s\"\n",     {DrugLabelAddress[DL_NAME]})
printf(fp, "A40,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS1]})
printf(fp, "A60,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS2]})
printf(fp, "A80,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS3]})
printf(fp,"A100,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_TEL]})

--animal
printf(fp,"A200,0,0,2,1,1,N,\"%s\"\n",          {CurPatient[PA_NAME]})

--drug
--printf(fp,"A200,45,0,3,1,1,N,\"%s\"\n",               {selected_prod[PROD_ITEM]})
if quantity = floor(quantity) then
        printf(fp,"A200,30,0,3,1,1,N,\"%d %s\"\n",         {floor(quantity), selected_prod[PROD_ITEM]})
else
        printf(fp,"A200,30,0,3,1,1,N,\"%.2f %s\"\n",         {quantity, selected_prod[PROD_ITEM]})
end if

--batch number
printf(fp,"A200,52,0,2,1,1,N,\"%s\"\n",         {"Batch : " & selected_prod[PROD_BATCH_NUMBER]})

--dosage
if length(drug_dosage) > 29 then
        space_posn = 29
        for i = 29 to 1 by -1 do
                if drug_dosage[i] = ' ' then
                        space_posn = i
                        exit
                end if
        end for


        printf(fp, "A200,85,0,4,1,1,N,\"%-29.29s\"\n", {drug_dosage[1..space_posn]})
        printf(fp,"A200,115,0,4,1,1,N,\"%-29.29s\"\n", {drug_dosage[space_posn + 1..$]})
else
        printf(fp, "A200,85,0,4,1,1,N,\"%-29.29s\"\n", {drug_dosage})
end if

--drug specific warnings
printf(fp,"A200,160,0,4,1,1,N,\"%-29.29s\"\n", {selected_prod[PROD_WARNING]})

--general warnings
printf(fp,"A200,200,0,4,1,1,R,\"Keep out of reach of children\"\n", {})
printf(fp,"A200,250,0,4,1,1,R,\"  For animal treatment only  \"\n", {})

--dates
printf(fp,"A140,275,3,4,1,1,N,\"%s\"\n",{DateToStr(nowDate())})

--client details
printf(fp,"A670,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_SURNAME]})
printf(fp,"A690,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS1]})
printf(fp,"A710,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS2]})
printf(fp,"A730,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS3]})
printf(fp,"A750,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS4]})
printf(fp,"A770,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_POSTCODE]})

--number of labels to print
printf(fp, "P%d\n", {n}) 

close(fp)

--now send it off to the printer
printers_print_file(labelprn, PR_LABEL)
system_delete_file(labelprn)


end procedure


  -----------------------------------------------------------------------
global procedure printers_blank_drug_label(integer n)
-----------------------------------------------------------------------
sequence labelprn, dts
integer fp, space_posn
DateTime dt

dt = nowDateTime()
dts = ""
space_posn = 0

--convert dt to a number string
for i = 1 to 2 do
        for j = 1 to 3 do
                dts = sprintf("%s%d", {dts, dt[i][j]} )         
        end for
end for 

labelprn = "BlankLabel.tmp"

fp = open(labelprn, "w")

--practice address
printf(fp, "\nN\nA20,275,3,2,1,1,N,\"%-20.20s\"\n",     {DrugLabelAddress[DL_NAME]})
printf(fp, "A40,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS1]})
printf(fp, "A60,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS2]})
printf(fp, "A80,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_ADDRESS3]})
printf(fp,"A100,275,3,2,1,1,N,\"%-20.20s\"\n",  {DrugLabelAddress[DL_TEL]})

printf(fp,"A140,275,3,4,1,1,N,\"%s\"\n",{"Date :"})

printf(fp,"A200,10,0,3,1,1,N,\"%s\"\n",{"Patient :"})

printf(fp,"A200,60,0,3,1,1,N,\"%s\"\n",{"Product :"})

printf(fp, "A200,110,0,4,1,1,N,\"%-29.29s\"\n", {"Dosage :"})

--general warnings
printf(fp,"A200,200,0,4,1,1,R,\"Keep out of reach of children\"\n", {})
printf(fp,"A200,250,0,4,1,1,R,\"  For animal treatment only  \"\n", {})

printf(fp,"A670,275,3,2,1,1,N,\"%-20.20s\"\n",{"Client details : "})


--number of labels to print
printf(fp, "P%d\n", {n}) 

close(fp)

--now send it off to the printer
printers_print_file(labelprn, PR_LABEL)
system_delete_file(labelprn)
  

end procedure




-----------------------------------------------------------------------------------------------------------------
global procedure printers_client_and_patient_label(integer with_tel)
-----------------------------------------------------------------------------------------------------------------
integer fp
sequence fname

if length(CurPatient[PA_MICROCHIP]) < 3 then
        CurPatient[PA_MICROCHIP] = ""
end if

fname = sprintf("%d-%dlabel.tmp", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]})

fp = open(fname, "w")
printf(fp,"\nN\n", {})
printf(fp,"A50,0,0,3,1,1,N,\"Registered at :\"\n", {})
printf(fp,"A50,20,0,3,1,1,N,\"%s\"\n",{remove_trailing_spaces(globalSettings[GS_PRACTICE])})
printf(fp,"A50,40,0,3,1,1,N,\"%s\"\n",{remove_trailing_spaces(globalSettings[GS_TEL])})
printf(fp,"A50,100,0,3,1,1,N,\"%-5.5s%-5.5s%-20.20s%-4.4s%-20.20s\"\n",
                {CurClient[CL_TITLE],CurClient[CL_FIRST_NAME],CurClient[CL_SURNAME]," ",CurPatient[PA_NAME]})
printf(fp,"A50,120,0,3,1,1,N,\"%-30.30s%-4.4s%-20.20s\"\n",{CurClient[CL_ADDRESS1], " ", CurPatient[PA_SPECIES]} )
printf(fp,"A50,140,0,3,1,1,N,\"%-30.30s%-4.4s%-20.20s\"\n",{CurClient[CL_ADDRESS2], " ", CurPatient[PA_BREED]} )
printf(fp,"A50,160,0,3,1,1,N,\"%-30.30s%-4.4s%-20.20s\"\n",{CurClient[CL_ADDRESS3], " ", CurPatient[PA_SEX]} )
printf(fp,"A50,180,0,3,1,1,N,\"%-30.30s%-4.4s%-20.20s\"\n",{CurClient[CL_ADDRESS4], " ", CurPatient[PA_DOB]} )
printf(fp,"A50,200,0,3,1,1,N,\"%-30.30s%-4.4s%-20.20s\"\n",{CurClient[CL_POSTCODE], " ", CurPatient[PA_COLOR]} )
if with_tel = TRUE then
        printf(fp,"A50,220,0,3,1,1,N,\"%-15.15s%-4.4s%-15.15s\"\n",{CurClient[CL_TEL1], " ", CurClient[CL_TEL2]} )
end if
printf(fp,"A50,275,0,3,1,1,N,\"Microchip number : %s\"\n",{CurPatient[PA_MICROCHIP]})
printf(fp,"P1\n",{})

close(fp)
printers_print_file(fname, PR_LABEL)
system_delete_file(fname)

end procedure


-----------------------------------------------------------------------------------------------------------------
global procedure printers_client_only_label(integer with_tel)
-----------------------------------------------------------------------------------------------------------------
integer fp
sequence fname

if length(CurPatient[PA_MICROCHIP]) < 2 then
        CurPatient[PA_MICROCHIP] = ""
end if


fname = sprintf("%d-%dlabel.tmp", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]})

fp = open(fname, "w")
printf(fp,"\nN\n", {})
printf(fp,"A50,0,0,3,2,2,N,\"%s %s %s\"\n",{remove_trailing_spaces(CurClient[CL_TITLE]),remove_trailing_spaces(CurClient[CL_FIRST_NAME]),remove_trailing_spaces(CurClient[CL_SURNAME])})
printf(fp,"A50,60,0,3,2,2,N,\"%-30.30s\"\n",{remove_trailing_spaces(CurClient[CL_ADDRESS1])} )
printf(fp,"A50,100,0,3,2,2,N,\"%-30.30s\"\n",{remove_trailing_spaces(CurClient[CL_ADDRESS2])} )
printf(fp,"A50,140,0,3,2,2,N,\"%-30.30s\"\n",{remove_trailing_spaces(CurClient[CL_ADDRESS3])} )
printf(fp,"A50,180,0,3,2,2,N,\"%-30.30s\"\n",{remove_trailing_spaces(CurClient[CL_ADDRESS4])} )
printf(fp,"A50,220,0,3,2,2,N,\"%-30.30s\"\n",{remove_trailing_spaces(CurClient[CL_POSTCODE])} )
if with_tel = TRUE then
        printf(fp,"A50,260,0,3,1,1,N,\"%-15.15s %-15.15s\"\n",{remove_trailing_spaces(CurClient[CL_TEL1]), " ", remove_trailing_spaces(CurClient[CL_TEL2])} )
end if
printf(fp,"P1\n",{})

close(fp)
printers_print_file(fname, PR_LABEL)
system_delete_file(fname)


end procedure

-----------------------------------------------------------------------------------------------------------------
global procedure printers_patient_only_label(integer with_tel)
-----------------------------------------------------------------------------------------------------------------
integer fp
sequence fname

if length(CurPatient[PA_MICROCHIP]) < 3 then
        CurPatient[PA_MICROCHIP] = ""
end if

fname = sprintf("%d-%dlabel.tmp", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]})

fp = open(fname, "w")
printf(fp,"\nN\n", {})

printf(fp,"A50,0,0,3,2,2,N,\"%s\"\n",  {remove_trailing_spaces(CurPatient[PA_NAME])} )
printf(fp,"A50,60,0,3,2,1,N,\"%s\"\n", {remove_trailing_spaces(CurPatient[PA_SPECIES])} )
printf(fp,"A50,85,0,3,2,1,N,\"%s\"\n",{remove_trailing_spaces(CurPatient[PA_BREED])} )
printf(fp,"A50,110,0,3,2,1,N,\"%s\"\n",{remove_trailing_spaces(CurPatient[PA_SEX])} )
printf(fp,"A50,135,0,3,2,1,N,\"%s\"\n",{remove_trailing_spaces(CurPatient[PA_DOB])} )
printf(fp,"A50,160,0,3,2,1,N,\"%s\"\n",{remove_trailing_spaces(CurPatient[PA_COLOR])} )
printf(fp,"A50,175,0,3,2,1,N,\"%s\"\n",{CurPatient[PA_MICROCHIP]} )
if with_tel = TRUE then
        printf(fp,"A50,260,0,3,1,1,N,\"%-15.15s %-15.15s\"\n",{remove_trailing_spaces(CurClient[CL_TEL1]), " ", remove_trailing_spaces(CurClient[CL_TEL2])} )
end if

printf(fp,"P1\n",{})

close(fp)
printers_print_file(fname, PR_LABEL)
system_delete_file(fname)


end procedure

------------------------------------------------------------------------------------------------------------------
global procedure printers_freehand_drug_label(sequence prod, sequence dosage1, sequence dosage2, integer n)
------------------------------------------------------------------------------------------------------------------
sequence labelprn, dts
integer fp, space_posn
DateTime dt

dt = nowDateTime()
dts = ""
space_posn = 0

--convert dt to a number string
for i = 1 to 2 do
        for j = 1 to 3 do
                dts = sprintf("%s%d", {dts, dt[i][j]} )         
        end for
end for 

labelprn = sprintf("label%d-%s.tmp", {CurClient[CL_CLIENT_NO], dts} )

fp = open(labelprn, "w")

--practice address
printf(fp, "\nN\nA20,275,3,2,1,1,N,\"%-20.20s\"\n",     {DrugLabelAddress[DL_NAME]})
printf(fp, "A40,275,3,2,1,1,N,\"%-20.20s\"\n",          {DrugLabelAddress[DL_ADDRESS1]})
printf(fp, "A60,275,3,2,1,1,N,\"%-20.20s\"\n",          {DrugLabelAddress[DL_ADDRESS2]})
printf(fp, "A80,275,3,2,1,1,N,\"%-20.20s\"\n",          {DrugLabelAddress[DL_ADDRESS3]})
printf(fp,"A100,275,3,2,1,1,N,\"%-20.20s\"\n",          {DrugLabelAddress[DL_TEL]})

--animal
printf(fp,"A200,0,0,2,1,1,N,\"%s\"\n",          {CurPatient[PA_NAME]})

--drug
printf(fp,"A200,45,0,3,1,1,N,\"%s\"\n",         {prod})

--dosage
printf(fp, "A200,85,0,4,1,1,N,\"%-29.29s\"\n", {dosage1})
printf(fp,"A200,115,0,4,1,1,N,\"%-29.29s\"\n", {dosage2})

--dates
printf(fp,"A140,275,3,4,1,1,N,\"%s\"\n",{DateToStr(nowDate())})

--client details
printf(fp,"A670,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_SURNAME]})
printf(fp,"A690,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS1]})
printf(fp,"A710,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS2]})
printf(fp,"A730,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS3]})
printf(fp,"A750,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_ADDRESS4]})
printf(fp,"A770,275,3,2,1,1,N,\"%-20.20s\"\n",{CurClient[CL_POSTCODE]})

--general warnings
printf(fp,"A200,200,0,4,1,1,R,\"Keep out of reach of children\"\n", {})
printf(fp,"A200,250,0,4,1,1,R,\"  For animal treatment only  \"\n", {})

--number of labels to print
printf(fp, "P%d\n", {n}) 

close(fp)

--now send it off to the printer
if n > 0 then
        printers_print_file(labelprn, PR_LABEL)
end if
system_delete_file(labelprn)

end procedure


------------------------------------------------------------------------------------------------------------------
global procedure printers_reminder_label(sequence rem_list)
--from the c file
-- fprintf(fq,"A50,0,0,4,2,2,N,\"%s\"\n",label_str[1]);
-- fprintf(fq,"A50,80,0,3,2,1,N,\"%s\"\n",label_str[2]);
-- fprintf(fq,"A50,110,0,3,2,1,N,\"%s\"\n",label_str[3]);
-- fprintf(fq,"A50,140,0,3,2,1,N,\"%s\"\n",label_str[4]);
-- fprintf(fq,"A50,170,0,3,2,1,N,\"%s\"\n",label_str[5]);
-- fprintf(fq,"A50,200,0,3,2,1,N,\"%s\"\n",label_str[6]);
-- fprintf(fq,"A50,245,0,3,1,1,N,\"%s\"\n",label_str[7]);
-- fprintf(fq,"A600,0,0,1,1,1,N,\"(%i)\"\n", Global.branch);

--reminder structure in recall.ex file
------------------------------------------------------------------------------------------------------------------
integer fp

fp = open("rem.tmp", "w")

printf(fp,"\nN\nA50,0,0,4,2,2,N,\"%s %s\"\n",{rem_list[2], rem_list[1]})
printf(fp,"A50,80,0,3,2,1,N,\"%s\"\n",{rem_list[3]})     --a1
printf(fp,"A50,110,0,3,2,1,N,\"%s\"\n",{rem_list[4]})  --a2
printf(fp,"A50,140,0,3,2,1,N,\"%s\"\n",{rem_list[5]})  --a3
printf(fp,"A50,170,0,3,2,1,N,\"%s\"\n",{rem_list[6]})  --a4
printf(fp,"A50,200,0,3,2,1,N,\"%s\"\n",{rem_list[7]})  --postcode
printf(fp,"A50,245,0,3,1,1,N,\"%s\"\n",{rem_list[9]})  --overdueness
printf(fp,"A600,0,0,1,1,1,N,\"(%s)\"\n", {rem_list[8]})  --branch
printf(fp,"P1\n",{})

close(fp)

printers_print_file("rem.tmp", PR_LABEL)
system_delete_file("rem.tmp")

end procedure


------------------------------------------------------------------------------------------------------------------
global procedure printers_notes_search_label(sequence notes_result)
------------------------------------------------------------------------------------------------------------------
integer fp, lc, chunk
sequence ptemp

--whats the maximumum label line length, at specific sizes?
--this printer (Eltron TLP 2642 series), printing seems to go up to 275 pixels for label length

fp = open("lt.txt", "w")

printf(fp, "\nN\n", {})

-- for i = 1 to 20 do
--         printf(fp,"A50,%d,0,3,1,1,N,\"%d\"\n",{i*20,i}) 
-- end for
--Above config fits in all lines over several labels, BUT
--lines 15 and 16 appear on the label separation, so should print returns after these for a coiple of lines

lc = 1
chunk = 0
ptemp = {}

while 1 do

        ptemp =  remove_trailing_spaces(notes_result[chunk + lc][N_DATE]) & " " & notes_result[chunk + lc][N_NOTE]
        if length(ptemp) > 52 then
                ptemp = ptemp[1..52]
        end if          

        printf(fp, "A50,%d,0,3,1,1,N,\"%s\"\n",{chunk + lc*20, ptemp} )    
        
        lc += 1
        if lc = 15 then
                chunk += 14
                lc = 1
                printf(fp,"P1\n",{})
                printf(fp, "\nN\n", {})
        end if
        
        if chunk + lc > length(notes_result)    then
                exit 
        end if  
        
end while


printf(fp,"P1\n",{})

close(fp)

printers_print_file("lt.txt", PR_LABEL)
unlink("lt.txt")

end procedure




