--vaccine and other recall reminders


--globals for this file
integer NO_REMINDER_WITHIN        --days

sequence date_from, date_to, cur_date
integer jdate_from, jdate_to, cur_jdate
sequence selected_reminders


------------------------------------------------------------------------------------------------------------
procedure show_reminder_selections()
------------------------------------------------------------------------------------------------------------
sequence box1, box2, type_list

type_list = repeat("", 10)

--selction of types to send
SetSize(11,30)
position(5,40)
SetColors(WHITE, BLACK)
box1 = PlainBox(DefaultBox)

for i = 1 to 10 do
        if selected_reminders[i] = 'X' then
                type_list[i] = "[X] " & ReminderTypes[i]
        else
                type_list[i] = "[ ] " & ReminderTypes[i]
        end if
        printcolor({5+i, 41}, {WHITE, BLACK}, type_list[i] )
end for

--selection dates
SetSize(3,30)
position(18,40)
SetColors(WHITE, BLACK)
box2 = PlainBox(DefaultBox)
printcolor({19, 41}, {WHITE, BLACK}, "Date from : " & date_from)
printcolor({20, 41}, {WHITE, BLACK}, "Date to   : " & date_to)

end procedure


------------------------------------------------------------------------------------------------------------
procedure scan_vaccine_reminders()
--this proc should only ever be run once
------------------------------------------------------------------------------------------------------------
sequence cmd, data, client_patient_list
integer rem_jdate

SetColors(BRIGHT_WHITE, BLUE)
position (  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - 28/2)
SetSize(2, 28)
MessageBox("Scanning for vaccines.....",{})

cmd = "SELECT DISTINCT client_no, patient_no FROM Notes WHERE note LIKE '%VACC%' AND type LIKE 'S%'"
data = query_database("xnotes.sql", cmd)

client_patient_list = data[2..$]

--for each of those, find when was last vaccinated
--will record all living patients, as may do amnesty again in future
position (  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - 28/2)
SetColors(BRIGHT_WHITE, GREEN)
MessageBox("Checking notes.........", {})

for i = 1 to length(client_patient_list) do

        cmd = "SELECT jdate FROM Notes where note LIKE '%VACC%' AND type LIKE 'S%' AND patient_no = " & client_patient_list[i][2] --sprintf("%d", {client_patient_list[i][2]} )
        data = query_database("xnotes.sql", cmd)

        if length(data) > 0 then        
                rem_jdate = strtoval(data[$][1])+ floor(12 * 30.5)   --just doing for all vaccs atm
                
                --since this technically should be a unique occurence of patient in the list, should just have to insert the record into the database
                cmd = "INSERT INTO Reminders (jdate, client_no, patient_no, type, reminder_count) " &
                        "VALUES ( " &
                        sprintf("%d", {rem_jdate}) & ", " &
                        client_patient_list[i][1] & ", " &
                        client_patient_list[i][2] & ", " &
                        "1, " &
                        "3 )"                                           --set to recall 3 times
                                                                        --jdate_last run DEFAULTS to 0

                VOID = query_database("xclipats.sql", cmd)
        end if

end for


SetStyle(5)
SetColors(WHITE, BLACK)
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - 28/2)
SetSize(2, 28)
MessageBox("", {})
SetStyle(1)

end procedure




------------------------------------------------------------------------------------------------------------
procedure check_reminders()
------------------------------------------------------------------------------------------------------------
sequence cmd, data

cmd = "SELECT * FROM Reminders"
data = query_database("xclipats.sql", cmd)

if length(data) = 0 then
        scan_vaccine_reminders()
end if

end procedure


------------------------------------------------------------------------------------------------------------
procedure select_dates()
------------------------------------------------------------------------------------------------------------
sequence result

position(9,9)
SetColors(YELLOW, BLUE)
result = Form("Reminder dates",
                {"Date from ", date_from, 13,
                 "Date to   ", date_to, 13})

--valid dates?
if utils_validDate(result[1]) = 1 and utils_validDate(result[2]) = 1 then
        date_from = result[1]
        date_to = result[2]

        --jdate_from = julianDay(date_from)
        --jdate_to =   julianDay(date_to)

        jdate_from = dateStrtoJdays(date_from)
        jdate_to = dateStrtoJdays(date_to)
        
--VOID = get_yn_box(sprintf("%d %d", {jdate_from, jdate_to}) )

        show_reminder_selections()
else
        VOID = get_yn_box("Invalid date entered - try again!")
end if

end procedure

------------------------------------------------------------------------------------------------------------
procedure select_reminders()
------------------------------------------------------------------------------------------------------------
sequence result, trs


--trs is temp reminder selection
trs = repeat({},10)
for i = 1 to 10 do
        if selected_reminders[i] = 'X' then
                trs[i] = {MF_CHECK, i+2,1, 1, ReminderTypes[i]}
        else
                trs[i] = {MF_CHECK, i+2,1, 0, ReminderTypes[i]}
        end if
end for

SetSize(13,30)
result = MixedForm("Select reminders", {YELLOW, BLUE}, 5,40, trs)

--clear the box
position(5,40) SetSize(13, 30) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

for i = 1 to 10 do
        if result[i] = TRUE then
                selected_reminders[i] = 'X'     
        else
                selected_reminders[i] = '-'     
        end if
end for

 show_reminder_selections()

end procedure

------------------------------------------------------------------------------------------------------------
function create_rem_list(sequence tmp)
--creates the actual list that will be printed
--1 client surname
--2 patient name
--3 address 1
--4 address 2
--5 address 3
--6 address 4
--7 postcode
--8  branch name /code
--9 your XXXXXXXX is due (overdue, if past current date)
--10 date due on
--11 Reminder.id
--12 reminder_count
------------------------------------------------------------------------------------------------------------
sequence rem_list, rem_record, cmd, data

rem_list = {}

--tmp structure corresponds to database structure
for i = 1 to length(tmp) do
        rem_record = repeat({}, 12)

        --client details
        cmd ="SELECT * FROM Clients where client_no = " & tmp[i][3]
        data = query_database("xclipats.sql", cmd)
        rem_record[1] = remove_trailing_spaces(data[2][CL_SURNAME])
        rem_record[3] = remove_trailing_spaces(data[2][CL_ADDRESS1])
        rem_record[4] = remove_trailing_spaces(data[2][CL_ADDRESS2])
        rem_record[5] = remove_trailing_spaces(data[2][CL_ADDRESS3])
        rem_record[6] = remove_trailing_spaces(data[2][CL_ADDRESS4])
        rem_record[7] = remove_trailing_spaces(data[2][CL_POSTCODE])
        
        cmd = "SELECT name FROM Patients WHERE patient_no = " & tmp[i][4]
        data = query_database("xclipats.sql", cmd)
        rem_record[2] = remove_trailing_spaces(data[2][1])
        
        rem_record[8] =  globalSettings[GS_BRANCH]
        
        if strtoval(tmp[i][2]) < cur_jdate then
                rem_record[9] = "Your " & ReminderTypes[strtoval(tmp[i][5])] & " is overdue."    
        else
                rem_record[9] = "Your " & ReminderTypes[strtoval(tmp[i][5])] & " is due."        
        end if  
        
        rem_record[10] = JdaystodateStr(strtoval(tmp[i][2])) 
        
        rem_record[11] = strtoval(tmp[i][1])    --Reminder.id 
        rem_record[12] = strtoval(tmp[i][6])    --reminder_count


        rem_list = append(rem_list, rem_record)
        
end for


return rem_list
end function


------------------------------------------------------------------------------------------------------------
function create_reminder_list()
--have selection criteria
------------------------------------------------------------------------------------------------------------
sequence data, cmd, rem_list, tmp, rem_record 
integer death_count

--VOID = get_yn_box(sprintf("%d %d", {jdate_from, jdate_to}) )

cmd = sprintf("SELECT * FROM Reminders where jdate >= %d and jdate <= %d and reminder_count > 0", {jdate_from, jdate_to} )
data = query_database("xclipats.sql", cmd)

if length(data) = 0 then return {} end if

tmp = data[2..$]

rem_list = {}

for i = 1 to length(tmp) do
        --check selected_reminders
        if selected_reminders[strtoval(tmp[i][5])] = 'X' then                                   --reminder type
                if cur_jdate - strtoval(tmp[i][7]) >= NO_REMINDER_WITHIN then  
                         --check patient is alive - don't want to send dead reminders
                        cmd = "SELECT status from Patients where patient_no = " & tmp[i][4]      --still a string!
                        data = query_database("xclipats.sql", cmd)
                        if data[2][1][1] != 'X' then
                                rem_list = append(rem_list, tmp[i])
                        else
                                tmp[i][6][1] = 'D'      --notify deadness
                        end if
                end if
        end if
end for

--remove dead patients reminders from list
death_count = 0
for i = 1 to length(tmp) do
        if tmp[i][6][1] = 'D' then
                death_count += 1
                cmd = "DELETE FROM Reminders WHERE client_no = " & tmp[i][3] & " AND patient_no = " & tmp[i][4]
                VOID = query_database("xclipats.sql", cmd) 
        end if
end for

if death_count > 0 then
        VOID = get_yn_box("Deleted " & sprintf("%d", {death_count}) & " dead patient reminders" )
end if

--now turn rem_list into something usable and printable
rem_list = create_rem_list(rem_list)

VOID = get_yn_box(sprintf("There are %d reminders", {length(rem_list)} ) )

return rem_list
end function

------------------------------------------------------------------------------------------------------------
function select_reprem_date(sequence jdate_choices)
------------------------------------------------------------------------------------------------------------
integer  choice
sequence date_choices

date_choices = repeat("", length(jdate_choices))
for i = 1 to length(jdate_choices) do
        date_choices = JdaystodateStr(jdate_choices[i])   
end for

position(9,9)
SetColors(BLACK, CYAN)
SetSize(6, 14)
choice = ListBoxIndex("Select date", {date_choices}, 1)

if choice = -1 then return 0 end if

return jdate_choices[choice]
end function

------------------------------------------------------------------------------------------------------------
function reproduce_reminder_list()
------------------------------------------------------------------------------------------------------------
sequence data, cmd, rem_list, tmp, rem_record 
integer sel_jdate

--firstly get dates have available reminder runs
cmd = sprintf("SELECT DISTINCT jdate_last_run FROM Reminders where jdate_last_run > %d ORDER BY jdate_last_run DESC", {cur_jdate - 18*30} ) -- max 18 months
data = query_database("xclipats.sql", cmd)

if length(data) = 0 then return {} end if

for i = 2 to length(data) do
        data[i] = strtoval(data[i][1])          --totally misusing / abusing data!!
end for

sel_jdate = select_reprem_date(data[2..$])

if sel_jdate = 0 then return {} end if

rem_list = {}

--now get the reminders with the selected dates
cmd = sprintf("SELECT * FROM Reminders where jdate_last_run = %d", {sel_jdate})
data = query_database("xclipats.sql", cmd)

rem_list = create_rem_list(data[2..$])
VOID = get_yn_box(sprintf("There are %d reminders", {length(rem_list)} ) )

return rem_list
end function

------------------------------------------------------------------------------------------------------------
procedure show_rem_list(sequence rem_list)
------------------------------------------------------------------------------------------------------------
--will just put the list into a file to send
integer fp

if length(rem_list) > 0 then
        fp = open("rem_list.tmp", "w")
        for i = 1 to length(rem_list) do
                printf(fp, "%-10.10s %-20.20s %-20.20s %s\n", {rem_list[i][2], rem_list[i][1], rem_list[i][3], rem_list[i][10]})
        end for
        close(fp)
        
        system_view_file("rem_list.tmp")
        if upper(get_yn_box("Print this (y/n)[n]")) = 'Y' then
                printers_print_file("rem_list.tmp", PR_GENERAL)
        end if
        unlink("rem_list.tmp")
end if

end procedure


------------------------------------------------------------------------------------------------------------
procedure produce_reminders(sequence rem_list)
--and commit changes to database
--update last_run date
--reduce produced reminder count
------------------------------------------------------------------------------------------------------------
integer fp, rem_count
sequence cmd, data                                                                                                           

rem_count = 1
SetColors(WHITE, BLUE)

--fp = open("rem.tmp","w")
for i = 1 to length(rem_list) do
        printers_reminder_label(rem_list[i])
        
        position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - 5/2)
        SetSize(2, 5+2)
        MessageBox(sprintf("%d", {rem_count}), {})
        rem_count += 1

       cmd =   "UPDATE Reminders SET " &
                "reminder_count = " & sprintf("%d", {rem_list[i][12] - 1 } ) & ", " & 
                "jdate_last_run = " & sprintf("%d", {cur_jdate} ) & " " &
                "WHERE id = " & sprintf("%d", {rem_list[i][11]} )
        VOID = query_database("xclipats.sql", cmd)
        
        --printf(fp, "%s\n", {cmd})

end for

--clear the box
SetStyle(5)
SetColors(WHITE, BLACK)
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - 5/2)
SetSize(2, 5+2)
MessageBox("", {})
SetStyle(1)


--close(fp)

end procedure


------------------------------------------------------------------------------------------------------------
global procedure recall_main()
--reminders are set up under global settings
--10 slots, slot numbers correspond to vaccine type
--saved as list of types,
--when service used, saves a reminder type into reminder database
--in order to save time, should I check for duplicates?
--or just check here
--reminder_count contains number of reminders left that can be sent - ie is preloaded with number of
--reminders, and decremented to 0
--also have jdate_last_run - so when reminders are run, records it, so can avoid doing it if too short a time
------------------------------------------------------------------------------------------------------------
integer choice, current_choice
sequence menu_items, rem_list

menu_items = {  "Select reminder dates",
                "Select reminder types",
                --"Show reminder list",
                "Produce reminders",
                "Reproduce reminders",
                "Quit"
                }

check_reminders()               

selected_reminders = "XXXXXXXXXX"       --all reminders selected when start

--set date_from to 90 days ago
jdate_from = julianDay(nowDate()) - 110
jdate_to =   julianDay(nowDate()) + 30
cur_jdate =  julianDay(nowDate()) 

date_from = JdaystodateStr(jdate_from)
date_to = JdaystodateStr(jdate_to)
cur_date =  JdaystodateStr(cur_jdate)

NO_REMINDER_WITHIN = 21

--show reminder selection parameters
show_reminder_selections()

rem_list = {}
current_choice = 1
while 1 do
        position(8,8)
        SetColors(BRIGHT_WHITE, BLACK)
        SetSize(length(menu_items)+3, 25)

        choice = Select("Recalls and reminders", current_choice, menu_items )

        current_choice = choice

        if choice = -1 or choice = length(menu_items) then exit end if

        if choice = 1 then
                select_dates()
                rem_list = {}
        elsif choice = 2 then
                select_reminders()
                rem_list = {}
        elsif choice = 3 then
                rem_list = create_reminder_list()   
                show_rem_list(rem_list)
                if upper(get_yn_box("Produce reminders (y/n)[n]")) = 'Y' then
                        produce_reminders(rem_list)
                end if
                show_reminder_selections()
        elsif choice = 4 then
                rem_list = reproduce_reminder_list()
                if length(rem_list) = 0 then
                        VOID = get_yn_box("No reminders sent - ever!")
                else
                        show_rem_list(rem_list)
                        if upper(get_yn_box("Produce reminders (y/n)[n]")) = 'Y' then
                                produce_reminders(rem_list)
                        end if
                end if                      
                show_reminder_selections()
        end if

end while


end procedure
