include database.e
include graphics.e
include Fdialogs.ex
include wildcard.e

without warning

--if graphics_mode(14) then
--end if

--set the screen background to clear boxes
SCREEN_BKGND = BLACK
bk_color(SCREEN_BKGND)

integer     err,
            finish,
            i, i1, ds, di

atom        SelectedIndex

object      t_key

sequence    result,
            genbox,
            FindPerson,
            SearchList,
            NameSelectList,
            SelectedPerson,
            PersonTitle,
            PersonDetails,
            temp_str
                
                

constant    SURNAME = 1,
            FORENAME = 2,
            ADDRESS1 = 3,
            ADDRESS2 = 4,
            ADDRESS3 = 5,
            ADDRESS4 = 6,
            POSTCODE = 7,
            TEL1 = 8,
            TEL2 = 9,
            EMAIL = 10,
            FAX = 11,
            NOTES = 12,
            CATEGORY = 13

global sequence record

-- create the record sequence for future use
record = repeat({},13)


--------------------------------------------
procedure resetRecord()
    record = repeat({},13)  
end procedure
--------------------------------------------

--------------------------------------------
-- See if str2 exists in str1, at the beginning
--------------------------------------------
function compare_strings(sequence str1, sequence str2)

    if length(str1) < length(str2) then
        return FALSE        
    end if
    
    if length(str1) = 0 or length(str2) = 0 then
        return FALSE
    end if

    str1 = upper(str1)
    str2 = upper(str2)

    if equal(str1[1..length(str2)], str2) then
        return TRUE
    else
        return FALSE
    end if
    
end function
--------------------------------------------


--------------------------------------------
procedure RecordForm()

        position(5,12)
        SetSize(10,21)
        SetColors(YELLOW, BLUE)

        
        record = Form("Add a person",
                        {"Surname              ", record[SURNAME],  30,
                        "Forename or initials ", record[FORENAME], 30,
                        "Address 1            ", record[ADDRESS1], 30,
                        "Address 2            ", record[ADDRESS2], 30,
                        "Address 3            ", record[ADDRESS3], 30,
                        "Address 4            ", record[ADDRESS4], 30,
                        "Postcode             ", record[POSTCODE], 10,
                        "Telephone work       ", record[TEL1],     15,
                        "Telephone home       ", record[TEL2],     15,
                        "E-mail               ", record[EMAIL],    30,
                        "Fax                  ", record[FAX],      15,
                        "Note                 ", record[NOTES],    30,
                        "Category             ", record[CATEGORY], 20                   
                        })

end procedure
--------------------------------------------


-----------------------------------------------------------------------------------------------
global function rolodex_main()
-----------------------------------------------------------------------------------------------
integer choice, current_choice

utils_clear_screen()
-- set the title
position(1,1)
SetSize(2, SCREEN_COLS - 2)
MessageBox("Rolodex - euphoria name, address and telephone scratchpad",{})

--testing generic box
--object result
--result = GenericBox("Hi",{})


-- check the database
finish = 0
err = db_open("xrolodex", DB_LOCK_SHARED)
if err != DB_OK then --create it
    err = db_create("xrolodex", DB_LOCK_NO)
    if err != DB_OK  then
        position(10,10)
        SetSize(2,20)
        MessageBox("Unable to create the database - exiting",{})
        finish = 1
    else
        i = db_create_table("DataSet1")
    end if
end if
db_close()

current_choice = 1
while 1 do
    if finish = 1 then exit
    end if

    resetRecord()

    --create the main menu
    position(4,2)
    SetSize(6,13)
    SetColors(BLUE,WHITE)
    choice = Select("Menu",current_choice,
                    {"Find a person",
                    "Add a person",
                    "Exit"})
    current_choice = choice

    if choice = 3 then
        exit
    end if

    if choice = 2 then  --add a person
        --surname
        
        --record[SURNAME] = "Burch"
        --record[FORENAME] = "Christoher"

        RecordForm() --get the form details

        --ask if you want to save the changes
        position(5,12)
        SetColors(WHITE, RED)
        SetSize(5,12)
        SetHint("")
        if Select("Save person",1,{"   Yes   ","    No   " }) = 1 then      --save the person
                --now add it to the database
                --printf(1,"%s,%s\n%s\n%s\n", {"Hello", record[SURNAME], record[FORENAME], record[ADDRESS1]}) --debug
                i1 = db_open("xrolodex", DB_LOCK_EXCLUSIVE) -- already checked for presence
                ds = db_select_table("DataSet1")
                t_key = record[SURNAME] & db_table_size()+1
                di = db_insert(t_key, record)
                if di = DB_EXISTS_ALREADY then
                    printf(1,"Failed",{})
                end if
                db_close()
        end if
        --clear the message box
        position(5,12)
        SetStyle(5)
        SetColors(WHITE, SCREEN_BKGND)
        MessageBox("",{""})
        SetStyle(1)

        position(15,1)
                
    end if --end of add a person

    if choice = 1 then --find a person
        i1 = db_open("xrolodex", DB_LOCK_EXCLUSIVE)
        ds = db_select_table("DataSet1")
        t_key = db_table_size()
        if  t_key > 0 then
            position(5,12)
            SetColors(WHITE, BLUE)
            SetSize(6,35)
            FindPerson = Input("Find a person",
                                {"Enter all or part of the surname",
                                "",""},
                                "                              ")
                                
            --remove trailing spaces from FindPerson
            FindPerson = remove_trailing_spaces(FindPerson)
                        
            --Clear the input box
            SetStyle(5) SetColors(WHITE, SCREEN_BKGND) MessageBox( "", {""} ) SetStyle(1)
        
            --search thru the database and create a list of matched records
            SearchList = {} NameSelectList = ""
            position (15,1)
            for j = 1 to t_key do
                record = db_record_data(j)
                --printf(1,"%s %d %s, %d %d\n",{ record[SURNAME], t_key ,FindPerson, length(record[SURNAME]), length(FindPerson)} ) --debug
                if compare_strings(record[SURNAME], FindPerson) then
                    --printf(1,"MATCH!\n",{})  --debug
                    SearchList = append(SearchList, {record[SURNAME], j} )
                    temp_str = record[SURNAME]
                    if length(temp_str) > 23 then
                        temp_str = temp_str[1..23]
                    end if
                    NameSelectList = append(NameSelectList, temp_str)
                end if
            end for
            
            --display the list, or notify no matches
            if length(SearchList) > 0 then
                SelectedIndex = 1
                while SelectedIndex > 0 do
                    DisplayHint("Return, ESC, (E)dit, (D)elete")
                    position(5,10)
                    SetSize(14,25)
                    SetColors(BRIGHT_WHITE,GREEN)
                    SelectedIndex = ListBoxIndex("Select person", NameSelectList, SelectedIndex)
                    
                     --check global key list signal
                    if LIST_KEY = 'e' or LIST_KEY = 'E' then --edit
                        record = db_record_data( SearchList[SelectedIndex][2] )
                        RecordForm()
                        db_replace_data(SearchList[SelectedIndex][2], record )
                    end if
                    if LIST_KEY = 'd' or LIST_KEY = 'D' then --delete
                        position(5,20)
                        SetColors(WHITE, RED)
                        SetSize(5,21)
                        SetHint("")
                        if Select("Really delete person",1,{"   Yes   ","    No   " }) = 1 then 
                                db_delete_record(SearchList[SelectedIndex][2])
                                SelectedIndex =1
                        end if
                        --clear the message box
                        position(5,20)
                        SetStyle(5)
                        SetColors(WHITE, SCREEN_BKGND)
                        MessageBox("",{""})
                        SetStyle(1)
                        exit
                    end if


                    if SelectedIndex > 0 then --display selected person
                        --load record with details
                        record = db_record_data( SearchList[SelectedIndex][2] )
                        --create title
                        PersonTitle = "Currently selected : " & record[SURNAME]
                        if length(PersonTitle) > 33 then
                            PersonTitle = PersonTitle[1..33]
                        end if
                        --create details
                        PersonDetails = {}
                        PersonDetails = append(PersonDetails, "Surname   : " & record[SURNAME])
                        PersonDetails = append(PersonDetails, "Forname   : " & record[FORENAME])
                        PersonDetails = append(PersonDetails, "Address   : " & record[ADDRESS1])
                        PersonDetails = append(PersonDetails, "            " & record[ADDRESS2])
                        PersonDetails = append(PersonDetails, "            " & record[ADDRESS3])
                        PersonDetails = append(PersonDetails, "            " & record[ADDRESS4])
                        PersonDetails = append(PersonDetails, "Postcode  : " & record[POSTCODE])
                        PersonDetails = append(PersonDetails, "Telephone : " & record[TEL1])
                        PersonDetails = append(PersonDetails, "            " & record[TEL2])
                        PersonDetails = append(PersonDetails, "e-mail    : " & record[EMAIL])
                        PersonDetails = append(PersonDetails, "Notes     : " & record[NOTES])
                        PersonDetails = append(PersonDetails, "Category  : " & record[CATEGORY])
                        --display details
                        DisplayHint("ESC, (E)dit, (D)elete")
                        position(5,37)
                        SetSize(15,41)
                        SetColors(BLACK, WHITE)
                        genbox = GenericBox(PersonTitle, PersonDetails)
                    end if
                end while
                --delete listbox
                position(5,10) SetSize(14,25) SetStyle(5) SetColors(WHITE, SCREEN_BKGND) MessageBox( "", {""} ) SetStyle(1)
                --delete details box
                position(5,37) SetSize(15,41) SetStyle(5) SetColors(WHITE, SCREEN_BKGND) MessageBox( "", {""} ) SetStyle(1)

            else
                SetSize(2,25)
                position( (vid_conf[VC_LINES]-2)/2, (vid_conf[VC_COLUMNS]-25)/2 )
                SetColors(WHITE, RED)
                Notify("    Sorry, no matches",
                    {} )
                --clear the notify box
                SetStyle(5) SetColors(WHITE, SCREEN_BKGND) MessageBox("", {""} ) SetStyle(1)
            end if
                
                
                    
        
        else
            --notify that there ar no saved records
            SetSize(2,25)
            position( (vid_conf[VC_LINES]-2)/2, (vid_conf[VC_COLUMNS]-25)/2 )
            SetColors(WHITE, RED)
            Notify("    Sorry, no records",
                    {} )
            --clear the notify box
            SetStyle(5)
            SetColors(WHITE, SCREEN_BKGND)
            MessageBox("", {""} )
            SetStyle(1)
        end if
    end if

end while --end of main loop

bk_color(BLACK)
clear_screen()


return 0
end function

