--frequently used utilities
include datetime.e


-------------------------------------------------------------------------------------
global procedure utils_clear_screen()
-------------------------------------------------------------------------------------

SetColors(BLACK,WHITE)
position(1,1) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
clear_screen()

end procedure

-------------------------------------------------------------------------------------
global function utils_separate_sequence(object seq, integer l)
--takes a sequence, separates into several sequences of
--max length l
-------------------------------------------------------------------------------------
sequence tmp

tmp = {}

if sequence(seq) = 0 or length(seq) = 0 then
        return tmp
end if

--the easy one first
if length(seq) <= l then
        tmp = seq
        return tmp
else

end if

return tmp
end function

-------------------------------------------------------------------------------------
global procedure flush_key_buffers()
-------------------------------------------------------------------------------------
while get_key() != -1 do
end while
end procedure

-------------------------------------------------------------------------------------
global function escape_quotes(object str)
--used by the database to escape single 's
-------------------------------------------------------------------------------------
  sequence tmp

  tmp = ""
  
  if sequence(str) = 0 or length(str) = 0 then return tmp end if
  
  for i = 1 to length(str) do
     if str[i] = 39 then
        tmp = tmp & "'" & str[i]
     else
        tmp = tmp & str[i]
     end if
  end for

  return tmp
end function


-------------------------------------------------------------------------------------
global function get_yn_box(sequence str)
-------------------------------------------------------------------------------------
object c
integer l

flush_key_buffers()

l = length(str)

SetColors(WHITE, RED)
--postion(line, column)
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - l/2)
SetSize(2, l+2)
MessageBox(str, {})

c = wait_key()

--clear the box
SetStyle(5)
SetColors(WHITE, BLACK)
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - l/2)
SetSize(2, l+2)
MessageBox("", {})
SetStyle(1)


return c
end function

-------------------------------------------------------------------------------------
global function quick_question(sequence str, sequence bcolors)
-------------------------------------------------------------------------------------
object c
integer l

flush_key_buffers()

l = length(str)

SetColors(bcolors[1], bcolors[2])
--postion(line, column)
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - l/2)
SetSize(2, l+2)
MessageBox(str, {})

c = wait_key()

--clear the box
SetStyle(5)
SetColors(WHITE, BLACK)
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - l/2)
SetSize(2, l+2)
MessageBox("", {})
SetStyle(1)


return c
end function


-------------------------------------------------------------------------------------
global function remove_trailing_spaces(sequence str)
-------------------------------------------------------------------------------------
integer x

    x = length(str)
    if x = 0 then return "" end if

    while str[x] = 32 or str[x] = '\n' or str[x] = 0 or str[x] = '\t' do
        x = x-1
        if x <= 1 then exit
        end if
    end while

    if x < 1 then x = 1 end if
    str = str[1..x]

    if length(str) = 1 and (str[1] = 32 or str[1] = ENTER) then
        str = ""
    end if

return str
end function



-------------------------------------------------------------------------------------
global function strtoval(object str)
--value is a pain in the ass
-------------------------------------------------------------------------------------
sequence conv
atom val

--safeguard, if a real value is passed
if atom(str) then return str end if

conv = value(str)
if conv[1] = GET_SUCCESS then
    val = conv[2]
else val = 0
end if

return val
end function

-------------------------------------------------------------------------------------
global function TextToNumber(object str)
--in case I use this from win32 lib
-------------------------------------------------------------------------------------
return strtoval(str)
end function

-------------------------------------------------------------------------------------
global function remove_all_spaces(sequence str)
-------------------------------------------------------------------------------------
sequence str2
str2 = {}

for i = 1 to length(str) do
        if str[i] != ' ' then
                str2 = append(str2, str[i])
        end if
end for

return str2
end function


-------------------------------------------------------------------------------------
global function standardDatestr(sequence str)
--takes a date string, returns a standard date string
-------------------------------------------------------------------------------------
sequence str2
str2 = {}

str = remove_trailing_spaces(str)
str = remove_all_spaces(str)

for i = 1 to length(str) do
        if str[i] = '.' or str[i] = ',' or str[i] = '\\' or str[i] = '-' then 
                str2 = append(str2, '/') 
        else str2 = append(str2, str[i])
        end if
end for

return str2
end function


-------------------------------------------------------------------------------------
global function datestrtoDate(sequence str)
--takes a date string, returns a Date type (sequence)
-------------------------------------------------------------------------------------
sequence dateasDate
dateasDate = {0,0,0}

dateasDate[3] = strtoval(str) -- should take care of the day

for i = 1 to length(str) do
        if str[i] = '/' then 
                dateasDate[2] = strtoval(str[i+1..$])
                for j = i+1 to length(str) do
                        if str[j] = '/' then 
                                dateasDate[1] = strtoval(str[j+1..$])
                                exit
                        end if
                end for
                exit
        end if
end for

if dateasDate[1] < 100 then dateasDate[1] += 1900 end if

return dateasDate
end function


-------------------------------------------------------------------------------------
global function DOB2age(sequence str)
--takes a date string, returns the age as a string
-------------------------------------------------------------------------------------
sequence age, str2
sequence now_date, dob_date
atom days, years, months

dob_date = {0,0,0}
age = {}
days = 0

now_date = nowDate()

--firstly, standardise date string
str2 = standardDatestr(str)

--convert standard date str to Date sequence
dob_date = datestrtoDate(str2)


--now have dob_date as date
if ValidDate(dob_date) = 0 then
        return ""
end if

days = daysDifference(dob_date, now_date)

--how many years
years = floor(days/365)
days = remainder(days, 365)
months = floor(days/30)
days = remainder(days, 30)

if years > 0 then
        age = sprintf("%dy %dm", {years, months})
else    age = sprintf("%dm %dd", {months, days})
end if

return age
end function

-------------------------------------------------------------------------------------
global function DateToStr(sequence date_seq)
--takes a date sequence, returns a date (Y,M,D)
-------------------------------------------------------------------------------------
sequence str
str = ""

if ValidDate(date_seq) = 0 then
    return ""
end if

for i = length(date_seq) to 1 by -1 do
    str = str & sprintf("%02d/" , {date_seq[i]})
end for
str = str[1..$-1]

return str
end function


-------------------------------------------------------------------------------------
global function check_date(sequence str)
--takes a string, checks whether in DOB or age format 
--returns a DOB as standard string
--also checks for all other possible delimmeters,
--and will return todays date if invalid
-------------------------------------------------------------------------------------
sequence str2, tmp
integer age_format, years, months, days, days_old, dob_format, slash_count
sequence now_date, dob_date, st


now_date = nowDate()
st = {}
slash_count = 0

age_format = FALSE
dob_format = FALSE
days = 0 years = 0 months = 0

str = upper(str)

--remove spaces from str
str = remove_all_spaces(str)

--DOB or age format?
for i = 1 to length(str) do
        if str[i] = 'Y' or str[i] = 'M' or str[i] = 'D' then
                age_format = TRUE
                exit
        end if
end for

if age_format = TRUE then --create date from that
        --first split string
        st = {}
        for i = 1 to length(str) do
                st = append(st, str[i])
                if str[i] = 'Y' then 
                        years = strtoval(st)
                        st = {}
                elsif
                        str[i] = 'M' then 
                        months = strtoval(st)
                        st = {}
                elsif
                        str[i] = 'D' then
                        days = strtoval(st)
                        st = {}
                end if
        end for
        
        --next calc number of days from this
        days_old = 365*years + floor(30.5*months) + days
        
        --now create new date from this - subtract days from date
        dob_date = subFromDate(now_date, days_old)
        
        --now create str2, the actual dob, from this
        str2 = sprintf("%02d", {dob_date[3]}) & "/" & sprintf("%02d", {dob_date[2]})  & "/" & sprintf("%d", {dob_date[1]})
else
        --not an age format - check to see it is a valid date format
        str = standardDatestr(str)
        tmp = datestrtoDate(str)
        str = DateToStr(tmp)    
        
        for i = 1 to length(str) do
                if str[i] = '/' then slash_count += 1 end if    
        end for

        if slash_count = 2 then
                --seems to be valid date - although no checking of date validity
                str2 = str
        else 
                str2 = DateToStr(nowDate())
        end if
end if

return str2
end function


-------------------------------------------------------------------------------------
global function get_max_str(integer max)
--returns a string of max length max
-------------------------------------------------------------------------------------
sequence curs_posn, text
atom c

curs_posn = get_position() --{line, col}
text = ""

while 1 do
        c = wait_key()
        if c = ENTER then exit end if
        
        if c = bksp and length(text) > 1 then
                text = text[1..$-1]
        elsif c = bksp and length(text) <= 1  then
                text = ""
        elsif (c >= 'a' and c <= 'z') or (c >= 'A' and c <= 'Z') or (c >= '0' and c <= '9') or (c >= 32 and c <= 126) then      
                text = text & c
                if length(text) > max then exit end if
        end if
                
        position(curs_posn[1], curs_posn[2])
        puts(1, text & ' ')
        position(curs_posn[1], curs_posn[2] + length(text) )
        
end while

return text
end function

-------------------------------------------------------------------------------------------------
global function utils_valid_time(object str)
--takes a string with a time in it
--returns the number of seconds since midnight
--or -1 if not valid
--valid string
--  at least 5 chars long (assumes 24 hour clock)
--  valid HH MM separator |:;,.
-------------------------------------------------------------------------------------------------
sequence delims
integer success, secs, hours, mins

delims = "|:;,."
success = FALSE
secs = -1

--obvious checks
if sequence(str) = 0 then return -1 end if
if length(str) != 5 then return -1 end if

for i = 1 to length(delims) do
        if str[3] = delims[i] then success = TRUE end if
end for
if success = FALSE then return -1 end if

hours = strtoval(str)
mins = strtoval(str[4..$])

if hours > 23 or mins > 59 then return -1 end if

secs = mins*60 + hours*60*60

return secs
end function

-------------------------------------------------------------------------------------------------
global function utils_secstotimestr(integer secs)
--takes number of secs since midnight
--returns a string HH:MM
--inverse of utils_validate_time
-------------------------------------------------------------------------------------------------
sequence str
integer hours, mins

hours = floor(secs/3600)
mins = floor( (secs - (hours*3600))/60 )

str = sprintf("%02d:%02d", {hours, mins})

return str
end function

-------------------------------------------------------------------------------------------------
global function dateStrtoJdays(sequence str)
--converts a string to a number of days since Julian event 0
-------------------------------------------------------------------------------------------------
atom numdays
sequence date_seq

--convert any likely characters to standard '/'
for i = 1 to length(str) do
        if str[i] = '.' or str[i] = '\\' or str[i] = ',' or str[i] = '-' then
                str[i] = '/'
        end if
end for

--convert date str to date sequence
date_seq = datestrtoDate(str)

if ValidDate(date_seq) then
        --convert that to Jdays
        numdays = julianDay(date_seq)
else 
        numdays = -1
end if
        
return numdays
end function

-----------------------------------------------------------------------------------------------
global function JdaystodateStr(atom jdays)
-----------------------------------------------------------------------------------------------
sequence str, dateobj

dateobj = julianDate(jdays)

str = DateToStr(dateobj)

return str
end function


------------------------------------------------------------------------------------
global function utils_compress_2_string(object seq)
--takes a sequence, returns a string separated by |
--note - only works on 2 level sequences
------------------------------------------------------------------------------------
sequence str

str = "" 

--check its a sequence
if atom(seq) then
        return -1
end if

--convert each element of seq to a seq, and add it to str
if length(seq) > 0 then
        for i = 1 to length(seq) do
                if sequence(seq[i]) then
                        str &= seq[i]
                else
                        str &= {seq[i]}
                end if
                -- str &= "|"   --old form
                str = remove_trailing_spaces(str) & "{r1}"
        end for
else
        str = "{r1}{r1}"        --strange, but will make next end if, not add anything
end if

if match("{r1}", str) != 1 then
        str = "{r1}" & str
end if

return str
end function


------------------------------------------------------------------------------------
function utils_resolve_strings_r1(sequence str, integer line_count)
------------------------------------------------------------------------------------
sequence sub_strings
integer count, c1, c2

count = 0
c1 = 1 c2 = 1
sub_strings = {}

str = str[5..$-4] --trims off beginning and end "{r1}" s

if length(str) = 0 then
        return {}
end if

while 1 do
        c2 = match("{r1}", str)
        if c2 > 0 then
                sub_strings = append(sub_strings, str[c1..c2-1])
                str = str[c2+4..$] 
        else
                sub_strings = append(sub_strings, str)
                exit                 
        end if
end while



return sub_strings
end function

------------------------------------------------------------------------------------
global function utils_resolve_strings(sequence str, integer line_count)
--takes a long string, of strings separated by '|', return a sequence of strings
--if line_count < 0 then works out line count
--{r1} revison 1 compression, replaces newline with {r1}

------------------------------------------------------------------------------------
sequence sub_strings
integer count

--VOID = get_yn_box(str)
if match("{r1}", str) = 1 then
        sub_strings = utils_resolve_strings_r1(str, line_count)
        --VOID = get_yn_box("Matched!")
        return sub_strings
end if  

if line_count < 0 then
        --count number of | 
        count = 0
        for i = 1 to length(str) do
                if str[i] = '|' then count += 1 end if
        end for
        line_count = count
end if

sub_strings = repeat({}, line_count)
count = 1

for i = 1 to length(str) do
        if str[i] = '|' then
                count += 1
        else
                sub_strings[count] &= str[i]
        end if
        if count > line_count then exit end if
end for

return sub_strings
end function

---------------------------------------------------------------------------------
global function utils_abs(object x)
--BASIC abs
---------------------------------------------------------------------------------

if atom(x) = 0 then
        return x
end if

if x < 0 then x = -x end if

return x
end function
global function abs(object x)
return utils_abs(x)
end function

---------------------------------------------------------------------------------
global function utils_2str(object s, integer dp)
--takes an object, returns a str (sequence) representation
--dp - decimal places to use for numbers - if -1 just as it comes
---------------------------------------------------------------------------------
sequence str, format_str

if sequence(s) then return s end if

--integer or real?
if integer(s) then
        str = sprintf("%d", {s})
else
        if dp = -1 then
                format_str = "%f"
        else
                format_str = "%." & sprintf("%d", {dp}) & "f"
        end if
        str = sprintf(format_str, {s})
end if

return str

end function

---------------------------------------------------------------------------------
global function utils_validDate(sequence str)
--takes a date str, returns true if valid, false if not
--convert str to date object then test with validDate()
---------------------------------------------------------------------------------
sequence d_obj

d_obj = datestrtoDate(str)

if ValidDate(d_obj) then
        return 1
else
        return 0
end if

end function


---------------------------------------------------------------------------------
global function utils_compress(object obj)
--takes any object, returns a 1d sequence
--using these as referral functions for best compression conversion techniques
---------------------------------------------------------------------------------
sequence tmp

tmp = utils_compress_2_string(obj)

return tmp
end function


---------------------------------------------------------------------------------
global function utils_decompress(object seq)
--takes any 1d sequence, returns the object
---------------------------------------------------------------------------------
sequence tmp

tmp = utils_resolve_strings(seq, -1)

return tmp
end function

----------------------------------------------------------------------------------------------------
global function seqcpy(sequence src_seq, sequence dest_seq, integer start_pos)
--equivalent strcpy in c, with added define start pos
----------------------------------------------------------------------------------------------------
integer term_pos, src_len, dest_len

src_len = length(src_seq)
dest_len = length(dest_seq)

if start_pos > dest_len then return dest_seq end if

term_pos = start_pos + src_len - 1

if term_pos > dest_len then
        term_pos = dest_len
end if       

for i = start_pos to term_pos do
        dest_seq[i] = src_seq[i - start_pos + 1]
end for

return dest_seq
end function

------------------------------------------------------------------------------------------------------
global function seqreplace(sequence str1, sequence str2, sequence line)
--replace str1 with str2 in line
------------------------------------------------------------------------------------------------------
sequence temp
integer pos_start, pos_end

pos_start = match(str1, line)
if pos_start = 0 then
        return line
end if

if pos_start = 1 then
        temp = remove_trailing_spaces(str2) & " " & line[length(remove_trailing_spaces(str1))+1 .. $] 
else
        temp = line[1..pos_start] & " " &  remove_trailing_spaces(str2) & " " & line[length(remove_trailing_spaces(str1))+1 .. $] 
end if

return temp
end function

