--sub program for vatbook,
--bad debt reports,
--quick financial reports


---------------------------------------------------------------------------------------------------------------
function fees_drugs_vat_wrk(sequence wrk_list)
---------------------------------------------------------------------------------------------------------------
sequence FDV

FDV = {0,0,0,0}         --fees, drugs, VAT, total

for i = 1 to length(wrk_list) do
        if wrk_list[i][N_TYPE][1] = 'S' then
                FDV[1] += wrk_list[i][N_FEES]
                FDV[3] += wrk_list[i][N_VAT]
                FDV[4] = FDV[4] + FDV[1] + FDV[3]
        elsif wrk_list[i][N_TYPE][1] = 'D' then
                FDV[2] += wrk_list[i][N_DRUGS]
                FDV[3] += wrk_list[i][N_VAT]
                FDV[4] = FDV[4] + FDV[2] + FDV[3]
        end if
end for


return FDV
end function




---------------------------------------------------------------------------------------------------------------
function today_VAT_book(sequence ds)
--output
--breakdown fees, drugs, VAT, total for day
--breakdown by payment type
--list cheque, and card payments, clients
--breakdown by vet
--list clients seen with balance outstanding
--list payments and methods by each individual client
--PAYMENT+METHODS = global variable defined in vetstruc.ex
---------------------------------------------------------------------------------------------------------------
sequence data, cmd, wrk_list, FDV, PMNTS
integer fp
atom PMNTS_TOT

FDV = {0,0,0,0}         --fees, drugs, VAT, total
PMNTS_TOT = 0

cmd = "SELECT * FROM notes where date like '" & remove_trailing_spaces(ds) & "%' AND total <> 0"
data = query_database("xnotes.sql", cmd)

if length(data) = 0 then
        printcolor( {9,18}, {BRIGHT_WHITE, GREEN}, "No work today!" )
        VOID = wait_key()
        return 0 
end if

--that'll give us a list of work with todays date,
wrk_list = data[2..$]
for i = 1 to length(wrk_list) do
        wrk_list[i] = data_validate_note(wrk_list[i])
end for

FDV = fees_drugs_vat_wrk(wrk_list)

fp = open("vatbook.txt", "w")
printf(fp, "Vatbook for %s\n=======================\n\n", {DateToStr(nowDate()) } )

printf(fp, "Work done\n---------\n", {})
printf(fp, "%10s %10s %10s %10s\n", {"Fees", "Drugs", "VAT", "Total" } )
printf(fp, "%10.2f %10.2f %10.2f %10.2f\n\n", {FDV[1], FDV[2],FDV[3],FDV[4] } )

--payments by what method
PMNTS = repeat(0, length(PAYMENT_METHODS))     --same number of different payment methods 
                                                --holds totals of payments, each type
                                                --PDSA special case
for i = 1 to length(wrk_list) do
        if wrk_list[i][N_TYPE][1] = 'P' then
                --what type of payment?
                for j = 1 to length(PAYMENT_METHODS) do
                        if match(upper(PAYMENT_METHODS[j]), upper(wrk_list[i][N_NOTE]) ) > 0 then
                                PMNTS[j] += wrk_list[i][N_TOTAL]
                        end if
                end for
        end if
end for

printf(fp, "Payments type totals\n--------------------\n", {})
for i = 1 to length(PAYMENT_METHODS) do
        printf(fp, "%-10s : %8.2f\n", {PAYMENT_METHODS[i], PMNTS[i]} )        
        PMNTS_TOT += PMNTS[i]
end for
printf(fp, "%-10s : %8.2f\n", {"Total", PMNTS_TOT})


close(fp)

system_view_file("vatbook.txt")
if upper(get_yn_box("Print this (y/n)[n]")) = 'Y' then
        printers_print_file("vatbook.txt", PR_GENERAL)
end if
unlink("vatbook.txt")


return 0
end function



---------------------------------------------------------------------------------------------------------------
procedure bad_debts()
--initial test to see if bad debt flag has been set any where!
---------------------------------------------------------------------------------------------------------------
sequence data, cmd, bd_list, tmp
integer fp
atom total

total = 0

printcolor( {9,18}, {BRIGHT_WHITE, GREEN}, sprintf("%10s", {"Querying.."} ) )

cmd = "SELECT client_no, surname, address1, flags, outs_bal FROM clients ORDER BY surname"
data = query_database("xclipats.sql", cmd)

bd_list = {}
for i = 2 to length(data) do
        if data[i][4][FL_BAD_DEBT] = 'X' then
                bd_list = append(bd_list, data[i])
                bd_list[$][1] = strtoval(bd_list[$][1])
                bd_list[$][5] = strtoval(bd_list[$][5])
        end if
end for

--this gives us a list of clients flagged as bad debtors
--create a table with the client number, name, address, outstanding balance, and when became a bad debt

fp = open("bd.tmp", "w")
printf(fp, "%-40s %-13s %8s\n", {"Client details", "Date", "Outstanding" } )
printf(fp, "==================================================================\n", {} )
for i = 1 to length(bd_list) do
        cmd = "SELECT * FROM notes WHERE client_no = " & sprintf("%d", {bd_list[i][1]}) &
                "AND (type LIKE 'A%' OR type LIKE 'R%' OR type LIKE 'U%' or type LIKE 'B%')"
        data = query_database("xnotes.sql", cmd)
        printcolor( {9,18}, {BRIGHT_WHITE, GREEN}, sprintf("%10d", {bd_list[i][1]} ) )

        if length(data) > 0 then
                tmp = data[$][N_DATE]
        else tmp = "??"
        end if

        --put the last result onto a file
        printf(fp, "%-8d %-10.10s %-20.20s [%-12s]  %8.2f\n", {bd_list[i][1], bd_list[i][2], bd_list[i][3], tmp, bd_list[i][5] } )
        total += bd_list[i][5]

end for

printf(fp, "\n\n%-8s %-10.10s %-20.20s %-12s  %10.2f\n", {"Total", "", "", "", total } )
close(fp)

system_view_file("bd.tmp")

if upper(get_yn_box("Print this (y/n)[n]")) = 'Y' then
        printers_print_file("bd.tmp", PR_GENERAL)
end if
unlink("bd.tmp")

end procedure




----------------------------------------------------------------------------------------------------------------
function get_types_list(integer t, sequence data)
----------------------------------------------------------------------------------------------------------------
sequence sel_list

sel_list = {}

for i = 2 to length(data) do
        if data[i][CL_FLAGS][FL_LAST_SENT] = t then
                sel_list = append(sel_list, data[i])
        end if

end for

return sel_list
end function

----------------------------------------------------------------------------------------------------------------
function find_date_sent(integer client_no, integer n_type)
----------------------------------------------------------------------------------------------------------------
sequence ds, cmd, data

cmd = "SELECT date FROM notes WHERE client_no = " & sprintf("%d", {client_no}) & 
        "AND type like '" & n_type & "%'"
data = query_database("xnotes.sql", cmd)  

if length(data) = 0 then
        ds = "??"
else    
        ds = data[$][1]
end if

return ds
end function


----------------------------------------------------------------------------------------------------------------
function  list_outstanding_clients()
----------------------------------------------------------------------------------------------------------------
sequence cmd, data, type_list, sel_list, outs_list, ds 
integer fp
atom total, gr_total

type_list = "IRSB-"
sel_list = {}
outs_list = {}

cmd = "SELECT * FROM clients WHERE outs_bal > 0.01 ORDER BY surname"
data = query_database("xclipats.sql", cmd)

if length(data) = 0 then return 0 end if

for i = 2 to length(data) do
        data[i] = data_validate_client(data[i])
end for 

gr_total = 0

fp = open("outstanding.txt", "w")
--present data as groups of type last sent
for i = 1 to length(type_list) do
        sel_list = get_types_list(type_list[i], data)        

        
        if type_list[i] = 'I' then
                printf(fp, "Last sent an Invoice\n======================\n", {})
        elsif type_list[i] = 'R' then
                printf(fp, "Last sent a Reminder\n======================\n", {})
        elsif type_list[i] = 'S' then
                printf(fp, "Last sent a Statement\n======================\n", {})
        elsif type_list[i] = 'B' then
                printf(fp, "Last sent a Bad debt\n======================\n", {})
        elsif type_list[i] = '-' then
                printf(fp, "Last sent Nothing at all\n======================\n", {})
        
        end if  

        total = 0        
        for j = 1 to length(sel_list) do 
                if  type_list[i] = '-' then
                        ds = "NA"
                elsif type_list[i] = 'I' then
                        --find date sent invoice
                        ds = find_date_sent(sel_list[j][CL_CLIENT_NO], 'I') 
                elsif type_list[i] = 'R' then
                        ds = find_date_sent(sel_list[j][CL_CLIENT_NO], 'R') 
                elsif type_list[i] = 'S' then
                        ds = find_date_sent(sel_list[j][CL_CLIENT_NO], 'U') 
                elsif type_list[i] = 'B' then
                        ds = find_date_sent(sel_list[j][CL_CLIENT_NO], 'B') 
                end if 

                printf(fp, "%-8d %-10.10s %-20.20s [%-12s]  %8.2f\n", {sel_list[j][CL_CLIENT_NO], sel_list[j][CL_SURNAME], sel_list[j][CL_ADDRESS1], ds, sel_list[j][CL_OUTS_BAL]}) 
                total +=  sel_list[j][CL_OUTS_BAL]
                printcolor( {9,18}, {BRIGHT_WHITE, GREEN}, sprintf("%-20.20s", {sel_list[j][CL_SURNAME]} ) )

                ds = ""
                        
        end for
        
        printf(fp, "\n%-8s %-10.10s %-20.20s  %-12s   %8.2f\n", {"Total", "", "", "", total}) 
        gr_total += total
        
        printf(fp, "\n\n", {})
        
end for

printf(fp, "%-8s %-10.10s %-20.20s %-12s %8.2f\n", {"Grand total", "", "", "", gr_total}) 
close(fp)



system_view_file("outstanding.txt")
if upper(get_yn_box("Print this (y/n)[n]")) = 'Y' then
        printers_print_file("outstanding.txt", PR_GENERAL)
end if
unlink("outstanding.txt")



return 0
end function



----------------------------------------------------------------------------------------------------------------
global procedure vatbook_main()
----------------------------------------------------------------------------------------------------------------
integer choice, current_choice
sequence menu_items



menu_items = {"Todays VAT book",
                "Previous days VAT books",
                "Bad debt report",
                "List clients with outstanding balances",
                "Quit"
                }


current_choice = 1
while 1 do
        position(8,8)
        SetColors(BRIGHT_WHITE, BLACK)
        SetSize(8,40)

        choice = Select("Vat book", current_choice, menu_items )

        current_choice = choice

        if choice = -1 or choice = length(menu_items) then exit end if

        if choice = 3 then
                bad_debts()
        elsif choice = 4 then
                VOID = list_outstanding_clients()
        elsif choice =1 then
                VOID = today_VAT_book( DateToStr(nowDate()) )
        end if

end while



end procedure

