--contains definitions for record structure sequences
global constant JV_VERSION = "Release 0.1"
global sequence JV_BRANCH
JV_BRANCH = ""
global sequence JV_COLOURS

global constant TRUE = 1, FALSE = 0
global object VOID
global integer HASH_FLAG
HASH_FLAG = FALSE

-----------------------------------------------------------------------------------------
--global return_id's
--waiting_room.ex
global integer  rid_a2wr,               --add to waiting room
                rid_rmfwr,              --remove from waiting room
                rid_gdl,                        --get_diary_list
                rid_open_diary,
                rid_load_all_patients,
                rid_add_patient,
                rid_load_patient_list,
                rid_load_all_live_patients
-----------------------------------------------------------------------------------------


--Client structure - this should correspond to databse structure, for ease of reference
global constant         CL_CLIENT_NO            =       1,
                        CL_SURNAME              =       2,
                        CL_FIRST_NAME           =       3,
                        CL_TITLE                =       4,
                        CL_ADDRESS1             =       5,
                        CL_ADDRESS2             =       6,
                        CL_ADDRESS3             =       7,
                        CL_ADDRESS4             =       8,
                        CL_POSTCODE             =       9,
                        CL_TEL1                 =       10,
                        CL_TEL2                 =       11,
                        CL_FLAGS                =       12,
                        CL_WARNING              =       13,
                        CL_LAST_CONS_DATE       =       14,
                        CL_NEXT_CONS_DATE       =       15,
                        CL_NEXT_CONS_TIME       =       16,
                        CL_LAST_PAID            =       17,
                        CL_BILL_TYPE            =       18,
                        CL_FEES                 =       19,
                        CL_DRUGS                =       20,
                        CL_VAT                  =       21,
                        CL_OUTS_BAL             =       22,
                        CL_GONE_TO              =       23,
                        CL_BRANCH               =       24,
                        CL_MISC1                =       25,
                        CL_MISC2                =       26,

                        --aliases
                        CL_NUMBER               =       1  
                        

global constant FL_SEND_INVOICE = 1,
                FL_ADD_SURCHARGE = 2,
                FL_ADD_ACC_FEE = 3,
                FL_SLOW_PAYER = 4,
                FL_BAD_DEBT = 5,
                FL_PDSA = 6,
                FL_PLAN = 7,
                FL_ACCOUNT_ALLOWED = 8,
                FL_INVOICE_SENT = 9,
                FL_SEND_REMINDERS = 10,
                FL_SEND_STATEMENT = 11,
                FL_VAT_ON_DRUGS = 12,
                FL_VAT_ON_SERVICES = 13,
                FL_IGNORE_WHEN_INVOICING = 14,
                FL_LAST_SENT = 15,                      --only one not 'X' or '-'
                                                        -- 'I', 'R', 'S', 'B'
                                                        -- in order to save time, will only reset these when
                                                        --      running invoices
                                                        --      running the vat book have been sent
                                                        --      (making a payment)
                FL_HIDE_PAYMENT_BREAKDOWN = 16,         --should payment breakdowns be hidden? - = no, X = yes
                FL_PAYMENTS_ON_CLIENT = 17              --show payments on patients (-) or clients (X)

                --IRS - invoice/reminder/statement

--can change this if / when add flags
global constant FL_FLAG_COUNT = 17

global sequence CurClient
CurClient = repeat({}, 27)

--Patient structure
global constant         PA_PATIENT_NO =         1,
                        PA_TYPE =               2,
                        PA_NAME =               3,
                        PA_DOB =                4,
                        PA_SPECIES =            5,
                        PA_SEX =                6,
                        PA_BREED =              7,
                        PA_COLOR =              8,
                        PA_INSURED =            9,
                        PA_FARM_NAME =          10,
                        PA_FARM_TYPE =          11,
                        PA_HERD_REF =           12,
                        PA_HEIGHT =             13,
                        PA_TATTOO =             14,
                        PA_MICROCHIP =          15,
                        PA_STATUS =             16,     --use this for various flags
                                                        --[1] dead
                        PA_WEIGHT =             17,
                        PA_FEES =               18,
                        PA_DRUGS =              19,
                        PA_VAT =                20,
                        PA_OUTS_BAL =           21,
                        PA_MILEAGE =            22,
                        PA_CLIENT_NO =          23


--patient status settings                                               
global constant         ST_DEAD =               1

global sequence CurPatient
CurPatient = repeat({}, 45)

--PDSA fields
global constant         PDSA_CLIENT_NO =        1,
                        PDSA_PATIENT_NO =           2,
                        PDSA_PATIENT_NAME =         3,
                        PDSA_CERT_NO =              4,
                        PDSA_EXPIRY =               5,
                        PDSA_NOTES =                6,
                        PDSA_CHRONIC_COND =         7,
                        PDSA_CATEGORY =             8
global sequence PDSAPatient
PDSAPatient = repeat({}, 8)                     
                        

--Notes structure
global constant         N_NUMBER =              1,
                        N_PATIENT_NO =          2,
                        N_CLIENT_NO =           3,
                        N_DATE =                4,
                        N_NOTE =                5,
                        N_FEES =                6,
                        N_DRUGS =               7,
                        N_VAT =                 8,
                        N_TOTAL =               9,
                        N_USER =                10,
                        N_TYPE =                11,     --S service
                                                        --D drug
                                                        --T text / statement
                                                        --W weight
                                                        --P payment
                                                        --A accounting info
                                                        --I invoice
                                                        --R reminder

                                                        -- ****** NEW *******
                                                        --U statement
                                                        --B bad debt notification
                                                        --C archive note - says notes archived

                                                        --always use sequence for N_TYPE, eg Note[N_TYPE] = "B", or Note[N_TYPE][1] = 'B'

                        N_ANALYSIS =            12,
                        N_JDATE =               13

global sequence CurNote, Notes
global integer L_NOTE 
        L_NOTE = 13     --length of a notes record
CurNote = repeat({}, L_NOTE)

--User structure
global constant U_NAME  =       1,
                U_INIT =        2,      --initials!
                U_PASS  =       3,
                U_SECURITY  =   4
global sequence CurUser
CurUser = repeat({}, 4)

global sequence ClientList, SelectedCliPat, LastSelectedCliPat
ClientList = {}
SelectedCliPat = {0,0}
LastSelectedCliPat =  {0,0}

--new client??
global constant         NC_SURNAME =        1,
                        NC_FIRST_NAME =     2,
                        NC_TITLE =          3,
                        NC_ADDRESS1 =       4,
                        NC_ADDRESS2 =       5,
                        NC_ADDRESS3 =       6,
                        NC_ADDRESS4 =       7,
                        NC_POSTCODE =       8,
                        NC_TEL1 =           9,
                        NC_TEL2 =           10
                    
--global settings
global constant         GS_VAT =        1,
                        GS_ECU =        2,
                        GS_PRACTICE =   3,
                        GS_ADDRESS1 =   4,
                        GS_ADDRESS2 =   5,
                        GS_ADDRESS3 =   6,
                        GS_ADDRESS4 =   7,
                        GS_POSTCODE =   8,
                        GS_TEL =        9,
                        GS_VATREG =     10,
                        GS_BRANCH =     11,
                        GS_BRANCH_NUMBER = 12
global sequence globalSettings
globalSettings = repeat({}, 12)

--practice drug label address
global constant         DL_NAME =       1,
                        DL_ADDRESS1 =   2,
                        DL_ADDRESS2 =   3,
                        DL_ADDRESS3 =   4,
                        DL_ADDRESS4 =   5,
                        DL_POSTCODE =   6,
                        DL_TEL =        7
global sequence DrugLabelAddress
DrugLabelAddress = repeat({},7)                                         

--printers
global constant         PR_LABEL =      1,
                        PR_RECEIPT =    2,
                        PR_INVOICING =  3,
                        PR_STATEMENT =  4,
                        PR_HISTORY =    5,
                        PR_GENERAL =    6,
                        PR_FORMS =      7,
                        PR_DIARY =      8,
                        PR_ESTIMATES =  9,
                        PR_INVOICE_SUMMARIES = 10
global sequence printers
printers = repeat({}, 10)
global constant CHAR_PER_LINE = 80


--Products
global constant         PROD_ITEM =             1,   PROD_NAME = 1,
                        PROD_CODE =             2,
                        PROD_TYPE =             3,
                        PROD_CATEGORY =         4,
                        PROD_SUPPLIER =         5,
                        PROD_SUP_REF =          6,
                        PROD_MAN_REF =          7, 
                        PROD_LICENSE =          8,
                        PROD_NUMBER =           9,
                        PROD_PACK_COST =        10,
                        PROD_UNITS_PACK =       11,     --how many units in the pack. eg 100 mls, 10 tablets
                        PROD_PACK_UNITS =       12,     --whats in the pack, eg tablets, mls
                        PROD_ANALYSIS =         13,
                        PROD_IN_STOCK =         14,
                        PROD_UNIT_SALES =       15,
                        PROD_COST =             16,
                        PROD_MARKUP =           17,
                        PROD_DISC =             18,
                        PROD_SALES_PRICE =      19,
                        PROD_MILK_WITHHOLD =    20,
                        PROD_MEAT_WITHHOLD =    21,
                        PROD_EGG_WITHHOLD =     22,
                        PROD_WARNING =          23,
                        PROD_GEN_LABEL =        24,
                        PROD_EXTRA_LABEL =      25,
                        PROD_DOSAGE =           26,
                        PROD_GEN_LETTER =       27,
                        PROD_VAT =              28,
                        PROD_RECALL =           29,     --a slot number, at the moment
                        PROD_DOSE_UNITS =       30,
                        PROD_WEIGHT_MULT =      31,
                        PROD_STATUS =           32,     --1 make dead ('D' indicates decease)
                                                        --2 
                                                        --5 PDSA
                        PROD_SEX =              33,
                        PROD_BASE_FEE =         34,
                        PROD_INFO =             35,     --not native to vet.c data files
                        PROD_RECALL_INTERVAL = 36,
                        PROD_RECALL_COUNT = 37,
                        PROD_BATCH_NUMBER = 38

global sequence Product
Product = repeat({}, 38)

--Reminder table
global constant         REM_DATE        =       1,
                        REM_CLIENT_NO   =       2,
                        REM_PATIENT_NO  =       3,
                        REM_TYPE        =       4,
                        REM_COUNT       =       5

global sequence Reminder
Reminder = repeat({}, 5)
                        
global sequence ReminderTypes
ReminderTypes = repeat({}, 10)

global sequence ProductCategories
ProductCategories = repeat({}, 26)

--popups
global constant POP_CLIENT_NO =         1,
                POP_PATIENT_NO =        2,
                POP_COLOUR =            3,
                POP_COP =               4,
                POP_TEXT =              5
global sequence Popup
Popup = repeat({}, 5)

--diary details
global constant DD_NAME =               1,
                DD_TIME_START =         2,
                DD_TIME_END =           3,
                DD_APPT_LENGTH =        4,
                DD_SLOTS_PER_APPT =     5,
                DD_USE_ON_DAYS =        6,
                DD_SLOTS_PER_PAGE =     7

--diary page / slot
global constant DP_INDEX =              1,
                DP_CLIENT_NAME =        2,
                DP_PATIENT_NAME =       3,
                DP_CLIENT_NO =          4,
                DP_PATIENT_NO =         5,
                DP_DATE =               6,
                DP_TIME =               7,
                DP_SLOT_ON_PAGE =       8,
                DP_REASON =             9

--Days of week
global constant WEEKDAYS = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"}
global constant MONTHS = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}

global integer diary_flag,      --flag for called by diary
                called_from_wr,  --flag indicates that has come from waiting room
                called_from_patient
                
diary_flag = FALSE
called_from_wr = FALSE
called_from_patient = FALSE

--payment methgods
global sequence PAYMENT_METHODS
PAYMENT_METHODS = {"Cash", "Cheque", "Card", "Other", "PDSA"}


global constant FormCodes = 
        {       {"{BLCLPAT}", "Client and patient block"},
                {"{DATE}", "Date"},
                {"{BLCLIENT)", "Client block"},
                {"{BLPATIENT}", "Patient block"},
                {"{CLNAMENICE}", "Nice client name"},
                {"{PANAME}", "Patient name"},
                {"{PASPECIES}", "Patient species"},
                {"{PAHIMHER}", "Him or her"},
                {"{PAHISHERS}", "His or hers"}
        }




        


