--waiting room
--all aspects of waiting room in here


constant WR_CLIENT_NO   = 1,
         WR_PATIENT_NO  = 2,
         WR_CLIENT_NAME = 3,
         WR_PATIENT_NAME = 4,
         WR_TO_SEE       = 5,
         WR_REASON       = 6,
         WR_TYPE         = 7,
         WR_SECS         = 8


--------------------------------------------------------------------------------------------------------------
function advance_cur_pos(integer cur_pos, sequence str)
--------------------------------------------------------------------------------------------------------------
integer posn
posn = 0

for j = cur_pos + 1 to length(str) do
        if str[j] = '|' then
                cur_pos = j
                posn = cur_pos
                exit
        end if
end for

if posn = 0 then cur_pos = length(str) end if

return cur_pos
end function

--------------------------------------------------------------------------------------------------------------
function load_waiting_room()
--wr_file - the raw data, as it appears in the file
--wr_item - a line of dat broken down into sequences
--wr - the waitng room - a list of wr_item s
--------------------------------------------------------------------------------------------------------------
integer fp, m1, m2
sequence wr, wr_item, wr_file
object line

wr_item = repeat({}, 8)
wr_file = {} --simply the raw data from the file
wr = {}

fp = open("waiting_room","r")
if fp > 0 then
        while 1 do
                line = gets(fp)
                if sequence(line) then
                        wr_file = append(wr_file, line)
                else
                        exit
                end if
        end while
        close(fp)
else 
        return wr
end if

if length(wr_file) > 0 then
        for i = 1 to length(wr_file) do
                wr_item = repeat({}, 8)
                m1 = 1 m2 = 1
                for j = 1 to WR_TYPE do
                        --find posn of next '|'
                        m2 = advance_cur_pos(m2, wr_file[i])
                        wr_item[j] = wr_file[i][m1..m2-1]
                        --advance the markers
                        m1 = m2+1
                        m2 = m1
                end for
                --finally
                wr_item[WR_SECS] = wr_file[i][m1..$]

                --now convert the relavent strings to numbers
                wr_item[WR_CLIENT_NO] = strtoval(wr_item[WR_CLIENT_NO])
                wr_item[WR_PATIENT_NO] = strtoval(wr_item[WR_PATIENT_NO])
                wr_item[WR_SECS] = strtoval(wr_item[WR_SECS])

                wr = append(wr, wr_item)
                
        end for
end if

return wr
end function

--------------------------------------------------------------------------------------------------------------
function save_waiting_room(sequence wr)
--updates the current waiting room
--lock and load current waiting room on disk
--update any additional items
--save it back to disk
--------------------------------------------------------------------------------------------------------------
integer fp

fp = open("waiting_room", "w")
        

for i = 1 to length(wr) do
        printf(fp, "%d|%d|%s|%s|%s|%s|%s|%d\n",{wr[i][WR_CLIENT_NO],
                                                        wr[i][WR_PATIENT_NO],
                                                        wr[i][WR_CLIENT_NAME],
                                                        wr[i][WR_PATIENT_NAME],
                                                        wr[i][WR_TO_SEE],
                                                        wr[i][WR_REASON],
                                                        wr[i][WR_TYPE],
                                                        wr[i][WR_SECS]
                                                        })
end for

close(fp)

return wr
end function

--------------------------------------------------------------------------------------------------------------
function lock_wr(integer wr_lock_no, integer lock_on)
--------------------------------------------------------------------------------------------------------------
integer fp, can_lock, escape_wait
object line
integer cur_lock_no

can_lock = 0
escape_wait = 0

while 1 do      
        fp = open("wr_lock", "r")
        if fp > 0 then
                line = gets(fp)
                if sequence(line) then
                        cur_lock_no = strtoval(line)
                        if cur_lock_no = 0 then cur_lock_no = -1 end if
                else
                        cur_lock_no = -1
                end if
                close(fp)
        else 
                cur_lock_no = -1
        end if
        if cur_lock_no = wr_lock_no or cur_lock_no = -1 then --I am allowed to change the file
                can_lock = 1
                exit
        end if
        
        --notify of wait
        SetSize(2, 15)
        SetColors(BLACK, CYAN)
        position( (SCREEN_LINES-2)/2, (SCREEN_COLS-15)/2)
        MessageBox("",{"Please wait " & sprintf("%d", {escape_wait}) })

        escape_wait += 1
        if escape_wait > 5 then exit end if
        sleep(1)
end while


if can_lock = 1 then --I am allowed to change the file
        fp = open("wr_lock", "w")
        if lock_on = 1 then
                puts(fp, sprintf("%d", {wr_lock_no}) & "\n")
        else
                puts(fp, "")
        end if
        close(fp)       

else
        return FALSE
end if

return TRUE

end function

--------------------------------------------------------------------------------------------------------------
global procedure add_to_waiting_room(integer client_no, 
                                        integer patient_no, 
                                        sequence client_name, 
                                        sequence patient_name, 
                                        sequence reason,
                                        sequence wr_type)
--can be added from either the diary, or the client page
--no display, just returns to the calling func
--------------------------------------------------------------------------------------------------------------
sequence wr_item,
        to_see,
        wr
integer wr_lock_no, exists_at, notify_flag
        
wr_item = repeat({}, 8)
to_see = {}
wr = {}
wr_lock_no = rand(100000)
exists_at = 0
notify_flag = 1

if wr_type[1] = 'w' then
        wr_type = "W"
        diary_flag = 0
        reason = "-"
        notify_flag = 0
end if

if length(reason) = 0  then
        SetColors(YELLOW,BLUE)
        position(  (SCREEN_LINES/2) + 1, (SCREEN_COLS/2) - 20)
        reason = Form("Reason for the appointment",
                        {"Reason", "", 30,
                         "To see", "", 5})
        to_see = reason[2]
        reason = reason[1]
end if

if diary_flag = 1 then
        SetColors(YELLOW,BLUE)
        position(  (SCREEN_LINES/2) + 1, (SCREEN_COLS/2) - 20)
        reason = Form("Reason for the appointment",
                        {"Reason", reason, 30,
                         "To see", "", 5})
        to_see = reason[2]
        reason = reason[1]
end if


--now create the waiting room item
wr_item[WR_CLIENT_NO] = client_no
wr_item[WR_PATIENT_NO] = patient_no
wr_item[WR_CLIENT_NAME] = remove_trailing_spaces(client_name)
wr_item[WR_PATIENT_NAME] = remove_trailing_spaces(patient_name)
wr_item[WR_REASON] = remove_trailing_spaces(reason)
wr_item[WR_TO_SEE] = remove_trailing_spaces(to_see)
wr_item[WR_SECS] = DateTimeToSeconds(nowDateTime())
wr_item[WR_TYPE] = wr_type

if length(wr_item[WR_REASON]) = 0 then
        wr_item[WR_REASON] = "-"
end if
if length(wr_item[WR_TO_SEE]) = 0 then
        wr_item[WR_TO_SEE] = "-"
end if

--lock waiting room
--load waiting room
--update waiting room list
--save waiting room
--unlock waiting room

if lock_wr(wr_lock_no, 1) = TRUE then -- waiting room has been locked
        wr = load_waiting_room()
        
        if length(wr) > 0 then
                --check to see if client already on
                for i = 1 to length(wr) do
                        if wr[i][WR_CLIENT_NO] = client_no then
                                exists_at = i
                        end if
                end for
                if exists_at = 0 then
                        wr = append(wr, wr_item)
                else
                        wr[exists_at][WR_TYPE] = wr_type
                        wr[exists_at][WR_REASON] = reason
                end if
        else
                wr = append(wr, wr_item)
        end if
        
        
        wr = save_waiting_room(wr)

        
        VOID = lock_wr(wr_lock_no, 0) --unlock waiting room
        if wr_item[WR_TYPE][1] = 'W' and notify_flag = 1 then
                VOID = get_yn_box("Added to waiting room")
        end if
        
else
        VOID = get_yn_box("Waiting room time out - try again!") 
end if  

end procedure
rid_a2wr = routine_id("add_to_waiting_room")

--------------------------------------------------------------------------------------------------------------
function remove_from_wr(sequence wr, integer cur_selected)
--------------------------------------------------------------------------------------------------------------
sequence new_wr

new_wr = {}

for i = 1 to length(wr) do
        if i != cur_selected then
                new_wr = append(new_wr, wr[i])
        end if
end for

return new_wr
end function

--------------------------------------------------------------------------------------------------------------
global procedure remove_from_wr_from_client(integer client_no)
--load waiting room
--remove client from waiting room
--save waitng room
--------------------------------------------------------------------------------------------------------------
sequence wr
integer cur_selected, wr_lock_no

wr = load_waiting_room()
wr_lock_no = rand(100000)

for i = 1 to length(wr) do
        if wr[i][WR_CLIENT_NO] = client_no then
                cur_selected = i
        end if               
end for

wr = remove_from_wr(wr, cur_selected)

--lock waiting room
if lock_wr(wr_lock_no, TRUE) = TRUE then
        wr = save_waiting_room(wr)
        --unlock waiting room
        VOID = lock_wr(wr_lock_no, FALSE)
end if

end procedure
rid_rmfwr = routine_id("remove_from_wr_from_client")



--------------------------------------------------------------------------------------------------------------
global procedure waiting_room_footer()
--------------------------------------------------------------------------------------------------------------
sequence lower_divider

lower_divider = repeat('_', SCREEN_COLS)

printcolor({SCREEN_LINES-3, 1}, {WHITE, BLACK}, lower_divider)
printcolor( {SCREEN_LINES-2,1}, {WHITE, BLACK}, "Filters"  )
printcolor( {SCREEN_LINES-2,13}, {WHITE, BLACK}, "A - show all"  )
printcolor( {SCREEN_LINES-2,27}, {BRIGHT_GREEN, BLACK}, "W - to see"  )
printcolor( {SCREEN_LINES-2,41}, {BRIGHT_RED, BLACK}, "P - to pay"  )
printcolor( {SCREEN_LINES-2,62}, {BRIGHT_BLUE, BLACK}, "B - being seen"  )
printcolor( {SCREEN_LINES-1,1}, {YELLOW, BLACK}, "R - remove"  )
printcolor( {SCREEN_LINES-1,13}, {YELLOW, BLACK}, "U - move up"  )
printcolor( {SCREEN_LINES-1,27}, {YELLOW, BLACK}, "D - move down"  )
printcolor( {SCREEN_LINES-1,41}, {YELLOW, BLACK}, "G/ret - goto client"  )
printcolor( {SCREEN_LINES-1,62}, {YELLOW, BLACK}, "E - emergency"  )
printcolor( {SCREEN_LINES,1}, {CYAN, BLACK}, "M - mode    cursor keys - selection   Q - quit"  )


end procedure

------------------------------------------------------------------------------------------------------------
procedure wr_goto_client(sequence wr_item)
------------------------------------------------------------------------------------------------------------
sequence SelectedCliPat


SelectedCliPat = {0,0}

SelectedCliPat[1] = wr_item[WR_CLIENT_NO]
SelectedCliPat[2] = wr_item[WR_PATIENT_NO]

if SelectedCliPat[1] > 0 then
        if lock_client(SelectedCliPat[1]) = TRUE then --indicates the client can be locked, and has been
                client_patient_page(SelectedCliPat)
                unlock_client(SelectedCliPat[1])
        end if
end if

end procedure

--------------------------------------------------------------------------------------------------------------
function filter_waiting_room(sequence wr, integer filter)
--------------------------------------------------------------------------------------------------------------
sequence new_wr

new_wr = {}

for i = 1 to length(wr) do
        if wr[i][WR_TYPE][1] = filter then
                new_wr = append(new_wr, wr[i])
        end if
end for

return new_wr
end function

--------------------------------------------------------------------------------------------------------------
function check_wr_times(sequence wr, atom secs, integer wr_lock_no)
--------------------------------------------------------------------------------------------------------------
sequence new_wr

new_wr = {}

for i = 1 to length(wr) do
        --30 minutes for 'to pay'
        
        --VOID = get_yn_box(sprintf("%d", {floor((secs - wr[i][WR_SECS])/60)}))
        
        if wr[i][WR_TYPE][1] = 'P' then
                if floor((secs - wr[i][WR_SECS])/60) < 30  then
                        new_wr = append(new_wr, wr[i])
                end if
        end if

        if wr[i][WR_TYPE][1] = 'B' then
                new_wr = append(new_wr, wr[i])
        end if

        if wr[i][WR_TYPE][1] = 'W' then
                new_wr = append(new_wr, wr[i])
        end if

end for


if length(wr) != length(new_wr) and lock_wr(wr_lock_no, 1) = TRUE then
        wr = save_waiting_room(new_wr)
        VOID = lock_wr(wr_lock_no, 0)
end if



return new_wr
end function

--------------------------------------------------------------------------------------------------------------
global function waiting_room()
--displays and updates the waiting room
--waiting room file format
--client_no|patient_no|client_name|paient_name|to_see|reason|type|seconds_after_epoch_added(for time)
--eg
--3425|6767|Smith|Fred|CB|Rex|S|56789
--------------------------------------------------------------------------------------------------------------
sequence wr, time_seq, G, R, B, Y, GS, RS, BS, YS, display_color, tmp, tmpwr
atom secs, entry_secs, remaining_secs
integer c, cur_selected, max_list, last_list, refreshed, filter, old_wr_len, wr_lock_no, mode, minutes_on_wr

secs = 0
wr = load_waiting_room()
entry_secs = DateTimeToSeconds(nowDateTime())
cur_selected = 1
max_list = SCREEN_LINES - 4
G = {BRIGHT_GREEN, BLACK}       GS = {BLACK, WHITE}
R = {RED, BLACK}                RS = {RED, WHITE}
B = {BLUE, BLACK}               BS = {BLUE, WHITE}
Y = {YELLOW, BLACK}             YS = {BLACK, WHITE}
display_color = G
refreshed = 0
filter = 'A'
old_wr_len = 0
wr_lock_no = rand(100000)
mode = 1 --active , 0 = passive

last_list = length(wr)
if last_list > max_list then last_list = max_list end if

if last_list = 0 then 
        VOID = get_yn_box("Waiting room is empty")
        return 0 
end if

SetColors(WHITE, BLACK)
SetStyle(5) position(1,1) MessageBox("",{}) SetStyle(1) --need this so that screen clears properly
clear_screen()

printcolor({1,1}, {BLACK,CYAN}, "Waiting room : " & JV_BRANCH)

--footer menu
waiting_room_footer()

for i = 1 to last_list do
        if wr[i][WR_TYPE][1] = 'W' then
                display_color = G
        elsif wr[i][WR_TYPE][1] = 'P' then
                display_color = R
        elsif wr[i][WR_TYPE][1] = 'B' then
                display_color = B
        end if          
        printcolor({i+1, 1}, display_color, sprintf("%-15.15s %-15.15s %-20.20s %-5.5s", {wr[i][WR_CLIENT_NAME],wr[i][WR_PATIENT_NAME],wr[i][WR_REASON],wr[i][WR_TO_SEE   ]}  )     )
end for

--set selection bar
if wr[1][WR_TYPE][1] = 'W' then
        display_color = GS
elsif wr[1][WR_TYPE][1] = 'P' then
        display_color = RS
elsif wr[1][WR_TYPE][1] = 'B' then
        display_color = BS
end if          
printcolor({1+1, 1}, display_color, sprintf("%-15.15s %-15.15s %-20.20s %-5.5s", {wr[1][WR_CLIENT_NAME],wr[1][WR_PATIENT_NAME],wr[1][WR_REASON],wr[1][WR_TO_SEE]}  )     )


while 1 do
        if mode = 1 then
                c = upper(get_key())
        else
                c = upper(wait_key())
                refreshed = 0
        end if
        
        --time bits
        time_seq = nowTime()
        secs = DateTimeToSeconds(nowDateTime())
        remaining_secs = 30 - (secs - entry_secs)
        
        if c = 'Q' or remaining_secs <= 0 then exit end if
        
        --refresh every 5 seconds, or if a key is pressed
        if c != -1 then
                entry_secs = DateTimeToSeconds(nowDateTime())
        end if

        if c = up then
                cur_selected -= 1
                if cur_selected < 1 then cur_selected = 1 end if
                refreshed = 0
        end if
        if c = dn then
                cur_selected += 1
                if cur_selected > last_list then cur_selected = last_list end if
                refreshed = 0
        end if
        
        if c = ENTER or c = 'G' then
                called_from_wr = TRUE
                wr_goto_client(wr[cur_selected])
                called_from_wr = FALSE
                SetColors(WHITE, BLACK)
                SetStyle(5) position(1,1) MessageBox("",{}) SetStyle(1) --need this so that screen clears properly
                clear_screen()
                printcolor({1,1}, {BLACK,CYAN}, "Waiting room : " & JV_BRANCH)
                waiting_room_footer()
                refreshed = 0
                entry_secs = DateTimeToSeconds(nowDateTime())
        end if
        
        if c = 'R' then
                wr = remove_from_wr(wr, cur_selected)
                if lock_wr(wr_lock_no, 1) = TRUE then
                        wr = save_waiting_room(wr)
                        VOID = lock_wr(wr_lock_no, 0)           
                end if          
                refreshed = 0
                entry_secs = DateTimeToSeconds(nowDateTime())
        end if
        
        if c = 'M' then
                mode = (mode - 1) * -1
        end if

        if c = 'A' then filter = 'A' end if
        if c = 'W' then filter = 'W' end if
        if c = 'P' then filter = 'P' end if
        if c = 'B' then filter = 'B' end if
        
        if c = 'E' then
                --change current selected to top of list
                tmp = wr[cur_selected]
                tmpwr = wr
                wr = {tmp}
                
                for i = 1 to length(tmpwr) do
                        if cur_selected != i then
                                wr = append(wr, tmpwr[i]) 
                        end if
                end for
                
                wr[1][WR_REASON] = "Emergency!"
                
                if lock_wr(wr_lock_no, 1) = TRUE then
                        wr = save_waiting_room(wr)
                        VOID = lock_wr(wr_lock_no, 0)           
                end if  
                refreshed = 0        
       end if
        

        if length(wr) = 0 then exit end if
        
        if c != -1 or (remaining_secs/5 = floor(remaining_secs/5) )  then
                if refreshed = 0 then
                        old_wr_len = last_list
                        refreshed = 1
                        wr = load_waiting_room()

                        --check for waiting clients time limits
                        wr = check_wr_times(wr, secs, wr_lock_no)
                        
                        --check filter here
                        if filter != 'A' then
                                wr = filter_waiting_room(wr, filter)
                        end if
                        
                        if length(wr) = 0 then exit end if

                        --remove any extra items from display
                        last_list = length(wr)
                        if last_list > max_list then last_list = max_list end if
                        if last_list < old_wr_len then
                                for i = length(wr) to old_wr_len do
                                printcolor({i+1, 1}, {WHITE, BLACK}, "                                                                         "  )
                                end for
                        end if
                        if cur_selected > last_list then cur_selected = last_list end if

                        for i = 1 to last_list do
                                if wr[i][WR_TYPE][1] = 'W' then
                                        display_color = G
                                elsif wr[i][WR_TYPE][1] = 'P' then
                                        display_color = R
                                elsif wr[i][WR_TYPE][1] = 'B' then
                                        display_color = B
                                end if          
                                printcolor({i+1, 1}, display_color, sprintf("%-15.15s %-15.15s %-20.20s %-5.5s (%4d mins)", {wr[i][WR_CLIENT_NAME],wr[i][WR_PATIENT_NAME],wr[i][WR_REASON],wr[i][WR_TO_SEE], floor((secs - wr[i][WR_SECS])/60) }  )     )
                        end for

                        --selection bar
                        if wr[cur_selected][WR_TYPE][1] = 'W' then
                                display_color = GS
                        elsif wr[cur_selected][WR_TYPE][1] = 'P' then
                                display_color = RS
                        elsif wr[cur_selected][WR_TYPE][1] = 'B' then
                                display_color = BS
                        end if          
                        printcolor({cur_selected+1, 1}, display_color, sprintf("%-15.15s %-15.15s %-20.20s %-5.5s (%4d mins)", {wr[cur_selected][WR_CLIENT_NAME],wr[cur_selected][WR_PATIENT_NAME],wr[cur_selected][WR_REASON],wr[cur_selected][WR_TO_SEE], floor((secs - wr[cur_selected][WR_SECS])/60) }  )     )

                end if
        else
                refreshed = 0
        end if
        
        --refresh display top
        printcolor({1, length("Waiting room : " & JV_BRANCH)+ 3}, {BRIGHT_GREEN, BLACK}, sprintf("%02d:%02d   %02d            ", {time_seq[1], time_seq[2], remaining_secs}))
        if mode = 0 then
                        printcolor({1, length("Waiting room : " & JV_BRANCH)+ 3}, {BRIGHT_RED, BLACK}, sprintf("%02d:%02d   %s", {time_seq[1], time_seq[2], "PASSIVE MODE"}))
        end if
end while

return 0
end function





















